=== modified file 'HACKING'
--- HACKING	2006-02-22 12:31:33 +0000
+++ HACKING	2006-12-16 10:57:30 +0000
@@ -4,31 +4,7 @@
 
 
 == Formatting ==
-We use tabs rather than spaces in the Dogtail python sources
-
-If you don't know how to make your editor use tabs, here are some 
-instructions. Note that you can replace '4' with '2' '8' or
-any other number, but make sure to change it in both places.
-
--- Vim users --
-Put this in your ~/.vimrc:
-set tabstop=4
-set shiftwidth=4
-set noexpandtab
-
-
--- Emacs users --
-Put this in your ~/.emacs:
-(defun custom-python-mode ()
-	;; The following two variables must be equal for...
-	(setq tab-width 4)
-	(setq py-indent-offset 4)
-
-	;; The following setting to be actually respected:
-	;; Use tabs for indentation in Python mode
-	(setq indent-tabs-mode t))
-(add-hook 'python-mode-hook 'custom-python-mode)
-
+We use 4 spaces for indentation.
 
 == Python versions ==
 We're trying to support both Python 2.3 and Python 2.4

=== modified file 'MANIFEST.in'
--- MANIFEST.in	2006-02-22 12:31:33 +0000
+++ MANIFEST.in	2006-12-16 10:57:30 +0000
@@ -6,8 +6,8 @@
 include INSTALL
 include NEWS
 recursive-include docs *
-recursive-include debian *
 recursive-include scripts *
 include sniff/sniff.glade sniff/sniff.desktop sniff/icons/*.xpm
+include recorder/recorder.glade recorder/dogtail-recorder recorder/dogtail-recorder.desktop
 recursive-include examples *.py *.txt *.png *.cfg
 include icons/*.svg icons/*.png

=== modified file 'Makefile'
--- Makefile	2006-02-22 12:31:33 +0000
+++ Makefile	2006-12-16 10:57:30 +0000
@@ -1,7 +1,10 @@
 # dogtail *development* Makefile
 
 all:
-	exit 1
+	python setup.py build_ext --inplace
+
+install:
+	python setup.py install
 
 clean:
 	python setup.py clean

=== modified file 'NEWS'
--- NEWS	2006-08-01 22:59:27 +0000
+++ NEWS	2006-12-21 13:33:47 +0000
@@ -1,3 +1,151 @@
+dogtail 0.6.1
+=============
+
+Features:
+
+ * dogtail-recorder has a Play button now.
+
+ * dogtail-recorder now records right-clicks. That it didn't previously was an
+   oversight. Note that there is some inconsistency when dealing with context
+   menus, as the events often get fired in the wrong order.
+
+ * New logging mechanism:
+
+    - Debug output is now written to a file. To disable this, set 
+      dogtail.config.config.logDebugToFile to False.
+
+    - The procedural API defaults to not raising FocusErrors, and instead
+      issuing warnings via the debug logging mechanism (which prints to 
+      standard out along with writing to a file). To re-enable FocusErrors, set
+      dogtail.config.config.fatalErrors to True.
+
+ * Brian Cameron submitted a patch to make dogtail.distro correctly detect that
+   it is running on Solaris.
+
+Bugfixes:
+
+ * dogtail-recorder no longer offers the broken Object-Oriented backend as a
+   choice. If it gets fixed, it will be offered again.
+
+ * dogtail-recorder can be properly exited by clicking on the window manager
+   close button. In fact, the Quit button was removed also.
+
+ * dogtail-recorder's syntax hilighting works again, thanks to a patch from 
+   Dave Malcolm.
+
+ * Searching for nodes with parentheses in their names will no longer fail.
+
+ * The various pressKey() functions were blowing up on punctuation and 
+   newlines. Fixed.
+
+ * Predicate subclasses in dogtail.predicate which were missing debugNames have
+   gotten them back.
+
+ * Warnings are no longer issued when dogtail encounters invalid Unicode.
+
+ * Where several of our example scripts were broken, Michal Babej noticed and
+   submitted patches fixing them.
+
+ * dogtail's tarball is 90% smaller! Some overly large test images were 
+   replaced with very, very small ones that still do the job.
+
+
+dogtail 0.6.0
+=============
+
+Features:
+
+ * Keystroke recording support in dogtail-recorder:
+
+    - Normal keypresses (e.g. typing 'foo bar baz') will be recorded as 
+      "type('foo bar baz')" in the procedural API. dogtail.tree.Node has a new
+      method, typeText(), which is called by dogtail.procedural.type().
+
+    - Nonprintable keypresses (e.g. typing Control-Shift-c) will be recorded as
+      "keyCombo('<Control><Shift>c')" in the procedural API. dogtail.tree.Node
+      has a new method, keyCombo(), which is called by 
+      dogtail.procedural.keyCombo().
+
+    - The now-unnecessary 'Input Text' button has been removed.
+
+ * dogtail.tree.Node has new attributes and a new method:
+
+    - grabFocus(): Attempts to cause the node to grab the keyboard focus.
+
+    - focusable: Whether the node is able to have keyboard focus.
+
+    - focused: Whether the node currently has keyboard focus.
+
+    - checked: Whether the node is a checkbox that is currently checked.
+
+ * Dogtail now checks if accessibility is enabled before it does anything. 
+   sniff and dogtail-recorder will prompt to enable it via a dialog, and 
+   scripts themselves will just refuse to run.
+
+ * Dogtail no longer uses the IconLogger (in the notification area) by default.
+   Set dogtail.config.config.useIconLogger to True to reenable it.
+
+ * dogtail.utils.screenshot() was rewritten to use GDK instead of ImageMagick.
+
+Bugfixes:
+
+ * Dogtail is now much more robust in dealing with possibly-invalid Unicode
+   strings passed to it via AT-SPI. (GNOME bug #354515)
+
+ * Dogtail will not crash when it receives an SpiException caused by a CORBA 
+   COMM_FAILURE, unless the source of that error is the application under test.
+
+ * While exceptions occuring inside callbacks used in dogtail-recorder will 
+   still not properly be raised, they are now printed to standard out.
+
+ * SuSe support in dogtail.distro is fixed. (GNOME bug #353601)
+
+ * sniff and dogtail-recorder will now find their glade files, even if they're
+   installed into a nonstandard prefix. (GNOME bug #353719, #353731)
+
+ * dogtail-run-headless had a few bugs fixed.
+
+
+dogtail 0.5.2
+=============
+
+Features:
+
+ * A much-improved recorder:
+
+    - A procedural script writer, which is now default.
+
+    - An 'Input Text' feature, which allows you to set the text attribute
+      of any visible Node via the recorder. Coming soon is proper keystroke
+      recording.
+
+    - The script view now uses syntax hilighting where available. (GNOME bug
+      #345374)
+
+ * A completely-rewritten dogtail-run-headless, which now offers two session
+   types: minimal GNOME and metacity. The syntax has changed, so use 
+   'dogtail-run-headless --help' to get started. (GNOME bug #320548)
+
+ * All 'name' arguments in dogtail.tree and dogtail.procedural now accept 
+   regular expressions.
+
+ * Support for AccessibleSelections, providing a clean way to select page
+   tabs and combo box items. (GNOME bug #336562)
+
+ * Support for building in a jhbuild environment. (GNOME bug #318535)
+
+ * Far more extensive unit tests for dogtail.tree.Node.
+
+Bugfixes:
+
+ * The source is now indented with spaces and not tabs! :) (GNOME bug #318833)
+
+ * Pyspi and dogtail no longer mysteriously stop working. (GNOME bug #321273)
+
+ * Sniff no longer crashes when an application being poked disappears. (GNOME 
+   bug #318135)
+
+
 dogtail 0.5.1
 =============
 

=== modified file 'PKG-INFO'
--- PKG-INFO	2006-08-01 22:59:27 +0000
+++ PKG-INFO	2006-12-21 13:33:47 +0000
@@ -1,10 +1,10 @@
 Metadata-Version: 1.0
 Name: dogtail
-Version: 0.5.1
+Version: 0.6.1
 Summary: GUI test tool and automation framework that uses Accessibility (a11y) technologies to communicate with desktop applications.
 Home-page: http://people.redhat.com/zcerza/dogtail/
 Author: Zack Cerza <zcerza@redhat.com>,
-Ed Rousseau <rousseau@redhat.com>, 
+Ed Rousseau <rousseau@redhat.com>,
 David Malcolm <dmalcolm@redhat.com>
 Author-email: dogtail-list@gnome.org
 License: UNKNOWN

=== modified file 'README'
--- README	2006-02-22 12:31:33 +0000
+++ README	2006-12-16 10:57:30 +0000
@@ -16,20 +16,22 @@
 Dependencies
 ============
 
-pyspi 0.5.3 or newer:
+pyspi 0.6.0 or newer:
   http://people.redhat.com/zcerza/dogtail/releases/
 
 Python bindings for your distribution, e.g. python-apt or rpm-python
 
+PyGTK and GNOME-Python
+
 Applications to test, e.g. from the GNOME desktop:
   http://gnome.org/
 
+Xvfb and xinit:
+  http://xorg.freedesktop.org/
+
 ImageMagick (optional):
   http://www.imagemagick.org/
 
-Xvfb (optional):
-  http://xorg.freedesktop.org/
-
 cElementTree or ElementTree (optional):
   http://effbot.org/downloads/
 

=== removed directory 'debian'
=== removed file 'debian/changelog'
--- debian/changelog	2006-08-01 22:59:27 +0000
+++ debian/changelog	1970-01-01 00:00:00 +0000
@@ -1,56 +0,0 @@
-dogtail (0.5.1-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Tue, 14 Mar 2006 16:21:00 -0500
-
-dogtail (0.5.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * Build-Depend on python-at-spi (>=0.5.3-1).
-  * Add post-install script that calls gtk-update-icon-cache.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Fri,  3 Feb 2006 16:24:56 -0500
-
-dogtail (0.4.3-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Mon, 24 Oct 2005 02:32:14 -0400
-
-dogtail (0.4.2-3) unstable; urgency=low
-
-  * Correct website URL.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Wed, 19 Oct 2005 19:16:14 -0400
-
-dogtail (0.4.2-2) unstable; urgency=low
-
-  * Add Recommends for xvfb. 
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Tue, 11 Oct 2005 16:59:04 -0400
-
-dogtail (0.4.2-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Thu,  6 Oct 2005 23:25:03 -0400
-
-dogtail (0.4.1-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Thu,  6 Oct 2005 17:23:03 -0400
-
-dogtail (0.4.0-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Thu,  6 Oct 2005 16:54:16 -0400
-
-dogtail (0.0.1.90-1) unstable; urgency=low
-
-  * Initial Release
-
- -- Zack Cerza <zcerza@coe.neu.edu>  Sun, 10 Jul 2006 22:40:36 -0400
-

=== removed file 'debian/compat'
--- debian/compat	2006-02-22 12:31:33 +0000
+++ debian/compat	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-4

=== removed file 'debian/control'
--- debian/control	2006-02-22 12:31:33 +0000
+++ debian/control	1970-01-01 00:00:00 +0000
@@ -1,14 +0,0 @@
-Source: dogtail
-Section: misc
-Priority: optional
-Maintainer: Zack Cerza <zcerza@coe.neu.edu>
-Build-Depends: debhelper (>=4.2.0), cdbs
-Standards-Version: 3.6.1.1
-
-Package: python-dogtail
-Architecture: all
-Depends: python-at-spi (>=0.5.3-1)
-Recommends: imagemagick, python-celementtree | python-elementtree, python-apt, xvfb
-Description: Automated desktop testing framework
- Insert better long description here
-

=== removed file 'debian/copyright'
--- debian/copyright	2006-02-22 12:31:33 +0000
+++ debian/copyright	1970-01-01 00:00:00 +0000
@@ -1,24 +0,0 @@
-This package was debianized by Zack Cerza <zcerza@coe.neu.edu> on
-Sun, 10 Jul 2006 22:40:36 -0400
-
-It was downloaded from http://people.redhat.com/zcerza/dogtail/
-
-Upstream Authors: Ed Rousseau and Zack Cerza
-
-This software is copyright (c) Red Hat, Inc.
-
-This program is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or
-(at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-
-On Debian systems, the complete text of the GNU General Public License can be found in the file `/usr/share/common-licenses/GPL'.

=== removed file 'debian/python-dogtail.install'
--- debian/python-dogtail.install	2006-02-22 12:31:33 +0000
+++ debian/python-dogtail.install	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-debian/tmp/usr/lib/python*/site-packages/dogtail/*
-debian/tmp/usr/share/doc/python-dogtail/*

=== removed file 'debian/python-dogtail.post-install'
--- debian/python-dogtail.post-install	2006-02-22 12:31:33 +0000
+++ debian/python-dogtail.post-install	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-gtk-update-icon-cache -f /usr/share/icons/hicolor 2>/dev/null

=== removed file 'debian/rules'
--- debian/rules	2006-02-22 12:31:33 +0000
+++ debian/rules	1970-01-01 00:00:00 +0000
@@ -1,11 +0,0 @@
-#!/usr/bin/make -f
-
-include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/class/python-distutils.mk
-
-DEB_COMPRESS_EXCLUDE := .txt
-
-binary-post-install/python-dogtail::
-	mv debian/python-dogtail/usr/share/doc/dogtail/* \
-		debian/python-dogtail/usr/share/doc/python-dogtail/
-	rm -rf debian/python-dogtail/usr/share/doc/dogtail/

=== modified file 'dogtail.spec'
--- dogtail.spec	2006-08-01 22:59:27 +0000
+++ dogtail.spec	2006-12-21 13:33:47 +0000
@@ -1,21 +1,21 @@
 Summary: GUI test tool and automation framework
 Name: dogtail
-Version: 0.5.1
+Version: 0.6.1
 Release: 1%{?dist}
 License: GPL
 Group: User Interface/X
-URL: http://people.redhat.com/zcerza/dogtail/releases/dogtail-0.5.1.tar.gz
-Source0: %{name}-%{version}.tar.gz
+URL: http://people.redhat.com/zcerza/dogtail/
+Source0: http://people.redhat.com/zcerza/dogtail/releases/dogtail-%{version}.tar.gz
 BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 BuildArch: noarch
 BuildRequires: python
-Requires: pyspi >= 0.5.3
+BuildRequires: desktop-file-utils
+Requires: pyspi >= 0.6.0
 Requires: pygtk2
+Requires: gnome-python2-gconf
 Requires: rpm-python
-Requires: ImageMagick
-Requires: Xvfb
-Requires(post): desktop-file-utils
-Requires(postun): desktop-file-utils
+Requires: xorg-x11-server-Xvfb
+Requires: xorg-x11-xinit
 
 %description
 GUI test tool and automation framework that uses assistive technologies to 
@@ -33,16 +33,19 @@
 python ./setup.py install -O2 --root=$RPM_BUILD_ROOT --record=%{name}.files
 rm -rf $RPM_BUILD_ROOT/%{_docdir}/dogtail
 find examples -type f -exec chmod 0644 \{\} \;
+desktop-file-install $RPM_BUILD_ROOT/%{_datadir}/applications/sniff.desktop \
+  --vendor=fedora \
+  --dir=$RPM_BUILD_ROOT/%{_datadir}/applications \
+  --add-category X-Fedora \
+  --delete-original
 
 %post
 touch --no-create %{_datadir}/icons/hicolor || :
 [ -x /usr/bin/gtk-update-icon-cache ] && gtk-update-icon-cache --quiet -f %{_datadir}/icons/hicolor || :
-update-desktop-database &> /dev/null || :
 
 %postun
 touch --no-create %{_datadir}/icons/hicolor || :
 [ -x /usr/bin/gtk-update-icon-cache ] && gtk-update-icon-cache --quiet -f %{_datadir}/icons/hicolor || :
-update-desktop-database &> /dev/null || :
 
 %clean
 rm -rf $RPM_BUILD_ROOT
@@ -59,6 +62,29 @@
 %doc examples/
 
 %changelog
+* Mon Oct 16 2006 Zack Cerza <zcerza@redhat.com> - 0.6.1-1
+- New upstream release.
+
+* Wed Sep 13 2006 Zack Cerza <zcerza@redhat.com> - 0.6.0-1
+- New upstream release.
+- Add Requires for xorg-x11-xinit.
+- Add Requires for gnome-python2-gconf.
+- Bump pyspi Requires.
+
+* Tue Aug 01 2006 Zack Cerza <zcerza@redhat.com> - 0.5.2-1
+- New upstream release.
+- Update Requires from Xvfb to xorg-x11-server-Xvfb.
+- Bump pyspi Requires.
+- Remove ImageMagick Requires.
+- Escape post-macro in changelog-macro.
+
+* Mon Apr 17 2006 Zack Cerza <zcerza@redhat.com> - 0.5.1-3
+- Fix the URL field.
+
+* Tue Mar 21 2006 Zack Cerza <zcerza@redhat.com> - 0.5.1-2
+- Fix URL and Source0 fields.
+- Fix desktop-file-utils magic; use desktop-file-install.
+
 * Fri Feb 24 2006 Zack Cerza <zcerza@redhat.com> - 0.5.1-1
 - Remove BuildRequires on at-spi-devel. Added one on python.
 - Use macros instead of absolute paths.
@@ -91,7 +117,7 @@
   python-elementtree.
 - Moved documentation (including examples) to the correct place.
 - Make sure /usr/share/doc/dogtail is removed.
-- Added 'gtk-update-icon-cache' to %post.
+- Added 'gtk-update-icon-cache' to %%post.
 
 * Mon Oct 24 2005 Zack Cerza <zcerza@redhat.com> - 0.4.3-1
 - New upstream release.

=== modified file 'dogtail/__init__.py'
--- dogtail/__init__.py	2006-08-01 22:59:27 +0000
+++ dogtail/__init__.py	2006-12-21 13:33:47 +0000
@@ -6,11 +6,10 @@
 """
 
 __author__ = """Zack Cerza <zcerza@redhat.com>,
-Ed Rousseau <rousseau@redhat.com>, 
+Ed Rousseau <rousseau@redhat.com>,
 David Malcolm <dmalcolm@redhat.com>"""
-__version__ = "0.5.1"
+__version__ = "0.6.1"
 __copyright__ = "Copyright © 2005 Red Hat, Inc."
 __license__ = "GPL"
 
-__all__ = ("config", "predicate", "procedural", "tc", "tree", "utils")
-
+__all__ = ("config", "predicate", "procedural", "tc", "tree", "utils", "errors")

=== removed directory 'dogtail/apps'
=== removed file 'dogtail/apps/__init__.py'
--- dogtail/apps/__init__.py	2006-08-01 22:59:27 +0000
+++ dogtail/apps/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-# -*- coding: UTF-8 -*-
-"""
-Types of applications
-
-David Malcolm <dmalcolm@redhat.com>
-"""
-
-__author__ = "David Malcolm <dmalcolm@redhat.com>"
-__version__ = "0.5.1"
-__copyright__ = "Copyright © 2005 Red Hat, Inc."
-__license__ = "GPL"
-
-__all__ = ('categories')

=== removed file 'dogtail/apps/categories.py'
--- dogtail/apps/categories.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/categories.py	1970-01-01 00:00:00 +0000
@@ -1,45 +0,0 @@
-# Mixin interfaces for writing generalised tests across applications in a category:
-class WebBrowser:
-	"""Mixin/interface for writing cross-browser tests"""
-	def browseToLocalFile(self, filename):
-		"""Test hook to test viewing a local file."""
-		raise NotImplementedError
-
-	def browseToUrl(self, urlString):
-		"""Test hook to test browsing a URL."""
-		raise NotImplementedError
-
-class EmailClient:
-	"""Mixin/interface for writing tests for multiple email clients"""
-	def importSingleEmail(self, filename):
-		"""Test hook to test importing a single email."""
-		raise NotImplementedError
-
-class FileBrowser:
-	"""Mixin/interface for writing tests for multiple file browser applications"""
-	def viewFolder(self, directory):
-		"""Test hook to open a view of the directory."""
-		raise NotImplementedError
-
-class ChatClient:
-	"""Mixin/interface for writing tests for multiple chat clients (xchat, Gaim, Konversation, Kopete)"""
-
-class WordProcessor:
-	"""Mixin/interface for writing tests for word processor apps (OpenOffice.org Writer, Abiword, KWord)"""
-
-class Spreadsheet:
-	"""Mixin/interface for writing tests for spreadsheet apps (OpenOffice.org Calc, Gnumeric, KSpread)"""
-
-class PresentationApp:
-	"""Mixin/interface for writing tests for presentation apps (OpenOffice.org Impress, KPresenter)"""
-
-class DesktopPanel:
-	"""Mixin/interface for writing tests for multiple implementations of the desktop panel"""
-	def applications(self):
-		"""Get a list of MenuItemRef instances for every user-visible application launchable from the panel"""
-		raise NotImplementedError
-
-	def get():
-		"""Static method to get an instance of the DesktopPanel in use, be it GnomePanel or Kicker"""
-		raise NotImplementedError
-	get = staticmethod(get)

=== removed directory 'dogtail/apps/wrappers'
=== removed file 'dogtail/apps/wrappers/__init__.py'
--- dogtail/apps/wrappers/__init__.py	2006-08-01 22:59:27 +0000
+++ dogtail/apps/wrappers/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-# -*- coding: UTF-8 -*-
-"""
-Wrappers to ease writing scripts for specific applications
-
-Author: David Malcolm <dmalcolm@redhat.com>
-"""
-
-__author__ = "David Malcolm <dmalcolm@redhat.com>"
-__version__ = "0.5.1"
-__copyright__ = "Copyright © 2005 Red Hat, Inc."
-__license__ = "GPL"
-

=== removed file 'dogtail/apps/wrappers/epiphany.py'
--- dogtail/apps/wrappers/epiphany.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/epiphany.py	1970-01-01 00:00:00 +0000
@@ -1,66 +0,0 @@
-"""Wrapper code to help when scripting Epiphany
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import *
-from dogtail.apps.categories import *
-
-class EpiphanyApp(Application, WebBrowser):
-	"""Utility wrapper for Epiphany; implements the Webbrowser mixin interface"""
-
-	def __init__(self):
-		Application.__init__(self, root.application("epiphany"))
-
-		if isinstance(distro, Debian):
-			self.epiPackageName="epiphany-browser"
-		else:
-			self.epiPackageName="epiphany"
-		self.epiVersion = packageDb.getVersion(self.epiPackageName)
-		print "Epiphany version %s"%self.epiVersion
-
-	def browseToUrl(self, urlString):
-		# Click on File->New Tab on some epiphany window:
-		newTabMenuItem = self.menu("File").menuItem("New Tab")
-		newTabMenuItem.click()
-
-		window = EpiphanyWindow(newTabMenuItem.findAncestor(predicate.IsAWindow()))
-
-		tabs = window.tabs()
-
-		# Set URL:
-		print window.urlEntry().extents
-		window.urlEntry().text = urlString
-		window.urlEntry().doAction('activate')
-
-		# This is in the final tab; return it:
-		return tabs[-1]
-
-class EpiphanyWindow(Window):
-	def __init__(self, node):
-		Window.__init__(self, node)
-		self.pageTabList = self.child(roleName='page tab list', debugName='Page Tab List')
-
-	def tabs(self):
-		"""
-		FIXME: not true: Get all tabs of this window as a list of EpiphanyTab instances
-		"""
-		return self.pageTabList.findChildren (predicate.GenericPredicate(roleName='page tab'), recursive=True)
-
-	def urlEntry(self):
-		"""
-		Get the text entry Node for entering URLs.
-		FIXME: this is currently something of a hack
-		"""
-		# FIXME: we hope that this gives us the correct text entry:
-		return self.child(roleName='text', debugName='URL Entry')
-
-#	 def newTab(self, url):
-		
-	
-#class EpiphanyTab(Node):
-#	 def __init__(self, node, window):
-#		 Node.__init__(self, node)
-#		 self.window = window

=== removed file 'dogtail/apps/wrappers/evolution.py'
--- dogtail/apps/wrappers/evolution.py	2006-08-01 22:59:27 +0000
+++ dogtail/apps/wrappers/evolution.py	1970-01-01 00:00:00 +0000
@@ -1,602 +0,0 @@
-"""Wrapper code to help when scripting Evolution
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.procedural import *
-from dogtail.utils import run
-from os import environ, path, remove
-
-from dogtail.distro import *
-from dogtail.version import Version
-
-from dogtail.apps.categories import *
-
-# Evolution folder browser (GtkTreeView?) seems to be implemented as a list of role='table cell' children (the rows), with each having a list of 'table cell' children (the table cells)
-# The table rows have NODE_CHILD_OF relations (with paths, in at-poke)
-# 
-
-# Use the gettext translations sniffed from the package db:
-import dogtail.i18n
-#dogtail.i18n.loadTranslationsFromPackageMoFiles('evolution')
-dogtail.i18n.loadTranslationsFromPackageMoFiles('evolution-connector')
-
-# App-specific wrapper classes:
-
-class EvolutionApp(Application, EmailClient):
-	"""
-	Useful test hooks for Evolution testcases
-	"""
-	def __init__(self):
-		Application.__init__(self, root.application("evolution"))
-
-		self.evoVersion = packageDb.getVersion("evolution")
-		print "Evolution version %s"%self.evoVersion
-
-		if self.evoVersion>=Version([1,5,0]):
-			self.edsVersion = packageDb.getVersion("evolution-data-server")
-			print "evolution-data-server version %s"%self.edsVersion
-		else:
-			self.edsVersion = None
-
-		# The name of the gtkhtml package(s) for the various versions of Evolution varies between distributions:
-		self.gtkhtmlVersion = None
-		if distro:
-			if isinstance(distro, RedHatOrFedora):
-				self.gtkhtmlPackageName = "gtkhtml3"
-			else:
-				raise "You need to implement appropriate logic here to get the name of the gtkhtml package for your distribution for this version of Evolution"
-			self.gtkhtmlVersion = packageDb.getVersion(self.gtkhtmlPackageName)
-			print "%s version %s"%(self.gtkhtmlPackageName, self.gtkhtmlVersion)
-
-	def getConfigMenuItem(self):
-		"""
-		Get the menu item that triggers the Settings/Preferences dialog,
-		handling version-specific differences
-		"""
-		if self.evoVersion<Version([2,1,0]):
-			return self.menu("Tools").menuItem("Settings...")
-		else:
-			return self.menu("Edit").menuItem("Preferences")
-
-	def doPasswordDialog(self, password, rememberPassword):
-		"""
-		Utility function for dealing with Evolution's password dialog.	It
-		finds the dialog, then fills in the password, setting the 'Remember
-		Password' checkbox accordingly. It then clicks on OK
-		"""
-		passwdDlg = self.child(roleName="alert", recursive=False, debugName="passwordDlg")
-		passwdDlg.child("Remember this password").setCheckbox = rememberPassword
-		passwdDlg.child(roleName="password text").passwordText = password
-		passwdDlg.child("OK").click()
-
-	def getSelectFolderDialog(self):
-		"""
-		Utility function to get the 'Select folder' dialog, wrapped
-		"""
-		return EvolutionSelectFolderDialog(self.dialog("Select folder"), self)
-
-#FIXME: generalize this to handle arbitrary error dialogs, and allow a non-fatal version where we check that an error that was meant to occur did occur?
-#FIXME: maybe allow installation of error detection hooks into the agent, and have it do it after every "action"??? (more complicated?)
-	def detectAuthFailure(self):
-		"""
-		Detect an 'Evolution Error' dialog, raising an exception if one is
-		found.	The text of the dialog is scraped into the exception.
-		"""
-		errorDlg = self.child("Evolution Error", recursive=False)
-		if errorDlg:
-			raise "AuthenticationError: %s"%errorDlg.child(roleName="label").text
-
-#FIXME: finish the import hooks
-
-	def __doImportFirstPage(self):
-		"""
-		Open the File->Import wizard and navigate to the second page
-		"""
-		self.menu("File").menuItem("Import...").click()
-		importAssistant = Wizard(self.child("Evolution Import Assistant", recursive=False), "Import Assistant")
-		importAssistant.clickForward()
-		return importAssistant
-
-	def __doImportFromOtherProgram(self):
-		importAssistant = self.__doImportFirstPage()
-		importAssistant.child("Import data and settings from older programs").click()
-		importAssistant.clickForward()
-		return importAssistant
-
-	def __doImportFromSingleFile(self, filename, filetype):
-		importAssistant = self.__doImportFirstPage()
-		importAssistant.child("Import a single file").click()
-		importAssistant.clickForward()
-
-		importAssistant.child(label="Filename:").child(roleName="text").text = filename
-		importAssistant.child(label="File type:").combovalue=filetype
-		importAssistant.clickForward()
-		
-		return importAssistant
-	
-	def importSingleEmail(self, filename, useSubfolder=False):
-		"""
-		Test hook to test importing a single email. Imports the email into a
-		local folder (either the local Inbox, or creates specially-purpose
-		subfolder inside the local Inbox), then views that email (and then
-		tests that Evolution is still running)
-
-		FIXME: not fully implemented yet
-		"""
-
-		# Tested on Evolution 2.0.4 and Evolution 2.4.0:
-		# FIXME: what's the _exact_ value for this version test?
-		if self.evoVersion>=Version([2,4.0]):
-			filetype = "Berkeley Mailbox (mbox)"
-		else:
-			filetype = "MBox (mbox)"
-	  
-		importAssistant = self.__doImportFromSingleFile(filename, filetype)
-
-		if useSubfolder:
-			# Unfortunately this doesn't yet have a labelling relationship (in evolution-data-server 1.4.0)
-			#importAssistant.child(label="Destination folder:").click()
-			# So we get it by its label:
-			importAssistant.child("Inbox").click()
-
-			selectFolderDlg = self.getSelectFolderDialog()
-			folderName = "test folder for %s"%agent.testRunId
-			selectFolderDlg.newInboxSubfolder(folderName)
-			# FIXME: the above can fail if the testrun ID contains characters that can't be a folder name
-		
-		importAssistant.clickForward()
-		importAssistant.child("Import").click()
-
-		# FIXME: now view it and see if we're still alive
-		# use PrintPreview as well
-
-	def __doIdentityPage(self, accountWiz, account):	
-		# "Identity" page:
-		accountWiz.child(label="Full Name:").text = account.fullName
-		accountWiz.child(label="Email Address:").text = account.emailAddress
-		accountWiz.child(label="Reply-To:").text = account.replyTo
-		accountWiz.child(label="Organization:").text = account.organisation
-		accountWiz.clickForward()
-
-	def __doReceivingEmailPage(self, accountWiz, account):	
-		# "Receiving Email" page:
-		accountWiz.child(label="Server Type: ").combovalue=account.getReceivingComboValue()
-
-		if isinstance(account, ExchangeAccount):
-			if self.evoVersion>Version([2,3,0]):
-				accountWiz.child(label="Username:").text = account.windowsUsername
-				accountWiz.child(label="OWA Url:").text = account.urlForOWA
-
-				# For Exchange, in Evolution 2.3 and later we have to click on the authenticate button to get further:
-				accountWiz.child("Authenticate").click()
-				self.doPasswordDialog(account.password, True)
-				self.detectAuthFailure()
-			else:
-				accountWiz.child(label="Exchange Server:").text = account.server
-				accountWiz.child(label="Windows Username:").text = account.windowsUsername
-				
-		elif isinstance(account,MixedAccount):
-			# In Evolution 2.0.4, server field is labelled "Host:", in Evolution 2.4.0 it is labelled "Server:"
-			# FIXME: check for other versions of Evolution; what is the _exact_ test here?
-			if self.evoVersion<Version([2,4,0]):
-				accountWiz.child(label="Host:").text = account.receiveMethod.server
-			else:
-				accountWiz.child(label="Server:").text = account.receiveMethod.server
-			accountWiz.child(label="Username:").text = account.receiveMethod.username
-			# FIXME: "Use secure Connection"
-			# FIXME: "Check for Supported Types"
-			# FIXME: "Remember password"
-		else:
-			raise NotImplementedError
-
-		accountWiz.clickForward()
-
-	def __doReceivingOptionsPage(self, accountWiz, account):	
-		# "Receiving Options" page:
-		# FIXME: implement
-		accountWiz.clickForward()
-
-	def __doSendingEmailPage(self, accountWiz, account):	
-		# "Sending Email" page:
-		# FIXME: this fails; it picks up on the "Server Type:" from the earlier page
-		# and hence can't find the value it wants in the combo. Should use the correct page for all of this...
-		sendingEmailPage = accountWiz.currentPage()
-		sendingEmailPage.child(label="Server Type: ").combovalue = account.getSendingComboValue()
-		print sendingEmailPage
-		if isinstance(account,MixedAccount):
-			if isinstance(account.sendMethod,SMTPSettings):
-				sendingEmailPage.child(label="Server:").text = account.sendMethod.server
-				# FIXME: "Server requires authentication"
-				# etc etc
-
-				# FIXME: is this visible? "SSL is not supported in this build of Evolution"
-		elif isinstance(account, ExchangeAccount):
-			# Nothing should need doing
-			pass
-		else:
-			raise NotImplementedError
-		accountWiz.clickForward()
-
-	def __doAccountManagementPage(self, accountWiz, accountName):	
-		# "Account Management" page:
-		accountWiz.child(label="Name:").text = accountName
-		accountWiz.clickForward()
-
-	def createAccount(self, account, accountName):
-		"""
-		Add a new account, running the Evolution Account Assistant, filling in
-		the values given.
-		"""
-		
-		self.getConfigMenuItem().click()
-		settingsDlg = self.child("Evolution Settings", recursive=False)
-		#pageTabs = settingsDlg.child(roleName="page tab list")
-		# page tabs don't seem to be labelled in the tree... how do we get at this?
-
-		# for now, assume Mail Accounts tab is selected..
-		# Account wizard takes a while to appear...
-		settingsDlg.child("Add").click()
-		# this one needs a watch, I guess
-
-		accountWiz = Wizard(self.child("Evolution Account Assistant", recursive=False),"Evolution Account Assistant")
-		accountWiz.clickForward()
-
-		self.__doIdentityPage(accountWiz, account)
-		self.__doReceivingEmailPage(accountWiz, account)
-		self.__doReceivingOptionsPage(accountWiz, account)
-		self.__doSendingEmailPage(accountWiz, account)
-		self.__doAccountManagementPage(accountWiz, accountName)
-
-		# "Done" page:
-		accountWiz.child("Apply").click()
-
-		# FIXME: we should add a review stage where we check that all widgets have the correct settings. (But why should that even be necessary? Can our framework implement that on the script's behalf? perhaps with a UITransaction class or somesuch?)
-
-	def doFirstTimeWizard(self, account, accountName, timezoneName):
-		setupWiz = Wizard(self.window('Evolution Setup Assistant'))
-		setupWiz.clickForward()
-
-		self.__doIdentityPage(setupWiz, account)
-		self.__doReceivingEmailPage(setupWiz, account)
-		self.__doReceivingOptionsPage(setupWiz, account)
-		self.__doSendingEmailPage(setupWiz, account)
-		self.__doAccountManagementPage(setupWiz, accountName)
-		
-		# Timezone page:
-		# FIXME: timezone selection doesn't yet work
-		#self.child("TimeZone Combobox").child(timezoneName).click()
-		setupWiz.clickForward()
-
-		# "Done" page:
-		setupWiz.child("Apply").click()
-		
-	def composeEmail(self):
-		"""
-		Utility function to start composing a new email.
-
-		Returns a Composer instance wrapping the new email composer window.
-		"""
-		self.menu("File").child("Mail Message").click()
-		composer = self.window("Compose a message")
-		return Composer(composer)
-		
-	def createMeeting(self):
-		"""
-		Utility function to start creating a new meeting.
-
-		Returns a MeetingWindow instance wrapping the new meeting window.
-		"""
-		self.menu("File").child("Meeting").click()
-		meetingWin = self.dialog("Meeting - No summary")
-		return MeetingWindow(meetingWin)
-		
-
-class Composer(Window):
-	"""
-	Subclass of Window wrapping an Evolution email composer, with utility functions
-	"""
-
-	def __init__(self, node):
-		Window.__init__(self, node)
-
-		#FIXME: doesn't seem to be accessible on FC3 with evolution-2.0.4/gtkhtml3-3.3.2
-		gtkhtmlPanel = self.child(name="Panel containing HTML", roleName="panel")
-		gtkhtmlPanel.debugName="GTKHtml panel"
-		self.htmlNode = gtkhtmlPanel.child(roleName="text")
-
-	def __setattr__(self, name, value):
-		if name=="to":
-			# Set the To: ("addressee" if you're feeling fancy) of the email:
-			self.textentry("To:").text = value
-		elif name=="subject":
-			# Set the subject of the email:
-			self.child(label="Subject:").text = value
-		elif name=="body":
-			# Set the body text of the email:
-			self.htmlNode.text = value
-		else:
-			# otherwise, use normal Python attribute-handling:
-			self.__dict__[name]=value
-
-	def setHtml(self, htmlFlag):
-		if not htmlFlag:
-			raise NotImplementedError
-	
-		# Set to HTML
-		formatMenu = self.menu("Format")
-		formatMenu.menuItem("HTML").click()
-
-	def setHeader(self, level):
-		"""
-		Set the text type to 'Heading 1-6'
-		"""
-		formatMenu = self.menu("Format")
-		headingMenu = formatMenu.menu("Heading")
-		headingMenu.menuItem("Header %s"% level).click()
-
-	def setBulletedList(self):
-		"""
-		Sets the text style to be 'Bulleted List'
-		"""
-		formatMenu = self.menu("Format")
-		headingMenu = formatMenu.menu("Heading")
-		headingMenu.menuItem("Bulleted List").click()
-
-	def typeText(self, text):
-		self.htmlNode.typeText(text)
-
-	def send(self):
-		"""
-		Clicks on the Send menu item to send this email.  Use with caution!
-		"""
-		self.menuItem("Send").click()
-
-	def testUndoRedo(self):
-		"""
-		Repeatedly does an 'Undo' until everything is undone, then does a 'Redo'
-		that many times, and checks that the content is the same.
-
-		Unfortunately, this doesn't work; Undo is always sensitive, even when
-		there's nothing to undo:
-		http://bugzilla.gnome.org/show_bug.cgi?id=257214
-		"""
-		numUndos = 0
-		undo = self.menuItem("Undo")
-		redo = self.menuItem("Redo")
-
-		originalText = self.htmlNode.text
-		
-		while undo.sensitive:
-			undo.click()
-			numUndos+=1
-
-		# Now redo it:
-		for i in range(numUndos):
-			redo.click()
-
-		newText = self.htmlNode.text
-
-		if newText!=originalText:
-			raise UndoRedoException(originalText, newText)
-
-class UndoRedoException(Exception):
-	def __init__(self, originalValue, newValue):
-		self.originalValue = originalValue
-		self.newValue = newValue
-
-	def __str__(self):
-		return "Original value %s not equal to new value %s"%(originalValue, newValue)
-
-class AppointmentWindow(Window):
-	"""
-	Subclass of Window wrapping an Evolution appointment window, with utility functions
-	"""
-	def __init__(self, node):
-		Window.__init__(self, node)
-
-	def __setattr__(self, name, value):
-		if name=="summary":
-			self.tab("Appointment").child(label="Summary:").text = value
-		else:
-			# otherwise, use normal Python attribute-handling:
-			self.__dict__[name]=value
-
-class MeetingWindow(AppointmentWindow):
-	"""
-	Subclass of AppointmentWindow wrapping an Evolution meeting window, with utility functions
-	"""
-	def __init__(self, node):
-		AppointmentWindow.__init__(self, node)
-		self.invitationsTab = self.tab("Invitations")
-		self.attendeeTable = self.invitationsTab.child(roleName='table')
-		
-	def addAttendee(self, attendee, attendeeType, role, rsvp, status):
-		"""
-		Add an attendeee to this meeting. Doesn't fully work yet.
-		"""
-		self.invitationsTab.button('Add').click()
-
-class SelectFolderDialog(Window):
-	"""
-	Subclass of Window wrapping an Evolution 'Select Folder' dialog, with
-	utility functions
-	"""
-
-	def __init__(self, node, evoApp):
-		Window.__init__(self, node)
-		self.evoApp = evoApp
-
-	def newInboxSubfolder(self, name):
-		self.child("New").click()
-		createFolderDlg = self.evoApp.dialog("Create folder")
-		createFolderDlg.child(label="Folder name:").text = name
-
-		tree = self.child("Mail Folder Tree")
-		tableCell = "On This Computer"
-		"Inbox"
-		# FIXME: need implement table stuff for this...
-		#"On This Computer" / "Inbox"
-		
-		# FIXME: select parent folder
-		createFolderDlg.child("Create").click()
-		# this is only clickable if we have a sane folder name and a selected parent
-
-		# FIXME: now need to select the new folder in the Select Folder dialog
-
-		# FIXME: finally, should click on OK (or should the caller do this?)
-
-class Account:
-	"""
-	Base class for an Evolution account, for use when creating test accounts
-	"""
-	def __init__(self, fullName, emailAddress, replyTo="", organisation="", password=""):
-		self.fullName = fullName
-		self.emailAddress = emailAddress
-		self.replyTo = replyTo
-		self.organisation = organisation
-		self.password = password
-
-	def getReceivingComboValue(self):
-		raise NotImplementedError
-
-	def getSendingComboValue(self):
-		raise NotImplementedError
-
-class UseSecureConnection:
-	NEVER, WHENEVER, ALWAYS = ("NEVER", "WHENEVER", "ALWAYS")
-
-class ExchangeAccount(Account):
-	"""
-	Subclass of Account representing an Exchange account
-	"""
-	def __init__(self, fullName, emailAddress, windowsUsername, server="", urlForOWA="", replyTo="", organisation="", password=""):
-		Account.__init__(self, fullName, emailAddress, replyTo, organisation, password)
-		self.windowsUsername = windowsUsername
-		self.server = server
-		self.urlForOWA = urlForOWA
-
-	def getReceivingComboValue(self):
-		return "Microsoft Exchange"
-
-	def getSendingComboValue(self):
-		return "Microsoft Exchange"
-
-class MixedAccount(Account):
-	"""
-	Subclass of Account representing a combination of a receiving method and a
-	sending method
-	"""
-	def __init__(self, fullName, emailAddress, receiveMethod, sendMethod, replyTo="", organisation="", ):
-		Account.__init__(self, fullName, emailAddress, replyTo, organisation, password="")
-		assert isinstance(receiveMethod, ReceiveSettings)
-		assert isinstance(sendMethod, SendSettings)
-		self.receiveMethod = receiveMethod
-		self.sendMethod = sendMethod		
-
-	def getReceivingComboValue(self):
-		return self.receiveMethod.getServerTypeComboValue()
-
-	def getSendingComboValue(self):
-		return self.sendMethod.getServerTypeComboValue()
-
-class ReceiveSettings:
-	def getServerTypeComboValue(self):
-		raise NotImplementedError
-	
-class SendSettings:
-	def getServerTypeComboValue(self):
-		raise NotImplementedError
-
-class IMAPSettings(ReceiveSettings):
-	def __init__(self, server, username, useSecureConnection, authenticationType, rememberPassword=False):
-		self.server = server
-		self.username = username
-		self.useSecureConnection = useSecureConnection
-		self.authenticationType = authenticationType
-		self.rememberPassword = rememberPassword
-
-	def getServerTypeComboValue(self):
-		return "IMAP"
-
-class SMTPSettings(SendSettings):
-	def __init__(self, server, useSecureConnection, authenticationType="plain", requireAuth=False, username="", rememberPassword=False):
-		self.server = server
-		self.username = username
-		self.useSecureConnection = useSecureConnection
-		self.authenticationType = authenticationType
-		self.rememberPassword = rememberPassword
-		self.requireAuth = requireAuth
-
-	def getServerTypeComboValue(self):
-		return "SMTP"
-
-class SendmailSettings(SendSettings):
-	def getServerTypeComboValue(self):
-		return "Sendmail"
-
-class ReceiptOptions:
-	"""
-	Class containing the options found on the 'Receiving Email' page of the
-	configuration dialogs.
-	"""
-	def __init__(self, autocheckOn=False, autocheckInterval=10, customConnectionCommand=None, showOnlySubscribedFolders=False, overrideNamespace=None, applyFiltersToNewInInbox=False, checkNewForJunk=False, onlyCheckForJunkInInbox=False, autosyncRemoteMailLocally=False):
-		raise NotImplementedError
-
-def TestFocus():
-	focus.application("evolution")
-	focus.menu("File")
-	click("Import...")
-	focus.application("evolution")
-	focus.dialog("Evolution Import Assistant")
-	click("Forward") # grrr... selects the Forward menu item, rather than the Forward button
-
-def blowAwayEvolution():
-	"""
-	Helper function for testing Evolution.
-
-	Use with caution.
-
-	This forcibly shuts down evolution, then blows away all Evolution settings.
-	(FIXME: first copy the GConf data first to ./evolution-gconf-backup.xml ???)	
-	"""
-	os.system ('evolution --force-shutdown')
-	sleep(5)
-	os.system ('gconftool-2 --recursive-unset /apps/evolution')
-
-
-def doFirstTimeWizard(account, accountName, timezoneName):
-	"""
-	Helper function for testing Evolution.
-
-	Use with caution.
-
-	This forcibly shuts down evolution, then blows away all Evolution settings.
-	(FIXME: first copy the GConf data first to ./evolution-gconf-backup.xml ???)
-
-	It then runs the first time wizard with the given settings.
-
-	Returns an EvolutionApp instance.
-	"""
-	blowAwayEvolution()
-	
-	run('evolution')
-	evo = EvolutionApp()
-	evo.doFirstTimeWizard(account, accountName, timezoneName)
-
-	return evo
-	
-def setBogusGConfAccountData():
-	"""
-	Helper function for testing Evolution.
-
-	Use with caution.
-	
-	This writes totally bogus account data into the GConf key 
-	"/apps/evolution/mail/accounts", in order to hack past the first-time
-	wizard.
-	"""
-	os.system('gconftool-2 --type list --list-type=string --set /apps/evolution/mail/accounts ["This is bogus data that is not even an attempt at well-formed XML"]')
-

=== removed file 'dogtail/apps/wrappers/gcalctool.py'
--- dogtail/apps/wrappers/gcalctool.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/gcalctool.py	1970-01-01 00:00:00 +0000
@@ -1,37 +0,0 @@
-import dogtail.tree
-
-class GCalcTool(dogtail.tree.Application):
-	def clickNumeral(self, num):
-		self.button('Numeric %s'%num).click()	
-	
-	def typeNumber(self, num, base):
-		digits = []
-		while num>0:
-			digit = num%base
-			digits.insert(0, digit)
-			num = num/base
-		if len(digits)==0:
-			digits=[0]
-		# print digits
-		for digit in digits:
-			self.clickNumeral(digit)
-		
-	def clearEntry(self):
-		self.button('Clear entry').click()
-
-	def doBinaryInfixOp(self, a, b, button):
-		self.clearEntry()
-		self.typeNumber(a, 10)
-		self.button(button).click()
-		self.typeNumber(b, 10)
-		self.button('Calculate result').click()
-		return self.getText()
-
-	def doSum(self, a, b):
-		return self.doBinaryInfixOp(a, b, 'Add')
-
-	def doProduct(self, a, b):
-		return self.doBinaryInfixOp(a, b, 'Multiply')
-		
-	def getText(self):
-		return self.child(roleName='edit bar').text

=== removed file 'dogtail/apps/wrappers/gedit.py'
--- dogtail/apps/wrappers/gedit.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/gedit.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-import dogtail.tree
-
-class Gedit(dogtail.tree.Application):
-	def setText(self, text):
-		buf = self.child(roleName = 'text')
-		buf.text = text
-
-	def getText(self):
-		return self.child(roleName='text').text
-
-	def openLocation(self, uri):
-		menuItem = self.menu("File").menuItem("Open Location...")
-		menuItem.click()
-		dlg = self.dialog('Open Location')
-		dlg.child(roleName = 'text').text = uri
-		dlg.button('Open').click()
-
-	def saveAs(self, uri):
-		menuItem = self.menu("File").menuItem("Save As...")
-		menuItem.click()
-		dlg = self.dialog('Save As...')
-		dlg.child(roleName = 'text').text = uri
-		dlg.button('Save').click()
-
-	def printPreview(self):
-		menuItem = self.menu("File").menuItem("Print Preview")
-		menuItem.click()
-

=== removed file 'dogtail/apps/wrappers/gnomepanel.py'
--- dogtail/apps/wrappers/gnomepanel.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/gnomepanel.py	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-"""Wrapper code to help when scripting gnome-panel
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import packageDb
-from dogtail.apps.categories import *
-from dogtail.version import Version
-
-class GnomePanel(Application, DesktopPanel):
-	"""Useful test hooks for GNOME panel testcases"""
-	def __init__(self):
-		Application.__init__(self, root.application("gnome-panel"))
-
-		self.version = packageDb.getVersion("gnome-panel")
-		
-		print "gnome-panel version %s"%self.version
-
-	def getApplicationsMenu(self):
-		if self.version>=Version([2,10.0]):
-			# this works on FC5:
-			return self.child(name = 'Applications', roleName = 'menu', recursive=True, debugName="Applications menu")
-		else:
-			# this makes it work on FC3:
-			# assume that the first menu we find is the main menu:
-			return self.findChild(predicate.GenericPredicate(roleName="menu"), recursive=True, debugName="Applications menu")
-
-	def applications(self):
-		"""Generator of MenuItem for all menuitems representing applications under the Applications menu."""
-		appMenu = self.getApplicationsMenu()
-
-		return appMenu.findChildren(predicate.GenericPredicate(roleName="menu item"), recursive=True)
-

=== removed file 'dogtail/apps/wrappers/kicker.py'
--- dogtail/apps/wrappers/kicker.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/kicker.py	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-"""Wrapper code to help when scripting Kicker, the KDE panel
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import packageDb
-from dogtail.apps.categories import *
-
-class Kicker(ApplicationRef, DesktopPanel):
-		"""Utility wrapper for Kicker, the KDE panel; implements the DesktopPanel mixin interface"""
-

=== removed file 'dogtail/apps/wrappers/konqueror.py'
--- dogtail/apps/wrappers/konqueror.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/konqueror.py	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-"""Wrapper code to help when scripting Konqueror
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import packageDb
-from dogtail.apps.categories import *
-
-class KonquerorApp(ApplicationRef, FileBrowser, WebBrowser):
-	"""Utility wrapper for Konqueror; implements the FileBrowser and WebBrowser mixin interfaces"""
-

=== removed file 'dogtail/apps/wrappers/mozilla.py'
--- dogtail/apps/wrappers/mozilla.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/mozilla.py	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-"""Wrapper code to help when scripting Mozilla apps
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import packageDb
-from dogtail.apps.categories import *
-
-class MozillaApp(Application):
-	"""Useful test hooks for mozilla application testcases (Firefox, Thunderbird)"""
-	def __init__(self):
-		Application.__init__(self, root.application("mozilla"))
-
-		self.version = packageDb.getVersion("firefox")
-		print "Firefox version %s"%self.version
-
-class FirefoxApp(MozillaApp, WebBrowser):
-	"""Utility wrapper for Firefox; implements the Webbrowser mixin interface"""
-
-class ThunderbirdApp(MozillaApp, EmailClient):
-	"""Utility wrapper for Thunderbird; implements the EmailClient mixin interface"""

=== removed file 'dogtail/apps/wrappers/nautilus.py'
--- dogtail/apps/wrappers/nautilus.py	2006-08-01 22:59:27 +0000
+++ dogtail/apps/wrappers/nautilus.py	1970-01-01 00:00:00 +0000
@@ -1,48 +0,0 @@
-"""Wrapper code to help when scripting Nautilus
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import packageDb
-from dogtail.apps.categories import *
-
-import os
-
-class IsAnIcon(predicate.Predicate):
-	"""Search subclass that looks for icons"""
-	def satisfiedByNode(self, node):
-		return node.roleName=='icon'
-
-	def describeSearchResult(self):
-		return 'icon'
-
-class NautilusApp(Application, FileBrowser):
-	"""Utility wrapper for Nautilus; implements the FileBrowser mixin interface"""
-
-	def __init__ (self):
-		Application.__init__(self, root.application("nautilus"))
-
-		self.nautiVersion = packageDb.getVersion("nautilus")
-		print "Nautilus version %s"%self.nautiVersion
-
-		try:
-			self.gnomevfsVersion = packageDb.getVersion("gnome-vfs2")
-			print "GnomeVFS version %s"%self.gnomevfsVersion
-		except: pass # handle undetected gnomevfs version; probably named differently on different distros
-
-	def openPath (self, path):
-		"""
-		Open a Nautilus spatial window for the given path (not a URL).
-
-		Returns a Window instance
-		"""
-		os.system('nautilus %s'%os.path.abspath(path))
-
-		return NautilusWindow(self.window(windowName=os.path.basename(path)))
-
-class NautilusWindow(Window):
-	def iconView (self):
-		return self.child("Content View").child("Icon View")
-

=== removed file 'dogtail/apps/wrappers/yelp.py'
--- dogtail/apps/wrappers/yelp.py	2006-02-22 12:31:33 +0000
+++ dogtail/apps/wrappers/yelp.py	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-"""Wrapper code to help when scripting yelp
-
-Author: David Malcolm <dmalcolm@redhat.com>"""
-
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-from dogtail.tree import *
-from dogtail.distro import packageDb
-from dogtail.apps.categories import *
-from dogtail.version import Version
-
-class YelpApp(Application):
-	def __init__(self):
-		Application.__init__(self, root.application("gnome-help"))
-
-		self.version = packageDb.getVersion("yelp")
-		
-		print "yelp version %s"%self.version
-	
-	def checkError(self):
-		"""
-		Look for error dialogs, raising an error if one is found.
-		"""
-		errorDlg = self.findChild(predicate.GenericPredicate(name="Error", roleName="alert"), requireResult=False)
-		if errorDlg!=None:
-			msg = ""
-			for text in errorDlg.findChildren(predicate.GenericPredicate(roleName='label')):
-				msg += text.text
-			raise msg
-	
-	def window(self):
-		"""
-		Find a window of the app
-		"""
-		return self.findChild(predicate.GenericPredicate(roleName="frame"))
-
-	def ensureLoadingComplete(self):
-		"""
-		Wait for yelp to stop having "Loading..." as a title
-		"""
-		window = self.window()
-
-		numWaits = 0
-		
-		# FIXME: i18n issues!
-		while window.name =='Loading...':
-			sleep(5)
-			if ++numWaits > 20:
-				raise "Yelp took too long to open help"
-		
-				
-def checkAppHelp(app):
-	"""
-	Click on Help->Contents and check that help comes up properly.
-	"""
-	app.menu('Help').menuItem('Contents').click()
-
-	yelp = YelpApp()
-	yelp.ensureLoadingComplete()
-	yelp.checkError()

=== modified file 'dogtail/config.py'
--- dogtail/config.py	2006-02-22 12:31:33 +0000
+++ dogtail/config.py	2006-12-16 10:57:30 +0000
@@ -1,4 +1,3 @@
-#!/usr/bin/env python
 """
 The configuration module.
 """
@@ -9,188 +8,256 @@
 import locale
 
 def _scriptName():
-	return os.path.basename(sys.argv[0]).replace('.py','')
+    return os.path.basename(sys.argv[0]).replace('.py','')
 
 def _encoding():
-	return locale.getpreferredencoding().lower()
+    return locale.getpreferredencoding().lower()
 
 class _Config(object):
-	"""
-	Contains configuration parameters for the dogtail run.
-
-	ensureSensitivity (boolean):
-	Should we check that ui nodes are sensitive (not 'greyed out') before
-	performing actions on them? If this is True (the default) it will raise
-	an exception if this happens. Can set to False as a workaround for apps
-	and toolkits that don't report sensitivity properly.
-
-	searchBackoffDuration (float):
-	Time in seconds for which to delay when a search fails.
-
-	searchWarningThreshold (int):
-	Number of retries before logging the individual attempts at a search.
-
-	searchCutoffCount (int):
-	Number of times to retry when a search fails.
-	
-	debugSearching (boolean):
-	Whether to write info on search backoff and retry to the debug log.
-	
-	debugSleep (boolean):
-	Whether to log whenever we sleep to the debug log.
-	
-	defaultDelay (float):
-	Default time in seconds to sleep when delaying.
-	
-	absoluteNodePaths (boolean):
-	Whether we should identify nodes in the logs with long 'abcolute paths', or
-	merely with a short 'relative path'. FIXME: give examples
-	
-	debugSearchPaths (boolean):
-	Whether we should write out debug info when running the SearchPath
-	routines.
-	
-	debugTranslation (boolean):
-	Whether we should write out debug information from the translation/i18n
-	subsystem.
-
-	blinkOnActions (boolean):
-	Whether we should blink a rectangle around a Node when an action is 
-	performed on it.
-	"""
-	__scriptName = staticmethod(_scriptName)
-	__encoding = staticmethod(_encoding)
-	
-	defaults = {
-		# Storage
-		'scratchDir' : '/tmp/dogtail/',
-		'dataDir' : '/tmp/dogtail/data/',
-		'logDir' : '/tmp/dogtail/logs/',
-		'scriptName' : _scriptName(),
-		'encoding' : _encoding(),
-		'configFile' : None,
-		'baseFile' : None,
-		
-		# Timing
-		'actionDelay' : 1.0,
-		'runInterval' : 0.5,
-		'runTimeout' : 30,
-		'searchBackoffDuration' : 0.5,
-		'searchWarningThreshold' : 3,
-		'searchCutoffCount' : 20,
-		'defaultDelay' : 0.5,
-
-		# Debug
-		'debugSearching' : False,
-		'debugSleep' : False,
-		'debugSearchPaths' : False,
-		'absoluteNodePaths' : False,
-		'ensureSensitivity' : False,
-		'debugTranslation' : False,
-		'blinkOnActions' : False
-	}
-	
-	options = {}
-	
-	invalidValue = "__INVALID__"
-
-	def __init__(self):
-		scriptName = _scriptName()
-		encoding = _encoding()
-		_Config.__createDir(_Config.defaults['scratchDir'])
-		_Config.__createDir(_Config.defaults['logDir'])
-		_Config.__createDir(_Config.defaults['dataDir'])
-
-	def __setattr__(self, name, value):
-		try:
-			if _Config.defaults[name] != value or _Config.options.get(name, _Config.invalidValue) != value:
-				if "Dir" in name: _Config.__createDir(value)
-				_Config.options[name] = value
-		except KeyError: raise KeyError, name + " is not a valid option."
-	
-	def __getattr__(self, name):
-		try: return _Config.options[name]
-		except KeyError:
-			try: return _Config.defaults[name]
-			except KeyError: raise KeyError, name + " is not a valid option."
-
-	def __createDir(cls, dirName):
-		"""
-		Creates a directory (if it doesn't currently exist), creating any parent directories it needs.
-		"""
-		dirName = os.path.abspath(dirName)
-		#print "Checking for %s ..." % dirName,
-		if not os.path.isdir(dirName): 
-			#print "Not found."
-			parentDirName = os.path.sep + os.path.sep.join(os.path.split(dirName + os.path.sep)[0].split(os.path.sep)[1:-1])
-			#print "Checking for parent %s ..." % parentDirName,
-			if not os.path.isdir(parentDirName): 
-				#print "Not found."
-				#print "Parent %s ..." % parentDirName
-				_Config.__createDir(parentDirName)
-				print "Creating %s ..." % dirName
-				os.mkdir(dirName)
-			else:
-				#print "Found."
-				print "Creating %s ..." % dirName
-				os.mkdir(dirName)
-		#else: print "Found."
-	__createDir = classmethod(__createDir)
-	
-	def load(self, dict):
-		"""
-		Loads values from dict, preserving any options already set that are not overridden.
-		"""
-		_Config.options.update(dict)
-	
-	def	reset(self):
-		"""
-		Resets all settings to their defaults.
-		"""
-		_Config.options = {}
+    """
+    Contains configuration parameters for the dogtail run.
+
+    scratchDir(str):
+    Directory where things like screenshots are stored.
+
+    dataDir(str):
+    Directory where related data files are located.
+
+    logDir(str):
+    Directory where dogtail.tc.TC*-generated logs are stored.
+
+    scriptName(str) [Read-Only]:
+    The name of the script being run.
+    
+    encoding(str)
+    The encoding for text, used by dogtail.tc.TCString .
+
+    actionDelay(float):
+    The delay after an action is executed.
+
+    typingDelay(float):
+    The delay after a character is typed on the keyboard.
+
+    runInterval(float):
+    The interval at which dogtail.utils.run() and dogtail.procedural.run() 
+    check to see if the application has started up.
+
+    runTimeout(int):
+    The timeout after which dogtail.utils.run() and dogtail.procedural.run()
+    give up on looking for the newly-started application.
+    
+    searchBackoffDuration (float):
+    Time in seconds for which to delay when a search fails.
+
+    searchWarningThreshold (int):
+    Number of retries before logging the individual attempts at a search.
+
+    searchCutoffCount (int):
+    Number of times to retry when a search fails.
+
+    defaultDelay (float):
+    Default time in seconds to sleep when delaying.
+
+    debugSearching (boolean):
+    Whether to write info on search backoff and retry to the debug log.
+
+    debugSleep (boolean):
+    Whether to log whenever we sleep to the debug log.
+
+    debugSearchPaths (boolean):
+    Whether we should write out debug info when running the SearchPath
+    routines.
+
+    absoluteNodePaths (boolean):
+    Whether we should identify nodes in the logs with long 'abcolute paths', or
+    merely with a short 'relative path'. FIXME: give examples
+
+    ensureSensitivity (boolean):
+    Should we check that ui nodes are sensitive (not 'greyed out') before
+    performing actions on them? If this is True (the default) it will raise
+    an exception if this happens. Can set to False as a workaround for apps
+    and toolkits that don't report sensitivity properly.
+
+    debugTranslation (boolean):
+    Whether we should write out debug information from the translation/i18n
+    subsystem.
+
+    blinkOnActions (boolean):
+    Whether we should blink a rectangle around a Node when an action is
+    performed on it.
+
+    fatalErrors (boolean):
+    Whether errors encountered in dogtail.procedural should be considered
+    fatal. If True, exceptions will be raised. If False, warnings will be 
+    passed to the debug logger.
+
+    useIconLogger (boolean):
+    Whether we should place an icon in the notification area and print debug
+    messages to it.
+
+    logDebugToFile (boolean):
+    Whether to write debug output to a log file.
+    """
+    __scriptName = staticmethod(_scriptName)
+    __encoding = staticmethod(_encoding)
+
+    defaults = {
+            # Storage
+            'scratchDir' : '/tmp/dogtail/',
+            'dataDir' : '/tmp/dogtail/data/',
+            'logDir' : '/tmp/dogtail/logs/',
+            'scriptName' : _scriptName(),
+            'encoding' : _encoding(),
+            'configFile' : None,
+            'baseFile' : None,
+
+            # Timing
+            'actionDelay' : 1.0,
+            'typingDelay' : 0.075,
+            'runInterval' : 0.5,
+            'runTimeout' : 30,
+            'searchBackoffDuration' : 0.5,
+            'searchWarningThreshold' : 3,
+            'searchCutoffCount' : 20,
+            'defaultDelay' : 0.5,
+
+            # Debug
+            'debugSearching' : False,
+            'debugSleep' : False,
+            'debugSearchPaths' : False,
+            'absoluteNodePaths' : False,
+            'ensureSensitivity' : False,
+            'debugTranslation' : False,
+            'blinkOnActions' : False,
+            'fatalErrors' : False,
+
+            # Logging
+            'useIconLogger' : False,
+            'logDebugToFile' : True
+    }
+
+    options = {}
+
+    invalidValue = "__INVALID__"
+
+    def __init__(self):
+        scriptName = _scriptName()
+        encoding = _encoding()
+        _Config.__createDir(_Config.defaults['scratchDir'])
+        _Config.__createDir(_Config.defaults['logDir'])
+        _Config.__createDir(_Config.defaults['dataDir'])
+
+    def __setattr__(self, name, value):
+        if not config.defaults.has_key(name):
+            raise AttributeError, name + " is not a valid option."
+
+        elif _Config.defaults[name] != value or \
+                _Config.options.get(name, _Config.invalidValue) != value:
+            if 'Dir' in name:
+                _Config.__createDir(value)
+                if value[-1] != '/': value = value + '/'
+            elif name == 'useIconLogger':
+                import logging
+                if value == True:
+                    logging.Logger.iconLogger = logging.IconLogger()
+                elif value == False:
+                    del logging.Logger.iconLogger
+                    logging.Logger.iconLogger = None
+                else: raise ValueError, value
+            _Config.options[name] = value
+
+    def __getattr__(self, name):
+        try: return _Config.options[name]
+        except KeyError:
+            try: return _Config.defaults[name]
+            except KeyError: raise AttributeError, name + " is not a valid option."
+
+    def __createDir(cls, dirName):
+        """
+        Creates a directory (if it doesn't currently exist), creating any parent directories it needs.
+        """
+        dirName = os.path.abspath(dirName)
+        #print "Checking for %s ..." % dirName,
+        if not os.path.isdir(dirName):
+            #print "Not found."
+            parentDirName = os.path.sep + os.path.sep.join(os.path.split(dirName + os.path.sep)[0].split(os.path.sep)[1:-1])
+            #print "Checking for parent %s ..." % parentDirName,
+            if not os.path.isdir(parentDirName):
+                #print "Not found."
+                #print "Parent %s ..." % parentDirName
+                _Config.__createDir(parentDirName)
+                print "Creating %s ..." % dirName
+                os.mkdir(dirName)
+            else:
+                #print "Found."
+                print "Creating %s ..." % dirName
+                os.mkdir(dirName)
+        #else: print "Found."
+    __createDir = classmethod(__createDir)
+
+    def load(self, dict):
+        """
+        Loads values from dict, preserving any options already set that are not overridden.
+        """
+        _Config.options.update(dict)
+
+    def     reset(self):
+        """
+        Resets all settings to their defaults.
+        """
+        _Config.options = {}
 
 
 config = _Config()
 
 if __name__ == '__main__':
-	anyFailed = False
-	def failOrPass(failure, description):
-		if failure: 
-			anyFailed = True
-			print "FAILED: " + description
-		else: print "PASSED: " + description
-	
-	# BEGIN tests
-	
-	failure = True
-	for option in config.defaults.keys():
-		#print failure, getattr(config, option), config.defaults[option]
-		failure = not failure and ( getattr(config, option) == config.defaults[option])
-	failOrPass(failure, "Reading all default values")
-	
-	failure = True
-	failure = config.ensureSensitivity != True
-	config.ensureSensitivity = False
-	failure = failure or config.ensureSensitivity == True
-	config.ensureSensitivity = True
-	failure = failure or config.ensureSensitivity != True
-	failOrPass(failure, "Setting ensureSensitivity")
-
-	failure = True
-	failure = not os.path.isdir(config.defaults['scratchDir'])
-	failure = failure or not os.path.isdir(config.defaults['logDir'])
-	failure = failure or not os.path.isdir(config.defaults['dataDir'])
-	failOrPass(failure, "Looking for default directories")
-
-	failure = True
-	config.scratchDir = '/tmp/dt'
-	failure = not os.path.isdir('/tmp/dt')
-	config.logDir = '/tmp/dt_log/'
-	failure = failure or not os.path.isdir('/tmp/dt_log/')
-	config.dataDir = '/tmp/dt_data'
-	failure = failure or not os.path.isdir('/tmp/dt_data')
-	failOrPass(failure, "Changing default directories")
-
-	# END tests
-	
-	if anyFailed: sys.exit(1)
+    anyFailed = False
+    def failOrPass(failure, description):
+        if failure:
+            anyFailed = True
+            print "FAILED: " + description
+        else: print "PASSED: " + description
+
+    # BEGIN tests
+
+    failure = True
+    for option in config.defaults.keys():
+        #print failure, getattr(config, option), config.defaults[option]
+        failure = not failure and ( getattr(config, option) == config.defaults[option])
+    failOrPass(failure, "Reading all default values")
+
+    failure = True
+    failure = config.ensureSensitivity != config.defaults['ensureSensitivity']
+    config.ensureSensitivity = False
+    failure = failure or config.ensureSensitivity == True
+    config.ensureSensitivity = True
+    failure = failure or config.ensureSensitivity != True
+    failOrPass(failure, "Setting ensureSensitivity")
+
+    failure = True
+    failure = not os.path.isdir(config.defaults['scratchDir'])
+    failure = failure or not os.path.isdir(config.defaults['logDir'])
+    failure = failure or not os.path.isdir(config.defaults['dataDir'])
+    failOrPass(failure, "Looking for default directories")
+
+    failure = True
+    config.scratchDir = '/tmp/dt'
+    failure = not os.path.isdir('/tmp/dt')
+    config.logDir = '/tmp/dt_log/'
+    failure = failure or not os.path.isdir('/tmp/dt_log/')
+    config.dataDir = '/tmp/dt_data'
+    failure = failure or not os.path.isdir('/tmp/dt_data')
+    failOrPass(failure, "Changing default directories")
+
+    failure = True
+    config.useIconLogger = True
+    import logging
+    try:
+        if isinstance(logging.debugLogger.iconLogger, logging.IconLogger):
+            failure = False
+    except AttributeError: pass
+    failOrPass(failure, "Setting useIconLogger")
+
+    # END tests
+
+    if anyFailed: sys.exit(1)

=== modified file 'dogtail/distro.py'
--- dogtail/distro.py	2006-08-01 22:59:27 +0000
+++ dogtail/distro.py	2006-12-21 13:33:47 +0000
@@ -4,310 +4,333 @@
 __author__ = "Dave Malcolm <dmalcolm@redhat.com>, Zack Cerza <zcerza@redhat.com>"
 
 import os
+import re
 from version import Version
-
+from logging import debugLogger as logger
 
 class DistributionNotSupportedError(Exception):
-	"""
-	This distribution is not supported.
-
-	Arguments:
-		distro: the distribution that is not supported.
-	"""
-	PATCH_MESSAGE = "Please send patches to dogtail-devel-list@gnome.org"
-
-	def __init__(self, distro):
-		self.distro = distro
-
-	def __str__(self):
-		return self.distro + ". " + DistributionNotSupportedError.PATCH_MESSAGE
+    """
+    This distribution is not supported.
+
+    Arguments:
+            distro: the distribution that is not supported.
+    """
+    PATCH_MESSAGE = "Please send patches to dogtail-devel-list@gnome.org"
+
+    def __init__(self, distro):
+        self.distro = distro
+
+    def __str__(self):
+        return self.distro + ". " + DistributionNotSupportedError.PATCH_MESSAGE
 
 class PackageNotFoundError(Exception):
-	"""
-	Error finding the requested package.
-	"""
-	pass
+    """
+    Error finding the requested package.
+    """
+    pass
 
 global packageDb
 global distro
 
 class PackageDb:
-	"""
-	Class to abstract the details of whatever software package database is in use (RPM, APT, etc)
-	"""
-	def __init__(self):
-		self.prefix = '/usr'
-		self.localePrefixes = [self.prefix + '/share/locale']
-
-	def getVersion(self, packageName):
-		"""
-		Method to get the version of an installed package as a Version instance (or raise an exception if not found)
-		Note: does not know about distributions' internal revision numbers.
-		"""
-		raise NotImplementedError
-
-	def getFiles(self, packageName):
-		"""
-		Method to get a list of filenames owned by the package, or raise an exception if not found.
-		"""
-		raise NotImplementedError
-
-	def getMoFiles(self, locale = None):
-		"""
-		Method to get a list of all .mo files on the system, optionally for a specific locale.
-		"""
-		moFiles = {}
-
-		def appendIfMoFile(moFiles, dirName, fNames):
-			import re
-			for fName in fNames:
-				if re.match('(.*)\\.mo', fName):
-					moFiles[dirName + '/' + fName] = None
-		
-		for localePrefix in self.localePrefixes:
-			if locale: localePrefix = localePrefix + '/' + locale
-			os.path.walk(localePrefix, appendIfMoFile, moFiles)
-
-		return moFiles.keys()
-
-	def getDependencies(self, packageName):
-		"""
-		Method to get a list of unique package names that this package 
-		is dependent on, or raise an exception if the package is not 
-		found.
-		"""
-		raise NotImplementedError
+    """
+    Class to abstract the details of whatever software package database is in use (RPM, APT, etc)
+    """
+    def __init__(self):
+        self.prefix = '/usr'
+        self.localePrefixes = [self.prefix + '/share/locale']
+
+    def getVersion(self, packageName):
+        """
+        Method to get the version of an installed package as a Version instance (or raise an exception if not found)
+        Note: does not know about distributions' internal revision numbers.
+        """
+        raise NotImplementedError
+
+    def getFiles(self, packageName):
+        """
+        Method to get a list of filenames owned by the package, or raise an exception if not found.
+        """
+        raise NotImplementedError
+
+    def getMoFiles(self, locale = None):
+        """
+        Method to get a list of all .mo files on the system, optionally for a specific locale.
+        """
+        moFiles = {}
+
+        def appendIfMoFile(moFiles, dirName, fNames):
+            import re
+            for fName in fNames:
+                if re.match('(.*)\\.mo', fName):
+                    moFiles[dirName + '/' + fName] = None
+
+        for localePrefix in self.localePrefixes:
+            if locale: localePrefix = localePrefix + '/' + locale
+            os.path.walk(localePrefix, appendIfMoFile, moFiles)
+
+        return moFiles.keys()
+
+    def getDependencies(self, packageName):
+        """
+        Method to get a list of unique package names that this package
+        is dependent on, or raise an exception if the package is not
+        found.
+        """
+        raise NotImplementedError
 
 class _RpmPackageDb(PackageDb):
-	def __init__(self):
-		PackageDb.__init__(self)
-
-	def getVersion(self, packageName):
-		import rpm
-		ts = rpm.TransactionSet()
-		for header in ts.dbMatch("name", packageName):
-			return Version.fromString(header["version"])
-		raise PackageNotFoundError, packageName
-
-	def getFiles(self, packageName):
-		import rpm
-		ts = rpm.TransactionSet()
-		for header in ts.dbMatch("name", packageName):
-			return header["filenames"]
-		raise PackageNotFoundError, packageName
-
-	def getDependencies(self, packageName):
-		import rpm
-		ts = rpm.TransactionSet()
-		for header in ts.dbMatch("name", packageName):
-			# Simulate a set using a hash (to a dummy value);
-			# sets were only added in Python 2.4
-			result = {}
-
-			# Get the list of requirements; these are 
-			# sometimes package names, but can also be
-			# so-names of libraries, and invented virtual 
-			# ids
-			for requirement in header[rpm.RPMTAG_REQUIRES]:
-				# Get the name of the package providing
-				# this requirement:
-				for depPackageHeader in ts.dbMatch("provides", requirement):
-					depName = depPackageHeader['name']
-					if depName!=packageName:
-						# Add to the Hash with a dummy value
-						result[depName]=None
-			return result.keys()
-		raise PackageNotFoundError, packageName
+    def __init__(self):
+        PackageDb.__init__(self)
+
+    def getVersion(self, packageName):
+        import rpm
+        ts = rpm.TransactionSet()
+        for header in ts.dbMatch("name", packageName):
+            return Version.fromString(header["version"])
+        raise PackageNotFoundError, packageName
+
+    def getFiles(self, packageName):
+        import rpm
+        ts = rpm.TransactionSet()
+        for header in ts.dbMatch("name", packageName):
+            return header["filenames"]
+        raise PackageNotFoundError, packageName
+
+    def getDependencies(self, packageName):
+        import rpm
+        ts = rpm.TransactionSet()
+        for header in ts.dbMatch("name", packageName):
+            # Simulate a set using a hash (to a dummy value);
+            # sets were only added in Python 2.4
+            result = {}
+
+            # Get the list of requirements; these are
+            # sometimes package names, but can also be
+            # so-names of libraries, and invented virtual
+            # ids
+            for requirement in header[rpm.RPMTAG_REQUIRES]:
+                # Get the name of the package providing
+                # this requirement:
+                for depPackageHeader in ts.dbMatch("provides", requirement):
+                    depName = depPackageHeader['name']
+                    if depName!=packageName:
+                        # Add to the Hash with a dummy value
+                        result[depName]=None
+            return result.keys()
+        raise PackageNotFoundError, packageName
 
 class _AptPackageDb(PackageDb):
-	def __init__(self):
-		PackageDb.__init__(self)
-		self.cache = None
-	
-	def getVersion(self, packageName):
-		if not self.cache:
-			import apt_pkg
-			apt_pkg.init()
-			self.cache = apt_pkg.GetCache()
-		packages = self.cache.Packages
-		for package in packages:
-			if package.Name == packageName:
-				import re
-				verString = re.match('.*Ver:\'(.*)-.*\' Section:', str(package.CurrentVer)).group(1)
-				return Version.fromString(verString)
-		raise PackageNotFoundError, packageName
-
-	def getFiles(self, packageName):
-		files = []
-		list = os.popen('dpkg -L %s' % packageName).readlines()
-		if not list:
-			raise PackageNotFoundError, packageName
-		else:
-			for line in list:
-				file = line.strip()
-				if file: files.append(file)
-			return files
-	
-	def getDependencies(self, packageName):
-		# Simulate a set using a hash (to a dummy value);
-		# sets were only added in Python 2.4
-		result = {}
-		if not self.cache:
-			import apt_pkg
-			apt_pkg.init()
-			self.cache = apt_pkg.GetCache()
-		packages = self.cache.Packages
-		for package in packages:
-			if package.Name == packageName:
-				current = package.CurrentVer
-				if not current:
-					raise PackageNotFoundError, packageName
-				depends = current.DependsList
-				list = depends['Depends']
-				for dependency in list:
-					name = dependency[0].TargetPkg.Name
-					# Add to the hash using a dummy value
-					result[name] = None
-		return result.keys()
+    def __init__(self):
+        PackageDb.__init__(self)
+        self.cache = None
+
+    def getVersion(self, packageName):
+        if not self.cache:
+            import apt_pkg
+            apt_pkg.init()
+            self.cache = apt_pkg.GetCache()
+        packages = self.cache.Packages
+        for package in packages:
+            if package.Name == packageName:
+                import re
+                verString = re.match('.*Ver:\'(.*)-.*\' Section:', str(package.CurrentVer)).group(1)
+                return Version.fromString(verString)
+        raise PackageNotFoundError, packageName
+
+    def getFiles(self, packageName):
+        files = []
+        list = os.popen('dpkg -L %s' % packageName).readlines()
+        if not list:
+            raise PackageNotFoundError, packageName
+        else:
+            for line in list:
+                file = line.strip()
+                if file: files.append(file)
+            return files
+
+    def getDependencies(self, packageName):
+        # Simulate a set using a hash (to a dummy value);
+        # sets were only added in Python 2.4
+        result = {}
+        if not self.cache:
+            import apt_pkg
+            apt_pkg.init()
+            self.cache = apt_pkg.GetCache()
+        packages = self.cache.Packages
+        for package in packages:
+            if package.Name == packageName:
+                current = package.CurrentVer
+                if not current:
+                    raise PackageNotFoundError, packageName
+                depends = current.DependsList
+                list = depends['Depends']
+                for dependency in list:
+                    name = dependency[0].TargetPkg.Name
+                    # Add to the hash using a dummy value
+                    result[name] = None
+        return result.keys()
 
 class _UbuntuAptPackageDb(_AptPackageDb):
-	def __init__(self):
-		_AptPackageDb.__init__(self)
-		self.localePrefixes.append(self.prefix + '/share/locale-langpack')
+    def __init__(self):
+        _AptPackageDb.__init__(self)
+        self.localePrefixes.append(self.prefix + '/share/locale-langpack')
 
 class _PortagePackageDb(PackageDb):
-	def __init__(self):
-		PackageDb.__init__(self)
+    def __init__(self):
+        PackageDb.__init__(self)
 
-	def getVersion(self, packageName):
-		# the portage utilities are almost always going to be in /usr/lib/portage/pym
-		import sys
-		sys.path.append ('/usr/lib/portage/pym')
-		import portage
-		# FIXME: this takes the first package returned in the list, in the case that there are
-		# slotted packages, and removes the leading category such as 'sys-apps'
-		gentooPackageName = portage.db["/"]["vartree"].dbapi.match(packageName)[0].split('/')[1];
-		# this removes the distribution specific versioning returning only the upstream version
-		upstreamVersion = portage.pkgsplit(gentooPackageName)[1]
-		#print "Version of package is: " + upstreamVersion
-		return Version.fromString(upstreamVersion);
+    def getVersion(self, packageName):
+        # the portage utilities are almost always going to be in /usr/lib/portage/pym
+        import sys
+        sys.path.append ('/usr/lib/portage/pym')
+        import portage
+        # FIXME: this takes the first package returned in the list, in the case that there are
+        # slotted packages, and removes the leading category such as 'sys-apps'
+        gentooPackageName = portage.db["/"]["vartree"].dbapi.match(packageName)[0].split('/')[1];
+        # this removes the distribution specific versioning returning only the upstream version
+        upstreamVersion = portage.pkgsplit(gentooPackageName)[1]
+        #print "Version of package is: " + upstreamVersion
+        return Version.fromString(upstreamVersion);
 
 class _ConaryPackageDb(PackageDb):
-	def __init__(self):
-		PackageDb.__init__(self)
-
-	def getVersion(self, packageName):
-		import conary
-		from conaryclient import ConaryClient
-		client = ConaryClient()
-		dbVersions = client.db.getTroveVersionList(packageName)
-		if not len(dbVersions):
-			raise PackageNotFoundError, packageName
-		return dbVersions[0].trailingRevision().asString().split("-")[0]
+    def __init__(self):
+        PackageDb.__init__(self)
+
+    def getVersion(self, packageName):
+        import conary
+        from conaryclient import ConaryClient
+        client = ConaryClient()
+        dbVersions = client.db.getTroveVersionList(packageName)
+        if not len(dbVersions):
+            raise PackageNotFoundError, packageName
+        return dbVersions[0].trailingRevision().asString().split("-")[0]
+
+# getVersion not implemented because on Solaris multiple modules are installed
+# in single packages, so it is hard to tell what version number of a specific
+# module.
+#
+class _SolarisPackageDb(PackageDb):
+    def __init__(self):
+        PackageDb.__init__(self)
 
 class JhBuildPackageDb(PackageDb):
-	def __init__(self):
-		PackageDb.__init__(self)
-		prefixes = []
-		prefixes.append(os.environ['LD_LIBRARY_PATH'])
-		prefixes.append(os.environ['XDG_CONFIG_DIRS'])
-		prefixes.append(os.environ['PKG_CONFIG_PATH'])
-		self.prefix = os.path.commonprefix(prefixes)
-		self.localePrefixes.append(self.prefix + '/share/locale')
-	
-	def getDependencies(self, packageName):
-		result = {}
-		lines = os.popen('jhbuild list ' + packageName).readlines()
-		for line in lines:
-			if line:
-				result[line.strip()] = None
-		return result.keys()
+    def __init__(self):
+        PackageDb.__init__(self)
+        prefixes = []
+        prefixes.append(os.environ['LD_LIBRARY_PATH'])
+        prefixes.append(os.environ['XDG_CONFIG_DIRS'])
+        prefixes.append(os.environ['PKG_CONFIG_PATH'])
+        self.prefix = os.path.commonprefix(prefixes)
+        self.localePrefixes.append(self.prefix + '/share/locale')
+
+    def getDependencies(self, packageName):
+        result = {}
+        lines = os.popen('jhbuild list ' + packageName).readlines()
+        for line in lines:
+            if line:
+                result[line.strip()] = None
+        return result.keys()
 
 class Distro:
-	"""
-	Class representing a distribution.
-	
-	Scripts may want to do arbitrary logic based on whichever distro is in use (e.g. handling differences in names of packages, distribution-specific patches, etc.)
-
-	We can either create methods in the Distro class to handle these, or we can use constructs like isinstance(distro, Ubuntu) to handle this. We can even create hierarchies of distro subclasses to handle this kind of thing (could get messy fast though)
-	"""
+    """
+    Class representing a distribution.
+
+    Scripts may want to do arbitrary logic based on whichever distro is in use (e.g. handling differences in names of packages, distribution-specific patches, etc.)
+
+    We can either create methods in the Distro class to handle these, or we can use constructs like isinstance(distro, Ubuntu) to handle this. We can even create hierarchies of distro subclasses to handle this kind of thing (could get messy fast though)
+    """
 
 class RedHatOrFedora(Distro):
-	"""
-	Class representing one of Red Hat Linux, Fedora, Red Hat Enterprise Linux, or one of the rebuild-style derivatives
-	"""
-	def __init__(self):
-		self.packageDb = _RpmPackageDb()
+    """
+    Class representing one of Red Hat Linux, Fedora, Red Hat Enterprise Linux, or one of the rebuild-style derivatives
+    """
+    def __init__(self):
+        self.packageDb = _RpmPackageDb()
 
 class Debian(Distro):
-	"""
-	Class representing one of the Debian or Debian-derived distributions
-	"""
-	def __init__(self):
-		self.packageDb = _AptPackageDb()
+    """
+    Class representing one of the Debian or Debian-derived distributions
+    """
+    def __init__(self):
+        self.packageDb = _AptPackageDb()
 
 class Ubuntu(Debian):
-	"""
-	Class representing one of the Debian or Debian-derived distributions
-	"""
-	def __init__(self):
-		self.packageDb = _UbuntuAptPackageDb()
+    """
+    Class representing one of the Debian or Debian-derived distributions
+    """
+    def __init__(self):
+        self.packageDb = _UbuntuAptPackageDb()
 
 class Suse(Distro):
-	"""
-	Class representing one of the SuSE or SuSE-derived distributions
-	"""
+    """
+    Class representing one of the SuSE or SuSE-derived distributions
+    """
+    def __init__(self):
+        self.packageDb = _RpmPackageDb()
 
 class Gentoo(Distro):
-	"""
-	Class representing one of the Gentoo or Gentoo-derived distributions
-	"""
-	def __init__(self):
-		self.packageDb = _PortagePackageDb()
+    """
+    Class representing one of the Gentoo or Gentoo-derived distributions
+    """
+    def __init__(self):
+        self.packageDb = _PortagePackageDb()
 
 class Conary(Distro):
-	"""
-	Class representing a Conary-based distribution
-	"""
-	def __init__(self):
-		self.packageDb = _ConaryPackageDb()
+    """
+    Class representing a Conary-based distribution
+    """
+    def __init__(self):
+        self.packageDb = _ConaryPackageDb()
+
+class Solaris(Distro):
+    """
+    Class representing a Solaris distribution
+    """
+    def __init__(self):
+        self.packageDb = _SolarisPackageDb()
 
 class JHBuild(Distro):
-	"""
-	Class representing a JHBuild environment
-	"""
-	def __init__(self):
-		self.packageDb = JhBuildPackageDb()
+    """
+    Class representing a JHBuild environment
+    """
+    def __init__(self):
+        self.packageDb = JhBuildPackageDb()
 
-print "Detecting distribution:",
+message = "Detecting distribution: "
 if os.environ.get("CERTIFIED_GNOMIE", "no") == "yes":
-	print "JHBuild environment"
-	distro = JHBuild()
+    logger.log(message + "JHBuild environment")
+    distro = JHBuild()
+elif os.path.exists ("/etc/SuSE-release"):
+    logger.log(message + "SuSE (or derived distribution)")
+    distro = Suse()
+elif os.path.exists ("/etc/fedora-release"):
+    logger.log(message + "Fedora (or derived distribution)")
+    distro = RedHatOrFedora()
 elif os.path.exists ("/etc/redhat-release"):
-	print "Red Hat/Fedora/derived distribution"
-	distro = RedHatOrFedora()
-elif os.path.exists ("/etc/SuSE-release"):
-	print "SuSE (or derived distribution)"
-elif os.path.exists ("/etc/fedora-release"): 
-	print "Fedora (or derived distribution)"
-	distro = RedHatOrFedora()
+    logger.log(message + "Red Hat/Fedora/derived distribution")
+    distro = RedHatOrFedora()
 elif os.path.exists ("/usr/share/doc/ubuntu-minimal"):
-	print "Ubuntu (or derived distribution)"
-	distro = Ubuntu()
+    logger.log(message + "Ubuntu (or derived distribution)")
+    distro = Ubuntu()
 elif os.path.exists ("/etc/debian_version"):
-	print "Debian (or derived distribution)"
-	distro = Debian()
+    logger.log(message + "Debian (or derived distribution)")
+    distro = Debian()
 elif os.path.exists ("/etc/gentoo-release"):
-	print "Gentoo (or derived distribution)"
-	distro = Gentoo()
+    logger.log(message + "Gentoo (or derived distribution)")
+    distro = Gentoo()
 elif os.path.exists ("/etc/slackware-version"):
-	print "Slackware"
-	raise DistributionNotSupportedError("Slackware")
+    logger.log(message + "Slackware")
+    raise DistributionNotSupportedError("Slackware")
 elif os.path.exists ("/var/lib/conarydb/conarydb"):
-	print "Conary-based distribution"
-	distro = Conary()
+    logger.log(message + "Conary-based distribution")
+    distro = Conary()
+elif os.path.exists ("/etc/release") and \
+        re.match (".*Solaris", open ("/etc/release").readline()):
+    print "Solaris distribution"
+    distro = Solaris()
 else:
-	print "Unknown"
-	raise DistributionNotSupportedError("Unknown")
+    logger.log(message + "Unknown")
+    raise DistributionNotSupportedError("Unknown")
 
 packageDb = distro.packageDb

=== modified file 'dogtail/dump.py'
--- dogtail/dump.py	2006-02-22 12:31:33 +0000
+++ dogtail/dump.py	2006-12-16 10:57:30 +0000
@@ -7,60 +7,58 @@
 # Anyway, I'd *love* to be able to unregister this signal handler.
 import signal, sys
 def signalHandler (signal, frame):
-	sys.exit(0)
+    sys.exit(0)
 signal.signal(signal.SIGINT, signalHandler)
 
 spacer = ' '
 def plain (node, depth = 0):
-	"""
-	Plain-text dump. The hierarchy is represented through indentation.
-	The default indentation string is a single space, ' ', but can be changed.
-	"""
-	print spacer*(depth) + str (node)
-	try:
-		for action in node.actions:
-			print spacer*(depth + 1) + str (action)
-	except AttributeError: pass
-	try:
-		for child in node.children:
-			plain (child, depth + 1)
-	except AttributeError: pass
+    """
+    Plain-text dump. The hierarchy is represented through indentation.
+    The default indentation string is a single space, ' ', but can be changed.
+    """
+    print spacer*(depth) + str (node)
+    try:
+        for action in node.actions:
+            print spacer*(depth + 1) + str (action)
+    except AttributeError: pass
+    try:
+        for child in node.children:
+            plain (child, depth + 1)
+    except AttributeError: pass
 
 def xml (node):
-	try: import cElementTree as ElementTree
-	except ImportError: from elementtree import ElementTree
-	def buildElementTree (parentElement, node):
-		element = ElementTree.SubElement(parentElement, 'node')
-		name = ElementTree.SubElement(element, 'name')
-		name.text = node.name
-		roleName = ElementTree.SubElement(element, 'roleName')
-		roleName.text = node.roleName
-		description = ElementTree.SubElement(element, 'description')
-		description.text = node.description
-		try:
-			text = ElementTree.SubElement(element, 'text')
-			text.text = node.text
-		except AttributeError: pass
-		
-		try:
-			for action in node.actions:
-				actionElement = ElementTree.SubElement(element, 'action')
-				name = ElementTree.SubElement(actionElement, 'name')
-				name.text = action.name
-				description = ElementTree.SubElement(actionElement, 'description')
-				description.text = action.description
-				keyBinding = ElementTree.SubElement(actionElement, 'keyBinding')
-				keyBinding.text = action.keyBinding
-		except AttributeError: pass	
-		
-		try:
-			for child in node.children:
-				buildElementTree(element, child)
-		except AttributeError: pass
-	root = ElementTree.Element('node')
-	element = root
-	buildElementTree(root, node)
-	tree = ElementTree.ElementTree(root)
-	ElementTree.dump(tree)
-		
-
+    try: import cElementTree as ElementTree
+    except ImportError: from elementtree import ElementTree
+    def buildElementTree (parentElement, node):
+        element = ElementTree.SubElement(parentElement, 'node')
+        name = ElementTree.SubElement(element, 'name')
+        name.text = node.name
+        roleName = ElementTree.SubElement(element, 'roleName')
+        roleName.text = node.roleName
+        description = ElementTree.SubElement(element, 'description')
+        description.text = node.description
+        try:
+            text = ElementTree.SubElement(element, 'text')
+            text.text = node.text
+        except AttributeError: pass
+
+        try:
+            for action in node.actions:
+                actionElement = ElementTree.SubElement(element, 'action')
+                name = ElementTree.SubElement(actionElement, 'name')
+                name.text = action.name
+                description = ElementTree.SubElement(actionElement, 'description')
+                description.text = action.description
+                keyBinding = ElementTree.SubElement(actionElement, 'keyBinding')
+                keyBinding.text = action.keyBinding
+        except AttributeError: pass
+
+        try:
+            for child in node.children:
+                buildElementTree(element, child)
+        except AttributeError: pass
+    root = ElementTree.Element('node')
+    element = root
+    buildElementTree(root, node)
+    tree = ElementTree.ElementTree(root)
+    ElementTree.dump(tree)

=== modified file 'dogtail/errors.py'
--- dogtail/errors.py	2006-02-22 12:31:33 +0000
+++ dogtail/errors.py	2006-12-16 10:57:30 +0000
@@ -3,11 +3,23 @@
 General exceptions; not overly module-specific
 """
 __author__ = "Zack Cerza <zcerza@redhat.com>"
+from logging import debugLogger as logger
 
+import inspect
+def warn(message, caller = True):
+    """
+    Generate a warning, and pass it to the debug logger.
+    """
+    frameRec = inspect.stack()[-1]
+    message = "Warning: %s:%s: %s" % (frameRec[1], frameRec[2], message)
+    if caller and frameRec[1] != '<stdin>' and frameRec[1] != '<string>': 
+        message = message + ':\n  ' + frameRec[4][0]
+    del frameRec
+    logger.log(message)
 
 class DependencyNotFoundError(Exception):
-	"""
-	A dependency was not found.
-	"""
-	pass
+    """
+    A dependency was not found.
+    """
+    pass
 

=== modified file 'dogtail/i18n.py'
--- dogtail/i18n.py	2006-08-01 22:59:27 +0000
+++ dogtail/i18n.py	2006-12-21 13:33:47 +0000
@@ -16,206 +16,246 @@
 
 from logging import debugLogger as logger
 
+def safeDecode(string):
+    if not isinstance(string, unicode):
+        try:
+            string = string.decode('utf-8')
+        except UnicodeDecodeError:
+            #logger.log(traceback.format_exc())
+            #logger.log("The following string is invalid and caused the above error: '%s'" % string)
+            string = string.decode('utf-8', 'replace')
+    return string
+
+def safeEncode(string):
+    pass
+
+
 """
-Singleton list of TranslationDb instances, to be initialized by the script with 
+Singleton list of TranslationDb instances, to be initialized by the script with
 whatever translation databases it wants.
 """
 translationDbs = []
 
 class TranslationDb:
-	"""
-	Abstract base class representing a database of translations
-	"""
-	def getTranslationsOf(self, srcName):
-		"""
-		Pure virtual method to look up the translation of a string.
-		Returns a list of candidate strings (the translation), empty if not found.
-		
-		Note that a source string can map to multiple translated strings. For 
-		example, in the French translation of Evolution, the string "Forward" can 
-		translate to both
-		(i) "Faire suivre" for forwarding an email, and 
-		(ii) "Suivant" for the next page in a wizard.
-		"""
-		raise NotImplementedError
+    """
+    Abstract base class representing a database of translations
+    """
+    def getTranslationsOf(self, srcName):
+        """
+        Pure virtual method to look up the translation of a string.
+        Returns a list of candidate strings (the translation), empty if not found.
+
+        Note that a source string can map to multiple translated strings. For
+        example, in the French translation of Evolution, the string "Forward" can
+        translate to both
+        (i) "Faire suivre" for forwarding an email, and
+        (ii) "Suivant" for the next page in a wizard.
+        """
+        raise NotImplementedError
 
 class GettextTranslationDb(TranslationDb):
-	"""
-	Implementation of TranslationDb which leverages gettext, using a single
-	translation mo-file.
-	"""
-	def __init__(self, moFile):
-		self.__moFile = moFile
-		self.__gnutranslations = gettext.GNUTranslations(open(moFile))
-
-	def getTranslationsOf(self, srcName):
-		if not isinstance(srcName, unicode):
-			srcName = srcName.decode('utf-8')
-		# print "searching for translations of %s"%srcName
-		# Use a dict to get uniqueness:
-		results = {}
-		result = self.__gnutranslations.ugettext(srcName)
-		if result!=srcName:
-			results[result]=None
-
-		# Hack alert:
-		#
-		# Note that typical UI definition in GTK etc contains strings with 
-		# underscores to denote accelerators. 
-		# For example, the stock GTK "Add" item has text "_Add" which e.g. 
-		# translates to "A_jouter" in French
-		#
-		# Since these underscores have been stripped out before we see these strings,
-		# we are looking for a translation of "Add" into "Ajouter" in this case, so
-		# we need to fake it, by looking up the string multiple times, with underscores
-		# inserted in all possible positions, stripping underscores out of the result. 
-		# Ugly, but it works.
-			
-		for index in range(len(srcName)):
-			candidate = srcName[:index]+"_"+srcName[index:]
-			result = self.__gnutranslations.ugettext(candidate)
-			if result!=candidate:
-				# Strip out the underscore, and add to the result:
-				results[result.replace('_','')]=True
-			
-		return results.keys()
+    """
+    Implementation of TranslationDb which leverages gettext, using a single
+    translation mo-file.
+    """
+    def __init__(self, moFile):
+        self.__moFile = moFile
+        self.__gnutranslations = gettext.GNUTranslations(open(moFile))
+
+    def getTranslationsOf(self, srcName):
+        srcName = safeDecode(srcName)
+        # print "searching for translations of %s"%srcName
+        # Use a dict to get uniqueness:
+        results = {}
+        result = self.__gnutranslations.ugettext(srcName)
+        if result!=srcName:
+            results[result]=None
+
+        # Hack alert:
+        #
+        # Note that typical UI definition in GTK etc contains strings with
+        # underscores to denote accelerators.
+        # For example, the stock GTK "Add" item has text "_Add" which e.g.
+        # translates to "A_jouter" in French
+        #
+        # Since these underscores have been stripped out before we see these strings,
+        # we are looking for a translation of "Add" into "Ajouter" in this case, so
+        # we need to fake it, by looking up the string multiple times, with underscores
+        # inserted in all possible positions, stripping underscores out of the result.
+        # Ugly, but it works.
+
+        for index in range(len(srcName)):
+            candidate = srcName[:index]+"_"+srcName[index:]
+            result = self.__gnutranslations.ugettext(candidate)
+            if result!=candidate:
+                # Strip out the underscore, and add to the result:
+                results[result.replace('_','')]=True
+
+        return results.keys()
 
 def translate(srcString):
-	"""
-	Look up srcString in the various translation databases (if any), returning
-	a list of all matches found (potentially the empty list)
-	"""
-	# Use a dict to get uniqueness:
-	results = {}
-	# Try to translate the string:
-	for translationDb in translationDbs:
-		for result in translationDb.getTranslationsOf(srcString):
-			result = result.encode('utf-8')
-			results[result]=True
-
-	# No translations found:
-	if len(results)==0:
-		if config.config.debugTranslation:
-			logger.log('Translation not found for "%s"'%srcString)
-	return results.keys()
-		
+    """
+    Look up srcString in the various translation databases (if any), returning
+    a list of all matches found (potentially the empty list)
+    """
+    # Use a dict to get uniqueness:
+    results = {}
+    # Try to translate the string:
+    for translationDb in translationDbs:
+        for result in translationDb.getTranslationsOf(srcString):
+            result = safeDecode(result)
+            results[result]=True
+
+    # No translations found:
+    if len(results)==0:
+        if config.config.debugTranslation:
+            logger.log('Translation not found for "%s"'%srcString)
+    return results.keys()
+
 class TranslatableString:
-	"""
-	Class representing a string that we want to match strings against, handling 
-	translation for us, by looking it up once at construction time.
-	""" 
-
-	def __init__(self, untranslatedString):
-		"""
-		Constructor looks up the string in all of the translation databases, storing
-		the various translations it finds.
-		"""
-		if isinstance(untranslatedString, unicode):
-			untranslatedString = untranslatedString.encode('utf-8')
-		else:
-			untranslatedString = untranslatedString.decode('utf-8')
-		self.untranslatedString = untranslatedString
-		self.translatedStrings = translate(untranslatedString)
-
-	def matchedBy(self, string):
-		"""
-		Compare the test string against either the translation of the original 
-		string (or simply the original string, if no translation was found).
-		"""
-		#print "comparing %s against %s"%(string, self)
-		matched = False
-		if len(self.translatedStrings)>0:
-			matched = string in self.translatedStrings
-			return matched
-		else:
-			matched = string==self.untranslatedString
-			return matched
-			
-	def __str__(self):
-		"""
-		Provide a meaningful debug version of the string (and the translation in 
-		use)
-		"""
-		if len(self.translatedStrings)>0:
-			# build an output string, with commas in the correct places
-			translations = ""			
-			for tString in self.translatedStrings:
-				translations += '"%s", ' % tString.decode('utf-8')
-			result = '"%s" (%s)' % (self.untranslatedString, translations)
-			return result.encode('utf-8')
-		else:
-			return '"%s"' % (self.untranslatedString)
+    """
+    Class representing a string that we want to match strings against, handling
+    translation for us, by looking it up once at construction time.
+    """
+
+    def __init__(self, untranslatedString):
+        """
+        Constructor looks up the string in all of the translation databases, storing
+        the various translations it finds.
+        """
+        if isinstance(untranslatedString, unicode):
+            untranslatedString = safeDecode(untranslatedString)
+        else:
+            untranslatedString = safeDecode(untranslatedString)
+        self.untranslatedString = untranslatedString
+        self.translatedStrings = translate(untranslatedString)
+
+    def matchedBy(self, string):
+        """
+        Compare the test string against either the translation of the original
+        string (or simply the original string, if no translation was found).
+        """
+        #print "comparing %s against %s"%(string, self)
+        def stringsMatch(inS, outS):
+            """
+            Compares a regular expression to a string
+
+            inS: the regular expression (or normal string)
+            outS: the normal string to be compared against
+            """
+            inString = str(inS)
+            outString = outS
+            if inString == outString:
+                return True
+            inString = inString + '$'
+            inString = safeDecode(inString)
+            outString = safeDecode(outString)
+            if inString[0] == '*':
+                inString = "\\" + inString
+            # Escape all parentheses, since grouping will never be needed here
+            inString = re.sub('([\(\)])', r'\\\1', inString)
+            match = re.match(inString, outString)
+            matched = match is not None
+            return matched
+
+        matched = False
+        # the 'ts' variable keeps track of whether we're working with
+        # translated strings. it's only used for debugging purposes.
+        #ts = 0
+        #print string, str(self)
+        for translatedString in self.translatedStrings:
+            #ts = ts + 1
+            matched = stringsMatch(translatedString, string)
+            if not matched:
+                matched = translatedString == string
+            if matched: return matched
+        #ts=0
+        return stringsMatch(self.untranslatedString, string)
+
+    def __str__(self):
+        """
+        Provide a meaningful debug version of the string (and the translation in
+        use)
+        """
+        if len(self.translatedStrings)>0:
+            # build an output string, with commas in the correct places
+            translations = ""
+            for tString in self.translatedStrings:
+                translations += u'"%s", ' % safeDecode(tString)
+            result = u'"%s" (%s)' % (safeDecode(self.untranslatedString), translations)
+            return safeDecode(result)
+        else:
+            return '"%s"' % (self.untranslatedString)
 
 
 
 def isMoFile(filename, language = ''):
-	"""
-	Does the given filename look like a gettext mo file?
-	
-	Optionally: Does the file also contain translations for a certain language,
-	for example 'ja'?
-	"""
-	if re.match('(.*)\\.mo$', filename):
-		if not language: return True
-		elif re.match('/usr/share/locale(.*)/%s(.*)/LC_MESSAGES/(.*)\\.mo$' % \
-				language, filename):
-			return True
-		else:
-			return False
-	else:
-		return False
+    """
+    Does the given filename look like a gettext mo file?
+
+    Optionally: Does the file also contain translations for a certain language,
+    for example 'ja'?
+    """
+    if re.match('(.*)\\.mo$', filename):
+        if not language: return True
+        elif re.match('/usr/share/locale(.*)/%s(.*)/LC_MESSAGES/(.*)\\.mo$' % \
+                        language, filename):
+            return True
+        else:
+            return False
+    else:
+        return False
 
 def getMoFilesForPackage(packageName, language = '', getDependencies=True):
-	"""
-	Look up the named package and find all gettext mo files within it and its
-	dependencies. It is possible to restrict the results to those of a certain
-	language, for example 'ja'.
-	"""
-	result = []
-	for filename in distro.packageDb.getFiles(packageName):
-		if isMoFile(filename, language):
-			result.append(filename)
-
-	if getDependencies:
-		# Recurse:
-		for dep in distro.packageDb.getDependencies(packageName):
-			# We pass False to the inner call because getDependencies has already 
-			# walked the full tree
-			result.extend(getMoFilesForPackage(dep, language, False))
-		
-	return result
+    """
+    Look up the named package and find all gettext mo files within it and its
+    dependencies. It is possible to restrict the results to those of a certain
+    language, for example 'ja'.
+    """
+    result = []
+    for filename in distro.packageDb.getFiles(packageName):
+        if isMoFile(filename, language):
+            result.append(filename)
+
+    if getDependencies:
+        # Recurse:
+        for dep in distro.packageDb.getDependencies(packageName):
+            # We pass False to the inner call because getDependencies has already
+            # walked the full tree
+            result.extend(getMoFilesForPackage(dep, language, False))
+
+    return result
 
 def loadTranslationsFromPackageMoFiles(packageName, getDependencies=True):
-	"""
-	Helper function which appends all of the gettext translation mo-files used by 
-	the package (and its dependencies) to the translation database list.
-	"""
-	# Keep a list of mo-files that are already in use to avoid duplicates.
-	moFiles = {}
-	def load(packageName, language = '', getDependencies = True):
-		for moFile in getMoFilesForPackage(packageName, language, getDependencies):
-			# Searching the popt mo-files for translations makes gettext bail out, 
-			# so we ignore them here. This is 
-			# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=172155 .
-			if 'popt.mo' not in moFile:
-				try:
-					translationDbs.append(GettextTranslationDb(moFile))
-					moFiles[moFile] = None
-				except (AttributeError, IndexError), inst:
-					if config.config.debugTranslation:
-						#import traceback
-						#logger.log(traceback.format_exc())
-						logger.log("Warning: Failed to load mo-file for translation: " + moFile)
-				
-	# Hack alert:
-	#
-	# The following special-case is necessary for Ubuntu, since their 
-	# translations are shipped in a single huge package. The downside to
-	# this special case, aside from the simple fact that there is one, 
-	# is that it makes automatic translations much slower.
-
-	language = os.environ.get('LANGUAGE', os.environ['LANG'])[0:2]
-	if isinstance(distro.distro, distro.Ubuntu):
-		load('language-pack-gnome-%s' % language, language)
-	load(packageName, language, getDependencies)
-
+    """
+    Helper function which appends all of the gettext translation mo-files used by
+    the package (and its dependencies) to the translation database list.
+    """
+    # Keep a list of mo-files that are already in use to avoid duplicates.
+    moFiles = {}
+    def load(packageName, language = '', getDependencies = True):
+        for moFile in getMoFilesForPackage(packageName, language, getDependencies):
+            # Searching the popt mo-files for translations makes gettext bail out,
+            # so we ignore them here. This is
+            # https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=172155 .
+            if 'popt.mo' not in moFile:
+                try:
+                    translationDbs.append(GettextTranslationDb(moFile))
+                    moFiles[moFile] = None
+                except (AttributeError, IndexError), inst:
+                    if config.config.debugTranslation:
+                        #import traceback
+                        #logger.log(traceback.format_exc())
+                        logger.log("Warning: Failed to load mo-file for translation: " + moFile)
+
+    # Hack alert:
+    #
+    # The following special-case is necessary for Ubuntu, since their
+    # translations are shipped in a single huge package. The downside to
+    # this special case, aside from the simple fact that there is one,
+    # is that it makes automatic translations much slower.
+
+    language = os.environ.get('LANGUAGE', os.environ['LANG'])[0:2]
+    if isinstance(distro.distro, distro.Ubuntu):
+        load('language-pack-gnome-%s' % language, language)
+    load(packageName, language, getDependencies)

=== modified file 'dogtail/logging.py'
--- dogtail/logging.py	2006-08-01 22:59:27 +0000
+++ dogtail/logging.py	2006-12-21 13:33:47 +0000
@@ -6,193 +6,223 @@
 """
 
 __author__ = """Ed Rousseau <rousseau@redhat.com>,
-Zack Cerza <zcerza@redhat.com, 
+Zack Cerza <zcerza@redhat.com,
 David Malcolm <dmalcolm@redhat.com>
 """
 import os
+import sys
 import time
 import datetime
 from config import config
+import codecs
 
 # Timestamp class for file logs
 class TimeStamp:
-	"""
-	Generates timestamps tempfiles and log entries
-	"""
-	def __init__(self):
-		self.now = "0"
-		self.timetup = time.localtime()
-	
-	def zeroPad(self, int, width = 2):
-		"""
-		Pads an integer 'int' with zeroes, up to width 'width'.
-		
-		Returns a string.
-		
-		It will not truncate. If you call zeroPad(100, 2), '100' will be returned.
-		"""
-		if int < 10 ** width:
-			return ("0" * (width - len(str(int))) ) + str(int)
-		else: 
-			return str(int)
-
-	# file stamper
-	def fileStamp(self, filename, addTime = True):
-		"""
-		Generates a filename stamp in the format of filename_YYYYMMDD-hhmmss.
-		A format of filename_YYYYMMDD can be used instead by specifying addTime = False.
-		"""
-		self.now = filename.strip() + "_"
-		self.timetup = time.localtime()
-
-		# Should produce rel-eng style filestamps
-		# format it all pretty by chopping the tuple
-		fieldCount = 3
-		if addTime: fieldCount = fieldCount + 3
-		for i in range(fieldCount):
-			if i == 3: self.now = self.now + '-'
-			self.now = self.now + self.zeroPad(self.timetup[i])
-		return self.now
-
-	# Log entry stamper
-	def entryStamp(self):
-		"""
-		Generates a logfile entry stamp of YYYY.MM.DD HH:MM:SS
-		"""
-		self.timetup = time.localtime()
-
-		# This will return a log entry formatted string in YYYY.MM.DD HH:MM:SS
-		for i in range(6):
-			# put in the year
-			if i == 0:
-				self.now = str(self.timetup[i])
-			# Format Month and Day
-			elif i == 1 or i == 2:
-				self.now = self.now + "." + self.zeroPad(self.timetup[i])
-			else:
-				x = self.timetup[i]
-				# make the " " between Day and Hour and put in the hour
-				if i == 3:
-					self.now = self.now + " " + self.zeroPad(self.timetup[i])
-				# Otherwise Use the ":" divider
-				else:
-					self.now = self.now + ":" + self.zeroPad(self.timetup[i])
-		return self.now
-
-
-# Class that writes to the Log
-class LogWriter:
-	"""
-	Writes entries into the Dogtail log
-	"""
-	def __init__(self):
-		self.entry = {}
-		# Set the logDir - maybe we want to use mktemp(1) for this later.
-		self.logDir = config.logDir #'/tmp/dogtail-' + os.environ['LOGNAME'] + '/'
-		if not os.path.isdir(self.logDir): os.makedirs(self.logDir)
-		self.logfile = ''
-		self.scriptName = config.scriptName 
-		if not self.scriptName: self.scriptName = 'log'
-		self.loghandle = "" # Handle to the logfile
-		self.stamper = TimeStamp()
-		# check to see if we can write to the logDir
-		if os.path.isdir(self.logDir):
-			# generate a logfile name and check if it already exists
-			self.logfile = self.logDir + self.stamper.fileStamp(self.scriptName)
-			i = 0
-			while os.path.exists(self.logfile):
-				# Append the pathname
-				if i == 0:
-					self.logfile = self.logfile + "." + str(i)
-				else:
-					logsplit = self.logfile.split(".")
-					logsplit[-1] = str(i)
-					self.logfile = ".".join(logsplit)
-				i += 1
-		else:
-			# If path doesn't exist, raise an exception
-			raise IOError, "Log path %s does not exist or is not a directory" % self.logDir
-
-		# Try to create the file and write the header info
-		try:
-			print "Creating logfile at %s ..." % self.logfile
-			date = datetime.datetime.strftime(datetime.datetime.now(), '%d %b %Y %H:%M:%S')
-			self.loghandle = open(self.logfile, 'w')
-			self.loghandle.write("##### " + self.scriptName + " Created on: " + date + "\n")
-			self.loghandle.flush()
-			self.loghandle.close()
-		except IOError:
-			print "Could not create and write to " + self.logfile
-
-
-	# Writes the result of a test case comparison to the log
-	def writeResult(self, entry):
-		"""
-		Writes the log entry. Requires a 1 {key: value} pair dict for an argument or else it will throw an exception.
-		"""
-		self.entry = entry
-		# We require a 1 key: value dict
-		# Strip all leading and trailing witespace from entry dict and convert
-	# to string for writing
-
-		if len(self.entry) == 1:
-			key = self.entry.keys()
-			value = self.entry.values()
-			key = key[0]
-			value = value[0]
-			self.entry = str(key) + ":	" + str(value)
-		else:
-			raise ValueError
-			print "Method argument requires a 1 {key: value} dict. Supplied argument not one {key: value}"
-
-		# Try to open and write the result to the log
-		try:
-			self.loghandle = open(self.logfile, 'a')
-			self.loghandle.write(self.stamper.entryStamp() + "	" + self.entry + "\n")
-			self.loghandle.flush()
-			self.loghandle.close()
-
-		except IOError:
-			print "Could not write to file " + self.logfile
+    """
+    Generates timestamps tempfiles and log entries
+    """
+    def __init__(self):
+        self.now = "0"
+        self.timetup = time.localtime()
+
+    def zeroPad(self, int, width = 2):
+        """
+        Pads an integer 'int' with zeroes, up to width 'width'.
+
+        Returns a string.
+
+        It will not truncate. If you call zeroPad(100, 2), '100' will be returned.
+        """
+        if int < 10 ** width:
+            return ("0" * (width - len(str(int))) ) + str(int)
+        else:
+            return str(int)
+
+    # file stamper
+    def fileStamp(self, filename, addTime = True):
+        """
+        Generates a filename stamp in the format of filename_YYYYMMDD-hhmmss.
+        A format of filename_YYYYMMDD can be used instead by specifying addTime = False.
+        """
+        self.now = filename.strip() + "_"
+        self.timetup = time.localtime()
+
+        # Should produce rel-eng style filestamps
+        # format it all pretty by chopping the tuple
+        fieldCount = 3
+        if addTime: fieldCount = fieldCount + 3
+        for i in range(fieldCount):
+            if i == 3: self.now = self.now + '-'
+            self.now = self.now + self.zeroPad(self.timetup[i])
+        return self.now
+
+    # Log entry stamper
+    def entryStamp(self):
+        """
+        Generates a logfile entry stamp of YYYY.MM.DD HH:MM:SS
+        """
+        self.timetup = time.localtime()
+
+        # This will return a log entry formatted string in YYYY.MM.DD HH:MM:SS
+        for i in range(6):
+            # put in the year
+            if i == 0:
+                self.now = str(self.timetup[i])
+            # Format Month and Day
+            elif i == 1 or i == 2:
+                self.now = self.now + "." + self.zeroPad(self.timetup[i])
+            else:
+                x = self.timetup[i]
+                # make the " " between Day and Hour and put in the hour
+                if i == 3:
+                    self.now = self.now + " " + self.zeroPad(self.timetup[i])
+                # Otherwise Use the ":" divider
+                else:
+                    self.now = self.now + ":" + self.zeroPad(self.timetup[i])
+        return self.now
 
 class IconLogger:
-	"""
-	Writes entries to the tooltip of an icon in the notification area or the desktop.
-	"""
-	trayicon = None
-	def __init__(self, config = None, module_list = None):
-		if not IconLogger.trayicon:
-			from trayicon import TrayIcon
-			IconLogger.trayicon = TrayIcon()
-			if IconLogger.trayicon.proc: self.works = True
-			else: self.works = False
-			iconName = 'dogtail-tail-48.png'
-			iconPath = '/usr/share/icons/hicolor/48x48/apps/' + iconName
-			if os.path.exists(iconPath):
-				IconLogger.trayicon.set_icon(iconPath)
-			self.message('dogtail running...')
-
-	def message(self, msg):
-		"""
-		Display a message to the user
-		"""
-		IconLogger.trayicon.set_tooltip(msg)
-
-class DebugLogger:
-	"""
-	Writes entries to standard out, and to an IconLogger if possible.
-	"""
-	def __init__(self):
-		self.iconLogger = IconLogger()
-
-	def log(self, message):
-		"""
-		Hook used for logging messages. Might eventually be a virtual
-		function, but nice and simple for now.
-		"""
-		# Try to use the IconLogger.
-		if self.iconLogger.works: self.iconLogger.message(message)
-		# Also write to standard out.
-		print message
-
-debugLogger = DebugLogger()
+    """
+    Writes entries to the tooltip of an icon in the notification area or the desktop.
+    """
+    trayicon = None
+    def __init__(self):
+        if not IconLogger.trayicon:
+            from trayicon import TrayIcon
+            IconLogger.trayicon = TrayIcon()
+            if IconLogger.trayicon.proc: self.works = True
+            else: self.works = False
+            iconName = 'dogtail-tail-48.png'
+            iconPath = '/usr/share/icons/hicolor/48x48/apps/' + iconName
+            if os.path.exists(iconPath):
+                IconLogger.trayicon.set_icon(iconPath)
+            self.message('dogtail running...')
+
+    def message(self, msg):
+        """
+        Display a message to the user
+        """
+        IconLogger.trayicon.set_tooltip(msg)
+
+    def __del__(self):
+        IconLogger.trayicon.close()
+
+class Logger:
+    """
+    Writes entries to standard out, and to an IconLogger if desired.
+    """
+    iconLogger = None
+    stamper = TimeStamp()
+    def __init__(self, logName, file = False, stdOut = True):
+        """
+        FIXME! make this log to a file based on the name arg.
+
+        name: the name of the log
+
+        file: The file object to log to.
+
+        stdOut: Whether to log to standard out.
+        """
+        self.logName = logName
+        self.stdOut = stdOut
+        self.file = file # Handle to the logfile
+        if not self.file: return
+
+        logDir = config.logDir
+        if not os.path.isdir(logDir): os.makedirs(logDir)
+
+        scriptName = config.scriptName
+        if not scriptName: scriptName = 'log'
+        self.fileName = scriptName
+
+        # check to see if we can write to the logDir
+        if os.path.isdir(logDir):
+            # generate a logfile name and check if it already exists
+            self.fileName = logDir + self.stamper.fileStamp(self.fileName) + '_' + self.logName
+            i = 0
+            while os.path.exists(self.fileName):
+                # Append the pathname
+                if i == 0:
+                    self.fileName = self.fileName + "." + str(i)
+                else:
+                    logsplit = self.fileName.split(".")
+                    logsplit[-1] = str(i)
+                    self.fileName = ".".join(logsplit)
+                i += 1
+        else:
+            # If path doesn't exist, raise an exception
+            raise IOError, "Log path %s does not exist or is not a directory" % logDir
+
+        # Try to create the file and write the header info
+        try:
+            print "Creating logfile at %s ..." % self.fileName
+            self.file = codecs.open(self.fileName, mode = 'wb', encoding = 'utf-8')
+            self.file.write("##### " + os.path.basename(self.fileName) + '\n')
+            self.file.flush()
+            #self.file.close()
+        except IOError:
+            print "Could not create and write to " + self.fileName
+
+    def log(self, message):
+        """
+        Hook used for logging messages. Might eventually be a virtual
+        function, but nice and simple for now.
+        """
+        message = message.decode('utf-8', 'replace')
+
+        # Try to use the IconLogger.
+        if self.iconLogger and self.iconLogger.works:
+            self.iconLogger.message(message)
+        
+        # Also write to standard out.
+        if self.stdOut: print message
+
+        # Try to open and write the result to the log file.
+        if not self.file: return
+        try:
+            #self.file = open(self.fileName, 'a')
+            self.file.write(message + '\n')
+            self.file.flush()
+            #self.file.close()
+        except IOError:
+            print "Could not write to file " + self.fileName
+
+class ResultsLogger(Logger):
+    """
+    Writes entries into the Dogtail log
+    """
+    def __init__(self, stdOut = True):
+        Logger.__init__(self, 'results', file = True, stdOut = stdOut)
+        # Set the logDir - maybe we want to use mktemp(1) for this later.
+
+    # Writes the result of a test case comparison to the log
+    def log(self, entry):
+        """
+        Writes the log entry. Requires a 1 {key: value} pair dict for an argument or else it will throw an exception.
+        """
+        # We require a 1 key: value dict
+        # Strip all leading and trailing witespace from entry dict and convert
+    # to string for writing
+
+        if len(entry) == 1:
+            key = entry.keys()
+            value = entry.values()
+            key = key[0]
+            value = value[0]
+            entry = str(key) + ":      " + str(value)
+        else:
+            raise ValueError, entry
+            print "Method argument requires a 1 {key: value} dict. Supplied argument not one {key: value}"
+
+        Logger.log(self, self.stamper.entryStamp() + "      " + entry)
+
+debugLogger = Logger('debug', file = True)
+
+import traceback
+def exceptionHook(exc, value, tb):
+    tbStringList = traceback.format_exception(exc, value, tb)
+    tbString = ''.join(tbStringList)
+    debugLogger.log(tbString)
+    sys.exc_clear()
+
+sys.excepthook = exceptionHook

=== modified file 'dogtail/path.py'
--- dogtail/path.py	2006-08-01 22:59:27 +0000
+++ dogtail/path.py	2006-12-21 13:33:47 +0000
@@ -5,107 +5,106 @@
 __author__ = """David Malcolm <dmalcolm@redhat.com>"""
 
 class SearchPath:
-	"""
-	Class used by the recording framework (and for more verbose script
-	logging) for identifying nodes in a persistent way, independent of the
-	style of script being written.
-
-	Implemented as a list of (predicate, isRecursive) pairs, giving the
-	'best' way to find the Accessible wrapped by a Node, starting at the
-	root and applying each search in turn.
-
-	This is somewhat analagous to an absolute path in a filesystem, except
-	that some of searches may be recursive, rather than just searching
-	direct children.
-		
-	FIXME: try to ensure uniqueness
-	FIXME: need some heuristics to get 'good' searches, whatever
-	that means
-	"""
-
-	def __init__(self):
-		self.__list = []
-
-	def __str__(self):
-		result = "{"
-		for (predicate, isRecursive) in self.__list:			
-			result += "/(%s,%s)"%(predicate.describeSearchResult(), isRecursive)
-		return result+"}"
-
-	# We need equality to work so that dicts of these work:
-	def __eq__(self, other):
-		# print "eq: self:%s"%self
-		# print "	other:%s"%other
-		if len(self.__list) != len(other.__list):
-			# print "nonequal length"
-			return False
-		else:
-			for i in range(len(self.__list)):
-				if self.__list[i]!=other.__list[i]:
-					return False
-		# print True
-		return True
-	
-	def append(self, predicate, isRecursive):
-		assert predicate
-		self.__list.append((predicate, isRecursive))
-
-	def __iter__(self):
-		return iter(self.__list)
-
-	def length(self):
-		return len(self.__list)
-
-	def makeScriptMethodCall(self):
-		"""
-		Used by the recording system.
-		
-		Generate the Python source code that will carry out this search.
-		"""
-		result = ""
-		for (predicate, isRecursive) in self.__list:
-			# print predicate
-			# print self.generateVariableName(predicate)
-			result += "." + predicate.makeScriptMethodCall(isRecursive)
-		return result
-
-	def getRelativePath(self, other):
-		"""
-		Given another SearchPath instance, if the other is 'below' this
-		one, return a SearchPath that describes how to reach it relative
-		to this one (a copy of the second part of the list).	Otherwise
-		return None.
-		"""
-		for i in range(len(self.__list)):
-			if self.__list[i]!=other.__list[i]:
-				break
-		if i>0:
-			# Slice from this point to the end:
-			result = SearchPath()
-			result.__list = other.__list[i+1:]
-
-			if False:
-				print "...................."
-				print "from %s"%self
-				print "to %s"%other
-				print "i=%s"%i
-				print "relative path %s"%result
-				print "...................."
-				
-			return result
-		else:
-			return None
-
-	def getPrefix(self, n):
-		"""
-		Get the first n components of this instance as a new instance
-		"""
-		result = SearchPath()
-		for i in range(n):
-			result.__list.append(self.__list[i])
-		return result
-
-	def getPredicate(self, i):
-		(predicate, isRecursive) = self.__list[i]
-		return predicate
-	
+    """
+    Class used by the recording framework (and for more verbose script
+    logging) for identifying nodes in a persistent way, independent of the
+    style of script being written.
+
+    Implemented as a list of (predicate, isRecursive) pairs, giving the
+    'best' way to find the Accessible wrapped by a Node, starting at the
+    root and applying each search in turn.
+
+    This is somewhat analagous to an absolute path in a filesystem, except
+    that some of searches may be recursive, rather than just searching
+    direct children.
+
+    FIXME: try to ensure uniqueness
+    FIXME: need some heuristics to get 'good' searches, whatever
+    that means
+    """
+
+    def __init__(self):
+        self.__list = []
+
+    def __str__(self):
+        result = "{"
+        for (predicate, isRecursive) in self.__list:
+            result += "/(%s,%s)"%(predicate.describeSearchResult(), isRecursive)
+        return result+"}"
+
+    # We need equality to work so that dicts of these work:
+    def __eq__(self, other):
+        # print "eq: self:%s"%self
+        # print "       other:%s"%other
+        if len(self.__list) != len(other.__list):
+            # print "nonequal length"
+            return False
+        else:
+            for i in range(len(self.__list)):
+                if self.__list[i]!=other.__list[i]:
+                    return False
+        # print True
+        return True
+
+    def append(self, predicate, isRecursive):
+        assert predicate
+        self.__list.append((predicate, isRecursive))
+
+    def __iter__(self):
+        return iter(self.__list)
+
+    def length(self):
+        return len(self.__list)
+
+    def makeScriptMethodCall(self):
+        """
+        Used by the recording system.
+
+        Generate the Python source code that will carry out this search.
+        """
+        result = ""
+        for (predicate, isRecursive) in self.__list:
+            # print predicate
+            # print self.generateVariableName(predicate)
+            result += "." + predicate.makeScriptMethodCall(isRecursive)
+        return result
+
+    def getRelativePath(self, other):
+        """
+        Given another SearchPath instance, if the other is 'below' this
+        one, return a SearchPath that describes how to reach it relative
+        to this one (a copy of the second part of the list).    Otherwise
+        return None.
+        """
+        for i in range(len(self.__list)):
+            if self.__list[i]!=other.__list[i]:
+                break
+        if i>0:
+            # Slice from this point to the end:
+            result = SearchPath()
+            result.__list = other.__list[i+1:]
+
+            if False:
+                print "...................."
+                print "from %s"%self
+                print "to %s"%other
+                print "i=%s"%i
+                print "relative path %s"%result
+                print "...................."
+
+            return result
+        else:
+            return None
+
+    def getPrefix(self, n):
+        """
+        Get the first n components of this instance as a new instance
+        """
+        result = SearchPath()
+        for i in range(n):
+            result.__list.append(self.__list[i])
+        return result
+
+    def getPredicate(self, i):
+        (predicate, isRecursive) = self.__list[i]
+        return predicate

=== modified file 'dogtail/predicate.py'
--- dogtail/predicate.py	2006-08-01 22:59:27 +0000
+++ dogtail/predicate.py	2006-12-21 13:33:47 +0000
@@ -8,353 +8,363 @@
 from i18n import TranslatableString
 
 def stringMatches(scriptName, reportedName):
-	assert isinstance(scriptName, TranslatableString)
-	
-	return scriptName.matchedBy(reportedName)
-	
+    assert isinstance(scriptName, TranslatableString)
+
+    return scriptName.matchedBy(reportedName)
+
 def makeScriptRecursiveArgument(isRecursive, defaultValue):
-	if isRecursive==defaultValue:
-		return ""
-	else:
-		return ", recursive=%s"%isRecursive
+    if isRecursive==defaultValue:
+        return ""
+    else:
+        return ", recursive=%s"%isRecursive
 
 def makeCamel(string):
-	"""
-	Convert string to camelCaps
-	"""
-	string = str(string)
-	# FIXME: this function is probably really fragile, lots of difficult cases here
+    """
+    Convert string to camelCaps
+    """
+    string = str(string)
+    # FIXME: this function is probably really fragile, lots of difficult cases here
 
-	# Sanitize string, replacing bad characters with spaces:
-	for char in ":;!@#$%^&*()-+=_~`\\/?|[]{}<>,.\t\n\r\"'":
-		string = string.replace(char, " ")
-	words = string.strip().split(" ")
-	for word in words:
-		word.strip
-	result = ""
-	firstWord=True
-	for word in words:
-		lowercaseWord = word.lower()
-		if firstWord:
-			result += lowercaseWord
-			firstWord=False
-		else:
-			result += lowercaseWord.capitalize()
-	return result
+    # Sanitize string, replacing bad characters with spaces:
+    for char in ":;!@#$%^&*()-+=_~`\\/?|[]{}<>,.\t\n\r\"'":
+        string = string.replace(char, " ")
+    words = string.strip().split(" ")
+    for word in words:
+        word.strip
+    result = ""
+    firstWord=True
+    for word in words:
+        lowercaseWord = word.lower()
+        if firstWord:
+            result += lowercaseWord
+            firstWord=False
+        else:
+            result += lowercaseWord.capitalize()
+    return result
 
 class Predicate:
-	"""Abstract base class representing a predicate function on nodes.
-
-	It's more than just a function in that it has data and can describe itself"""
-	def satisfiedByNode(self, node):
-		"""Pure virtual method returning a boolean if the predicate is satisfied by the node"""
-		raise NotImplementedError
-
-	def describeSearchResult(self, node):
-		raise NotImplementedError
-
-	def makeScriptMethodCall(self, isRecursive):
-		"""
-		Method to generate a string containing a (hopefully) readable search
-		method call on a node (to be used when generating Python source code in
-		the event recorder)
-		"""
-		raise NotImplementedError
-
-	def makeScriptVariableName(self):
-		"""
-		Method to generate a string containing a (hopefully) readable name
-		for a Node instance variable that would be the result of a search on
-		this predicate (to be used when generating Python source code in the
-		event recorder).
-		"""
-		raise NotImplementedError
-
-	def __eq__(self, other):
-		"""
-		Predicates are considered equal if they are of the same subclass and
-		have the same data
-		"""
-		# print "predeq: self:%s"%self
-		# print "		other:%s"%other
-		# print "predeq: selfdict:%s"%self.__dict__
-		# print "		otherdict:%s"%other.__dict__
-
-		if type(self)!=type(other):
-			return False
-		else:
-			return self.__dict__ == other.__dict__
+    """Abstract base class representing a predicate function on nodes.
+
+    It's more than just a function in that it has data and can describe itself"""
+    def satisfiedByNode(self, node):
+        """Pure virtual method returning a boolean if the predicate is satisfied by the node"""
+        raise NotImplementedError
+
+    def describeSearchResult(self, node):
+        raise NotImplementedError
+
+    def makeScriptMethodCall(self, isRecursive):
+        """
+        Method to generate a string containing a (hopefully) readable search
+        method call on a node (to be used when generating Python source code in
+        the event recorder)
+        """
+        raise NotImplementedError
+
+    def makeScriptVariableName(self):
+        """
+        Method to generate a string containing a (hopefully) readable name
+        for a Node instance variable that would be the result of a search on
+        this predicate (to be used when generating Python source code in the
+        event recorder).
+        """
+        raise NotImplementedError
+
+    def __eq__(self, other):
+        """
+        Predicates are considered equal if they are of the same subclass and
+        have the same data
+        """
+        # print "predeq: self:%s"%self
+        # print "               other:%s"%other
+        # print "predeq: selfdict:%s"%self.__dict__
+        # print "               otherdict:%s"%other.__dict__
+
+        if type(self)!=type(other):
+            return False
+        else:
+            return self.__dict__ == other.__dict__
 
 
 class IsAnApplicationNamed(Predicate):
-	"""Search subclass that looks for an application by name"""
-	def __init__(self, appName):
-		self.appName = TranslatableString(appName)
-
-	def satisfiedByNode(self, node):
-		return node.roleName=='application' and stringMatches(self.appName, node.name)
-
-	def describeSearchResult(self):
-		return '%s application'%self.appName
-
-	def makeScriptMethodCall(self, isRecursive):
-		# ignores the isRecursive parameter
-		return "application('%s')"%self.appName
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.appName)+"App"
+    """Search subclass that looks for an application by name"""
+    def __init__(self, appName):
+        self.appName = TranslatableString(appName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='application' and stringMatches(self.appName, node.name)
+
+    def describeSearchResult(self):
+        return '%s application'%self.appName
+
+    def makeScriptMethodCall(self, isRecursive):
+        # ignores the isRecursive parameter
+        return "application(%s)"%self.appName
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.appName)+"App"
 
 class GenericPredicate(Predicate):
-	"""SubtreePredicate subclass that takes various optional search fields"""
-
-	def __init__(self, name = None, roleName = None, description= None, label = None, debugName=None):
-		if name:
-			self.name = TranslatableString(name)
-		else:
-			self.name = None
-		self.roleName = roleName
-		self.description = description
-		if label:		
-			self.label = TranslatableString(label)
-		else:
-			self.label = None
-
-		if debugName:
-			self.debugName = debugName
-		else:
-			if label:
-				self.debugName = "labelled '%s'"%self.label
-			else:
-				self.debugName = "child with"
-			if name:
-				self.debugName += " name=%s" % self.name
-			if roleName:
-				self.debugName += " roleName='%s'"%roleName
-			if description:
-				self.debugName += " description='%s'"%description
-		assert self.debugName
-
-
-	def satisfiedByNode(self, node):
-		# labelled nodes are handled specially:
-		if self.label:
-			# this reverses the search; we're looking for a node with LABELLED_BY
-			# and then checking the label, rather than looking for a label and
-			# then returning whatever LABEL_FOR targets
-			if node.labeller:
-				return stringMatches(self.label, node.labeller.name)
-			else: return False	
-		else:
-			# Ensure the node matches any criteria that were set:
-			if self.name:
-				if not stringMatches(self.name,node.name): return False
-			if self.roleName:
-				if self.roleName!=node.roleName: return False
-			if self.description:
-				if self.description!=node.description: return False
-			return True
-		
-	def describeSearchResult(self):
-		return self.debugName
-
-	def makeScriptMethodCall(self, isRecursive):
-		if self.label:
-			args = "label='%s'"%label
-		else:
-			args = ""
-			if self.name:
-				args += " name='%s'"%self.name
-			if self.roleName:
-				args += " roleName='%s'"%self.roleName
-			if self.description:
-				args += " description='%s'"%self.description
-		return "child(%s%s)"%(args, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		if self.label:
-			return makeCamel(self.label)+"Node"
-		else:
-			if self.name:
-				return makeCamel(self.name)+"Node"
-			if self.roleName:
-				return makeCamel(self.roleName)+"Node"
-			if self.description:
-				return makeCamel(self.description)+"Node"		
+    """SubtreePredicate subclass that takes various optional search fields"""
+
+    def __init__(self, name = None, roleName = None, description= None, label = None, debugName=None):
+        if name:
+            self.name = TranslatableString(name)
+        else:
+            self.name = None
+        self.roleName = roleName
+        self.description = description
+        if label:
+            self.label = TranslatableString(label)
+        else:
+            self.label = None
+
+        if debugName:
+            self.debugName = debugName
+        else:
+            if label:
+                self.debugName = "labelled '%s'"%self.label
+            else:
+                self.debugName = "child with"
+            if name:
+                self.debugName += " name=%s" % self.name
+            if roleName:
+                self.debugName += " roleName='%s'"%roleName
+            if description:
+                self.debugName += " description='%s'"%description
+        assert self.debugName
+
+
+    def satisfiedByNode(self, node):
+        # labelled nodes are handled specially:
+        if self.label:
+            # this reverses the search; we're looking for a node with LABELLED_BY
+            # and then checking the label, rather than looking for a label and
+            # then returning whatever LABEL_FOR targets
+            if node.labeller:
+                return stringMatches(self.label, node.labeller.name)
+            else: return False
+        else:
+            # Ensure the node matches any criteria that were set:
+            if self.name:
+                if not stringMatches(self.name,node.name): return False
+            if self.roleName:
+                if self.roleName!=node.roleName: return False
+            if self.description:
+                if self.description!=node.description: return False
+            return True
+
+    def describeSearchResult(self):
+        return self.debugName
+
+    def makeScriptMethodCall(self, isRecursive):
+        if self.label:
+            args = "label=%s"%label
+        else:
+            args = ""
+            if self.name:
+                args += " name=%s"%self.name
+            if self.roleName:
+                args += " roleName=%s"%self.roleName
+            if self.description:
+                args += " description=%s"%self.description
+        return "child(%s%s)"%(args, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        if self.label:
+            return makeCamel(self.label)+"Node"
+        else:
+            if self.name:
+                return makeCamel(self.name)+"Node"
+            if self.roleName:
+                return makeCamel(self.roleName)+"Node"
+            if self.description:
+                return makeCamel(self.description)+"Node"
 
 class IsNamed(Predicate):
-	"""Predicate subclass that looks simply by name"""
-
-	def __init__(self, name):
-		self.name = TranslatableString(name)
-	
-	def satisfiedByNode(self, node):
-		return stringMatches(self.name, node.name)
-
-	def describeSearchResult(self):
-		return "named %s"%self.name
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "child(name='%s'%s)"%(self.name, makeScriptRecursiveArgument(isRecursive, True))
-	def makeScriptVariableName(self):
-		return makeCamel(self.name)+"Node"
+    """Predicate subclass that looks simply by name"""
+
+    def __init__(self, name):
+        self.name = TranslatableString(name)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return stringMatches(self.name, node.name)
+
+    def describeSearchResult(self):
+        return "named %s"%self.name
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "child(name=%s%s)"%(self.name, makeScriptRecursiveArgument(isRecursive, True))
+    def makeScriptVariableName(self):
+        return makeCamel(self.name)+"Node"
 
 class IsAWindowNamed(Predicate):
-	"""Predicate subclass that looks for a top-level window by name"""
-	def __init__(self, windowName):
-		self.windowName = TranslatableString(windowName)
-
-	def satisfiedByNode(self, node):
-		return node.roleName=='frame' and stringMatches(self.windowName, node.name)
-
-	def describeSearchResult(self):
-		return "%s window"%self.windowName
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "window('%s'%s)"%(self.windowName, makeScriptRecursiveArgument(isRecursive, False))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.windowName)+"Win"
+    """Predicate subclass that looks for a top-level window by name"""
+    def __init__(self, windowName):
+        self.windowName = TranslatableString(windowName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='frame' and stringMatches(self.windowName, node.name)
+
+    def describeSearchResult(self):
+        return "%s window"%self.windowName
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "window(%s%s)"%(self.windowName, makeScriptRecursiveArgument(isRecursive, False))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.windowName)+"Win"
 
 class IsAWindow(Predicate):
-	"""Predicate subclass that looks for top-level windows"""
-	def satisfiedByNode(self, node):
-		return node.roleName=='frame'
+    """Predicate subclass that looks for top-level windows"""
+    def satisfiedByNode(self, node):
+        return node.roleName=='frame'
 
-	def describeSearchResult(self):
-		return "window"
+    def describeSearchResult(self):
+        return "window"
 
 class IsADialogNamed(Predicate):
-	"""Predicate subclass that looks for a top-level dialog by name"""
-	def __init__(self, dialogName):
-		self.dialogName = TranslatableString(dialogName)
-
-	def satisfiedByNode(self, node):
-		return node.roleName=='dialog' and stringMatches(self.dialogName, node.name)
-
-	def describeSearchResult(self):
-		return '%s dialog'%self.dialogName
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "dialog('%s'%s)"%(self.dialogName, makeScriptRecursiveArgument(isRecursive, False))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.dialogName)+"Dlg"
+    """Predicate subclass that looks for a top-level dialog by name"""
+    def __init__(self, dialogName):
+        self.dialogName = TranslatableString(dialogName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='dialog' and stringMatches(self.dialogName, node.name)
+
+    def describeSearchResult(self):
+        return '%s dialog'%self.dialogName
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "dialog(%s%s)"%(self.dialogName, makeScriptRecursiveArgument(isRecursive, False))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.dialogName)+"Dlg"
 
 class IsLabelledBy(Predicate):
-	"""Predicate: is this node labelled by another node"""
-	pass
+    """Predicate: is this node labelled by another node"""
+    pass
 
 class IsLabelledAs(Predicate):
-	"""Predicate: is this node labelled with the text string (i.e. by another node with that as a name)"""
-	def __init__(self, labelText):
-		self.labelText = TranslatableString(labelText)
-		
-	def satisfiedByNode(self, node):
-		# FIXME
-		if node.labeller:
-			return stringMatches(self.labelText, node.labeller.name)
-		else: return False
-
-	def describeSearchResult(self):
-		return 'labelled %s'%self.labelText
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "child(label='%s'%s)"%(self.labelText, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.labelText)+"Node"
+    """Predicate: is this node labelled with the text string (i.e. by another node with that as a name)"""
+    def __init__(self, labelText):
+        self.labelText = TranslatableString(labelText)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        # FIXME
+        if node.labeller:
+            return stringMatches(self.labelText, node.labeller.name)
+        else: return False
+
+    def describeSearchResult(self):
+        return 'labelled %s'%self.labelText
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "child(label=%s%s)"%(self.labelText, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.labelText)+"Node"
 
 class IsAMenuNamed(Predicate):
-	"""Predicate subclass that looks for a menu by name"""
-	def __init__(self, menuName):
-		self.menuName = TranslatableString(menuName)
-	
-	def satisfiedByNode(self, node):
-		return node.roleName=='menu' and stringMatches(self.menuName, node.name)
-
-	def describeSearchResult(self):
-		return '%s menu'%(self.menuName)
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "menu('%s'%s)"%(self.menuName, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.menuName)+"Menu"
+    """Predicate subclass that looks for a menu by name"""
+    def __init__(self, menuName):
+        self.menuName = TranslatableString(menuName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='menu' and stringMatches(self.menuName, node.name)
+
+    def describeSearchResult(self):
+        return '%s menu'%(self.menuName)
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "menu(%s%s)"%(self.menuName, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.menuName)+"Menu"
 
 class IsAMenuItemNamed(Predicate):
-	"""Predicate subclass that looks for a menu item by name"""
-	def __init__(self, menuItemName):
-		self.menuItemName = TranslatableString(menuItemName)
-	
-	def satisfiedByNode(self, node):
-		roleName = node.roleName
-		return (roleName=='menu item' or roleName=='check menu item' or roleName=='radio menu item') and stringMatches(self.menuItemName, node.name)
-
-	def describeSearchResult(self):
-		return '%s menuitem'%(self.menuItemName)
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "menuItem('%s'%s)"%(self.menuItemName, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.menuItemName)+"MenuItem"
+    """Predicate subclass that looks for a menu item by name"""
+    def __init__(self, menuItemName):
+        self.menuItemName = TranslatableString(menuItemName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        roleName = node.roleName
+        return (roleName=='menu item' or roleName=='check menu item' or roleName=='radio menu item') and stringMatches(self.menuItemName, node.name)
+
+    def describeSearchResult(self):
+        return '%s menuitem'%(self.menuItemName)
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "menuItem(%s%s)"%(self.menuItemName, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.menuItemName)+"MenuItem"
 
 class IsATextEntryNamed(Predicate):
-	"""Predicate subclass that looks for a text entry by name"""
-	def __init__(self, textEntryName):
-		self.textEntryName = TranslatableString(textEntryName)
-	
-	def satisfiedByNode(self, node):
-		return node.roleName=='text' and stringMatches(self.textEntryName, node.name)
-
-	def describeSearchResult(self):
-		return '%s textentry'%(self.textEntryName)
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "textentry('%s'%s)"%(self.textEntryName, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.textEntryName)+"Entry"
+    """Predicate subclass that looks for a text entry by name"""
+    def __init__(self, textEntryName):
+        self.textEntryName = TranslatableString(textEntryName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='text' and stringMatches(self.textEntryName, node.name)
+
+    def describeSearchResult(self):
+        return '%s textentry'%(self.textEntryName)
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "textentry(%s%s)"%(self.textEntryName, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.textEntryName)+"Entry"
 
 class IsAButtonNamed(Predicate):
-	"""Predicate subclass that looks for a button by name"""
-	def __init__(self, buttonName):
-		self.buttonName = TranslatableString(buttonName)
-	
-	def satisfiedByNode(self, node):
-		return node.roleName=='push button' and stringMatches(self.buttonName, node.name)
-
-	def describeSearchResult(self):
-		return '%s button'%(self.buttonName)
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "button('%s'%s)"%(self.buttonName, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.buttonName)+"Button"
+    """Predicate subclass that looks for a button by name"""
+    def __init__(self, buttonName):
+        self.buttonName = TranslatableString(buttonName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='push button' and stringMatches(self.buttonName, node.name)
+
+    def describeSearchResult(self):
+        return '%s button'%(self.buttonName)
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "button(%s%s)"%(self.buttonName, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.buttonName)+"Button"
 
 class IsATabNamed(Predicate):
-	"""Predicate subclass that looks for a tab by name"""
-	def __init__(self, tabName):
-		self.tabName = TranslatableString(tabName)
-	
-	def satisfiedByNode(self, node):
-		return node.roleName=='page tab' and stringMatches(self.tabName, node.name)
-
-	def describeSearchResult(self):
-		return '%s tab'%(self.tabName)
-
-	def makeScriptMethodCall(self, isRecursive):
-		return "tab('%s'%s)"%(self.tabName, makeScriptRecursiveArgument(isRecursive, True))
-
-	def makeScriptVariableName(self):
-		return makeCamel(self.tabName)+"Tab"
+    """Predicate subclass that looks for a tab by name"""
+    def __init__(self, tabName):
+        self.tabName = TranslatableString(tabName)
+        self.debugName = self.describeSearchResult()
+
+    def satisfiedByNode(self, node):
+        return node.roleName=='page tab' and stringMatches(self.tabName, node.name)
+
+    def describeSearchResult(self):
+        return '%s tab'%(self.tabName)
+
+    def makeScriptMethodCall(self, isRecursive):
+        return "tab(%s%s)"%(self.tabName, makeScriptRecursiveArgument(isRecursive, True))
+
+    def makeScriptVariableName(self):
+        return makeCamel(self.tabName)+"Tab"
 
 class PredicateTests(unittest.TestCase):
-	def testCapitalization(self):
-			self.assertEquals(makeCamel("gnome-terminal"),"gnomeTerminal")
-			self.assertEquals(makeCamel("Evolution - Mail"), "evolutionMail")
-			self.assertEquals(makeCamel('self.assertEquals(makeCamel("Evolution - Mail"), "evolutionMail")'), "selfAssertequalsMakecamelEvolutionMailEvolutionmail")
+    def testCapitalization(self):
+        self.assertEquals(makeCamel("gnome-terminal"),"gnomeTerminal")
+        self.assertEquals(makeCamel("Evolution - Mail"), "evolutionMail")
+        self.assertEquals(makeCamel('self.assertEquals(makeCamel("Evolution - Mail"), "evolutionMail")'), "selfAssertequalsMakecamelEvolutionMailEvolutionmail")
 
 if __name__ == "__main__":
-	 unittest.main()
+    unittest.main()

=== modified file 'dogtail/procedural.py'
--- dogtail/procedural.py	2006-08-01 22:59:27 +0000
+++ dogtail/procedural.py	2006-12-21 13:33:47 +0000
@@ -3,286 +3,350 @@
 All the classes here are intended to be single-instance, except for Action.
 """
 __author__ = 'Zack Cerza <zcerza@redhat.com>'
+##############################################################################
+#                                                                            #
+# WARNING: Here There Be Dragons (TM)                                        #
+#                                                                            #
+# If you don't understand how to use this API, you almost certainly don't    #
+# want to read the code first. We make use of some very non-intuitive        #
+# features of Python in order to make the API very simplistic. Therefore,    #
+# you should probably only read this code if you're already familiar with    #
+# some of Python's advanced features. You have been warned. ;)               #
+#                                                                            #
+##############################################################################
 
 import tree
-from predicate import GenericPredicate, IsADialogNamed
+from predicate import GenericPredicate, IsADialogNamed, IsAnApplicationNamed
 from config import config
+import rawinput
 from time import sleep
 
 #FocusError = "FocusError: %s not found"
 class FocusError(Exception):
-	pass
+    pass
+
+import errors
+def focusFailed():
+    errors.warn('The requested object was not found')
 
 ENOARGS = "At least one argument is needed"
 
 class FocusBase:
-	"""
-	The base for every class in the module. Does nothing special, really.
-	"""
-	def __getattr__ (self, name):
-		# Fold all the Node's AT-SPI properties into the Focus object.
-		try: return getattr(self.node, name)
-		except AttributeError: raise AttributeError, name
-	
-	def __setattr__ (self, name, value):
-		# Fold all the Node's AT-SPI properties into the Focus object.
-		if name == 'node': 
-			self.__dict__[name] = value
-		else:
-			try: setattr(self.node, name, value)
-			except AttributeError: raise AttributeError, name
-	
+    """
+    The base for every class in the module. Does nothing special, really.
+    """
+    node = None
+
+    def __getattr__ (self, name):
+        # Fold all the Node's AT-SPI properties into the Focus object.
+        try: return getattr(self.node, name)
+        except AttributeError: 
+            raise AttributeError, name
+
+    def __setattr__ (self, name, value):
+        # Fold all the Node's AT-SPI properties into the Focus object.
+        if name == 'node':
+            self.__dict__[name] = value
+        else:
+            try: setattr(self.node, name, value)
+            except AttributeError: 
+                raise AttributeError, name
+
 class FocusApplication (FocusBase):
-	"""
-	Keeps track of which application is currently focused.
-	"""
-	desktop = tree.root
-	def __call__ (self, name = '', description = ''):
-		"""
-		If name or description are specified, search for an application that matches and refocus on it.
-		"""
-		if not name and not description:
-			raise TypeError, ENOARGS
-		# search for an application.
-		matched = False
-		for app in self.desktop.children:
-			nameMatch = app.name == name
-			descriptionMatch = app.description == description
-			if nameMatch and descriptionMatch:
-				FocusApplication.node = app
-				FocusDialog.node = None
-				FocusWidget.node = None
-				matched = True
-				break
-		if not matched: raise FocusError, name
+    """
+    Keeps track of which application is currently focused.
+    """
+    desktop = tree.root
+    def __call__ (self, name):
+        """
+        Search for an application that matches and refocus on the given name.
+        """
+        try:
+            predicate = IsAnApplicationNamed(name)
+            app = self.desktop.findChild(predicate, recursive = False, retry = False)
+        except tree.SearchError, desc:
+            if config.fatalErrors: raise FocusError, name
+            else:
+                focusFailed()
+                return
+        if app: 
+            FocusApplication.node = app
+            FocusDialog.node = None
+            FocusWidget.node = None
 
 class FocusDesktop (FocusBase):
-	"""
-	This isn't used yet, and may never be used.
-	"""	
-	pass
+    """
+    This isn't used yet, and may never be used.
+    """
+    pass
 
 class FocusDialog (FocusBase):
-	"""
-	Keeps track of which dialog is currently focused.
-	"""
-	def __call__ (self, name = '', description = ''):
-		"""
-		If name or description are specified, search for a dialog that matches and refocus on it.
-		"""
-		if not name and not description:
-			raise TypeError, ENOARGS
-		result = None
-		predicate = IsADialogNamed(name)
-		try:
-			result = FocusApplication.node.findChild(predicate, requireResult=False, recursive = False)
-		except AttributeError: pass
-		if result: 
-			FocusDialog.node = result
-			FocusWidget.node = None
-		else: raise FocusError, predicate.debugName
+    """
+    Keeps track of which dialog is currently focused.
+    """
+    def __call__ (self, name):
+        """
+        Search for a dialog that matches the given name and refocus on it.
+        """
+        result = None
+        predicate = IsADialogNamed(name)
+        try:
+            result = FocusApplication.node.findChild(predicate, requireResult=False, recursive = False)
+        except AttributeError: pass
+        if result:
+            FocusDialog.node = result
+            FocusWidget.node = None
+        else: 
+            if config.fatalErrors: raise FocusError, predicate.debugName
+            else:
+                focusFailed()
+                return
 
 class FocusWidget (FocusBase):
-	"""
-	Keeps track of which widget is currently focused.
-	"""
-	def __call__ (self, name = '', roleName = '', description = ''):
-		"""
-		If name, roleName or description are specified, search for a widget that matches and refocus on it.
-		"""
-		if not name and not roleName and not description:
-			raise TypeError, ENOARGS
-		
-		# search for a widget.
-		result = None
-		predicate = GenericPredicate(name = name, roleName = roleName, description = description)
-		try:
-			result = FocusWidget.node.findChild(predicate, requireResult = False, retry = False)
-		except AttributeError: pass
-		if result: FocusWidget.node = result
-		else:
-			try:
-				result = FocusDialog.node.findChild(predicate, requireResult = False, retry = False)
-			except AttributeError: pass
-		if result: FocusWidget.node = result
-		else: 
-			try:
-				result = FocusApplication.node.findChild(predicate, requireResult = False, retry = False)
-				if result: FocusWidget.node = result
-			except AttributeError: raise FocusError, name
-		
-		if result == None:
-			FocusWidget.node = result
-			raise FocusError, predicate.debugName
+    """
+    Keeps track of which widget is currently focused.
+    """
+    def __call__ (self, name = '', roleName = '', description = ''):
+        """
+        If name, roleName or description are specified, search for a widget that matches and refocus on it.
+        """
+        if not name and not roleName and not description:
+            raise TypeError, ENOARGS
+
+        # search for a widget.
+        result = None
+        predicate = GenericPredicate(name = name, roleName = roleName, description = description)
+        try:
+            result = FocusWidget.node.findChild(predicate, requireResult = False, retry = False)
+        except AttributeError: pass
+        if result: FocusWidget.node = result
+        else:
+            try:
+                result = FocusDialog.node.findChild(predicate, requireResult = False, retry = False)
+            except AttributeError: pass
+        if result: FocusWidget.node = result
+        else:
+            try:
+                result = FocusApplication.node.findChild(predicate, requireResult = False, retry = False)
+                if result: FocusWidget.node = result
+            except AttributeError: 
+                if config.fatalErrors: raise FocusError, name
+                else:
+                    focusFailed()
+                    return
+
+        if result == None:
+            FocusWidget.node = result
+            if config.fatalErrors: raise FocusError, predicate.debugName
+            else:
+                focusFailed()
+                return
 
 class Focus (FocusBase):
-	"""
-	The container class for the focused application, dialog and widget.
-	"""
-
-	def __getattr__ (self, name):
-		raise AttributeError, name
-	def __setattr__(self, name, value):
-		if name in ('application', 'dialog', 'widget'):
-			self.__dict__[name] = value
-		else:
-			raise AttributeError, name
-	
-	desktop = tree.root
-	application = FocusApplication()
-	app = application # shortcut :)
-	dialog = FocusDialog()
-	widget = FocusWidget()
-	
-	def button (self, name):
-		"""
-		A shortcut to self.widget(name, roleName = 'push button')
-		"""
-		self.widget(name = name, roleName = 'push button')
-	
-	def frame (self, name):
-		"""
-		A shortcut to self.widget(name, roleName = 'frame')
-		"""
-		self.widget(name = name, roleName = 'frame')
-	
-	def icon (self, name):
-		"""
-		A shortcut to self.widget(name, roleName = 'icon')
-		"""
-		self.widget(name = name, roleName = 'icon')
-	
-	def menu (self, name):
-		"""
-		A shortcut to self.widget(name, roleName = 'menu')
-		"""
-		self.widget(name = name, roleName = 'menu')
-	
-	def menuItem (self, name):
-		"""
-		A shortcut to self.widget(name, roleName = 'menu item')
-		"""
-		self.widget(name = name, roleName = 'menu item')
-	
-	def table (self, name = ''):
-		"""
-		A shortcut to self.widget(name, roleName 'table')
-		"""
-		self.widget(name = name, roleName = 'table')
-	
-	def tableCell (self, name = ''):
-		"""
-		A shortcut to self.widget(name, roleName 'table cell')
-		"""
-		self.widget(name = name, roleName = 'table cell')
-	
-	def text (self, name = ''):
-		"""
-		A shortcut to self.widget(name, roleName = 'text')
-		"""
-		self.widget(name = name, roleName = 'text')
-	
-	def window (self, name):
-		"""
-		A shortcut to self.widget(name, roleName = 'window')
-		"""
-		self.widget(name = name, roleName = 'window')
+    """
+    The container class for the focused application, dialog and widget.
+    """
+
+    def __getattr__ (self, name):
+        raise AttributeError, name
+    def __setattr__(self, name, value):
+        if name in ('application', 'dialog', 'widget'):
+            self.__dict__[name] = value
+        else:
+            raise AttributeError, name
+
+    desktop = tree.root
+    application = FocusApplication()
+    app = application # shortcut :)
+    dialog = FocusDialog()
+    widget = FocusWidget()
+
+    def button (self, name):
+        """
+        A shortcut to self.widget(name, roleName = 'push button')
+        """
+        self.widget(name = name, roleName = 'push button')
+
+    def frame (self, name):
+        """
+        A shortcut to self.widget(name, roleName = 'frame')
+        """
+        self.widget(name = name, roleName = 'frame')
+
+    def icon (self, name):
+        """
+        A shortcut to self.widget(name, roleName = 'icon')
+        """
+        self.widget(name = name, roleName = 'icon')
+
+    def menu (self, name):
+        """
+        A shortcut to self.widget(name, roleName = 'menu')
+        """
+        self.widget(name = name, roleName = 'menu')
+
+    def menuItem (self, name):
+        """
+        A shortcut to self.widget(name, roleName = 'menu item')
+        """
+        self.widget(name = name, roleName = 'menu item')
+
+    def table (self, name = ''):
+        """
+        A shortcut to self.widget(name, roleName 'table')
+        """
+        self.widget(name = name, roleName = 'table')
+
+    def tableCell (self, name = ''):
+        """
+        A shortcut to self.widget(name, roleName 'table cell')
+        """
+        self.widget(name = name, roleName = 'table cell')
+
+    def text (self, name = ''):
+        """
+        A shortcut to self.widget(name, roleName = 'text')
+        """
+        self.widget(name = name, roleName = 'text')
+
+    def window (self, name):
+        """
+        A shortcut to self.widget(name, roleName = 'window')
+        """
+        self.widget(name = name, roleName = 'window')
 
 class Action (FocusWidget):
-	"""
-	Aids in executing AT-SPI actions, refocusing the widget if necessary.
-	"""
-	def __init__ (self, action):
-		"""
-		action is a string with the same name as the AT-SPI action you wish to execute using this class.
-		"""
-		self.action = action
-	
-	def __call__ (self, name = '', roleName = '', description = '', delay = config.actionDelay):
-		"""
-		If name, roleName or description are specified, first search for a widget that matches and refocus on it.
-		Then execute the action.
-		"""
-		if name or roleName or description:
-			FocusWidget.__call__(self, name = name, roleName = roleName, description = description)
-		self.node.doAction(self.action)
-		sleep(delay)
-	
-	def __getattr__ (self, attr):
-		return getattr(FocusWidget.node, attr)
-
-	def __setattr__ (self, attr, value):
-		if attr == 'action': 
-			self.__dict__[attr] = value
-		else: setattr(FocusWidget, attr, value)
-
-	def button (self, name):
-		"""
-		A shortcut to self(name, roleName = 'push button')
-		"""
-		self.__call__(name = name, roleName = 'push button')
-	
-	def menu (self, name):
-		"""
-		A shortcut to self(name, roleName = 'menu')
-		"""
-		self.__call__(name = name, roleName = 'menu')
-	
-	def menuItem (self, name):
-		"""
-		A shortcut to self(name, roleName = 'menu item')
-		"""
-		self.__call__(name = name, roleName = 'menu item')
-	
-	def table (self, name = ''):
-		"""
-		A shortcut to self(name, roleName 'table')
-		"""
-		self.__call__(name = name, roleName = 'table')
-	
-	def tableCell (self, name = ''):
-		"""
-		A shortcut to self(name, roleName 'table cell')
-		"""
-		self.__call__(name = name, roleName = 'table cell')
-	
-	def text (self, name = ''):
-		"""
-		A shortcut to self(name, roleName = 'text')
-		"""
-		self.__call__(name = name, roleName = 'text')
+    """
+    Aids in executing AT-SPI actions, refocusing the widget if necessary.
+    """
+    def __init__ (self, action):
+        """
+        action is a string with the same name as the AT-SPI action you wish to execute using this class.
+        """
+        self.action = action
+
+    def __call__ (self, name = '', roleName = '', description = '', delay = config.actionDelay):
+        """
+        If name, roleName or description are specified, first search for a widget that matches and refocus on it.
+        Then execute the action.
+        """
+        if name or roleName or description:
+            FocusWidget.__call__(self, name = name, roleName = roleName, description = description)
+        self.node.doAction(self.action)
+        sleep(delay)
+
+    def __getattr__ (self, attr):
+        return getattr(FocusWidget.node, attr)
+
+    def __setattr__ (self, attr, value):
+        if attr == 'action':
+            self.__dict__[attr] = value
+        else: setattr(FocusWidget, attr, value)
+
+    def button (self, name):
+        """
+        A shortcut to self(name, roleName = 'push button')
+        """
+        self.__call__(name = name, roleName = 'push button')
+
+    def menu (self, name):
+        """
+        A shortcut to self(name, roleName = 'menu')
+        """
+        self.__call__(name = name, roleName = 'menu')
+
+    def menuItem (self, name):
+        """
+        A shortcut to self(name, roleName = 'menu item')
+        """
+        self.__call__(name = name, roleName = 'menu item')
+
+    def table (self, name = ''):
+        """
+        A shortcut to self(name, roleName 'table')
+        """
+        self.__call__(name = name, roleName = 'table')
+
+    def tableCell (self, name = ''):
+        """
+        A shortcut to self(name, roleName 'table cell')
+        """
+        self.__call__(name = name, roleName = 'table cell')
+
+    def text (self, name = ''):
+        """
+        A shortcut to self(name, roleName = 'text')
+        """
+        self.__call__(name = name, roleName = 'text')
 
 class Click (Action):
-	"""
-	A special case of Action, Click will eventually handle raw mouse events.
-	"""
-	primary = 1
-	middle = 2
-	secondary = 3
-	def __init__ (self):
-		Action.__init__(self, 'click')
-	
-	def __call__ (self, name = '', roleName = '', description = '', raw = False, button = primary, delay = config.actionDelay):
-		"""
-		If coords or button are specified, execute a raw mouse event. If not, just pass the rest of the arguments to Action.
-		"""
-		if raw and button:
-			# We're doing a raw mouse click
-			FocusWidget.__call__(self, name = name, roleName = roleName, description = description)
-			Click.node.rawClick(button)
-			sleep(delay)
-		else:
-			Action.__call__(self, name = name, roleName = roleName, description = description, delay = delay)
+    """
+    A special case of Action, Click will eventually handle raw mouse events.
+    """
+    primary = 1
+    middle = 2
+    secondary = 3
+    def __init__ (self):
+        Action.__init__(self, 'click')
+
+    def __call__ (self, name = '', roleName = '', description = '', raw = False, button = primary, delay = config.actionDelay):
+        """
+        If coords or button are specified, execute a raw mouse event. If not, just pass the rest of the arguments to Action.
+        """
+        if raw and button:
+            # We're doing a raw mouse click
+            FocusWidget.__call__(self, name = name, roleName = roleName, description = description)
+            Click.node.rawClick(button)
+            sleep(delay)
+        else:
+            Action.__call__(self, name = name, roleName = roleName, description = description, delay = delay)
+
+class Select (Action):
+    """
+    Aids in selecting and deselecting widgets, i.e. page tabs
+    """
+    select = 'select'
+    deselect = 'deselect'
+    def __init__(self, action):
+        """
+        action must be 'select' or 'deselect'.
+        """
+        if action not in (self.select, self.deselect):
+            raise ValueError, action
+        Action.__init__(self, action)
+
+    def __call__ (self, name = '', roleName = '', description = '', delay = config.actionDelay):
+        """
+        If name, roleName or description are specified, first search for a widget that matches and refocus on it.
+        Then execute the action.
+        """
+        if name or roleName or description:
+            FocusWidget.__call__(self, name = name, roleName = roleName, description = description)
+        func = getattr(self.node, self.action)
+        func()
+        sleep(delay)
+        
+def type(text):
+    if focus.widget.node:
+        focus.widget.node.typeText(text)
+    else:
+        rawinput.typeText(text)
+
+def keyCombo(combo):
+    if focus.widget.node:
+        focus.widget.node.keyCombo(combo)
+    else:
+        rawinput.keyCombo(combo)
 
 def run(application, arguments = '', appName = ''):
-	from utils import run as utilsRun
-	utilsRun(application + arguments, appName = appName)
-	focus.application(application)
-	
+    from utils import run as utilsRun
+    utilsRun(application + arguments, appName = appName)
+    focus.application(application)
 
 focus = Focus()
 click = Click()
 activate = Action('activate')
 openItem = Action('open')
 menu = Action('menu')
-
+select = Select(Select.select)
+deselect = Select(Select.deselect)

=== modified file 'dogtail/rawinput.py'
--- dogtail/rawinput.py	2006-08-01 22:59:27 +0000
+++ dogtail/rawinput.py	2006-12-21 13:33:47 +0000
@@ -11,102 +11,179 @@
 """
 
 import atspi
+import gtk.keysyms
+import gtk.gdk
+from config import config
 from utils import doDelay
 from logging import debugLogger as logger
+ev = atspi.EventGenerator()
+
+def doTypingDelay():
+    doDelay(config.typingDelay)
 
 def click (x, y, button = 1):
-	"""
-	Synthesize a mouse button click at (x,y)
-	"""
-	logger.log("Mouse button %s click at (%s,%s)"%(button,x,y))
-	ev = atspi.EventGenerator()
-	ev.click(x, y, button)
-	doDelay()
-	
+    """
+    Synthesize a mouse button click at (x,y)
+    """
+    logger.log("Mouse button %s click at (%s,%s)"%(button,x,y))
+    ev.click(x, y, button)
+    doDelay()
+
 def doubleClick (x, y, button = 1):
-	"""
-	Synthesize a mouse button double-click at (x,y)
-	"""
-	logger.log("Mouse button %s doubleclick at (%s,%s)"%(button,x,y))
-	ev = atspi.EventGenerator()
-	ev.doubleClick(x,y,button)
-	doDelay()
+    """
+    Synthesize a mouse button double-click at (x,y)
+    """
+    logger.log("Mouse button %s doubleclick at (%s,%s)"%(button,x,y))
+    ev.doubleClick(x,y,button)
+    doDelay()
 
 def press (x, y, button = 1):
-	"""
-	Synthesize a mouse button press at (x,y)
-	"""
-	logger.log("Mouse button %s press at (%s,%s)"%(button,x,y))
-	ev = atspi.EventGenerator()
-	ev.press(x,y, button)
-	doDelay()
-	
+    """
+    Synthesize a mouse button press at (x,y)
+    """
+    logger.log("Mouse button %s press at (%s,%s)"%(button,x,y))
+    ev.press(x,y, button)
+    doDelay()
+
 def release (x, y, button = 1):
-	"""
-	Synthesize a mouse button release at (x,y)
-	"""
-	logger.log("Mouse button %s release at (%s,%s)"%(button,x,y))
-	ev = atspi.EventGenerator()
-	ev.release(x,y,button)
-	doDelay()
+    """
+    Synthesize a mouse button release at (x,y)
+    """
+    logger.log("Mouse button %s release at (%s,%s)"%(button,x,y))
+    ev.release(x,y,button)
+    doDelay()
 
 def absoluteMotion (x, y):
-	"""
-	Synthesize mouse absolute motion to (x,y)
-	"""
-	logger.log("Mouse absolute motion to (%s,%s)"%(x,y))
-	ev = atspi.EventGenerator()
-	ev.absoluteMotion(x,y)
-	doDelay()
+    """
+    Synthesize mouse absolute motion to (x,y)
+    """
+    logger.log("Mouse absolute motion to (%s,%s)"%(x,y))
+    ev.absoluteMotion(x,y)
+    doDelay()
 
 def relativeMotion (x, y):
-	logger.log("Mouse relative motion of (%s,%s)"%(x,y))
-	ev = atspi.EventGenerator()
-	ev.relativeMotion(x,y)
-	doDelay()
+    logger.log("Mouse relative motion of (%s,%s)"%(x,y))
+    ev.relativeMotion(x,y)
+    doDelay()
 
 def drag(fromXY, toXY, button = 1):
-	"""
-	Synthesize a mouse press, drag, and release on the screen.
-	Wraps atspi.EventGenerator.drag, but with logging and delays.
-	"""
-	logger.log("Mouse button %s drag from %s to %s"%(button, fromXY, toXY))
-	ev = atspi.EventGenerator()
-
-	# A direct call to ev.drag doesn't work, delays seem to be needed
-	# for nautilus icon view to work, at least:
-		
-	(x,y) = fromXY
-	ev.press (x, y, button)
-	#doDelay()
-
-	(x,y) = toXY
-	ev.absoluteMotion(x,y)
-	doDelay()
-	
-	ev.release (x, y, button)
-	doDelay()
+    """
+    Synthesize a mouse press, drag, and release on the screen.
+    Wraps atspi.EventGenerator.drag, but with logging and delays.
+    """
+    logger.log("Mouse button %s drag from %s to %s"%(button, fromXY, toXY))
+
+    # A direct call to ev.drag doesn't work, delays seem to be needed
+    # for nautilus icon view to work, at least:
+
+    (x,y) = fromXY
+    ev.press (x, y, button)
+    #doDelay()
+
+    (x,y) = toXY
+    ev.absoluteMotion(x,y)
+    doDelay()
+
+    ev.release (x, y, button)
+    doDelay()
 
 def typeText(string):
-	"""
-	Types the specified string, one character at a time.
-	"""
-	ev = atspi.EventGenerator()
-	ev.injectKeyboardString(string)
-
-keySyms = {
-	'enter' : 0xff0d,
-	'esc' : 0xff1b,
-	'space' : 0x20
+    """
+    Types the specified string, one character at a time.
+    """
+    if not isinstance(string, unicode):
+        string = string.decode('utf-8')
+    for char in string:
+        pressKey(char)
+
+def __buildKeyStringsDict(keySymsDict):
+    syms = {}
+    keyStringsDict = {}
+    iter = keySymsDict.iteritems()
+    while True:
+        try:
+            item = iter.next()
+            """
+            if item[1] in syms.keys():
+                syms[item[1]].append(item[0])
+                print item[1], syms[item[1]]
+            else: 
+                try: syms[item[1]] = [item[0]]
+                except TypeError: pass
+            """
+            try:
+                if not keyStringsDict.has_key(item[1]):
+                    keyStringsDict[item[1]] = item[0]
+            except TypeError: pass
+        except StopIteration:
+            return keyStringsDict
+
+keySyms = gtk.keysyms.__dict__
+keyStrings = __buildKeyStringsDict(keySyms)
+
+keySymAliases = {
+    'enter' : 'Return',
+    'esc' : 'Escape',
+    'alt' : 'Alt_L',
+    'control' : 'Control_L',
+    'ctrl' : 'Control_L',
+    'shift' : 'Shift_L',
+    'del' : 'Delete',
+    'ins' : 'Insert',
+    'pageup' : 'Page_Up',
+    'pagedown' : 'Page_Down',
+    ' ' : 'space',
+    '\t' : 'Tab',
+    '\n' : 'Return'
 }
 
+def keySymToUniChar(keySym):
+    i = gtk.gdk.keyval_to_unicode(keySym)
+    if i: UniChar = unichr(i)
+    else: UniChar = ''
+    return UniChar
+
+def uniCharToKeySym(uniChar):
+    i = ord(uniChar)
+    keySym = gtk.gdk.unicode_to_keyval(i)
+    return keySym
+
 def pressKey(keyName):
-	"""
-	Presses (and releases) the key specified by keyName.
-	keyName is the English name of the key as seen on the keyboard. Ex: 'enter'
-	Names are looked up in the keySyms dict.
-	"""
-	ev = atspi.EventGenerator()
-	keySym = keySyms[keyName.lower()]
-	ev.generateKeyboardEvent(keySym, "", atspi.SPI_KEY_SYM)
+    """
+    Presses (and releases) the key specified by keyName.
+    keyName is the English name of the key as seen on the keyboard. Ex: 'enter'
+    Names are looked up in the keySyms dict. If they are not found there, 
+    they are looked up by uniCharToKeySym().
+    """
+    try:
+        keyName = keySymAliases.get(keyName.lower(), keyName)
+        keySym = keySyms[keyName]
+    except KeyError:
+        try: keySym = uniCharToKeySym(keyName)
+        except TypeError: raise KeyError, keyName
+    ev.generateKeyboardEvent(keySym, "", atspi.SPI_KEY_SYM)
+    doTypingDelay()
+
+def keyCombo(comboString):
+    """
+    Generates the appropriate keyboard events to simulate a user pressing the
+    specified key combination.
+
+    comboString is the representation of the key combo to be generated.
+    e.g. '<Control><Alt>p' or '<Control><Shift>PageUp' or '<Control>q'
+    """
+    strings = []
+    for s in comboString.split('<'):
+        if s:
+            for S in s.split('>'):
+                if S:
+                    S = keySymAliases.get(S.lower(), S)
+                    strings.append(S)
+    for s in strings:
+        if not keySyms.has_key(s):
+            raise ValueError, "Cannot find key %s" % s
+
+    ev.generateKeyCombo(strings)
+    doDelay()
+
 

=== modified file 'dogtail/tc.py'
--- dogtail/tc.py	2006-08-01 22:59:27 +0000
+++ dogtail/tc.py	2006-12-21 13:33:47 +0000
@@ -12,555 +12,554 @@
 import datetime
 import os.path
 from config import config
-from logging import LogWriter, TimeStamp
+from logging import ResultsLogger, TimeStamp, debugLogger
 from errors import DependencyNotFoundError
 
 
 class TC:
-	"""
-	The Test Case Superclass
-	"""
-	writer = LogWriter()
-	def __init__(self):
-		self.encoding = config.encoding
-		# ascii + unicode. 8 bit extended char has been ripped out
-		self.supportedtypes = ("ascii", "utf-8", "utf-16", "utf-16-be", "utf-16-le", "unicode-escape", "raw-unicode-escape",
-		"big5", "gb18030", "eucJP", "eucKR", "shiftJIS")
-
-	# String comparison function
-	def compare(self, label, baseline, undertest, encoding=config.encoding):
-		"""
-		Compares 2 strings to see if they are the same. The user may specify
-		the encoding to which the two strings are to be normalized for the
-		comparison. Default encoding is the default system encoding. 
-		Normalization to extended 8 bit charactersets is not supported.
-
-		When the origin of either baseline or undertest is a text file whose 
-		encoding is something other than ASCII, it is necessary to use 
-		codecs.open() instead of open(), so the file's encoding may be 
-		specified.
-		"""
-		self.label = label.strip()
-		self.baseline = baseline
-		self.undertest = undertest
-		for string in [self.baseline, self.undertest]:
-			try: string = unicode(string, 'utf-8')
-			except TypeError: pass
-		self.encoding = encoding
-
-		# Normalize the encoding type for the comparaison based on self.encoding
-		if self.encoding in self.supportedtypes:
-			self.baseline = (self.baseline).encode(self.encoding)
-			self.undertest = (self.undertest).encode(self.encoding)
-			# Compare the strings
-			if self.baseline == self.undertest:
-				self.result = {self.label: "Passed"}
-			else:
-				self.result = {self.label: "Failed - " + self.encoding + " strings do not match. " + self.baseline + " expected: Got " + self.undertest}
-			# Pass the test result to the LogWriter for writing
-			TC.writer.writeResult(self.result)
-			return self.result
-
-		else:
-			# We should probably raise an exception here
-			self.result = {self.label: "ERROR - " + self.encoding + " is not a supported encoding type"}
-			TC.writer.writeResult(self.result)
-			return self.result
- 
+    """
+    The Test Case Superclass
+    """
+    logger = ResultsLogger()
+    def __init__(self):
+        self.encoding = config.encoding
+        # ascii + unicode. 8 bit extended char has been ripped out
+        self.supportedtypes = ("ascii", "utf-8", "utf-16", "utf-16-be", "utf-16-le", "unicode-escape", "raw-unicode-escape",
+        "big5", "gb18030", "eucJP", "eucKR", "shiftJIS")
+
+    # String comparison function
+    def compare(self, label, baseline, undertest, encoding=config.encoding):
+        """
+        Compares 2 strings to see if they are the same. The user may specify
+        the encoding to which the two strings are to be normalized for the
+        comparison. Default encoding is the default system encoding.
+        Normalization to extended 8 bit charactersets is not supported.
+
+        When the origin of either baseline or undertest is a text file whose
+        encoding is something other than ASCII, it is necessary to use
+        codecs.open() instead of open(), so the file's encoding may be
+        specified.
+        """
+        self.label = label.strip()
+        self.baseline = baseline
+        self.undertest = undertest
+        for string in [self.baseline, self.undertest]:
+            try: string = unicode(string, 'utf-8')
+            except TypeError: pass
+        self.encoding = encoding
+
+        # Normalize the encoding type for the comparaison based on self.encoding
+        if self.encoding in self.supportedtypes:
+            self.baseline = (self.baseline).encode(self.encoding)
+            self.undertest = (self.undertest).encode(self.encoding)
+            # Compare the strings
+            if self.baseline == self.undertest:
+                self.result = {self.label: "Passed"}
+            else:
+                self.result = {self.label: "Failed - " + self.encoding + " strings do not match. " + self.baseline + " expected: Got " + self.undertest}
+            # Pass the test result to the ResultsLogger for writing
+            TC.logger.log(self.result)
+            return self.result
+
+        else:
+            # We should probably raise an exception here
+            self.result = {self.label: "ERROR - " + self.encoding + " is not a supported encoding type"}
+            TC.logger.log(self.result)
+            return self.result
+
 
 # String Test Case subclass
 class TCString(TC):
-	"""
-	String Test Case Class
-	"""
-	def __init__(self):
-		TC.__init__(self)
+    """
+    String Test Case Class
+    """
+    def __init__(self):
+        TC.__init__(self)
 
 # Image test case subclass
 class TCImage(TC):
-	"""
-	Image Test Case Class.
-	"""
-	IMVersion = ''
-	
-	def __init__(self):
-		TC.__init__(self)
-		self.supportedmetrics = ("MAE", "MSE", "PSE", "PSNR","RMSE", "none")
-		self.scratchDir = config.scratchDir
-		self.deldfile = 0
-
-		# Get the ImageMagick version by parsing its '-version' output.
-		IMVer = os.popen('compare -version').readline()
-		IMVer = re.match('Version: ImageMagick ([0-9\.]+) .*', IMVer)
-		if IMVer is not None: 
-			IMVer = IMVer.groups()[0]
-			TCImage.IMVersion = IMVer
-		else:
-			raise DependencyNotFoundError, "ImageMagick"
-
-	# Use ImageMagick to compare 2 files
-	def compare(self, label, baseline, undertest, dfile='default', metric='none', threshold=0.0):
-		"""
-		Calls ImageMagick's "compare" program. Default compares are based on
- 	size but metric based comparisons are also supported with a threshold
- 	determining pass/fail criteria.
-		"""
-		self.label = label.strip()
-		self.baseline = baseline.strip()
-		self.undertest = undertest.strip()
-		self.difference = 0.0
-		self.metric = metric.strip()
-		self.threshold = threshold
-
-		# Create a default filename and flag it for deletion
-		if dfile == "default":
-			x = TimeStamp()
-			# Remove all whitespace from the label since IM chokes on it
-			splabel = label.split(" ")
-			label = "".join(splabel)
-			self.dfile = self.scratchDir + x.fileStamp(label)
-			self.deldfile = 1
-		else: # or use the supplied one with no deletion
-			self.dfile = dfile
-			self.deldfile = 0
-
-		# Check to see if the metric type is supported
-		if self.metric in self.supportedmetrics:
-			# This is a bit convoluted and will be until IM completes
-			# implementation of command line chaining. This should be put into
-			# a try also munge together our IM call chain, if we're not doing
-			# numeric metrics
-			if self.metric == "none":
-				# Build the comparison string. Redirect STDERR to STDOUT;
-				# IM writes to STDERR and cmd reads STDOUT
-				cmd = ("compare " + self.baseline + " " + self.undertest + " " + self.dfile + " " + "2>&1")
-				# os.popen returns a list; if it is empty then we have passed
-				answer = os.popen(cmd).readlines()
-				if answer == []:
-					self.result = {self.label: "Passed - Images are the same size"}
-				else:
-					fanswer = answer[0].strip()
-					self.result = {self.label: "Failed - " + fanswer}
-				TC.writer.writeResult(self.result)
-				return self.result
-			else: # otherwise run the metric code
-				# Build the cmd
-				cmd = ("compare -metric " + self.metric + " " + self.baseline + " " + self.undertest + " " + self.dfile + " " + "2>&1")
-				answer = os.popen(cmd).readlines()
-
-				# We need to check if the metric comparison failed. Unfortunately we
-				# can only tell this by checking the length of the output of the 
-				# command. More unfortunately, ImageMagic changed the length of the
-				# output at version 6.2.4, so we have to work around that.
-				metricFailed = True
-				IMVersion = TCImage.IMVersion
-				if IMVersion <= '6.2.3' and len(answer) == 1: metricFailed = False
-				if IMVersion >= '6.2.4' and len(answer) != 1: metricFailed = False
-				if metricFailed:
-					fanswer = answer[0]
-					self.result = {self.label: "Failed - " + fanswer}
-				else: # grab the metric from answer and convert it to a number
-					fanswer = answer[0].strip()
-					fanswer = fanswer.split(" ")
-					fanswer = fanswer[0]
-					fanswer = float(fanswer)
-
-					if fanswer == float("inf"): #same under PSNR returns inf dB:
-						self.result = {self.label: "Passed - " + "compare results: " + str(fanswer) + " dB"}
-					elif fanswer > self.threshold:
-						excess = fanswer - self.threshold
-						self.result = {self.label: "Failed - " + "compare result exceeds threshold by: " + str(excess) + " dB"}
-					else:
-						under = self.threshold - fanswer
-						self.result = {self.label: "Passed - " + "compare results under threshold by: " + str(under) + " dB"}
-				TC.writer.writeResult(self.result)
-				return self.result
-
-			# delete the composite image file if self.dfile is default
-			if self.deldfile == 1:
-				try:
-					os.remove(self.dfile)
-				except IOError:
-					print "Could not delete tempfile " + self.dfile
-
-		else: # unsupported metric given
-			self.result = {self.label: "Failed - " + self.metric + " is not in the list of supported metrics"}
-			TC.writer.writeResult(self.result)
-			return self.result
+    """
+    Image Test Case Class.
+    """
+    IMVersion = ''
+
+    def __init__(self):
+        TC.__init__(self)
+        self.supportedmetrics = ("MAE", "MSE", "PSE", "PSNR","RMSE", "none")
+        self.scratchDir = config.scratchDir
+        self.deldfile = 0
+
+        # Get the ImageMagick version by parsing its '-version' output.
+        IMVer = os.popen('compare -version').readline()
+        IMVer = re.match('Version: ImageMagick ([0-9\.]+) .*', IMVer)
+        if IMVer is not None:
+            IMVer = IMVer.groups()[0]
+            TCImage.IMVersion = IMVer
+        else:
+            raise DependencyNotFoundError, "ImageMagick"
+
+    # Use ImageMagick to compare 2 files
+    def compare(self, label, baseline, undertest, dfile='default', metric='none', threshold=0.0):
+        """
+        Calls ImageMagick's "compare" program. Default compares are based on
+size but metric based comparisons are also supported with a threshold
+determining pass/fail criteria.
+        """
+        self.label = label.strip()
+        self.baseline = baseline.strip()
+        self.undertest = undertest.strip()
+        self.difference = 0.0
+        self.metric = metric.strip()
+        self.threshold = threshold
+
+        # Create a default filename and flag it for deletion
+        if dfile == "default":
+            x = TimeStamp()
+            # Remove all whitespace from the label since IM chokes on it
+            splabel = label.split(" ")
+            label = "".join(splabel)
+            self.dfile = self.scratchDir + x.fileStamp(label)
+            self.deldfile = 1
+        else: # or use the supplied one with no deletion
+            self.dfile = dfile
+            self.deldfile = 0
+
+        # Check to see if the metric type is supported
+        if self.metric in self.supportedmetrics:
+            # This is a bit convoluted and will be until IM completes
+            # implementation of command line chaining. This should be put into
+            # a try also munge together our IM call chain, if we're not doing
+            # numeric metrics
+            if self.metric == "none":
+                # Build the comparison string. Redirect STDERR to STDOUT;
+                # IM writes to STDERR and cmd reads STDOUT
+                cmd = ("compare " + self.baseline + " " + self.undertest + " " + self.dfile + " " + "2>&1")
+                # os.popen returns a list; if it is empty then we have passed
+                answer = os.popen(cmd).readlines()
+                if answer == []:
+                    self.result = {self.label: "Passed - Images are the same size"}
+                else:
+                    fanswer = answer[0].strip()
+                    self.result = {self.label: "Failed - " + fanswer}
+                TC.logger.log(self.result)
+                return self.result
+            else: # otherwise run the metric code
+                # Build the cmd
+                cmd = ("compare -metric " + self.metric + " " + self.baseline + " " + self.undertest + " " + self.dfile + " " + "2>&1")
+                answer = os.popen(cmd).readlines()
+
+                # We need to check if the metric comparison failed. Unfortunately we
+                # can only tell this by checking the length of the output of the
+                # command. More unfortunately, ImageMagic changed the length of the
+                # output at version 6.2.4, so we have to work around that.
+                metricFailed = True
+                IMVersion = TCImage.IMVersion
+                if IMVersion <= '6.2.3' and len(answer) == 1: metricFailed = False
+                if IMVersion >= '6.2.4' and len(answer) != 1: metricFailed = False
+                if metricFailed:
+                    fanswer = answer[0]
+                    self.result = {self.label: "Failed - " + fanswer}
+                else: # grab the metric from answer and convert it to a number
+                    fanswer = answer[0].strip()
+                    fanswer = fanswer.split(" ")
+                    fanswer = fanswer[0]
+                    fanswer = float(fanswer)
+
+                    if fanswer == float("inf"): #same under PSNR returns inf dB:
+                        self.result = {self.label: "Passed - " + "compare results: " + str(fanswer) + " dB"}
+                    elif fanswer > self.threshold:
+                        excess = fanswer - self.threshold
+                        self.result = {self.label: "Failed - " + "compare result exceeds threshold by: " + str(excess) + " dB"}
+                    else:
+                        under = self.threshold - fanswer
+                        self.result = {self.label: "Passed - " + "compare results under threshold by: " + str(under) + " dB"}
+                TC.logger.log(self.result)
+                return self.result
+
+            # delete the composite image file if self.dfile is default
+            if self.deldfile == 1:
+                try:
+                    os.remove(self.dfile)
+                except IOError:
+                    debugLogger.log("Could not delete tempfile " + self.dfile)
+
+        else: # unsupported metric given
+            self.result = {self.label: "Failed - " + self.metric + " is not in the list of supported metrics"}
+            TC.logger.log(self.result)
+            return self.result
 
 
 
 class TCNumber(TC):
-	"""
-	Number Comparaison Test Case Class
-	"""
-	def __init__(self):
-		TC.__init__(self)
-		self.supportedtypes = ("int", "long", "float", "complex", "oct", "hex")
-
-	# Compare 2 numbers by the type provided in the type arg
-	def compare(self, label, baseline, undertest, type):
-		"""
-		Compares 2 numbers to see if they are the same. The user may specify
-		how to normalize mixed type comparisons via the type argument.
-		"""
-		self.label = label.strip()
-		self.baseline = baseline
-		self.undertest = undertest
-		self.type = type.strip()
-
-		# If we get a valid type, convert to that type and compare
-		if self.type in self.supportedtypes:
-			# Normalize for comparison
-			if self.type == "int":
-				self.baseline = int(self.baseline)
-				self.undertest = int(self.undertest)
-			elif self.type == "long":
-				self.baseline = long(self.baseline)
-				self.undertest = long(self.undertest)
-			elif self.type == "float":
-				self.baseline = float(self.baseline)
-				self.undertest = float(self.undertest)
-			else:
-				self.baseline = complex(self.baseline)
-				self.undertest = complex(self.undertest)
-
-			#compare 
-			if self.baseline == self.undertest:
-				self.result = {self.label: "Passed - numbers are the same"}
-			else:
-				self.result = {self.label: "Failed - " + str(self.baseline) + " expected: Got " + str(self.undertest)}
-			TC.writer.writeResult(self.result)
-			return self.result
-		else:
-			self.result = {self.label: "Failed - " + self.type + " is not in list of supported types"}
-			TC.writer.writeResult(self.result)
-			return self.result
+    """
+    Number Comparaison Test Case Class
+    """
+    def __init__(self):
+        TC.__init__(self)
+        self.supportedtypes = ("int", "long", "float", "complex", "oct", "hex")
+
+    # Compare 2 numbers by the type provided in the type arg
+    def compare(self, label, baseline, undertest, type):
+        """
+        Compares 2 numbers to see if they are the same. The user may specify
+        how to normalize mixed type comparisons via the type argument.
+        """
+        self.label = label.strip()
+        self.baseline = baseline
+        self.undertest = undertest
+        self.type = type.strip()
+
+        # If we get a valid type, convert to that type and compare
+        if self.type in self.supportedtypes:
+            # Normalize for comparison
+            if self.type == "int":
+                self.baseline = int(self.baseline)
+                self.undertest = int(self.undertest)
+            elif self.type == "long":
+                self.baseline = long(self.baseline)
+                self.undertest = long(self.undertest)
+            elif self.type == "float":
+                self.baseline = float(self.baseline)
+                self.undertest = float(self.undertest)
+            else:
+                self.baseline = complex(self.baseline)
+                self.undertest = complex(self.undertest)
+
+            #compare
+            if self.baseline == self.undertest:
+                self.result = {self.label: "Passed - numbers are the same"}
+            else:
+                self.result = {self.label: "Failed - " + str(self.baseline) + " expected: Got " + str(self.undertest)}
+            TC.logger.log(self.result)
+            return self.result
+        else:
+            self.result = {self.label: "Failed - " + self.type + " is not in list of supported types"}
+            TC.logger.log(self.result)
+            return self.result
 
 
 if __name__ == '__main__':
-	# import the test modules
-	import codecs
-	from utils import *
-
-	# Set up vars to use to test TC class
-	baseline = "test"
-	undertest = "test"
-	label = "unit test case 1.0"
-	encoding = "utf-8"
-	result = {}
-
-	# Create the TC instance
-	case1 = TC()
-
-	# Fire off the compaison
-	result = case1.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - passed
-	print(result)
-
-	# Reset variables for failure path
-	undertest = "testy"
-	encoding = "utf-8"
-	result = {}
-	label = "unit test case 1.1"
-
-	# Compare again
-	result = case1.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - failure
-	print(result)
-
-	# Create a TCString instance
-	case2 = TCString()
-
-	# Load our variables for this test
-	label = " unit test case 2.0"
-	encoding = "utf-8"
-	baseline = u"groß"
-	undertest = u"gro\xc3\xa1"
-	result = {}
-
-	# Fire off a UTF-8 compare
-	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - passed
-	print(result)
-
-	# Fire the test for ASCII converted to UTF-8 testing
-	label = " unit test case 2.1"
-	encoding = "utf-8"
-	baseline = "please work"
-	undertest = "please work"
-	result = {}
-
-	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - passed
-	print(result)
-
-	# Reset variables for an out of range encoding type
-	label = " unit test case 2.2"
-	encoding = "swahilli"
-	baseline = "please work"
-	undertest = "please work"
-	result = {}
-
-	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - Error - not supported
-	print(result)
-
-	# Reset variables for unmatched utf-8 strings 
-	label = " unit test case 2.3"
-	encoding = "utf-8"
-	baseline = u"groß"
-	undertest = "nomatch"
-	result = {}
-
-#	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - failure
-	print(result)
-
-	# Reset variables for inherited TC base compare
-	label = " unit test case 2.4"
-	baseline = "This is inhereited"
-	undertest = "This is inhereited"
-	encoding = "utf-8"
-	result = {}
-
-	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - Passed
-	print(result)
-
-
-	# Include real CJKI (UTF-8) charcters for string compare
-	# For this first test case, we are comparing same JA characters
-	label = " unit test case 2.5"
-	encoding = "utf-8"
-	baseline = u"あか"
-	undertest = u"あか"
-	result = {}
-
-	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - Passed
-	print(result)
-
-
-	# Testing different JA characters
-	label = " unit test case 2.6"
-	encoding = "utf-8"
-	baseline = u"あか"
-	undertest = u"元気"
-	result = {}
-
-	result = case2.compare(label, baseline, undertest, encoding)
-
-	# Print the result - should be label - Failed
-	print(result)
-
-
-
-	# Test the timestamper class
-	# Create a new timestamp instance
-	# Print the file format time
-	stamp1 = TimeStamp()
-	presently = stamp1.fileStamp("filestamp")
-
-	# Print - should be filenameYYYYMMDD with local systems date
-	print presently
-
-	# Make a stamp entry
-	entry = stamp1.entryStamp()
-
-	# Print the entrystamp - should be YYYY-MM-DD_HH:MM:SS with local system time
-	print entry
-
-	# Test to see that image compares work - this a simple compare with defaults
-	# Load our variabes
-	label = "unit test case 3.0"
-	baseline = "../examples/data/GNOME-Street.png"
-	undertest = "../examples/data/GNOME-Street1.png"
-	result = {}
-
-	# Create a TCImage instance
-	case3 = TCImage()
-
-	# Fire off the compare
-	result = case3.compare(label, baseline, undertest)
-
-	# Print the result Should be label - Passed - Images are same size
-	print result
-
-	# Default compare with different images (the sizes differ)
-	label = "unit test case 3.1"
-	baseline = "../examples/data/GNOME-Street.png"
-	undertest = "../examples/data/g-star.png"
-	result = {}
-
-	# Fire off the compare
-	result = case3.compare(label, baseline, undertest)
-
-	# Print the result Should be label - Failied compare:Images differ in size
-	print result
-
-	# Image compare pass with the metrics option
-	label = "unit test case 3.2"
-	baseline = "../examples/data/GNOME-Street.png"
-	undertest = "../examples/data/GNOME-Street1.png"
-	result = {}
-	metrics = ("MAE", "MSE", "PSE", "PSNR"," RMSE")
-
-	for i in range(len(metrics)):
-		result = case3.compare(label, baseline, undertest, metric=metrics[i])
-		print metrics[i]
-		print result
-
-	# Image compare fail metrics
-	label = "unit test case 3.3"
-	baseline = "../examples/data/g-star.png"
-	undertest = "../examples/data/g-star1.png"
-	result = {}
-	metrics = ("MAE", "MSE", "PSE", "PSNR"," RMSE")
-
-	for i in range(len(metrics)):
-		result = case3.compare(label, baseline, undertest, metric=metrics[i])
-		print metrics[i]
-		print result
-
-	# Image comapre threshold metrics - only PNSR should pass
-	label = "unit test case 3.4"
-	baseline = "../examples/data/g-star.png"
-	undertest = "../examples/data/g-star1.png"
-	result = {}
-	metrics = ("MAE", "MSE", "PSE", "PSNR"," RMSE")
-	bound = 5
-
-	for i in range(len(metrics)):
-		result = case3.compare(label, baseline, undertest, metric=metrics[i], threshold=bound)
-		print metrics[i]
-		print result
-
-	# Bogus metric test
-	label = "unit test case 3.5"
-	baseline = "../examples/data/g-star.png"
-	undertest = "../examples/data/g-star1.png"
-	result = {}
-	metrics = "Guess"
-
-	result = case3.compare(label, baseline, undertest, metric=metrics)
-
-	# Should be failed - metric unsupported
-	print result
-
-	# Number comparison tests
-	label = "unit test case 4.0"
-	baseline = 42
-	undertest = 42
-	type = "int"
-	result = {}
-
-	# Make a TCNumber instance
-	case4 = TCNumber()
-
-	# Make a simple int compare
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should be Passed
-	print result
-
-	# Now make the int fail
-	label = "unit test case 4.1"
-	undertest = 999
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should fail
-	print result
-
-	# Now long pass
-	label = "unit test case 4.2"
-	baseline = 1112223334445556667778889990L
-	undertest = 1112223334445556667778889990L
-	type = "long"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should pass
-	print result
-
-	# Float Pass
-	label = "unit test case 4.3"
-	baseline = 99.432670
-	undertest = 99.432670
-	type = "float"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should pass
-	print result
-
-	# Complex pass
-	label = "unit test case 4.4"
-	baseline = 67+3j
-	undertest = 67+3j
-	type = "complex"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should pass
-	print result
-
-	# Octal pass
-	label = "unit test case 4.5"
-	baseline = 0400
-	undertest = 0400
-	type = "oct"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should pass
-	print result
-
-	# Hex pass
-	label = "unit test case 4.6"
-	baseline = 0x100
-	undertest = 0x100
-	type = "hex"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should pass
-	print result
-
-	# Conversion pass - pass in equivalent hex and octal but compare as int
-	label = "unit test case 4.7"
-	baseline = 0x100
-	undertest = 0400
-	type = "int"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should pass
-	print result
-
-	# Give a bogus type
-	label = "unit test case 4.8"
-	type = "face"
-	result = {}
-
-	result = case4.compare(label, baseline, undertest, type)
-
-	# Should fail - unsupported type
-	print result
-
+    # import the test modules
+    import codecs
+    from utils import *
+
+    # Set up vars to use to test TC class
+    baseline = "test"
+    undertest = "test"
+    label = "unit test case 1.0"
+    encoding = "utf-8"
+    result = {}
+
+    # Create the TC instance
+    case1 = TC()
+
+    # Fire off the compaison
+    result = case1.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - passed
+    print(result)
+
+    # Reset variables for failure path
+    undertest = "testy"
+    encoding = "utf-8"
+    result = {}
+    label = "unit test case 1.1"
+
+    # Compare again
+    result = case1.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - failure
+    print(result)
+
+    # Create a TCString instance
+    case2 = TCString()
+
+    # Load our variables for this test
+    label = " unit test case 2.0"
+    encoding = "utf-8"
+    baseline = u"groß"
+    undertest = u"gro\xc3\xa1"
+    result = {}
+
+    # Fire off a UTF-8 compare
+    result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - passed
+    print(result)
+
+    # Fire the test for ASCII converted to UTF-8 testing
+    label = " unit test case 2.1"
+    encoding = "utf-8"
+    baseline = "please work"
+    undertest = "please work"
+    result = {}
+
+    result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - passed
+    print(result)
+
+    # Reset variables for an out of range encoding type
+    label = " unit test case 2.2"
+    encoding = "swahilli"
+    baseline = "please work"
+    undertest = "please work"
+    result = {}
+
+    result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - Error - not supported
+    print(result)
+
+    # Reset variables for unmatched utf-8 strings
+    label = " unit test case 2.3"
+    encoding = "utf-8"
+    baseline = u"groß"
+    undertest = "nomatch"
+    result = {}
+
+#       result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - failure
+    print(result)
+
+    # Reset variables for inherited TC base compare
+    label = " unit test case 2.4"
+    baseline = "This is inhereited"
+    undertest = "This is inhereited"
+    encoding = "utf-8"
+    result = {}
+
+    result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - Passed
+    print(result)
+
+
+    # Include real CJKI (UTF-8) charcters for string compare
+    # For this first test case, we are comparing same JA characters
+    label = " unit test case 2.5"
+    encoding = "utf-8"
+    baseline = u"あか"
+    undertest = u"あか"
+    result = {}
+
+    result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - Passed
+    print(result)
+
+
+    # Testing different JA characters
+    label = " unit test case 2.6"
+    encoding = "utf-8"
+    baseline = u"あか"
+    undertest = u"元気"
+    result = {}
+
+    result = case2.compare(label, baseline, undertest, encoding)
+
+    # Print the result - should be label - Failed
+    print(result)
+
+
+
+    # Test the timestamper class
+    # Create a new timestamp instance
+    # Print the file format time
+    stamp1 = TimeStamp()
+    presently = stamp1.fileStamp("filestamp")
+
+    # Print - should be filenameYYYYMMDD with local systems date
+    print presently
+
+    # Make a stamp entry
+    entry = stamp1.entryStamp()
+
+    # Print the entrystamp - should be YYYY-MM-DD_HH:MM:SS with local system time
+    print entry
+
+    # Test to see that image compares work - this a simple compare with defaults
+    # Load our variabes
+    label = "unit test case 3.0"
+    baseline = "../examples/data/20w.png"
+    undertest = "../examples/data/20b.png"
+    result = {}
+
+    # Create a TCImage instance
+    case3 = TCImage()
+
+    # Fire off the compare
+    result = case3.compare(label, baseline, undertest)
+
+    # Print the result Should be label - Passed - Images are same size
+    print result
+
+    # Default compare with different images (the sizes differ)
+    label = "unit test case 3.1"
+    baseline = "../examples/data/20w.png"
+    undertest = "../examples/data/10w.png"
+    result = {}
+
+    # Fire off the compare
+    result = case3.compare(label, baseline, undertest)
+
+    # Print the result Should be label - Failied compare:Images differ in size
+    print result
+
+    # Image compare pass with the metrics option
+    label = "unit test case 3.2"
+    baseline = "../examples/data/20w.png"
+    undertest = "../examples/data/20b.png"
+    result = {}
+    metrics = ("MAE", "MSE", "PSE", "PSNR"," RMSE")
+
+    for i in range(len(metrics)):
+        result = case3.compare(label, baseline, undertest, metric=metrics[i])
+        print metrics[i]
+        print result
+
+    # Image compare fail metrics
+    label = "unit test case 3.3"
+    baseline = "../examples/data/10w.png"
+    undertest = "../examples/data/10b.png"
+    result = {}
+    metrics = ("MAE", "MSE", "PSE", "PSNR"," RMSE")
+
+    for i in range(len(metrics)):
+        result = case3.compare(label, baseline, undertest, metric=metrics[i])
+        print metrics[i]
+        print result
+
+    # Image comapre threshold metrics - only PNSR should pass
+    label = "unit test case 3.4"
+    baseline = "../examples/data/10w.png"
+    undertest = "../examples/data/10b.png"
+    result = {}
+    metrics = ("MAE", "MSE", "PSE", "PSNR"," RMSE")
+    bound = 5
+
+    for i in range(len(metrics)):
+        result = case3.compare(label, baseline, undertest, metric=metrics[i], threshold=bound)
+        print metrics[i]
+        print result
+
+    # Bogus metric test
+    label = "unit test case 3.5"
+    baseline = "../examples/data/10w.png"
+    undertest = "../examples/data/10b.png"
+    result = {}
+    metrics = "Guess"
+
+    result = case3.compare(label, baseline, undertest, metric=metrics)
+
+    # Should be failed - metric unsupported
+    print result
+
+    # Number comparison tests
+    label = "unit test case 4.0"
+    baseline = 42
+    undertest = 42
+    type = "int"
+    result = {}
+
+    # Make a TCNumber instance
+    case4 = TCNumber()
+
+    # Make a simple int compare
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should be Passed
+    print result
+
+    # Now make the int fail
+    label = "unit test case 4.1"
+    undertest = 999
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should fail
+    print result
+
+    # Now long pass
+    label = "unit test case 4.2"
+    baseline = 1112223334445556667778889990L
+    undertest = 1112223334445556667778889990L
+    type = "long"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should pass
+    print result
+
+    # Float Pass
+    label = "unit test case 4.3"
+    baseline = 99.432670
+    undertest = 99.432670
+    type = "float"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should pass
+    print result
+
+    # Complex pass
+    label = "unit test case 4.4"
+    baseline = 67+3j
+    undertest = 67+3j
+    type = "complex"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should pass
+    print result
+
+    # Octal pass
+    label = "unit test case 4.5"
+    baseline = 0400
+    undertest = 0400
+    type = "oct"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should pass
+    print result
+
+    # Hex pass
+    label = "unit test case 4.6"
+    baseline = 0x100
+    undertest = 0x100
+    type = "hex"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should pass
+    print result
+
+    # Conversion pass - pass in equivalent hex and octal but compare as int
+    label = "unit test case 4.7"
+    baseline = 0x100
+    undertest = 0400
+    type = "int"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should pass
+    print result
+
+    # Give a bogus type
+    label = "unit test case 4.8"
+    type = "face"
+    result = {}
+
+    result = case4.compare(label, baseline, undertest, type)
+
+    # Should fail - unsupported type
+    print result

=== modified file 'dogtail/trayicon.py'
--- dogtail/trayicon.py	2006-08-01 22:59:27 +0000
+++ dogtail/trayicon.py	2006-12-21 13:33:47 +0000
@@ -1,7 +1,7 @@
 # jhbuild - a build script for GNOME 1.x and 2.x
 # Copyright (C) 2001-2004 James Henstridge
 #
-#	trayicon.py: simple wrapper for zenity based tray icons
+#       trayicon.py: simple wrapper for zenity based tray icons
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -10,78 +10,77 @@
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA	02111-1307	USA
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA      02111-1307      USA
 
 import sys
 import os
 try:
-	import subprocess
+    import subprocess
 except ImportError:
-	# I know, let's add an ugly hack!
-	# Don't totally bail when not using python2.4 or newer.
-	# FIXME: since we aren't using any new functionality of subprocess, we
-	#    could just use the deprecated methods.
-	class subprocess:
-		PIPE = None
-		def Popen(cmd, close_fds, preexec_fn, stdin): return None
-		Popen = staticmethod(Popen)
-
-	
+    # I know, let's add an ugly hack!
+    # Don't totally bail when not using python2.4 or newer.
+    # FIXME: since we aren't using any new functionality of subprocess, we
+    #    could just use the deprecated methods.
+    class subprocess:
+        PIPE = None
+        def Popen(cmd, close_fds, preexec_fn, stdin): return None
+        Popen = staticmethod(Popen)
+
+
 
 class TrayIcon:
-	def __init__(self):
-		self._run_zenity()
-	def _run_zenity(self):
-		# run zenity with stdout and stderr directed to /dev/null
-		def preexec():
-			null = open('/dev/null', 'w')
-			try:
-				os.dup2(null.fileno(), sys.stdout.fileno())
-				os.dup2(null.fileno(), sys.stderr.fileno())
-			finally:
-				null.close()
-			os.setsid()
-		try:
-			self.proc = subprocess.Popen(['zenity', '--notification',
-										 '--listen'],
-										 close_fds=True,
-										 preexec_fn=preexec,
-										 stdin=subprocess.PIPE)
-		except (OSError, IOError):
-			self.proc = None
-
-	def close(self):
-		status = None
-		if self.proc:
-			self.proc.stdin.close()
-			status = self.proc.wait()
-			self.proc = None
-		return status
-
-	def _send_cmd(self, cmd):
-		if not self.proc: return
-		if isinstance(cmd, unicode):
-			cmd = cmd.encode('utf-8')
-		try:
-			self.proc.stdin.write(cmd)
-			self.proc.stdin.flush()
-		except (IOError, OSError), err:
-			self.close()
-	def set_icon(self, icon):
-		self._send_cmd('icon: %s\n' % icon)
-
-	def set_tooltip(self, tooltip):
-		self._send_cmd('tooltip: %s\n' % tooltip)
-	
-	def set_visible(self, visible):
-		if visible:
-			visible = 'true'
-		else:
-			visible = 'false'
-		self._send_cmd('visible: %s\n' % visible)
-
+    def __init__(self):
+        self._run_zenity()
+    def _run_zenity(self):
+        # run zenity with stdout and stderr directed to /dev/null
+        def preexec():
+            null = open('/dev/null', 'w')
+            try:
+                os.dup2(null.fileno(), sys.stdout.fileno())
+                os.dup2(null.fileno(), sys.stderr.fileno())
+            finally:
+                null.close()
+            os.setsid()
+        try:
+            self.proc = subprocess.Popen(['zenity', '--notification',
+                                                                     '--listen'],
+                                                                     close_fds=True,
+                                                                     preexec_fn=preexec,
+                                                                     stdin=subprocess.PIPE)
+        except (OSError, IOError):
+            self.proc = None
+
+    def close(self):
+        status = None
+        if self.proc:
+            self.proc.stdin.close()
+            status = self.proc.wait()
+            self.proc = None
+        return status
+
+    def _send_cmd(self, cmd):
+        if not self.proc: return
+        if isinstance(cmd, unicode):
+            cmd = cmd.encode('utf-8')
+        try:
+            self.proc.stdin.write(cmd)
+            self.proc.stdin.flush()
+        except (IOError, OSError), err:
+            self.close()
+    def set_icon(self, icon):
+        self._send_cmd('icon: %s\n' % icon)
+
+    def set_tooltip(self, tooltip):
+        self._send_cmd('tooltip: %s\n' % tooltip)
+
+    def set_visible(self, visible):
+        if visible:
+            visible = 'true'
+        else:
+            visible = 'false'
+        self._send_cmd('visible: %s\n' % visible)

=== modified file 'dogtail/tree.py'
--- dogtail/tree.py	2006-08-01 22:59:27 +0000
+++ dogtail/tree.py	2006-12-21 13:33:47 +0000
@@ -1,4 +1,3 @@
-#!/usr/bin/env python
 """Makes some sense of the AT-SPI API
 
 The tree API handles various things for you:
@@ -25,7 +24,7 @@
 by the Predicate class.
 
 Dogtail implements a high-level searching system, for finding a node (or
-nodes) satisfying whatever criteria you are interested in.	It does this with
+nodes) satisfying whatever criteria you are interested in.      It does this with
 a 'backoff and retry' algorithm. This fixes most timing problems e.g. when a
 dialog is in the process of opening but hasn't yet done so.
 
@@ -37,9 +36,9 @@
 all of this process in the debug log by setting 'config.debugSearching' to True
 
 We also automatically add a short delay after each action
-('config.defaultDelay' gives the time in seconds).	We'd hoped that the search
+('config.defaultDelay' gives the time in seconds).      We'd hoped that the search
 backoff and retry code would eliminate the need for this, but unfortunately we
-still run into timing issues.	 For example, Evolution (and probably most
+still run into timing issues.    For example, Evolution (and probably most
 other apps) set things up on new dialogs and wizard pages as they appear, and
 we can run into 'setting wars' where the app resets the widgetry to defaults
 after our script has already filled out the desired values, and so we lose our
@@ -53,7 +52,7 @@
 Unfortunately, some applications do not set up the 'sensitive' state
 correctly on their buttons (e.g. Epiphany on form buttons in a web page). The
 current workaround for this is to set config.ensureSensitivity=False, which
-disables the sensitivity testing. 
+disables the sensitivity testing.
 
 Authors: Zack Cerza <zcerza@redhat.com>, David Malcolm <dmalcolm@redhat.com>
 """
@@ -61,6 +60,9 @@
 David Malcolm <dmalcolm@redhat.com>
 """
 
+from utils import checkForA11y
+checkForA11y()
+
 import re
 import predicate
 from datetime import datetime
@@ -68,1101 +70,1191 @@
 from config import config
 from utils import doDelay
 from utils import Blinker
+import rawinput
 import path
 
 from logging import debugLogger as logger
 
 try:
-	import atspi
+    import atspi
 except ImportError:
-	# If atspi can't be imported, fail.
-	raise ImportError, "Error importing the AT-SPI bindings"
+    # If atspi can't be imported, fail.
+    raise ImportError, "Error importing the AT-SPI bindings"
 
 # We optionally import the bindings for libwnck.
 try:
-	import wnck
-	gotWnck = True
+    import wnck
+    gotWnck = True
 except ImportError:
-	# Skip this warning, since the functionality is almost entirely nonworking anyway.
-	#print "Warning: Dogtail could not import the Python bindings for libwnck. Window-manager manipulation will not be available."
-	gotWnck = False
-
-SearchError = "Couldn't find"
+    # Skip this warning, since the functionality is almost entirely nonworking anyway.
+    #print "Warning: Dogtail could not import the Python bindings for libwnck. Window-manager manipulation will not be available."
+    gotWnck = False
+
+class SearchError(Exception):
+    pass
+
+class ReadOnlyError(TypeError):
+    """
+    This attribute is not writeable.
+    """
+    message = "Cannot set %s. It is read-only."
+    def __init__(self, attr):
+        self.attr = attr
+
+    def __str__(self):
+        return self.message % self.attr
 
 class NotSensitiveError(Exception):
-	"""
-	The widget is not sensitive.
-	"""
-	message = "Cannot %s %s. It is not sensitive."
-	def __init__(self, action):
-		self.action = action
-	
-	def __str__(self):
-		return self.message % (self.action.name, self.action.node.getLogString())
+    """
+    The widget is not sensitive.
+    """
+    message = "Cannot %s %s. It is not sensitive."
+    def __init__(self, action):
+        self.action = action
+
+    def __str__(self):
+        return self.message % (self.action.name, self.action.node.getLogString())
 
 class ActionNotSupported(Exception):
-	"""
-	The widget does not support the requested action.
-	"""
-	message = "Cannot do '%s' action on %s"
-	def __init__(self, actionName, node):
-		self.actionName = actionName
-		self.node = node
-	
-	def __str__(self):
-		return self.message % (self.actionName, self.node.getLogString())
+    """
+    The widget does not support the requested action.
+    """
+    message = "Cannot do '%s' action on %s"
+    def __init__(self, actionName, node):
+        self.actionName = actionName
+        self.node = node
+
+    def __str__(self):
+        return self.message % (self.actionName, self.node.getLogString())
 
 class Action:
-	"""
-	Class representing an action that can be performed on a specific node
-	"""
-	# Valid types of actions we know about. Feel free to add any you see.
-	types = ('click',
-		 'press',
-		 'release',
-		 'activate',
-		 'jump',
-		 'check',
-		 'dock',
-		 'undock',
-		 'open',
-		 'menu')
-	
-	def __init__ (self, node, action, index):
-		self.node = node
-		self.__action = action
-		self.__index = index
-
-	def __getattr__ (self, attr):
-		if attr == "name":
-			return self.__action.getName (self.__index).lower()
-		elif attr == "description":
-			return self.__action.getDescription (self.__index)
-		elif attr == "keyBinding":
-			return self.__action.getKeyBinding (self.__index)
-		else: raise AttributeError, attr
-
-	def __str__ (self):
-		"""
-		Plain-text representation of the Action.
-		"""
-		string = "Action node='%s' name='%s' description='%s' keybinding='%s'" % (self.node, self.name, self.description, self.keyBinding)
-		return string
-
-	def do (self):
-		"""
-		Performs the given tree.Action, with appropriate delays and logging.
-		"""
-		assert isinstance(self, Action)
-		logger.log("%s on %s"%(self.name, self.node.getLogString()))
-		if not self.node.sensitive:
-			if config.ensureSensitivity:
-				raise NotSensitiveError, self
-			else:
-				nSE = NotSensitiveError(self)
-				print "Warning: " + str(nSE)
-		if config.blinkOnActions: self.node.blink()
-		result = self.__action.doAction (self.__index)
-		doDelay()
-		return result
+    """
+    Class representing an action that can be performed on a specific node
+    """
+    # Valid types of actions we know about. Feel free to add any you see.
+    types = ('click',
+             'press',
+             'release',
+             'activate',
+             'jump',
+             'check',
+             'dock',
+             'undock',
+             'open',
+             'menu')
+
+    def __init__ (self, node, action, index):
+        self.node = node
+        self.__action = action
+        self.__index = index
+
+    def __getattr__ (self, attr):
+        if attr == "name":
+            return self.__action.getName (self.__index).lower()
+        elif attr == "description":
+            return self.__action.getDescription (self.__index)
+        elif attr == "keyBinding":
+            return self.__action.getKeyBinding (self.__index)
+        else: raise AttributeError, attr
+
+    def __str__ (self):
+        """
+        Plain-text representation of the Action.
+        """
+        string = "Action node='%s' name='%s' description='%s' keybinding='%s'" % (self.node, self.name, self.description, self.keyBinding)
+        return string
+
+    def do (self):
+        """
+        Performs the given tree.Action, with appropriate delays and logging.
+        """
+        assert isinstance(self, Action)
+        logger.log("%s on %s"%(self.name, self.node.getLogString()))
+        if not self.node.sensitive:
+            if config.ensureSensitivity:
+                raise NotSensitiveError, self
+            else:
+                nSE = NotSensitiveError(self)
+                logger.log("Warning: " + str(nSE))
+        if config.blinkOnActions: self.node.blink()
+        result = self.__action.doAction (self.__index)
+        doDelay()
+        return result
 
 class Node:
-	"""
-	A node in the tree of UI elements. It wraps an Accessible and
-	exposes its useful members. It also has a debugName which is set
-	up automatically when doing searches.
-
-	Node instances have various attributes synthesized, to make it easy to
-	get and the underlying accessible data. Many more attributes can be
-	added as desired.
-
-	'name' (read-only string):
-	Wraps Accessible_getName on the Node's underlying Accessible
-	
-	'roleName' (read-only string):
-	Wraps Accessible_getRoleName on the Node's underlying Accessible
-	
-	'role' (read-only atspi role enum):
-	Wraps Accessible_getRole on the Node's underlying Accessible
-
-	'description' (read-only string):
-	Wraps Accessible_getDescription on the Node's underlying Accessible
-	
-	'parent' (read-only Node instance):
-	A Node instance wrapping the parent, or None. Wraps Accessible_getParent
-
-	'children' (read-only list of Node instances):
-	The children of this node, wrapping getChildCount and getChildAtIndex 
-
-	'text' (string):
-	For instances wrapping AccessibleText, the text. This is read-only,
-	unless the instance wraps an AccessibleEditableText. In this case, you
-	can write values to the attribute. This will get logged in the debug
-	log, and a delay will be added. After the delay, the content of the
-	node will be checked to ensure that it has the expected value. If it
-	does not, an exception will be raised. This does not work for password
-	dialogs (since all we get back are * characters). In this case, set
-	the passwordText attribute instead.
-
-	'passwordText' (write-only string):
-	See documentation of 'text' attribute above.
-	
-	'caretOffset' (read/write int):
-	For instances wrapping AccessibleText, the location of the text caret,
-	expressed as an offset in characters.
-
-	'combovalue' (write-only string):
-	For comboboxes. Write to this attribute to set the combobox to the
-	given value, with appropriate delays and logging.
-
-	'stateSet' (read-only StateSet instance):
-	Wraps Accessible_getStateSet; a set of boolean state flags
-	
-	'relations' (read-only list of atspi.Relation instances):
-	Wraps Accessible_getRelationSet
-
-	'labellee' (read-only list of Node instances):
-	The node(s) that this node is a label for. Generated from 'relations'.
-
-	'labeller' (read-only list of Node instances):
-	The node(s) that is/are a label for this node. Generated from
-	'relations'.
-
-	'sensitive' (read-only boolean):
-	Is this node sensitive (i.e. not greyed out). Generated from stateSet
-	based on presence of atspi.SPI_STATE_SENSITIVE
-	Not all applications/toolkits seem to properly set this up.
-
-	'showing' (read-only boolean):
-	Generated from stateSet based on presence of atspi.SPI_STATE_SHOWING
-
-	'actions' (read-only list of Action instances):
-	Generated from Accessible_getAction and AccessibleAction_getNActions
-
-	For each action that is supported by a node, a method is hooked up,
-	this can include the following list:
-	'click'
-	'press'
-	'release'
-	'activate'
-	'jump'
-	'check'
-	'dock'
-	'undock'
-	'open'
-	'menu'
-	
-	'extents' (readonly tuple):
-	For instances wrapping a Component, the (x,y,w,h) screen extents of the
-	component.
-
-	'position' (readonly tuple):
-	For instances wrapping a Component, the (x,y) screen position of the
-	component.
-
-	'size' (readonly tuple):
-	For instances wrapping a Component, the (w,h) screen size of the component.
-
-	'grabFocus':
-	For instances wrapping a Component, attempt to set the keyboard input focus 
-	to that Node.
-
-	'toolkit' (readonly string):
-	For instances wrapping an application, the name of the toolkit.
-	
-	'version'
-	For instances wrapping an application.
-	
-	'ID'
-	For instances wrapping an application.
-	
-	'pause' (function)
-	'resume' (function)
-	For instances wrapping an application; probably don't work
-	"""
-
-	#Valid types of AT-SPI objects we wrap.
-	contained = ('__accessible', '__action', '__component', '__text', '__editableText')
-
-	def __init__ (self, initializer):
-		self.__hideChildren = False
-		self.debugName = None
-		if isinstance(initializer, atspi.Accessible):
-			self.__accessible = initializer
-		elif isinstance(initializer, Node):
-			self.__accessible = initializer.__accessible
-			self.debugName = getattr(initializer, 'debugName', None)
-		else:
-			raise "Unknown Node initializer"
-		assert self.__accessible
-
-		# Swallow the Action object, if it exists
-		self.__action = self.__accessible.getAction()
-		if self.__action is not None:
-			def doAction(name):
-				"""
-				Performs the tree.Action with the given name, with appropriate delays and logging,
-				or raises the ActionNotSupported exception if the node doesn't support that particular
-				action.
-				"""
-				actions = self.actions
-				if actions.has_key(name):
-					return actions[name].do()
-				else:
-					raise ActionNotSupported(name, self)
-			self.doAction = doAction
-
-		# Swallow the Component object, if it exists
-		component = self.__accessible.getComponent()
-		if component is not None:
-			self.__component = component
-			
-			def grabFocus():
-				self.__component.grabFocus()
-			self.grabFocus = grabFocus
-
-			def rawClick(button = 1):
-				"""
-				Generates a raw mouse click event whether or not the Node has a 'click' action, using the specified button.
-				1 is left,
-				2 is middle,
-				3 is right.
-				"""
-				import rawinput
-				extents = self.extents
-				position = (extents[0], extents[1])
-				size = (extents[2], extents[3])
-				clickX = position[0] + 0.5 * size[0]
-				clickY = position[1] + 0.5 * size[1]
-				if config.debugSearching: logger.log("raw click on %s %s at (%s,%s)"%(self.name, self.getLogString(), str(clickX), str(clickY)))
-				rawinput.click(clickX, clickY, button)
-			self.rawClick = rawClick
-
-			def rawType(text):
-				"""
-				Generates raw keyboard events to type text into the Node.
-				"""
-				import rawinput
-				if config.debugSearching: logger.log("Typing text '%s' into %s"%(text, self.getLogString()))
-				self.grabFocus()
-				rawinput.typeText(text)
-			self.rawType = rawType
-			
-		# Swallow the Text object, if it exists
-		text = self.__accessible.getText()
-		if text is not None: 
-			self.__text = text
-			self.addSelection = self.__text.addSelection
-			self.getNSelections = self.__text.getNSelections
-			self.removeSelection = self.__text.removeSelection
-			self.setSelection = self.__text.setSelection
-
-		# Swallow the EditableText object, if it exists
-		editableText = self.__accessible.getEditableText()
-		if editableText is not None:
-			self.__editableText = editableText
-			self.setAttributes = self.__editableText.setAttributes
-
-		# Swallow the Hypertext object, if it exists
-		hypertext = self.__accessible.getHypertext()
-		if hypertext is not None:
-			self.__hypertext = hypertext
-
-		# Add more objects here. Nobody uses them yet, so I haven't.
-		# You also need to change the __getattr__ and __setattr__ functions.
-
-	# It'd be nice to know if two objects are "identical". However, the
-	# approach below does not work, since atspi.Accessible doesn't know
-	# how to check if two cspi.Accessible objects are "identical" either. :(
-	#def __cmp__ (self, node):
-	#	 return self.__accessible == node.__accessible
-
-	def __getattr__ (self, attr):
-		if False: pass
-		
-		# Attributes from Applications
-		# (self.__accessible will be an Application and not an Accessible)
-		elif attr == "toolkit" and type(self.__accessible) == atspi.Application:
-			return self.__accessible.getToolkit()
-		elif attr == "version" and type(self.__accessible) == atspi.Application:
-			return self.__accessible.getVersion()
-		elif attr == "ID" and type(self.__accessible) == atspi.Application:
-			return self.__accessible.getID()
-		# These two appear to be useless, so they're lazily bound. :)
-		elif attr == "pause" and type(self.__accessible) == atspi.Application:
-			return self.__accessible.pause
-		elif attr == "resume" and type(self.__accessible) == atspi.Application:
-			return self.__accessible.resume
-		
-		# Attributes from the Accessible object
-		elif attr == "name":
-			return self.__accessible.getName()
-		elif attr == "role":
-			return self.__accessible.getRole()
-		elif attr == "roleName":
-			return self.__accessible.getRoleName()
-		elif attr == "description":
-			return self.__accessible.getDescription()
-		elif attr == "parent":
-			try:
-				parentAcc = self.__accessible.getParent ()
-				if parentAcc:
-					parent = Node (parentAcc)
-					return parent
-				else:
-					return None
-			except AttributeError:
-				# Wrap the AttributeError to be more informative.
-				raise AttributeError, attr
-		elif attr == "children":
-			if self.__hideChildren: raise AttributeError, attr
-			children = []
-			for i in xrange (self.__accessible.getChildCount ()):
-				children.append (Node (self.__accessible.getChildAtIndex (i)))
-			# Attributes from the Hypertext object
-			try:
-				for i in range(self.__hypertext.getNLinks()):
-					children.append(Link(self, self.__hypertext.getLink(i), i))
-			except AttributeError: pass
-			if children: return children
-			else:
-				raise AttributeError, attr
-		elif attr == "stateSet":
-			return self.__accessible.getStateSet()
-		elif attr == "relations":
-			return self.__accessible.getRelationSet()
-		elif attr == "labellee":
-			# Find the nodes that this node is a label for:
-			# print self.relations
-			for relation in self.relations:
-				if relation.getRelationType() == atspi.SPI_RELATION_LABEL_FOR:
-					targets = relation.getTargets ()
-					return apply(Node, targets)
-		elif attr == "labeller":
-			# Find the nodes that are a label for this node:
-			# print self.relations
-			for relation in self.relations:
-				if relation.getRelationType() == atspi.SPI_RELATION_LABELED_BY:
-					targets = relation.getTargets ()
-					return apply(Node, targets)
-			
-		
-		# Attributes synthesized from the Accessible's stateSet:
-		elif attr == "sensitive":
-			return self.__accessible.getStateSet().contains(atspi.SPI_STATE_SENSITIVE)
-		elif attr == "showing":
-			return self.__accessible.getStateSet().contains(atspi.SPI_STATE_SHOWING)
-		
-		# Attributes from the Action object
-		elif attr == "actions":
-			actions = {}
-			for i in xrange (self.__action.getNActions ()):
-				action = (Action (self, self.__action, i))
-				actions[action.name] = action
-			if actions: 
-				return actions
-			else:
-				raise AttributeError, attr
-
-		# Attributes from the Component object
-		elif attr == "extents":
-			return self.__component.getExtents ()
-		elif attr == "position":
-			return self.__component.getPosition ()
-		elif attr == "size":
-			return self.__component.getSize ()
-
-		# Attributes from the Text object
-		elif attr == "text":
-			return self.__text.getText (0, 32767)
-		elif attr == "caretOffset":
-			return self.__text.getCaretOffset ()
-
-		# Attributes from the Component object
-		elif attr == "extents":
-			return self.__component.getExtents ()
-
-		else: raise AttributeError, attr
-
-	def __setattr__ (self, attr, value):
-		if False: pass
-		
-		# Are we swallowing an AT-SPI object?
-		elif attr.replace('_Node', '') in self.contained:
-			self.__dict__[attr] = value
-
-		# Attributes from the Text object
-		elif attr=="caretOffset":
-			self.__text.setCaretOffset(value)
-
-		# Attributes from the EditableText object
-		elif attr=="text":
-			"""
-			Set the text of the node to the given value, with
-			appropriate delays and logging, then test the result:
-			"""
-			if config.debugSearching: logger.log("Setting text of %s to '%s'"%(self.getLogString(), value))
-			self.__editableText.setTextContents (value)
-			doDelay()
-
-			#resultText = self.text
-			#if resultText != value:
-			#	raise "%s failed to have its text set to '%s'; value is '%s'"%(self.getLogString(), value, resultText)
-
-		elif attr=='passwordText':
-			"""
-			Set the text of the node to the given value, with
-			appropriate delays and logging. We can't test the
-			result, we'd only get * characters back.
-			"""
-			logger.log("Setting text %s to password '%s'"%(self.getLogString(), value))
-			self.__editableText.setTextContents (value)
-			doDelay()
-			
-		elif attr=="combovalue":
-			"""
-			Set the combobox to the given value, with appropriate delays and
-			logging.
-			"""
-			logger.log("Setting combobox %s to '%s'"%(self.getLogString(), value))
-			self.childNamed(childName=value).click()
-			doDelay()
-		else:
-			# FIXME: should we doing stuff like in the clause above???
-			self.__dict__[attr] = value
-
-	def typeText(self, string):
-		"""
-		Type the given text into the node, with appropriate delays and
-		logging.
-
-		FIXME: Doesn't work well at the moment
-		"""
-		logger.log("Typing text into %s: '%s'"%(self.getLogString(), string))
-
-		# Non-working implementation
-		# Unfortunately, the call to AccessibleText_setCaretOffset fails for Evolution's gtkhtml composer for some reason		
-		if False:
-			print "caret offset: %s"%self.caretOffset
-			self.__editableText.insertText (self.caretOffset, text)
-			self.caretOffset+=len(string) # FIXME: is this correct?
-			print "new caret offset: %s"%self.caretOffset
-
-		# Another non-working implementation
-		# Focus the node and inject and keyboard event:
-		# Unfortunately, this doesn't work well with Evolution either
-		if False:
-			self.grabFocus()
-			doDelay()
-			ev = atspi.EventGenerator()
-			ev.injectKeyboardString (string)
-
-		# This approach partially works:
-		if True:
-			self.text += string
-		
-		doDelay()
-
-	def __str__ (self):
-		"""
-		If debugName is set on this Node, returns debugName surrounded
-		in curly braces.
-		Otherwise, returns a plain-text representation of the most
-		important attributes of the underlying Accessible.
-		"""
-		if self.debugName:
-			return "{" + self.debugName + "}"
-		else:
-			string = "Node"
-			try: string = string + " roleName='%s'" % self.roleName
-			except AttributeError: pass
-			string = string + " name='%s' description='%s'" % (self.name, self.description)
-			try: string = string + " text='%s'" % self.text
-			except AttributeError: pass
-			return string
-
-	def getLogString(self):
-		"""
-		Get a string describing this node for the logs,
-		respecting the config.absoluteNodePaths boolean.
-		"""
-		if config.absoluteNodePaths:
-			return self.getAbsoluteSearchPath()
-		else:
-			return str(self)
-		
-	def satisfies (self, pred):
-		"""
-		Does this node satisfy the given predicate?
-		"""
-		# the logic is handled by the predicate:
-		assert isinstance(pred, predicate.Predicate)
-		return pred.satisfiedByNode(self)
-
-	def dump (self, type = 'plain'):
-		import dump
-		dumper = getattr (dump, type)
-		dumper (self)
-
-	def getAbsoluteSearchPath(self):
-		"""
-		FIXME: this needs rewriting...
-		Generate a SearchPath instance giving the 'best'
-		way to find the Accessible wrapped by this node again, starting
-		at the root and applying each search in turn.
-
-		This is somewhat analagous to an absolute path in a filesystem,
-		except that some of searches may be recursive, rather than just
-		searching direct children.
-
-		Used by the recording framework for identifying nodes in a
-		persistent way, independent of the style of script being
-		written.
-		
-		FIXME: try to ensure uniqueness
-		FIXME: need some heuristics to get 'good' searches, whatever
-		that means
-		"""
-		if config.debugSearchPaths:
-			print "getAbsoluteSearchPath(%s)"%self
-			
-		if self.roleName=='application':
-			result =path.SearchPath()
-			result.append(predicate.IsAnApplicationNamed(self.name), False)
-			return result
-		else:
-			if self.parent:
-				(ancestor, pred, isRecursive) = self.getRelativeSearch()
-				if config.debugSearchPaths:
-					print "got ancestor: %s"%ancestor
-				
-				ancestorPath = ancestor.getAbsoluteSearchPath()
-				ancestorPath.append(pred, isRecursive)
-				return ancestorPath
-			else:
-				# This should be the root node:
-				return path.SearchPath()
-
-	def getRelativeSearch(self):
-		"""
-		Get a (ancestorNode, predicate, isRecursive) triple that identifies the
-		best way to find this Node uniquely.
-		FIXME: or None if no such search exists?
-		FIXME: may need to make this more robust
-		FIXME: should this be private?
-		"""
-		if config.debugSearchPaths:
-			print "getRelativeSearchPath(%s)"%self
-			
-		assert self
-		assert self.parent
-
-		isRecursive = False
-		ancestor = self.parent
-
-		# iterate up ancestors until you reach an identifiable one,
-		# setting the search to be isRecursive if need be:
-		while not self.__nodeIsIdentifiable(ancestor):
-			ancestor = ancestor.parent
-			isRecursive = True
-
-		# Pick the most appropriate predicate for finding this node:
-		if self.labellee:
-			if self.labellee.name:
-				return (ancestor, predicate.IsLabelledAs(self.labellee.name), isRecursive)
-
-		if self.roleName=='menu':
-			return (ancestor, predicate.IsAMenuNamed(self.name), isRecursive)
-		elif self.roleName=='menu item' or self.roleName=='check menu item':
-			return (ancestor, predicate.IsAMenuItemNamed(self.name), isRecursive)
-		elif self.roleName=='text':
-			return (ancestor, predicate.IsATextEntryNamed(self.name), isRecursive)
-		elif self.roleName=='push button':
-			return (ancestor, predicate.IsAButtonNamed(self.name), isRecursive)
-		elif self.roleName=='frame':
-			return (ancestor, predicate.IsAWindowNamed(self.name), isRecursive)
-		elif self.roleName=='dialog':
-			return (ancestor, predicate.IsADialogNamed(self.name), isRecursive)
-		else:
-			pred = predicate.GenericPredicate(name=self.name, roleName=self.roleName)
-			return (ancestor, pred, isRecursive)
-
-	def __nodeIsIdentifiable(self, ancestor):
-		if ancestor.labellee:
-			return True
-		elif ancestor.name:
-			return True
-		elif not ancestor.parent:
-			return True
-		else:
-			return False
-
-	def grabFocus(self):
-		return self.__component.grabFocus ()
-
-	# The canonical search method:
-	def findChild(self, pred, recursive = True, debugName = None, retry = True, requireResult = True):
-		"""
-		Search for a node satisyfing the predicate, returning a Node.
-
-		If retry is True (the default), it makes multiple attempts, 
-		backing off and retrying on failure, and eventually raises a
-		descriptive exception if the search fails.
-
-		If retry is False, it gives up after one attempt.
-		
-		If requireResult is True (the default), an exception is raised after all 
-		attempts have failed. If it is false, the function simply returns None.
-	
-		FIXME: make multiple attempts?
-		"""
-		
-		def findFirstChildSatisfying (parent, pred, recursive = True):
-			"""
-			Internal helper function that does a one-shot search, recursing if need be.
-			"""
-			# print "findFirstChildSatisfying(%s, %s, recursive=%s)"%(parent, pred,recursive)
-			assert isinstance(pred, predicate.Predicate)
-		
-			try: children = parent.children
-			except: return None
-
-			for child in children:
-				# print child
-				if child.satisfies(pred):
-					return child
-				else:
-					if recursive:
-						child = findFirstChildSatisfying(child, pred, recursive)
-						if child: return child
-				# ...on to next child
-
-		def describeSearch (parent, pred, recursive, debugName):
-			"""
-			Internal helper function
-			"""
-			if recursive:
-				noun = "descendent"
-			else:
-				noun = "child"
-
-			if debugName == None:
-				debugName = pred.describeSearchResult()
-
-			return "%s of %s: %s"%(noun, parent.getLogString(), debugName)
-		
-		assert isinstance(pred, predicate.Predicate)
-		numAttempts = 0
-		while numAttempts<config.searchCutoffCount:
-			if numAttempts>=config.searchWarningThreshold or config.debugSearching:
-				print "searching for %s (attempt %i)"%(describeSearch(self, pred, recursive, debugName), numAttempts)
-			
-			result = findFirstChildSatisfying(self, pred, recursive)
-			if result:
-				assert isinstance(result, Node)
-				if debugName:
-					result.debugName = debugName
-				else:
-					result.debugName = pred.describeSearchResult()
-				return result
-			else:
-				if not retry: break
-				numAttempts+=1
-				if config.debugSearching or config.debugSleep:
-					print "sleeping for %f"%config.searchBackoffDuration
-				sleep(config.searchBackoffDuration)
-		if requireResult:
-			raise SearchError, describeSearch(self, pred, recursive, debugName)
-
-	# The canonical "search for multiple" method:
-	def findChildren(self, pred, recursive = True):
-		"""
-		Find all children/descendents satisfying the predicate.
-		"""
-		assert isinstance(pred, predicate.Predicate)
-
-		selfList = []
-
-		try: children = self.children
-		except: return None
-
-		for child in children:
-			if child.satisfies(pred): selfList.append(child)
-			if recursive:
-				childList = child.findChildren(pred, recursive)
-				if childList:
-					for child in childList:
-						selfList.append(child)
-			# ...on to next child
-
-		if selfList: return selfList
-
-	# The canonical "search above this node" method:
-	def findAncestor (self, pred):
-		"""
-		Search up the ancestry of this node, returning the first Node
-		satisfying the predicate, or None.
-		"""
-		assert isinstance(pred, predicate.Predicate)
-		candidate = self.parent
-		while candidate != None:
-			if candidate.satisfies(pred):
-				return candidate
-			else:
-				candidate = candidate.parent
-		# Not found:
-		return None
-	
-
-	# Various wrapper/helper search methods:
-	def child (self, name = '', roleName = '', description= '', label = '', recursive=True, debugName=None):
-		"""
-		Finds a child satisying the given criteria.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.GenericPredicate(name = name, roleName = roleName, description= description, label = label), recursive = recursive, debugName=debugName)
-
-	# FIXME: does this clash with the "menu" action
-	def menu(self, menuName, recursive=True):
-		"""
-		Search below this node for a menu with the given name.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsAMenuNamed(menuName=menuName), recursive)
-
-	def menuItem(self, menuItemName, recursive=True):
-		"""
-		Search below this node for a menu item with the given name.
-		
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsAMenuItemNamed(menuItemName=menuItemName), recursive)
-
-	def textentry(self, textEntryName, recursive=True):
-		"""
-		Search below this node for a text entry with the given name.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsATextEntryNamed(textEntryName=textEntryName), recursive)
-
-	def button(self, buttonName, recursive=True):
-		"""
-		Search below this node for a button with the given name.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsAButtonNamed(buttonName=buttonName), recursive)
-
-	def childLabelled(self, labelText, recursive=True):
-		"""
-		Search below this node for a child labelled with the given text.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsLabelled(labelText), recursive)
-
-	def childNamed(self, childName, recursive=True):
-		"""
-		Search below this node for a child with the given name.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsNamed(childName), recursive)
-
-	def tab(self, tabName, recursive=True):
-		"""
-		Search below this node for a tab with the given name.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return self.findChild (predicate.IsATabNamed(tabName=tabName), recursive)
-
-	def getUserVisibleStrings(self):
-		"""
-		Get all user-visible strings in this node and its descendents.
-		
-		(Could be implemented as an attribute)
-		"""
-		result=[]
-		if self.name:
-			result.append(self.name)
-		if self.description:
-			result.append(self.description)
-		try: 
-			children = self.children
-		except: return result
-		for child in children:
-				result.extend(child.getUserVisibleStrings())
-		return result
-
-	def blink(self, count = 2):
-		"""
-		Blink, baby!
-		"""
-		try:
-			(x, y, w, h) = self.extents
-			blinkData = Blinker(x, y, w, h, count)
-			return True
-		except AttributeError:
-			return False
-
-	def click(self):
-		"""
-		If the Node supports an action called "click", do it, with appropriate delays and logging.
-		Otherwise, raise an ActionNotSupported exception. 
-
-		Note that this is just a shortcut to doAction('click'), as it is by far the most-used
-		action. To do any other action such as 'activate' or 'open', you must use doAction().
-		"""
-		if self.__action is not None:
-			return self.doAction('click')
-		raise ActionNotSupported('click', self)
+    """
+    A node in the tree of UI elements. It wraps an Accessible and
+    exposes its useful members. It also has a debugName which is set
+    up automatically when doing searches.
+
+    Node instances have various attributes synthesized, to make it easy to
+    get and the underlying accessible data. Many more attributes can be
+    added as desired.
+
+    'name' (read-only string):
+    Wraps Accessible_getName on the Node's underlying Accessible
+
+    'roleName' (read-only string):
+    Wraps Accessible_getRoleName on the Node's underlying Accessible
+
+    'role' (read-only atspi role enum):
+    Wraps Accessible_getRole on the Node's underlying Accessible
+
+    'description' (read-only string):
+    Wraps Accessible_getDescription on the Node's underlying Accessible
+
+    'parent' (read-only Node instance):
+    A Node instance wrapping the parent, or None. Wraps Accessible_getParent
+
+    'children' (read-only list of Node instances):
+    The children of this node, wrapping getChildCount and getChildAtIndex
+
+    'text' (string):
+    For instances wrapping AccessibleText, the text. This is read-only,
+    unless the instance wraps an AccessibleEditableText. In this case, you
+    can write values to the attribute. This will get logged in the debug
+    log, and a delay will be added. After the delay, the content of the
+    node will be checked to ensure that it has the expected value. If it
+    does not, an exception will be raised. This does not work for password
+    dialogs (since all we get back are * characters). In this case, set
+    the passwordText attribute instead.
+
+    'passwordText' (write-only string):
+    See documentation of 'text' attribute above.
+
+    'caretOffset' (read/write int):
+    For instances wrapping AccessibleText, the location of the text caret,
+    expressed as an offset in characters.
+
+    'combovalue' (write-only string):
+    For comboboxes. Write to this attribute to set the combobox to the
+    given value, with appropriate delays and logging.
+
+    'stateSet' (read-only StateSet instance):
+    Wraps Accessible_getStateSet; a set of boolean state flags
+
+    'relations' (read-only list of atspi.Relation instances):
+    Wraps Accessible_getRelationSet
+
+    'labellee' (read-only list of Node instances):
+    The node(s) that this node is a label for. Generated from 'relations'.
+
+    'labeller' (read-only list of Node instances):
+    The node(s) that is/are a label for this node. Generated from
+    'relations'.
+
+    'checked' (read-only boolean):
+    Is this node checked? Only valid for checkboxes. Generated from stateSet
+    based on presence of atspi.SPI_STATE_CHECKED.
+
+    'sensitive' (read-only boolean):
+    Is this node sensitive (i.e. not greyed out). Generated from stateSet
+    based on presence of atspi.SPI_STATE_SENSITIVE
+    Not all applications/toolkits seem to properly set this up.
+
+    'showing' (read-only boolean):
+    Generated from stateSet based on presence of atspi.SPI_STATE_SHOWING
+
+    'focusable' (read-only boolean):
+    Generated from stateSet based on presence of atspi.SPI_STATE_FOCUSABLE
+
+    'focused' (read-only boolean):
+    Generated from stateSet based on presence of atspi.SPI_STATE_FOCUSED
+
+    'actions' (read-only list of Action instances):
+    Generated from Accessible_getAction and AccessibleAction_getNActions
+
+    For each action that is supported by a node, a method is hooked up,
+    this can include the following list:
+    'click'
+    'press'
+    'release'
+    'activate'
+    'jump'
+    'check'
+    'dock'
+    'undock'
+    'open'
+    'menu'
+
+    'extents' (readonly tuple):
+    For instances wrapping a Component, the (x,y,w,h) screen extents of the
+    component.
+
+    'position' (readonly tuple):
+    For instances wrapping a Component, the (x,y) screen position of the
+    component.
+
+    'size' (readonly tuple):
+    For instances wrapping a Component, the (w,h) screen size of the component.
+
+    'grabFocus':
+    For instances wrapping a Component, attempt to set the keyboard input focus
+    to that Node.
+
+    'toolkit' (readonly string):
+    For instances wrapping an application, the name of the toolkit.
+
+    'version'
+    For instances wrapping an application.
+
+    'ID'
+    For instances wrapping an application.
+
+    'pause' (function)
+    'resume' (function)
+    For instances wrapping an application; probably don't work
+    """
+
+    #Valid types of AT-SPI objects we wrap.
+    contained = ('__accessible', '__action', '__component', '__text', '__editableText', '__selection')
+
+    def __init__ (self, initializer):
+        self.__hideChildren = False
+        self.debugName = None
+        if isinstance(initializer, atspi.Accessible):
+            self.__accessible = initializer
+        elif isinstance(initializer, Node):
+            self.__accessible = initializer.__accessible
+            self.debugName = getattr(initializer, 'debugName', None)
+        else:
+            raise "Unknown Node initializer"
+        assert self.__accessible
+
+        # Swallow the Action object, if it exists
+        self.__action = self.__accessible.getAction()
+        if self.__action is not None:
+            def doAction(name):
+                """
+                Performs the tree.Action with the given name, with appropriate delays and logging,
+                or raises the ActionNotSupported exception if the node doesn't support that particular
+                action.
+                """
+                actions = self.actions
+                if actions.has_key(name):
+                    return actions[name].do()
+                else:
+                    raise ActionNotSupported(name, self)
+            self.doAction = doAction
+
+        # Swallow the Component object, if it exists
+        self.__component = self.__accessible.getComponent()
+        if self.__component is not None:
+            def grabFocus():
+                self.__component.grabFocus()
+                doDelay()
+            self.grabFocus = grabFocus
+
+            def rawClick(button = 1):
+                """
+                Generates a raw mouse click event whether or not the Node has a 'click' action, using the specified button.
+                1 is left,
+                2 is middle,
+                3 is right.
+                """
+                extents = self.extents
+                position = (extents[0], extents[1])
+                size = (extents[2], extents[3])
+                clickX = position[0] + 0.5 * size[0]
+                clickY = position[1] + 0.5 * size[1]
+                if config.debugSearching:
+                    logger.log("raw click on %s %s at (%s,%s)"%(self.name, self.getLogString(), str(clickX), str(clickY)))
+                rawinput.click(clickX, clickY, button)
+            self.rawClick = rawClick
+
+        # Swallow the Text object, if it exists
+        self.__text = self.__accessible.getText()
+        if self.__text is not None:
+            self.addSelection = self.__text.addSelection
+            self.getNSelections = self.__text.getNSelections
+            self.removeSelection = self.__text.removeSelection
+            self.setSelection = self.__text.setSelection
+
+        # Swallow the EditableText object, if it exists
+        self.__editableText = self.__accessible.getEditableText()
+        if self.__editableText is not None:
+            self.setAttributes = self.__editableText.setAttributes
+
+        # Swallow the Hypertext object, if it exists
+        self.__hypertext = self.__accessible.getHypertext()
+
+        # Swallow the Selection object, if it exists
+        self.__selection = self.__accessible.getSelection()
+        if self.__selection is not None:
+            def selectAll():
+                """
+                Selects all children.
+                """
+                return self.__selection.selectAll()
+            self.selectAll = selectAll
+
+            def deselectAll():
+                """
+                Deselects all selected children.
+                """
+                return self.__selection.clearSelection()
+            self.deselectAll = deselectAll
+
+        # Implement select() for children of nodes with Selection interfaces.
+        parent = self.parent
+        if parent and parent._Node__selection:
+            def select():
+                """
+                Selects the node, relative to its siblings.
+                """
+                return self.parent._Node__selection.selectChild(self.indexInParent)
+            self.select = select
+
+            def deselect():
+                """
+                Deselects the node, relative to its siblings.
+                """
+                selectedIndex = 0
+                parent = self.parent
+                for i in range(self.indexInParent):
+                    if parent.children[i].isSelected:
+                        selectedIndex+=1
+                return parent._Node__selection.deselectSelectedChild(selectedIndex)
+            self.deselect = select
+
+        # Add more objects here. Nobody uses them yet, so I haven't.
+        # You also need to change the __getattr__ and __setattr__ functions.
+
+    # It'd be nice to know if two objects are "identical". However, the
+    # approach below does not work, since atspi.Accessible doesn't know
+    # how to check if two cspi.Accessible objects are "identical" either. :(
+    #def __cmp__ (self, node):
+    #        return self.__accessible == node.__accessible
+
+    def __getattr__ (self, attr):
+        if False: pass
+
+        # Attributes from Applications
+        # (self.__accessible will be an Application and not an Accessible)
+        elif attr == "toolkit" and type(self.__accessible) == atspi.Application:
+            return self.__accessible.getToolkit()
+        elif attr == "version" and type(self.__accessible) == atspi.Application:
+            return self.__accessible.getVersion()
+        elif attr == "ID" and type(self.__accessible) == atspi.Application:
+            return self.__accessible.getID()
+        # These two appear to be useless, so they're lazily bound. :)
+        elif attr == "pause" and type(self.__accessible) == atspi.Application:
+            return self.__accessible.pause
+        elif attr == "resume" and type(self.__accessible) == atspi.Application:
+            return self.__accessible.resume
+
+        # Attributes from the Accessible object
+        elif attr == "name":
+            return self.__accessible.getName()
+        elif attr == "role":
+            return self.__accessible.getRole()
+        elif attr == "roleName":
+            return self.__accessible.getRoleName()
+        elif attr == "description":
+            return self.__accessible.getDescription()
+        elif attr == "parent":
+            parentAcc = self.__accessible.getParent ()
+            if parentAcc:
+                parent = Node (parentAcc)
+                return parent
+        elif attr =="indexInParent":
+            return self.__accessible.getIndexInParent()
+        elif attr == "children":
+            if self.__hideChildren: return
+            children = []
+            for i in xrange (self.__accessible.getChildCount ()):
+                if isinstance(self, Root):
+                    try: a = self.__accessible.getChildAtIndex (i)
+                    except atspi.SpiException:
+                        import traceback
+                        logger.log(traceback.format_exc())
+                else: a = self.__accessible.getChildAtIndex (i)
+                # Workaround to GNOME bug #321273
+                # http://bugzilla.gnome.org/show_bug.cgi?id=321273
+                if a is not None: children.append (Node (a))
+            # Attributes from the Hypertext object
+            if self.__hypertext:
+                for i in range(self.__hypertext.getNLinks()):
+                    children.append(Link(self, self.__hypertext.getLink(i), i))
+            return children
+        elif attr == "stateSet":
+            return self.__accessible.getStateSet()
+        elif attr == "relations":
+            return self.__accessible.getRelationSet()
+        elif attr == "labellee":
+            # Find the nodes that this node is a label for:
+            # print self.relations
+            for relation in self.relations:
+                if relation.getRelationType() == atspi.SPI_RELATION_LABEL_FOR:
+                    targets = relation.getTargets ()
+                    return apply(Node, targets)
+        elif attr == "labeller":
+            # Find the nodes that are a label for this node:
+            # print self.relations
+            for relation in self.relations:
+                if relation.getRelationType() == atspi.SPI_RELATION_LABELED_BY:
+                    targets = relation.getTargets ()
+                    return apply(Node, targets)
+
+        # Attributes synthesized from the Accessible's stateSet:
+        elif attr == "sensitive":
+            return self.__accessible.getStateSet().contains(atspi.SPI_STATE_SENSITIVE)
+        elif attr == "showing":
+            return self.__accessible.getStateSet().contains(atspi.SPI_STATE_SHOWING)
+        elif attr == "focusable":
+            return self.__accessible.getStateSet().contains(atspi.SPI_STATE_FOCUSABLE)
+        elif attr == "focused":
+            return self.__accessible.getStateSet().contains(atspi.SPI_STATE_FOCUSED)
+        elif attr == "checked":
+            return self.__accessible.getStateSet().contains(atspi.SPI_STATE_CHECKED)
+
+        # Attributes from the Action object
+        elif attr == "actions":
+            actions = {}
+            if self.__action:
+                for i in xrange (self.__action.getNActions ()):
+                    action = (Action (self, self.__action, i))
+                    actions[action.name] = action
+            return actions
+
+        # Attributes from the Component object
+        elif attr == "extents":
+            if self.__component:
+                return self.__component.getExtents()
+        elif attr == "position":
+            if self.__component:
+                return self.__component.getPosition()
+        elif attr == "size":
+            if self.__component:
+                # This always returns [0, 0]
+                #return self.__component.getSize()
+                extents = self.__component.getExtents()
+                size = (extents[2], extents[3])
+                return size
+
+        # Attributes from the Text object
+        elif attr == "text":
+            if self.__text:
+                return self.__text.getText(0, 32767)
+        elif attr == "caretOffset":
+            if self.__text:
+                return self.__text.getCaretOffset()
+
+        # Attributes from the Selection object
+        elif attr == "isSelected":
+            parent = self.parent
+            if parent and parent._Node__selection:
+                return self.parent._Node__selection.isChildSelected(self.indexInParent)
+        elif attr == "selectedChildren":
+            if self.__hideChildren:
+                return
+            selectedChildren = []
+            parent = self.parent
+            if parent and self.parent._Node__selection:
+                for i in xrange(self.__selection.getNSelectedChildren()):
+                    selectedChildren.append(Node(self.__selection.getSelectedChild(i)))
+            return selectedChildren
+
+        else: raise AttributeError, attr
+
+    def __setattr__ (self, attr, value):
+        if False: pass
+
+        # Are we swallowing an AT-SPI object?
+        elif attr.replace('_Node', '') in self.contained:
+            self.__dict__[attr] = value
+
+        # Read-only attributes from Applications
+        # (self.__accessible will be an Application and not an Accessible)
+        elif attr in ["toolkit", "version", "ID"]:
+            raise ReadOnlyError, attr
+
+        # Read-only attributes from the Accessible object
+        elif attr in ["name", "role", "roleName", "description", "parent",
+                      "indexInParent", "children", "stateSet", "relations",
+                      "labellee", "labeller"]:
+            raise ReadOnlyError, attr
+
+        # Read-only attributes synthesized from the Accessible's stateSet:
+        elif attr in ["sensitive", "showing", "focusable", "focused", "checked"]:
+            raise ReadOnlyError, attr
+
+        # Read-only attributes from the Action object
+        elif attr == "actions":
+            raise ReadOnlyError, attr
+
+        # Attributes from the Component object
+        elif attr in ["extents", "position", "size"]:
+            raise ReadOnlyError, attr
+
+        # Attributes from the Text object
+        elif attr=="caretOffset":
+            if not self.__text:
+                raise ReadOnlyError, attr
+            self.__text.setCaretOffset(value)
+
+        # Attributes from the EditableText object
+        elif attr=="text":
+            """
+            Set the text of the node to the given value, with
+            appropriate delays and logging, then test the result:
+            """
+            if not self.__editableText:
+                raise ReadOnlyError, attr
+            if config.debugSearching: logger.log("Setting text of %s to '%s'"%(self.getLogString(), value))
+            self.__editableText.setTextContents (value)
+            doDelay()
+
+            #resultText = self.text
+            #if resultText != value:
+            #       raise "%s failed to have its text set to '%s'; value is '%s'"%(self.getLogString(), value, resultText)
+
+        elif attr=='passwordText':
+            """
+            Set the text of the node to the given value, with
+            appropriate delays and logging. We can't test the
+            result, we'd only get * characters back.
+            """
+            if not self.__editableText:
+                raise ReadOnlyError, attr
+            logger.log("Setting text %s to password '%s'"%(self.getLogString(), value))
+            self.__editableText.setTextContents (value)
+            doDelay()
+
+        elif attr=="combovalue":
+            """
+            Set the combobox to the given value, with appropriate delays and
+            logging.
+            """
+            logger.log("Setting combobox %s to '%s'"%(self.getLogString(), value))
+            self.childNamed(childName=value).click()
+            doDelay()
+        else:
+            # FIXME: should we doing stuff like in the clause above???
+            self.__dict__[attr] = value
+
+    def typeText(self, string):
+        """
+        Type the given text into the node, with appropriate delays and
+        logging.
+        """
+        logger.log("Typing text into %s: '%s'"%(self.getLogString(), string))
+
+        # Non-working implementation
+        # Unfortunately, the call to AccessibleText_setCaretOffset fails for Evolution's gtkhtml composer for some reason
+        if False:
+            logger.log("caret offset: %s" % self.caretOffset)
+            self.__editableText.insertText (self.caretOffset, text)
+            self.caretOffset+=len(string) # FIXME: is this correct?
+            logger.log("new caret offset: %s" % self.caretOffset)
+
+        if self.focusable:
+            if not self.focused:
+                try: self.grabFocus()
+                except: logger.log("Node is focusable but I can't grabFocus!")
+            rawinput.typeText(string)
+        else:
+            logger.log("Node is not focusable; falling back to setting text")
+            node.text += string
+            doDelay()
+
+    def keyCombo(self, comboString):
+        if config.debugSearching: logger.log("Pressing keys '%s' into %s"%(combo, self.getLogString()))
+        if self.focusable:
+            if not self.focused:
+                try: self.grabFocus()
+                except: logger.log("Node is focusable but I can't grabFocus!")
+        else: logger.log("Node is not focusable; trying key combo anyway")
+        rawinput.keyCombo(comboString)
+
+    def __str__ (self):
+        """
+        If debugName is set on this Node, returns debugName surrounded
+        in curly braces.
+        Otherwise, returns a plain-text representation of the most
+        important attributes of the underlying Accessible.
+        """
+        if self.debugName:
+            return "{" + self.debugName + "}"
+        else:
+            string = "Node"
+            string = string + " roleName='%s'" % self.roleName
+            string = string + " name='%s' description='%s'" % (self.name, self.description)
+            if self.text is not None:
+                string = string + " text='%s'" % self.text
+            return string
+
+    def getLogString(self):
+        """
+        Get a string describing this node for the logs,
+        respecting the config.absoluteNodePaths boolean.
+        """
+        if config.absoluteNodePaths:
+            return self.getAbsoluteSearchPath()
+        else:
+            return str(self)
+
+    def satisfies (self, pred):
+        """
+        Does this node satisfy the given predicate?
+        """
+        # the logic is handled by the predicate:
+        assert isinstance(pred, predicate.Predicate)
+        return pred.satisfiedByNode(self)
+
+    def dump (self, type = 'plain'):
+        import dump
+        dumper = getattr (dump, type)
+        dumper (self)
+
+    def getAbsoluteSearchPath(self):
+        """
+        FIXME: this needs rewriting...
+        Generate a SearchPath instance giving the 'best'
+        way to find the Accessible wrapped by this node again, starting
+        at the root and applying each search in turn.
+
+        This is somewhat analagous to an absolute path in a filesystem,
+        except that some of searches may be recursive, rather than just
+        searching direct children.
+
+        Used by the recording framework for identifying nodes in a
+        persistent way, independent of the style of script being
+        written.
+
+        FIXME: try to ensure uniqueness
+        FIXME: need some heuristics to get 'good' searches, whatever
+        that means
+        """
+        if config.debugSearchPaths:
+            logger.log("getAbsoluteSearchPath(%s)" % self)
+
+        if self.roleName=='application':
+            result =path.SearchPath()
+            result.append(predicate.IsAnApplicationNamed(self.name), False)
+            return result
+        else:
+            if self.parent:
+                (ancestor, pred, isRecursive) = self.getRelativeSearch()
+                if config.debugSearchPaths:
+                    logger.log("got ancestor: %s" % ancestor)
+
+                ancestorPath = ancestor.getAbsoluteSearchPath()
+                ancestorPath.append(pred, isRecursive)
+                return ancestorPath
+            else:
+                # This should be the root node:
+                return path.SearchPath()
+
+    def getRelativeSearch(self):
+        """
+        Get a (ancestorNode, predicate, isRecursive) triple that identifies the
+        best way to find this Node uniquely.
+        FIXME: or None if no such search exists?
+        FIXME: may need to make this more robust
+        FIXME: should this be private?
+        """
+        if config.debugSearchPaths:
+            logger.log("getRelativeSearchPath(%s)" % self)
+
+        assert self
+        assert self.parent
+
+        isRecursive = False
+        ancestor = self.parent
+
+        # iterate up ancestors until you reach an identifiable one,
+        # setting the search to be isRecursive if need be:
+        while not self.__nodeIsIdentifiable(ancestor):
+            ancestor = ancestor.parent
+            isRecursive = True
+
+        # Pick the most appropriate predicate for finding this node:
+        if self.labellee:
+            if self.labellee.name:
+                return (ancestor, predicate.IsLabelledAs(self.labellee.name), isRecursive)
+
+        if self.roleName=='menu':
+            return (ancestor, predicate.IsAMenuNamed(self.name), isRecursive)
+        elif self.roleName=='menu item' or self.roleName=='check menu item':
+            return (ancestor, predicate.IsAMenuItemNamed(self.name), isRecursive)
+        elif self.roleName=='text':
+            return (ancestor, predicate.IsATextEntryNamed(self.name), isRecursive)
+        elif self.roleName=='push button':
+            return (ancestor, predicate.IsAButtonNamed(self.name), isRecursive)
+        elif self.roleName=='frame':
+            return (ancestor, predicate.IsAWindowNamed(self.name), isRecursive)
+        elif self.roleName=='dialog':
+            return (ancestor, predicate.IsADialogNamed(self.name), isRecursive)
+        else:
+            pred = predicate.GenericPredicate(name=self.name, roleName=self.roleName)
+            return (ancestor, pred, isRecursive)
+
+    def __nodeIsIdentifiable(self, ancestor):
+        if ancestor.labellee:
+            return True
+        elif ancestor.name:
+            return True
+        elif not ancestor.parent:
+            return True
+        else:
+            return False
+
+    # The canonical search method:
+    def findChild(self, pred, recursive = True, debugName = None, retry = True, requireResult = True):
+        """
+        Search for a node satisyfing the predicate, returning a Node.
+
+        If retry is True (the default), it makes multiple attempts,
+        backing off and retrying on failure, and eventually raises a
+        descriptive exception if the search fails.
+
+        If retry is False, it gives up after one attempt.
+
+        If requireResult is True (the default), an exception is raised after all
+        attempts have failed. If it is false, the function simply returns None.
+
+        FIXME: make multiple attempts?
+        """
+
+        def findFirstChildSatisfying (parent, pred, recursive = True):
+            """
+            Internal helper function that does a one-shot search, recursing if need be.
+            """
+            # print "findFirstChildSatisfying(%s, %s, recursive=%s)"%(parent, pred,recursive)
+            assert isinstance(pred, predicate.Predicate)
+
+            try: children = parent.children
+            except: return None
+
+            for child in children:
+                # print child
+                if child.satisfies(pred):
+                    return child
+                else:
+                    if recursive:
+                        child = findFirstChildSatisfying(child, pred, recursive)
+                        if child: return child
+                # ...on to next child
+
+        def describeSearch (parent, pred, recursive, debugName):
+            """
+            Internal helper function
+            """
+            if recursive:
+                noun = "descendent"
+            else:
+                noun = "child"
+
+            if debugName == None:
+                debugName = pred.describeSearchResult()
+
+            return "%s of %s: %s"%(noun, parent.getLogString(), debugName)
+
+        assert isinstance(pred, predicate.Predicate)
+        numAttempts = 0
+        while numAttempts<config.searchCutoffCount:
+            if numAttempts>=config.searchWarningThreshold or config.debugSearching:
+                logger.log("searching for %s (attempt %i)" % (describeSearch(self, pred, recursive, debugName), numAttempts))
+
+            result = findFirstChildSatisfying(self, pred, recursive)
+            if result:
+                assert isinstance(result, Node)
+                if debugName:
+                    result.debugName = debugName
+                else:
+                    result.debugName = pred.describeSearchResult()
+                return result
+            else:
+                if not retry: break
+                numAttempts+=1
+                if config.debugSearching or config.debugSleep:
+                    logger.log("sleeping for %f" % config.searchBackoffDuration)
+                sleep(config.searchBackoffDuration)
+        if requireResult:
+            raise SearchError(describeSearch(self, pred, recursive, debugName))
+
+    # The canonical "search for multiple" method:
+    def findChildren(self, pred, recursive = True):
+        """
+        Find all children/descendents satisfying the predicate.
+        """
+        assert isinstance(pred, predicate.Predicate)
+
+        selfList = []
+
+        try: children = self.children
+        except: return None
+
+        for child in children:
+            if child.satisfies(pred): selfList.append(child)
+            if recursive:
+                childList = child.findChildren(pred, recursive)
+                if childList:
+                    for child in childList:
+                        selfList.append(child)
+            # ...on to next child
+
+        if selfList: return selfList
+
+    # The canonical "search above this node" method:
+    def findAncestor (self, pred):
+        """
+        Search up the ancestry of this node, returning the first Node
+        satisfying the predicate, or None.
+        """
+        assert isinstance(pred, predicate.Predicate)
+        candidate = self.parent
+        while candidate != None:
+            if candidate.satisfies(pred):
+                return candidate
+            else:
+                candidate = candidate.parent
+        # Not found:
+        return None
+
+
+    # Various wrapper/helper search methods:
+    def child (self, name = '', roleName = '', description= '', label = '', recursive=True, debugName=None):
+        """
+        Finds a child satisying the given criteria.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.GenericPredicate(name = name, roleName = roleName, description= description, label = label), recursive = recursive, debugName=debugName)
+
+    # FIXME: does this clash with the "menu" action
+    def menu(self, menuName, recursive=True):
+        """
+        Search below this node for a menu with the given name.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsAMenuNamed(menuName=menuName), recursive)
+
+    def menuItem(self, menuItemName, recursive=True):
+        """
+        Search below this node for a menu item with the given name.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsAMenuItemNamed(menuItemName=menuItemName), recursive)
+
+    def textentry(self, textEntryName, recursive=True):
+        """
+        Search below this node for a text entry with the given name.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsATextEntryNamed(textEntryName=textEntryName), recursive)
+
+    def button(self, buttonName, recursive=True):
+        """
+        Search below this node for a button with the given name.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsAButtonNamed(buttonName=buttonName), recursive)
+
+    def childLabelled(self, labelText, recursive=True):
+        """
+        Search below this node for a child labelled with the given text.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsLabelled(labelText), recursive)
+
+    def childNamed(self, childName, recursive=True):
+        """
+        Search below this node for a child with the given name.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsNamed(childName), recursive)
+
+    def tab(self, tabName, recursive=True):
+        """
+        Search below this node for a tab with the given name.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return self.findChild (predicate.IsATabNamed(tabName=tabName), recursive)
+
+    def getUserVisibleStrings(self):
+        """
+        Get all user-visible strings in this node and its descendents.
+
+        (Could be implemented as an attribute)
+        """
+        result=[]
+        if self.name:
+            result.append(self.name)
+        if self.description:
+            result.append(self.description)
+        try:
+            children = self.children
+        except: return result
+        for child in children:
+            result.extend(child.getUserVisibleStrings())
+        return result
+
+    def blink(self, count = 2):
+        """
+        Blink, baby!
+        """
+        if not self.extents:
+            return False
+        else:
+            (x, y, w, h) = self.extents
+            blinkData = Blinker(x, y, w, h, count)
+            return True
+
+
+    def click(self):
+        """
+        If the Node supports an action called "click", do it, with appropriate delays and logging.
+        Otherwise, raise an ActionNotSupported exception.
+
+        Note that this is just a shortcut to doAction('click'), as it is by far the most-used
+        action. To do any other action such as 'activate' or 'open', you must use doAction().
+        """
+        if self.__action is not None:
+            return self.doAction('click')
+        raise ActionNotSupported('click', self)
 
 class Link(Node):
-	"""
-	Class representing a hyperlink
-	"""
-	contained = ('__hyperlink', '__node')
-
-	def __init__(self, node, hyperlink, index):
-		self.debugName = None
-		self.parent = node
-		self.__hyperlink = hyperlink
-		self.__index = index
-		self.__node = Node(self.__hyperlink.getObject(self.__index))
-		# Somehow, if we allow the children to be seen, things get weird.
-		self.__node.__hideChildren = True
-	
-	def __getattr__(self, name):
-		if False: pass
-		elif name == 'URI':
-			# Note: This doesn't seem to work. It usually just causes python to hang.
-			return self.__hyperlink.getURI(self.__index)
-		else: 
-			if name == 'children':
-				raise AttributeError, name
-			try: 
-				result = getattr(self.__node, name)
-				return result
-			except AttributeError: 
-				raise AttributeError, name
-
-	def __setattr__(self, name, value):
-		self.__dict__[name] = value
-		
+    """
+    Class representing a hyperlink
+    """
+    contained = ('__hyperlink', '__node')
+
+    def __init__(self, node, hyperlink, index):
+        self.debugName = None
+        self.parent = node
+        self.__hyperlink = hyperlink
+        self.__index = index
+        self.__node = Node(self.__hyperlink.getObject(self.__index))
+        # Somehow, if we allow the children to be seen, things get weird.
+        self.__node.__hideChildren = True
+
+    def __getattr__(self, name):
+        if False: pass
+        elif name == 'URI':
+            # Note: This doesn't seem to work. It usually just causes python to hang.
+            return self.__hyperlink.getURI(self.__index)
+        else:
+            if name == 'children':
+                return
+            try:
+                result = getattr(self.__node, name)
+                return result
+            except AttributeError:
+                raise AttributeError, name
+
+    def __setattr__(self, name, value):
+        self.__dict__[name] = value
+
 class Root (Node):
-	"""
-	FIXME:
-	"""
-	def applications(self):
-		"""
-		Get all applications.
-		"""
-		return root.findAllChildrenSatisfying(predicate.GenericPredicate(roleName="application"), recursive=False)
-
-	def application(self, appName):
-		"""
-		Gets an application by name, returning an Application instance 
-		or raising an exception.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		"""
-		return Application(root.findChild(predicate.IsAnApplicationNamed(appName),recursive=False))
+    """
+    FIXME:
+    """
+    def applications(self):
+        """
+        Get all applications.
+        """
+        return root.findAllChildrenSatisfying(predicate.GenericPredicate(roleName="application"), recursive=False)
+
+    def application(self, appName):
+        """
+        Gets an application by name, returning an Application instance
+        or raising an exception.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+        """
+        return Application(root.findChild(predicate.IsAnApplicationNamed(appName),recursive=False))
 
 class Application (Node):
-	def dialog(self, dialogName, recursive=False):
-		"""
-		Search below this node for a dialog with the given name,
-		returning a Window instance.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.
-		
-		FIXME: should this method activate the dialog?
-		"""
-		return self.findChild(predicate.IsADialogNamed(dialogName=dialogName), recursive)
-
-	def window(self, windowName, recursive=False):
-		"""
-		Search below this node for a window with the given name,
-		returning a Window instance.
-
-		This is implemented using findChild, and hence will automatically retry
-		if no such child is found, and will eventually raise an exception. It
-		also logs the search.		
-
-		FIXME: this bit isn't true:
-		The window will be automatically activated (raised and focused
-		by the window manager) if wnck bindings are available.
-		"""
-		result = Window(self.findChild (predicate.IsAWindowNamed(windowName=windowName), recursive))
-		# FIXME: activate the WnckWindow ?
-		#if gotWnck:
-		#	result.activate()
-		return result
-
-	def getWnckApplication(self):
-		"""
-		Get the wnck.Application instance for this application, or None
-		
-		Currently implemented via a hack: requires the app to have a
-		window, and looks up the application of that window
-		
-		wnck.Application can give you the pid, the icon, etc
-
-		FIXME: untested
-		"""
-		window = child(roleName='frame')
-		if window:
-			wnckWindow = window.getWnckWindow()
-			return wnckWindow.get_application()
-		
-		
+    def dialog(self, dialogName, recursive=False):
+        """
+        Search below this node for a dialog with the given name,
+        returning a Window instance.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+
+        FIXME: should this method activate the dialog?
+        """
+        return self.findChild(predicate.IsADialogNamed(dialogName=dialogName), recursive)
+
+    def window(self, windowName, recursive=False):
+        """
+        Search below this node for a window with the given name,
+        returning a Window instance.
+
+        This is implemented using findChild, and hence will automatically retry
+        if no such child is found, and will eventually raise an exception. It
+        also logs the search.
+
+        FIXME: this bit isn't true:
+        The window will be automatically activated (raised and focused
+        by the window manager) if wnck bindings are available.
+        """
+        result = Window(self.findChild (predicate.IsAWindowNamed(windowName=windowName), recursive))
+        # FIXME: activate the WnckWindow ?
+        #if gotWnck:
+        #       result.activate()
+        return result
+
+    def getWnckApplication(self):
+        """
+        Get the wnck.Application instance for this application, or None
+
+        Currently implemented via a hack: requires the app to have a
+        window, and looks up the application of that window
+
+        wnck.Application can give you the pid, the icon, etc
+
+        FIXME: untested
+        """
+        window = child(roleName='frame')
+        if window:
+            wnckWindow = window.getWnckWindow()
+            return wnckWindow.get_application()
+
+
 
 class Window (Node):
-	def getWnckWindow(self):
-		"""
-		Get the wnck.Window instance for this window, or None
-		"""
-		# FIXME: this probably needs rewriting:
-		screen = wnck.screen_get_default()
-		
-		# You have to force an update before any of the wnck methods
-		# do anything:
-		screen.force_update()
-		
-		for wnckWindow in screen.get_windows():
-			# FIXME: a dubious hack: search by window title:
-			if wnckWindow.get_name()==self.name:
-				return wnckWindow
-
-	def activate(self):
-		"""
-		Activates the wnck.Window associated with this Window.
-
-		FIXME: doesn't yet work
-		"""
-		wnckWindow = self.getWnckWindow()
-		# Activate it with a timestamp of 0; this may confuse
-		# alt-tabbing through windows etc:
-		# FIXME: is there a better way of getting a timestamp?
-		# gdk_x11_get_server_time (), with a dummy window
-		wnckWindow.activate(0)
+    def getWnckWindow(self):
+        """
+        Get the wnck.Window instance for this window, or None
+        """
+        # FIXME: this probably needs rewriting:
+        screen = wnck.screen_get_default()
+
+        # You have to force an update before any of the wnck methods
+        # do anything:
+        screen.force_update()
+
+        for wnckWindow in screen.get_windows():
+            # FIXME: a dubious hack: search by window title:
+            if wnckWindow.get_name()==self.name:
+                return wnckWindow
+
+    def activate(self):
+        """
+        Activates the wnck.Window associated with this Window.
+
+        FIXME: doesn't yet work
+        """
+        wnckWindow = self.getWnckWindow()
+        # Activate it with a timestamp of 0; this may confuse
+        # alt-tabbing through windows etc:
+        # FIXME: is there a better way of getting a timestamp?
+        # gdk_x11_get_server_time (), with a dummy window
+        wnckWindow.activate(0)
 
 class Wizard (Window):
-	"""
-	Note that the buttons of a GnomeDruid were not accessible until
-	recent versions of libgnomeui.	This is
-	http://bugzilla.gnome.org/show_bug.cgi?id=157936
-	and is fixed in gnome-2.10 and gnome-2.12 (in CVS libgnomeui);
-	there's a patch attached to that bug.
-
-	This bug is known to affect FC3; fixed in FC5
-	"""
-	def __init__(self, node, debugName=None):
-		Node.__init__(self, node)
-		if debugName:
-			self.debugName = debugName
-		logger.log("%s is on '%s' page"%(self, self.getPageTitle()))
-
-	def currentPage(self):
-		"""
-		Get the current page of this wizard
-
-		FIXME: this is currently a hack, supporting only GnomeDruid
-		"""
-		pageHolder = self.child(roleName='panel')
-		for child in pageHolder.children:
-			# current child has SHOWING state set, we hope:
-			#print child
-			#print child.showing
-			if child.showing:
-				return child
-		raise "Unable to determine current page of %s"%self
-
-	def getPageTitle(self):
-		"""
-		Get the string title of the current page of this wizard
-
-		FIXME: this is currently a total hack, supporting only GnomeDruid
-		"""
-		currentPage = self.currentPage()
-		return currentPage.child(roleName='panel').child(roleName='panel').child(roleName='label', recursive=False).text
-	
-	def clickForward(self):
-		"""
-		Click on the 'Forward' button to advance to next page of wizard.
-
-		It will log the title of the new page that is reached.
-
-		FIXME: what if it's Next rather than Forward ???
-
-		This will only work if your libgnomeui has accessible buttons;
-		see above.
-		"""
-		fwd = self.child("Forward")
-		fwd.click()
-
-		# Log the new wizard page; it's helpful when debugging scripts
-		logger.log("%s is now on '%s' page"%(self, self.getPageTitle()))
-		# FIXME disabled for now (can't get valid page titles)
-
-	def clickApply(self):
-		"""
-		Click on the 'Apply' button to advance to next page of wizard.
-		FIXME: what if it's Finish rather than Apply ???
-
-		This will only work if your libgnomeui has accessible buttons;
-		see above.
-		"""
-		fwd = self.child("Apply")
-		fwd.click()
-
-		# FIXME: debug logging?
+    """
+    Note that the buttons of a GnomeDruid were not accessible until
+    recent versions of libgnomeui.  This is
+    http://bugzilla.gnome.org/show_bug.cgi?id=157936
+    and is fixed in gnome-2.10 and gnome-2.12 (in CVS libgnomeui);
+    there's a patch attached to that bug.
+
+    This bug is known to affect FC3; fixed in FC5
+    """
+    def __init__(self, node, debugName=None):
+        Node.__init__(self, node)
+        if debugName:
+            self.debugName = debugName
+        logger.log("%s is on '%s' page"%(self, self.getPageTitle()))
+
+    def currentPage(self):
+        """
+        Get the current page of this wizard
+
+        FIXME: this is currently a hack, supporting only GnomeDruid
+        """
+        pageHolder = self.child(roleName='panel')
+        for child in pageHolder.children:
+            # current child has SHOWING state set, we hope:
+            #print child
+            #print child.showing
+            if child.showing:
+                return child
+        raise "Unable to determine current page of %s"%self
+
+    def getPageTitle(self):
+        """
+        Get the string title of the current page of this wizard
+
+        FIXME: this is currently a total hack, supporting only GnomeDruid
+        """
+        currentPage = self.currentPage()
+        return currentPage.child(roleName='panel').child(roleName='panel').child(roleName='label', recursive=False).text
+
+    def clickForward(self):
+        """
+        Click on the 'Forward' button to advance to next page of wizard.
+
+        It will log the title of the new page that is reached.
+
+        FIXME: what if it's Next rather than Forward ???
+
+        This will only work if your libgnomeui has accessible buttons;
+        see above.
+        """
+        fwd = self.child("Forward")
+        fwd.click()
+
+        # Log the new wizard page; it's helpful when debugging scripts
+        logger.log("%s is now on '%s' page"%(self, self.getPageTitle()))
+        # FIXME disabled for now (can't get valid page titles)
+
+    def clickApply(self):
+        """
+        Click on the 'Apply' button to advance to next page of wizard.
+        FIXME: what if it's Finish rather than Apply ???
+
+        This will only work if your libgnomeui has accessible buttons;
+        see above.
+        """
+        fwd = self.child("Apply")
+        fwd.click()
+
+        # FIXME: debug logging?
 
 try:
-	root = Root (atspi.registry.getDesktop ())
-	root.debugName= 'root'
+    root = Root (atspi.registry.getDesktop ())
+    root.debugName= 'root'
 except AssertionError:
-	# Warn if AT-SPI's desktop object doesn't show up.
-	print "Error: AT-SPI's desktop is not visible. Do you have accessibility enabled?"
-
-try:
-	# Check that there are applications running. Warn if none are.
-	test = root.children
-	del test
-except AttributeError:
-	print "Warning: AT-SPI's desktop is visible but it has no children. Are you running any AT-SPI-aware applications?"
-
-# This is my poor excuse for a unit test.
-if __name__ == '__main__':
-	import tc
-	f=root.findChild(name="File", roleName="menu")
-	case = tc.TCNumber()
-	case.compare("File menu text", 4, len(f.text), "float")
-	print case.result
+    # Warn if AT-SPI's desktop object doesn't show up.
+    logger.log("Error: AT-SPI's desktop is not visible. Do you have accessibility enabled?")
+
+# Check that there are applications running. Warn if none are.
+children = root.children
+if not children:
+    logger.log("Warning: AT-SPI's desktop is visible but it has no children. Are you running any AT-SPI-aware applications?")
+del children
 
 # Convenient place to set some debug variables:
 #config.debugSearching = True

=== modified file 'dogtail/utils.py'
--- dogtail/utils.py	2006-08-01 22:59:27 +0000
+++ dogtail/utils.py	2006-12-21 13:33:47 +0000
@@ -6,7 +6,7 @@
 """
 
 __author__ = """Ed Rousseau <rousseau@redhat.com>,
-Zack Cerza <zcerza@redhat.com, 
+Zack Cerza <zcerza@redhat.com,
 David Malcolm <dmalcolm@redhat.com>
 """
 
@@ -18,137 +18,189 @@
 from logging import TimeStamp
 from errors import DependencyNotFoundError
 
-def screenshot(windowname = 'root', file = 'screenshot.png', timeStamp = True, args = ''):
-	"""
-	This function wraps the ImageMagick import command to take a screenshot. 
-	
-	The file argument may be specified as 'foo', 'foo.png', or using any other 
-	extension that ImageMagick supports. PNG is the default.
-	
-	By default, screenshot filenames are in the format of foo_YYYYMMDD-hhmmss.png .
-	The timeStamp argument may be set to False to name the file foo.png.
-	"""
-	IMVer = os.popen('import -version').readline()
-	IMVer = re.match('Version: ImageMagick ([0-9\.]+) .*', IMVer)
-	if IMVer is None: 
-		raise DependencyNotFoundError, "ImageMagick"
-	
-	# config is supposed to create this for us. If it's not there, bail.
-	assert os.path.isdir(config.scratchDir)
-	
-	if windowname == '':
-		windowname = "root"
-
-	baseName = ''.join(file.split('.')[0:-1])
-	fileExt = file.split('.')[-1]
-	if not baseName: 
-		baseName = file
-		fileExt = 'png'
-	
-	if timeStamp:
-		ts = TimeStamp()
-		newFile = ts.fileStamp(baseName) + '.' + fileExt
-		path = config.scratchDir + newFile
-	else:
-		newFile = baseName + '.' + fileExt
-		path = config.scratchDir + newFile
-	
-	print path
-	
-	# Generate the command and redirect STDERR to STDOUT
-	# This really needs window manipulation and pyspi state binding to be done
-	# to actually be really useful
-	answer = []
-	cmd = "import -window '%s' %s %s 2>&1" % (windowname, path, args)
-	answer = os.popen(cmd).readlines()
-
-	# If successful we should get nothing back. If not something went wrong
-	# and our mouse is now probably unusable
-	if answer:
-		raise ValueError, "Screenshot failed: " + answer[-1]
-	assert os.path.exists(path)
-	logger.log("Screenshot taken: " + path)
-	return path
+def screenshot(file = 'screenshot.png', timeStamp = True):
+    """
+    This function wraps the ImageMagick import command to take a screenshot.
+
+    The file argument may be specified as 'foo', 'foo.png', or using any other
+    extension that ImageMagick supports. PNG is the default.
+
+    By default, screenshot filenames are in the format of foo_YYYYMMDD-hhmmss.png .
+    The timeStamp argument may be set to False to name the file foo.png.
+    """
+    if not isinstance(timeStamp, bool):
+        raise TypeError, "timeStampt must be True or False"
+    # config is supposed to create this for us. If it's not there, bail.
+    assert os.path.isdir(config.scratchDir)
+
+    baseName = ''.join(file.split('.')[0:-1])
+    fileExt = file.split('.')[-1].lower()
+    if not baseName:
+        baseName = file
+        fileExt = 'png'
+
+    if timeStamp:
+        ts = TimeStamp()
+        newFile = ts.fileStamp(baseName) + '.' + fileExt
+        path = config.scratchDir + newFile
+    else:
+        newFile = baseName + '.' + fileExt
+        path = config.scratchDir + newFile
+
+    import gtk.gdk
+    import gobject
+    rootWindow = gtk.gdk.get_default_root_window()
+    geometry = rootWindow.get_geometry()
+    pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, False, 8, geometry[2], \
+            geometry[3])
+    gtk.gdk.Pixbuf.get_from_drawable(pixbuf, rootWindow, \
+            rootWindow.get_colormap(), 0, 0, 0, 0, geometry[2], geometry[3])
+    # gtk.gdk.Pixbuf.save() needs 'jpeg' and not 'jpg'
+    if fileExt == 'jpg': fileExt = 'jpeg'
+    try: pixbuf.save(path, fileExt)
+    except gobject.GError:
+        raise ValueError, "Failed to save screenshot in %s format" % fileExt
+    assert os.path.exists(path)
+    logger.log("Screenshot taken: " + path)
+    return path
 
 def run(string, timeout=config.runTimeout, interval=config.runInterval, desktop=None, dumb=False, appName=''):
-	"""
-	Runs an application. [For simple command execution such as 'rm *', use os.popen() or os.system()]
-	If dumb is omitted or is False, polls at interval seconds until the application is finished starting, or until timeout is reached.
-	If dumb is True, returns when timeout is reached.
-	"""
-	from os import environ, spawnvpe, P_NOWAIT
-	if not desktop: from tree import root as desktop
-	args = string.split()
-	name = args[0]
-	pid = spawnvpe (P_NOWAIT, name, args, environ)
-
-	if not appName:
-		appName=args[0]
-	
-	if dumb:
-		# We're starting a non-AT-SPI-aware application. Disable startup detection.
-		doDelay(timeout)
-	else:
-		# Startup detection code
-		# The timing here is not totally precise, but it's good enough for now.
-		time = 0
-		while time < timeout:
-			time = time + interval
-			try:
-				for child in desktop.children[::-1]:
-					if child.name == appName:
-						for grandchild in child.children:
-							if grandchild.roleName == 'frame':
-								from procedural import focus
-								focus.application.node = child
-								doDelay(interval)
-								return pid
-			except AttributeError: pass
-			doDelay(interval)
-	return pid
+    """
+    Runs an application. [For simple command execution such as 'rm *', use os.popen() or os.system()]
+    If dumb is omitted or is False, polls at interval seconds until the application is finished starting, or until timeout is reached.
+    If dumb is True, returns when timeout is reached.
+    """
+    from os import environ, spawnvpe, P_NOWAIT
+    if not desktop: from tree import root as desktop
+    args = string.split()
+    name = args[0]
+    environ['GTK_MODULES'] = 'gail:atk-bridge'
+    pid = spawnvpe (P_NOWAIT, name, args, environ)
+
+    if not appName:
+        appName=args[0]
+
+    if dumb:
+        # We're starting a non-AT-SPI-aware application. Disable startup detection.
+        doDelay(timeout)
+    else:
+        # Startup detection code
+        # The timing here is not totally precise, but it's good enough for now.
+        time = 0
+        while time < timeout:
+            time = time + interval
+            try:
+                for child in desktop.children[::-1]:
+                    if child.name == appName:
+                        for grandchild in child.children:
+                            if grandchild.roleName == 'frame':
+                                from procedural import focus
+                                focus.application.node = child
+                                doDelay(interval)
+                                return pid
+            except AttributeError: pass
+            doDelay(interval)
+    return pid
 
 def doDelay(delay=None):
-	"""
-	Utility function to insert a delay (with logging and a configurable
-	default delay)
-	"""
-	if delay is None:
-		delay = config.defaultDelay
-	if config.debugSleep:
-		logger.log("sleeping for %f"%delay)
-	sleep(delay)
+    """
+    Utility function to insert a delay (with logging and a configurable
+    default delay)
+    """
+    if delay is None:
+        delay = config.defaultDelay
+    if config.debugSleep:
+        logger.log("sleeping for %f" % delay)
+    sleep(delay)
 
 class Blinker:
-	INTERVAL_MS = 200
-
-	def __init__(self, x, y, w, h, count = 2):
-		import gobject
-		import gtk.gdk
-		self.count = count
-		self.x = x
-		self.y = y
-		self.w = w
-		self.h = h
-		self.timeout_handler_id = gobject.timeout_add (Blinker.INTERVAL_MS, self.blinkDrawRectangle)
-		gtk.main()
-
-	def blinkDrawRectangle (self):
-		import gtk.gdk
-		display = gtk.gdk.display_get_default()
-		screen = display.get_default_screen()
-		rootWindow = screen.get_root_window()
-		gc = rootWindow.new_gc()
-
-		gc.set_subwindow (gtk.gdk.INCLUDE_INFERIORS)
-		gc.set_function (gtk.gdk.INVERT)
-		gc.set_line_attributes (3, gtk.gdk.LINE_SOLID, gtk.gdk.CAP_BUTT, gtk.gdk.JOIN_MITER)
-		rootWindow.draw_rectangle (gc, False, self.x, self.y, self.w, self.h);
-
-		self.count-=1
-
-		if self.count <= 0:
-			gtk.main_quit()
-			return False
-		
-		return True
-		
+    INTERVAL_MS = 200
+
+    def __init__(self, x, y, w, h, count = 2):
+        import gobject
+        import gtk.gdk
+        self.count = count
+        self.x = x
+        self.y = y
+        self.w = w
+        self.h = h
+        self.timeout_handler_id = gobject.timeout_add (Blinker.INTERVAL_MS, self.blinkDrawRectangle)
+        gtk.main()
+
+    def blinkDrawRectangle (self):
+        import gtk.gdk
+        display = gtk.gdk.display_get_default()
+        screen = display.get_default_screen()
+        rootWindow = screen.get_root_window()
+        gc = rootWindow.new_gc()
+
+        gc.set_subwindow (gtk.gdk.INCLUDE_INFERIORS)
+        gc.set_function (gtk.gdk.INVERT)
+        gc.set_line_attributes (3, gtk.gdk.LINE_SOLID, gtk.gdk.CAP_BUTT, gtk.gdk.JOIN_MITER)
+        rootWindow.draw_rectangle (gc, False, self.x, self.y, self.w, self.h);
+
+        self.count-=1
+
+        if self.count <= 0:
+            gtk.main_quit()
+            return False
+
+        return True
+
+
+import sys
+import gconf
+gconfClient = gconf.client_get_default()
+a11yGConfKey = '/desktop/gnome/interface/accessibility'
+
+def isA11yEnabled():
+    """
+    Checks if accessibility is enabled via gconf.
+    """
+    return gconfClient.get_bool(a11yGConfKey)
+
+def bailBecauseA11yIsDisabled():
+    logger.log("Dogtail requires that Assistive Technology support be enabled. Aborting...")
+    sys.exit(1)
+
+def enableA11y():
+    """
+    Enables accessibility via gconf.
+    """
+    return gconfClient.set_bool(a11yGConfKey, True)
+
+def checkForA11y():
+    """
+    Checks if accessibility is enabled, and halts execution if it is not.
+    """
+    if not isA11yEnabled(): bailBecauseA11yIsDisabled()
+
+def checkForA11yInteractively():
+    """
+    Checks if accessibility is enabled, and presents a dialog prompting the
+    user if it should be enabled if it is not already, then halts execution.
+    """
+    if isA11yEnabled(): return
+    import gtk
+    dialog = gtk.Dialog('Enable Assistive Technology Support?',
+                     None,
+                     gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
+                     (gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE, 
+                         "_Enable", gtk.RESPONSE_ACCEPT))
+    question = """Dogtail requires that Assistive Technology Support be enabled for it to function. Would you like to enable Assistive Technology support now?
+
+Note that you will have to log out for the change to fully take effect.
+    """.strip()
+    dialog.set_default_response(gtk.RESPONSE_ACCEPT)
+    questionLabel = gtk.Label(question)
+    questionLabel.set_line_wrap(True)
+    dialog.vbox.pack_start(questionLabel)
+    dialog.show_all()
+    result = dialog.run()
+    if result == gtk.RESPONSE_ACCEPT:
+        logger.log("Enabling accessibility...")
+        enableA11y()
+    elif result == gtk.RESPONSE_CLOSE:
+       bailBecauseA11yIsDisabled()
+    dialog.destroy()
+

=== modified file 'dogtail/version.py'
--- dogtail/version.py	2006-02-22 12:31:33 +0000
+++ dogtail/version.py	2006-12-16 10:57:30 +0000
@@ -7,81 +7,81 @@
 import unittest
 
 class Version:
-	"""
-	Class representing a version of a software package.
-	Stored internally as a list of subversions, from major to minor.
-	Overloaded comparison operators ought to work sanely.
-	"""
-	def __init__(self, versionList):
-		self.versionList = versionList
-
-	def fromString(versionString):
-		"""
-		Parse a string of the form number.number.number
-		"""
-		return Version(map(int, versionString.split(".")))
-	fromString = staticmethod(fromString)
-
-	def __str__(self):
-		return ".".join(map(str, self.versionList))
-
-	def __getNum(self):
-		tmpList = list(self.versionList)
-
-		while len(tmpList)<5:
-			tmpList += [0]
-
-		num = 0
-		for i in range(len(tmpList)):
-			num *=1000
-			num += tmpList[i]
-		return num
-		
-	def __lt__(self, other):
-		return self.__getNum()<other.__getNum()
-	def __le__(self, other):
-		return self.__getNum()<=other.__getNum()
-	def __eq__(self, other):
-		return self.__getNum()==other.__getNum()
-	def __ne__(self, other):
-		return self.__getNum()!=other.__getNum()
-	def __gt__(self, other):
-		return self.__getNum()>other.__getNum()
-	def __ge__(self, other):
-		return self.__getNum()>=other.__getNum()
+    """
+    Class representing a version of a software package.
+    Stored internally as a list of subversions, from major to minor.
+    Overloaded comparison operators ought to work sanely.
+    """
+    def __init__(self, versionList):
+        self.versionList = versionList
+
+    def fromString(versionString):
+        """
+        Parse a string of the form number.number.number
+        """
+        return Version(map(int, versionString.split(".")))
+    fromString = staticmethod(fromString)
+
+    def __str__(self):
+        return ".".join(map(str, self.versionList))
+
+    def __getNum(self):
+        tmpList = list(self.versionList)
+
+        while len(tmpList)<5:
+            tmpList += [0]
+
+        num = 0
+        for i in range(len(tmpList)):
+            num *=1000
+            num += tmpList[i]
+        return num
+
+    def __lt__(self, other):
+        return self.__getNum()<other.__getNum()
+    def __le__(self, other):
+        return self.__getNum()<=other.__getNum()
+    def __eq__(self, other):
+        return self.__getNum()==other.__getNum()
+    def __ne__(self, other):
+        return self.__getNum()!=other.__getNum()
+    def __gt__(self, other):
+        return self.__getNum()>other.__getNum()
+    def __ge__(self, other):
+        return self.__getNum()>=other.__getNum()
 
 class VersionTests(unittest.TestCase):
-	def testLt(self):
-		assert Version.fromString("2.0.1") < Version.fromString("2.1.0")
-		assert not Version.fromString("1.4.0") < Version.fromString("1.4.0")
-
-	def testLe(self):
-		assert Version.fromString("2.0.1") <= Version.fromString("2.1.0")
-		assert Version.fromString("1.4.0") <= Version.fromString("1.4.0")
-
-	def testEq(self):
-		assert not Version.fromString("2.0.1") == Version.fromString("2.1.0")
-		assert Version.fromString("1.4.0") == Version.fromString("1.4.0")
-
-	def testNe(self):
-		assert Version.fromString("2.0.1") != Version.fromString("2.1.0")
-		assert not Version.fromString("1.4.0") != Version.fromString("1.4.0")
-
-	def testGt(self):
-		assert Version.fromString("2.1.0") > Version.fromString("2.0.1")
-		assert not Version.fromString("1.4.0") > Version.fromString("1.4.0")
-
-	def testGe(self):
-		assert Version.fromString("2.1.0") >= Version.fromString("2.0.1")
-		assert Version.fromString("1.4.0") >= Version.fromString("1.4.0")
-
-	def testStr(self):
-		assert "2.0.4"==str(Version.fromString("2.0.4"))
-
-	def testParsing(self):
-		assert Version.fromString("0") == Version([0])
-		assert Version.fromString("0.1") == Version([0, 1])
-		assert Version.fromString("1.4.0") == Version([1, 4, 0])
+    def testLt(self):
+        assert Version.fromString("2.0.1") < Version.fromString("2.1.0")
+        assert not Version.fromString("1.4.0") < Version.fromString("1.4.0")
+
+    def testLe(self):
+        assert Version.fromString("2.0.1") <= Version.fromString("2.1.0")
+        assert Version.fromString("1.4.0") <= Version.fromString("1.4.0")
+
+    def testEq(self):
+        assert not Version.fromString("2.0.1") == Version.fromString("2.1.0")
+        assert Version.fromString("1.4.0") == Version.fromString("1.4.0")
+
+    def testNe(self):
+        assert Version.fromString("2.0.1") != Version.fromString("2.1.0")
+        assert not Version.fromString("1.4.0") != Version.fromString("1.4.0")
+
+    def testGt(self):
+        assert Version.fromString("2.1.0") > Version.fromString("2.0.1")
+        assert not Version.fromString("1.4.0") > Version.fromString("1.4.0")
+
+    def testGe(self):
+        assert Version.fromString("2.1.0") >= Version.fromString("2.0.1")
+        assert Version.fromString("1.4.0") >= Version.fromString("1.4.0")
+
+    def testStr(self):
+        assert "2.0.4"==str(Version.fromString("2.0.4"))
+
+    def testParsing(self):
+        assert Version.fromString("0") == Version([0])
+        assert Version.fromString("0.1") == Version([0, 1])
+        assert Version.fromString("1.4.0") == Version([1, 4, 0])
 
 if __name__ == "__main__":
-	unittest.main()
+    unittest.main()

=== removed file 'examples/abiword-test.py'
--- examples/abiword-test.py	2006-02-22 12:31:33 +0000
+++ examples/abiword-test.py	1970-01-01 00:00:00 +0000
@@ -1,45 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test AbiWord, converting a Word document to HTML, using the procedural API.
-# Also shows how to write code that handles different versions of a package,
-# querying the installed package version in a distribution-neutral fashion.
-# FIXME: not yet finished
-# FIXME: doesn't work yet.  Tested with AbiWord 2.0.12 on FC3
-
-from dogtail.procedural import *
-from dogtail.utils import *
-from dogtail.distro import *
-from dogtail.version import Version
-
-abiVersion = packageDb.getVersion('abiword')
-
-# Set up appname based on version of abiword:
-if abiVersion>=Version([2,3,0]):
-	appName = 'AbiWord-2.4'
-else:
-	appName = 'AbiWord'
-
-run("abiword", appName=appName)
-
-
-print "foo"
-
-focus.application(appName) #FIXME: shouldn't 'run' automatically scope the app?  this call seems to be needed
-
-print "bar"
-
-focus.menu('File')
-click('Open...')
-
-# On AbiWord 2.0.12 on FC3 this gives a GtkFileSelector dialog:
-focus.dialog('Open File')  # fails on FC3: the dialog has roleName="file chooser", rather than 'dialog'
-focus.text()
-focus.widget.object.text = "test-word-document.doc"
-# FIXME: path issues
-
-click('OK')
-
-focus.menu('File')
-click('Save As...')

=== removed file 'examples/crack.py'
--- examples/crack.py	2006-02-22 12:31:33 +0000
+++ examples/crack.py	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-class PresentationCrack:
-    """Gives a presentation of Dogtail, using Dogtail itself."""
-
-    def __init__(self):
-        self.evo = EvolutionApp()
-        self.pageNumber = 0
-        self.pageDelay = 3
-
-    def startPage(self, title):
-        sleep (self.pageDelay)
-        self.pageNumber+=1
-        self.composer = self.evo.composeEmail()
-        self.composer.subject = "Presentation page %s"%self.pageNumber
-
-        self.composer.setHtml(True)
-
-        self.composer.setHeader(1)
-        self.composer.htmlNode.text = title
-        self.composer.htmlNode.typeText("\n\n")
-
-    def addBullet(self, text):
-        self.composer.child("Bulleted List").click()
-        self.composer.htmlNode.typeText(text)
-
-    def runPresentation(self):
-        self.startPage("Dogtail: a Free Automated GUI test tool")
-        self.addBullet("foo")
-        self.addBullet("bar")
-        
-        self.startPage("Leveraging Synergies")
-        self.addBullet("pirates!")
-        self.addBullet("zombies!")
-        self.addBullet("zombie pirates!")
-    
-        self.startPage("4-Stroke Internal Combustion Engine")
-        self.addBullet("suck")
-        self.addBullet("squeeze")
-        self.addBullet("bang")
-        self.addBullet("blow")
-
-        self.startPage("Questions?")
-
-def runPresentationCrack():
-    pres = PresentationCrack()
-    pres.runPresentation()
-
-runPresentationCrack()

=== added file 'examples/data/10b.png'
Binary files examples/data/10b.png and examples/data/10b.png differ
=== added file 'examples/data/10w.png'
Binary files examples/data/10w.png and examples/data/10w.png differ
=== added file 'examples/data/20b.png'
Binary files examples/data/20b.png and examples/data/20b.png differ
=== added file 'examples/data/20w.png'
Binary files examples/data/20w.png and examples/data/20w.png differ
=== removed file 'examples/data/GNOME-Street.png'
Binary files examples/data/GNOME-Street.png and examples/data/GNOME-Street.png differ
=== removed file 'examples/data/GNOME-Street1.png'
Binary files examples/data/GNOME-Street1.png and examples/data/GNOME-Street1.png differ
=== removed file 'examples/data/g-star.png'
Binary files examples/data/g-star.png and examples/data/g-star.png differ
=== removed file 'examples/data/g-star1.png'
Binary files examples/data/g-star1.png and examples/data/g-star1.png differ
=== removed file 'examples/evolution-test-composing-html.py'
--- examples/evolution-test-composing-html.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-composing-html.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test composing (and sending) an HTML email
-
-# Under construction.  Doesn't yet work
-
-# FIXME:  partially rewrite; this would be a great example of a script using both APIs;  the typing stuff would work better with the procedural interface
-
-from dogtail.apps.wrappers.evolution import *
-
-evo = EvolutionApp()
-composer = evo.composeEmail()
-composer.to = "dmalcolm@redhat.com"
-composer.subject = "Yarrrrrr!!!"
-composer.setHtml(True)
-composer.setHeader(1)
-composer.typeText("Leveraging Synergies\n\n")
-composer.setBulletedList()
-composer.typeText("pirates!\n")
-composer.typeText("zombies!\n")
-composer.typeText("zombie pirates!")
-
-#composer.testUndoRedo()
-# unfortunately, undo doesn't seem to desensitize correctly in Evolution 2.4
-
-composer.send()

=== removed file 'examples/evolution-test-configuring-exchange.py'
--- examples/evolution-test-configuring-exchange.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-configuring-exchange.py	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-
-# Test configuring an account with the Exchange connector
-#
-# Assumes evolution is configured and is running
-
-from dogtail.apps.wrappers.evolution import *
-
-account = ExchangeAccount(fullName="John Doe",
-                          emailAddress="jdoe@example.com",
-                          windowsUsername=r'EXAMPLE\jdoe',
-                          server='192.168.0.1',
-                          urlForOWA='http://192.168.0.1',
-                          password="password")
-evo = EvolutionApp()
-evo.createAccount(account, "test Exchange account")

=== removed file 'examples/evolution-test-configuring-imap-smtp.py'
--- examples/evolution-test-configuring-imap-smtp.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-configuring-imap-smtp.py	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-
-# Test configuring an IMAP and SMTP account
-#
-# Assumes evolution is configured and is running
-
-from dogtail.apps.wrappers.evolution import *
-
-account = MixedAccount(fullName="John Doe",
-                       emailAddress="jdoe@example.com",
-                       receiveMethod = IMAPSettings(server="mail.example.com",
-                                                    username="jdoe",
-                                                    useSecureConnection=UseSecureConnection.ALWAYS,
-                                                    authenticationType="password"),
-                       sendMethod = SMTPSettings(server="smtp.example.com",
-                                                 useSecureConnection=UseSecureConnection.NEVER))
-evo = EvolutionApp()
-evo.createAccount(account, "test IMAP/SMTP account")

=== removed file 'examples/evolution-test-first-time-wizard.py'
--- examples/evolution-test-first-time-wizard.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-first-time-wizard.py	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-
-# Test configuring an IMAP and SMTP account
-#
-# Assumes evolution is configured and is running
-
-from dogtail.apps.wrappers.evolution import *
-
-account = MixedAccount(fullName="John Doe",
-                       emailAddress="jdoe@example.com",
-                       receiveMethod = IMAPSettings(server="mail.example.com",
-                                                    username="jdoe",
-                                                    useSecureConnection=UseSecureConnection.ALWAYS,
-                                                    authenticationType="password"),
-                       sendMethod = SMTPSettings(server="smtp.example.com",
-                                                 useSecureConnection=UseSecureConnection.NEVER))
-
-evo = doFirstTimeWizard(account, "test IMAP/SMTP account", "America/New_York")

=== removed file 'examples/evolution-test-sending-email.py'
--- examples/evolution-test-sending-email.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-sending-email.py	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test composing and sending an email
-#
-# Assumes evolution is configured and is running
-#
-
-from dogtail.apps.wrappers.evolution import *
-
-from datetime import datetime
-
-#testName = "UntitledDogtailTest"
-testRunId = "%s"%(datetime.now().isoformat())
-
-evo = EvolutionApp()
-composer = evo.composeEmail()
-composer.to = "YOUR-EMAIL-ADDRESS-HERE"
-composer.subject = "Test email (generated by Dogtail).  Testrun: %s)"%testRunId
-composer.body = "This is a test email generated by Dogtail."
-composer.send()

=== removed file 'examples/evolution-test-survives-email-CAN-2005-0806.py'
--- examples/evolution-test-survives-email-CAN-2005-0806.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-survives-email-CAN-2005-0806.py	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test importing an email that crashed older versions of Evolution
-#
-# Assumes evolution is configured and is running
-#
-# CAN-2005-0806.mbox is attachment 44836 in bugzilla.gnome.org
-# It is an email attached to bug 272609 (which was bug 72609 in the bugzilla.ximian.com)
-# which crashed an unpatched Evolution 2.0.3 when opened.
-# See http://www.cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2005-0806
-
-from dogtail.apps.wrappers.evolution import *
-
-evo = EvolutionApp()
-evo.importSingleEmail(path.abspath("data/CAN-2005-0806.mbox"))

=== removed file 'examples/evolution-test-switching-components.py'
--- examples/evolution-test-switching-components.py	2006-02-22 12:31:33 +0000
+++ examples/evolution-test-switching-components.py	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test repeatedly switching between evolution components
-#
-# Assumes evolution is configured and is running
-#
-
-# Use the gettext translations sniffed from the package db:
-import dogtail.i18n
-dogtail.i18n.loadTranslationsFromPackageMoFiles('evolution')
-
-import dogtail.tree
-
-evo = dogtail.tree.root.application('evolution')
-
-while True:
-	for compName in ['Mail', 'Contacts', 'Calendars', 'Tasks']:
-		evo.menu('View').menu('Window').menuItem(compName).click()

=== modified file 'examples/filechooser-stress-test.py'
--- examples/filechooser-stress-test.py	2006-02-22 12:31:33 +0000
+++ examples/filechooser-stress-test.py	2006-12-16 10:57:30 +0000
@@ -6,7 +6,6 @@
 run('gedit')
 
 while True:
-	click('Open...')
-	focus.dialog('Open File...')
-	click('Cancel')
-
+    click('Open...')
+    focus.dialog(u'Open Files\u2026')
+    click('Cancel')

=== removed file 'examples/firefox-test-browsing-local-html-file.py'
--- examples/firefox-test-browsing-local-html-file.py	2006-02-22 12:31:33 +0000
+++ examples/firefox-test-browsing-local-html-file.py	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test opening a new window and browsing to a local HTML file
-
-# Under construction.  Doesn't yet work
-
-from dogtail.apps.wrappers.mozilla import *
-
-import dogtail.config
-dogtail.config.config.debugSearching=True
-
-ff = FirefoxApp()
-wnd = ff.newWindow()
-wnd.browseTo("file://"+path.abspath("data/test.html"))

=== removed file 'examples/gcalctool-test-fibonacci.py'
--- examples/gcalctool-test-fibonacci.py	2006-02-22 12:31:33 +0000
+++ examples/gcalctool-test-fibonacci.py	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-#!/usr/bin/env python
-# Use GCalcTool to calculate the Fibonacci series (and check the results)
-
-import dogtail.tree
-from dogtail.apps.wrappers.gcalctool import *
-import dogtail.utils
-
-dogtail.utils.run('gcalctool')
-gcalctool = GCalcTool(dogtail.tree.root.application('gcalctool'))
-
-import dogtail.config
-dogtail.config.config.defaultDelay = 0.3
-
-a = 1
-b = 1
-	
-while True:
-	gcalctool.clearEntry()
-	gcalctool.typeNumber(a, 10)
-	gcalctool.button('Add').click()
-	gcalctool.typeNumber(b, 10)
-	
-	gcalctool.button('Calculate result').click()
-	
-	assert int(gcalctool.getText())==(a+b)
-	
-	a=b
-	b=int(gcalctool.getText())
-
-

=== modified file 'examples/gedit-test-utf8-procedural-api.py'
--- examples/gedit-test-utf8-procedural-api.py	2006-02-22 12:31:33 +0000
+++ examples/gedit-test-utf8-procedural-api.py	2006-12-16 10:57:30 +0000
@@ -10,9 +10,9 @@
 from dogtail.utils import screenshot
 
 # These next two lines get us translations for free. To see the script run
-# translated, run it like this: 
+# translated, run it like this:
 #  LANG=ja_JP.UTF-8 ./gedit-test-utf8-procedural-api.py
-# You might also want to set config.debugTranslation and 
+# You might also want to set config.debugTranslation and
 # config.debugSearching to True, just for fun.
 import dogtail.i18n
 dogtail.i18n.loadTranslationsFromPackageMoFiles('gedit')
@@ -24,7 +24,7 @@
 
 # Remove the output file, if it's still there from a previous run
 if path.isfile(path.join(path.expandvars("$HOME"), "Desktop", "UTF8demo.txt")):
-	remove(path.join(path.expandvars("$HOME"), "Desktop", "UTF8demo.txt"))
+    remove(path.join(path.expandvars("$HOME"), "Desktop", "UTF8demo.txt"))
 
 # Start gedit.
 run('gedit')
@@ -51,12 +51,12 @@
 
 # Focus gedit's Save As... dialog
 try:
-	# This string changed somewhere around gedit 2.13.2.
-	# This is the new string
-	focus.dialog(u'Save As\u2026')
+    # This string changed somewhere around gedit 2.13.2.
+    # This is the new string
+    focus.dialog(u'Save As\u2026')
 except FocusError:
-	# Fall back to the old string.
-	focus.dialog('Save as...')
+    # Fall back to the old string.
+    focus.dialog('Save as...')
 
 # click the Browse for other folders widget
 activate('Browse for other folders')
@@ -74,21 +74,21 @@
 # Let's quit now.
 click('Quit')
 
-# We have driven gedit now lets check to see if the saved file is the same as 
+# We have driven gedit now lets check to see if the saved file is the same as
 # the baseline file
 
 # Read in the "gold" file
 import codecs
 try:
-	# When reading the file, we have to make sure and tell codecs.open() which 
-	# encoding we're using, otherwise python gets confused later.
-	gold = open(path[0] + '/data/UTF-8-demo.txt', encoding='utf-8').readlines()
+    # When reading the file, we have to make sure and tell codecs.open() which
+    # encoding we're using, otherwise python gets confused later.
+    gold = open(path[0] + '/data/UTF-8-demo.txt', encoding='utf-8').readlines()
 except IOError:
-	print "File open failed"
+    print "File open failed"
 
 # Read the test file for comparison
 filepath = environ['HOME'] + '/Desktop/UTF8demo.txt'
-# When reading the file, we have to make sure and tell codecs.open() which 
+# When reading the file, we have to make sure and tell codecs.open() which
 # encoding we're using, otherwise python gets confused later.
 testfile = open(filepath, encoding='utf-8').readlines()
 
@@ -96,7 +96,6 @@
 # by line to see if they are the same
 i = 0
 for baseline in gold:
-	label = "line test " + str(i + 1)
-	TestString.compare(label, baseline, testfile[i], encoding='utf-8')
-	i = i + 1
-
+    label = "line test " + str(i + 1)
+    TestString.compare(label, baseline, testfile[i], encoding='utf-8')
+    i = i + 1

=== modified file 'examples/gedit-test-utf8-tree-api.py'
--- examples/gedit-test-utf8-tree-api.py	2006-02-22 12:31:33 +0000
+++ examples/gedit-test-utf8-tree-api.py	2006-12-16 10:57:30 +0000
@@ -11,7 +11,7 @@
 
 # Remove the output file, if it's still there from a previous run
 if path.isfile(path.join(path.expandvars("$HOME"), "Desktop", "UTF8demo.txt")):
-	remove(path.join(path.expandvars("$HOME"), "Desktop", "UTF8demo.txt"))
+    remove(path.join(path.expandvars("$HOME"), "Desktop", "UTF8demo.txt"))
 
 # Start gedit.
 run("gedit")
@@ -39,17 +39,25 @@
 savebutton.click()
 
 # Get a handle to gedit's Save As... dialog.
-saveas = gedit.dialog('Save as...')
+try:
+    saveas = gedit.dialog(u'Save As\u2026')
+except tree.SearchError:
+    saveas = gedit.dialog('Save as...')
 
 # We want to save to the file name 'UTF8demo.txt'.
 saveas.child(roleName = 'text').text = 'UTF8demo.txt'
 
-# Let's save it to the desktop.
-saveas.menuItem('Desktop').click()
-
-# Click the Save button.
+# Save the file on the Desktop
+
+# Don't make the mistake of only searching by name, there are multiple
+# "Desktop" entires in the Save As dialog - you have to query for the
+# roleName too - see the on-line help for the Dogtail "tree" class for
+# details
+desktop = saveas.child('Desktop', roleName='table cell')
+desktop.doAction('activate')
+
+#  Click the Save button.
 saveas.button('Save').click()
 
 # Let's quit now.
-filemenu.menuItem('Quit').click() 
-
+filemenu.menuItem('Quit').click()

=== removed file 'examples/gnome-panel-test-starting-every-app.py'
--- examples/gnome-panel-test-starting-every-app.py	2006-02-22 12:31:33 +0000
+++ examples/gnome-panel-test-starting-every-app.py	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Tries to start every user-visible application in the GNOME panel
-# FIXME: this doesn't yet work
-
-from dogtail.apps.wrappers.gnomepanel import *
-
-import dogtail.config
-dogtail.config.config.debugSearching=True
-
-panel = GnomePanel()
-for launcher in panel.applications():
-	print launcher
-	sleep(5) # really need this for sanity's sake!
-	launcher.click()    
-	
-
-    

=== removed file 'examples/google-search.py'
--- examples/google-search.py	2006-02-22 12:31:33 +0000
+++ examples/google-search.py	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test of filling in a form in a web browser
-# Under construction.  Doesn't yet work
-
-from dogtail.apps.wrappers.epiphany import *
-
-class GoogleFrontPage(Node):
-    def __init__(self, node):
-        Node.__init__(self, node)
-        self.searchButton = self.button('Google Search')
-        self.imFeelingLuckyButton = self.button("I'm Feeling Lucky")
-
-        # Locate the text entry dialog as a sibling of the search button
-        self.textEntry = self.searchButton.parent.child(roleName='text', debugName='Search String Text Entry')
-
-import dogtail.config
-dogtail.config.config.debugSearching=True
-
-# Epiphany doesn't seem to set the sensitivity state on buttons in web pages:
-dogtail.config.config.ensureSensitivity=False
-
-wb = EpiphanyApp()
-
-# Browse to Google front page
-tab = wb.browseToUrl("http://www.google.com")
-tab.dump()
-
-gfp = GoogleFrontPage(tab)
-
-# Debug dump:
-gfp.child(roleName='text').dump()
-
-# Do a search:
-gfp.textEntry.text = "zombie pirates"
-print gfp.searchButton.actions[0]
-gfp.searchButton.press()
-
-
-# Scrape out the results:
-frame = gfp.child(roleName='frame')
-results = frame.findChildren(predicate.GenericPredicate(roleName='text'), recursive=False)
-for result in results:
-    print "Result:"
-    print result.text
-    print "--------------------------------------"
-
-
-

=== modified file 'examples/i18n-test.py'
--- examples/i18n-test.py	2006-02-22 12:31:33 +0000
+++ examples/i18n-test.py	2006-12-16 10:57:30 +0000
@@ -10,15 +10,15 @@
 import dogtail.distro
 
 def translateAllStrings(appName):
-	"""
-	Test of the translation functions.
-	
-	Take all user-visible strings in an app that's running in the default locale
-	and try translating them all into the locale that this script is running in.
-	"""
-	for string in root.application(appName).getUserVisibleStrings():
-		print "User-visible string: %s"%string
-		print "Translation is:%s"%dogtail.i18n.translate(string)
+    """
+    Test of the translation functions.
+
+    Take all user-visible strings in an app that's running in the default locale
+    and try translating them all into the locale that this script is running in.
+    """
+    for string in root.application(appName).getUserVisibleStrings():
+        print "User-visible string: %s"%string
+        print "Translation is:%s"%dogtail.i18n.translate(string)
 
 print "Package dependencies: %s"%dogtail.distro.packageDb.getDependencies('evolution')
 #print dogtail.i18n.getMoFilesForPackage('evolution', True)

=== removed file 'examples/nautilus-test-icon-view-collage.py'
--- examples/nautilus-test-icon-view-collage.py	2006-02-22 12:31:33 +0000
+++ examples/nautilus-test-icon-view-collage.py	1970-01-01 00:00:00 +0000
@@ -1,159 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-
-# Nautilus test
-# Takes an image file, uses Imagemagick to chop it into tiles,
-# then arranges the Nautilus thumbnail icons into a collage
-# FIXME: somewhat unstable, requires a 640x480 image called victim.png
-
-from dogtail.apps.wrappers.nautilus import *
-from math import sin, cos, pi
-
-import os
-
-import dogtail.config
-#dogtail.config.config.debugSearching=True
-#dogtail.config.config.debugSleep = True
-
-n = NautilusApp()
-
-class Jigsaw:
-  def __init__(self, sourceImage):
-    self.sourceImage = os.path.abspath(sourceImage)
-    self.basePath = os.curdir
-    self.piecesPath = os.path.abspath(os.path.join(self.basePath, "JigsawPieces"))
-    self.resultPath = os.path.abspath(os.path.join(self.basePath, "JigsawResult"))
-    self.pieceArg = os.path.join(self.piecesPath, "piece.png")
-
-    self.baseWidth = 640
-    self.baseHeight = 480
-    self.divisor = 5
-    self.pieceWidth = self.baseWidth/self.divisor
-    self.pieceHeight = self.baseHeight/self.divisor
-    self.iconWidth = 70.0 # self.baseWidth/self.divisor
-    self.iconHeight = 54.0 # self.baseHeight/self.divisor
-
-  def makeCropCommand(self):
-    return 'convert -crop %sx%s %s %s'%(self.pieceWidth, self.pieceHeight, self.sourceImage, self.pieceArg)
-
-  def targetLocation(self, baseXY, index):
-    (baseX, baseY) = baseXY
-    (pieceX,pieceY) = ((float(index)%self.divisor)*self.iconWidth, (float(index)/self.divisor)*self.iconHeight)
-    return (baseX+pieceX,baseY+pieceY)
-
-  def makeDirectories(self):
-    try: os.mkdir(self.piecesPath)
-    except OSError: pass
-    
-    try: os.mkdir(self.resultPath)
-    except OSError: pass
-
-class Drag:
-  def __init__(self, startXY, endXY):
-    self.startXY = startXY
-    self.endXY = endXY
-
-  def doDrag(self, duration, steps):
-    ev = atspi.EventGenerator()
-
-    (x,y) = self.calcCoord(0.0)
-    ev.absoluteMotion(x, y)
-    doDelay(0.1)
-    ev.press (x,y,1)
-    
-    for step in range(steps):
-      frac = float(step)/float(steps)
-      (x,y) = self.calcCoord(frac)
-      #doDelay(duration/steps)
-      ev.absoluteMotion(x, y)
-
-    (x,y) = self.calcCoord(1.0)
-    ev.absoluteMotion(x,y)
-    doDelay(0.5)
-    ev.release (x,y,1)
-
-  def calcCoord(self, frac):
-    raise NotImplementedError
-    
-class LinearDrag(Drag):
-  def calcCoord(self, frac):
-    (startX, startY) = self.startXY
-    (endX, endY) = self.endXY
-    #(deltaX, deltaY) = (endX-startX, endY-startY)
-
-    return ( (startX*(1.0-frac)) + (endX*frac), (startY*(1.0-frac)) + (endY*frac))
-
-jigsaw = Jigsaw('victim.png')
-
-jigsaw.makeDirectories()
-
-command = jigsaw.makeCropCommand()
-print command
-os.system(command)
-#raise "foo"
-#os.exit()
-
-def prepareNautilusWindow(w):
-  viewMenu = w.menu("View")
-
-  # Ensure it's in icon view mode:
-  viewMenu.menuItem("View as Icons").click()
-
-  viewMenu.menuItem("Normal Size").click()
-  viewMenu.menuItem("Zoom In").click()
-
-  # Ensure we're in manual layout mode:
-  viewMenu.menu("Arrange Items").menuItem("Manually").click()
-
-  viewMenu.menuItem("Clean Up by Name").click()
-
-
-
-piecesWindow = n.openPath(jigsaw.piecesPath)
-resultWindow = n.openPath(jigsaw.resultPath)
-
-prepareNautilusWindow (piecesWindow)
-prepareNautilusWindow (resultWindow)
-
-#FIXME: now need to get both on top, with sane sizes
-
-# Find the icons:
-iv = piecesWindow.iconView()
-icons = iv.findChildren(IsAnIcon(), recursive=True)
-
-matcher = re.compile('piece-(.*).png')
-
-for icon in icons:
-  #print icon
-  index = int(matcher.match(icon.name).group(1))
-  (x,y,w,h) = icon.extents
-
-  (dstX, dstY, dstW, dstH) = resultWindow.iconView().extents
-  
-  (targetX, targetY) = jigsaw.targetLocation((dstX+100, dstY+100), index)
-  
-  # FIXME: different drag routes!
-  drag = LinearDrag((x+w/2,y+h/2), (targetX+w/2,targetY+h/2))
-  drag.doDrag(2.0, 50)
-
-# Drag out to select the entire collage:
-(dstX, dstY, dstW, dstH) = resultWindow.iconView().extents
-drag = LinearDrag((dstX+50, dstY+50), (dstX+500, dstY+500))
-drag.doDrag(2.0, 500)
-
-sleep(0.5)
-
-# Drag it somewhere:
-drag = LinearDrag((dstX+300, dstY+300), (dstX+600, dstY+600))
-drag.doDrag(2.0, 50)
-
-sleep(0.5)
-
-click(dstX+50, dstY+50, 1)
-#viewMenu = resultWindow.menu("View")
-#viewMenu.menuItem("Zoom In").click()
-#viewMenu.menuItem("Zoom In").click()
-
-

=== modified file 'examples/no-help-at-all.py'
--- examples/no-help-at-all.py	2006-02-22 12:31:33 +0000
+++ examples/no-help-at-all.py	2006-12-16 10:57:30 +0000
@@ -2,12 +2,12 @@
 """
 Dogtail script for generating unhelpful help file.
 
-Scours the UI of a program, and generates a parody of a help file for that 
+Scours the UI of a program, and generates a parody of a help file for that
 program.
 
 The resulting DocBook file is simply a reading back of the program's UI to you.
 
-The idea is to highlight a gripe of mine (and many other people): 
+The idea is to highlight a gripe of mine (and many other people):
 documentation should be more than this!
 
 This script is licensed under the GPL.
@@ -15,50 +15,58 @@
 __author__ = 'David Malcolm <dmalcolm@redhat.com>'
 
 from dogtail.tree import *
+from dogtail.utils import *
 import sys
 
 def writePCDataElement(name, content):
-	print '\t\t<%s>%s</%s>'%(name, content, name) # FIXME: escape the content
-	
+    print '\t\t<%s>%s</%s>'%(name, content, name) # FIXME: escape the content
+
 
 def generateUnhelpfulHelp(appName):
-	app = root.application(appName)
-	print '<?xml version="1.0"?>'
-	print '<!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN" "http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd">'
-	print '<article>'
-
-	taggedAppName = '<application>%s</application>'%appName
-
-	# Artile info:
-	print '\t<articleinfo>'
-	writePCDataElement("title", "The Totally Definitive No-Nonsense Unhelpful Complete Guide to %s for Mannequins in 40 Days - Unleashed!"%taggedAppName)
-	print '\t</articleinfo>'
-
-	# Guts of the article:
-	print '\t<sect1>'
-	writePCDataElement("title", "Introduction")
-	writePCDataElement("caution", "<para>Do not take these instructions seriously.  They are a parody of unhelpful help files found on many computer systems, and were autogenerated by <application>no-help-at-all</application></para>")
-	writePCDataElement("para", "You can start %s by opening a terminal and typing the <command>%s</command> command."%(taggedAppName, appName))
-	print '\t</sect1>'
-
-	menus = app.findChildren(predicate.GenericPredicate(roleName="menu"))
-	for menu in menus:
-		print '\t<sect1>'
-		writePCDataElement("title", "The <guimenu>%s</guimenu> menu"%menu.name)
-		writePCDataElement("para", "Use the <guimenu>%s</guimenu> menu to work with %ss"%(menu.name, menu.name.lower()))
-		items = menu.findChildren(predicate.GenericPredicate(roleName="menu item"), recursive=False)
-		if items!=None:
-			for item in items:
-				verb = item.name
-				noun = menu.name
-				print '\t\t<sect2>'
-				writePCDataElement("title", "%sing a %s"%(verb.title(), noun.lower()))
-				writePCDataElement("para", "To %s a %s, choose <guimenu>%s</guimenu> &gt; <guimenuitem>%s</guimenuitem>"%(verb.lower(), noun.lower(), menu.name, item.name))
-				print '\t\t</sect2>'
-		print '\t</sect1>'
-
-	print '</article>'
+    try:
+        app = root.application(appName)
+    except SearchError:
+        run(appName)
+    print '<?xml version="1.0"?>'
+    print '<!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN" "http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd">'
+    print '<article>'
+
+    taggedAppName = '<application>%s</application>'%appName
+
+    # Artile info:
+    print '\t<articleinfo>'
+    writePCDataElement("title", "The Totally Definitive No-Nonsense Unhelpful Complete Guide to %s for Mannequins in 40 Days - Unleashed!"%taggedAppName)
+    print '\t</articleinfo>'
+
+    # Guts of the article:
+    print '\t<sect1>'
+    writePCDataElement("title", "Introduction")
+    writePCDataElement("caution", "<para>Do not take these instructions seriously.  They are a parody of unhelpful help files found on many computer systems, and were autogenerated by <application>no-help-at-all</application></para>")
+    writePCDataElement("para", "You can start %s by opening a terminal and typing the <command>%s</command> command."%(taggedAppName, appName))
+    print '\t</sect1>'
+
+    menus = app.findChildren(predicate.GenericPredicate(roleName="menu"))
+    for menu in menus:
+        print '\t<sect1>'
+        writePCDataElement("title", "The <guimenu>%s</guimenu> menu"%menu.name)
+        writePCDataElement("para", "Use the <guimenu>%s</guimenu> menu to work with %ss"%(menu.name, menu.name.lower()))
+        items = menu.findChildren(predicate.GenericPredicate(roleName="menu item"), recursive=False)
+        if items!=None:
+            for item in items:
+                verb = item.name
+                noun = menu.name
+                print '\t\t<sect2>'
+                writePCDataElement("title", "%sing a %s"%(verb.title(), noun.lower()))
+                writePCDataElement("para", "To %s a %s, choose <guimenu>%s</guimenu> &gt; <guimenuitem>%s</guimenuitem>"%(verb.lower(), noun.lower(), menu.name, item.name))
+                print '\t\t</sect2>'
+        print '\t</sect1>'
+
+    print '</article>'
 
 if __name__=='__main__':
-	generateUnhelpfulHelp(sys.argv[1])
-	
+    try:
+        generateUnhelpfulHelp(sys.argv[1])
+    except IndexError:
+        print "####################################"
+        print "please supply an application name on the cmdline"
+        print "####################################"

=== removed file 'examples/recorder.py'
--- examples/recorder.py	2006-08-01 22:59:27 +0000
+++ examples/recorder.py	1970-01-01 00:00:00 +0000
@@ -1,223 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>, Zack Cerza <zcerza@redhat.com>'
-
-# Event recorder.
-# FIXME: under construction
-# The event handler callback seems to trap and lose Ctrl-C so you need to be ready to be
-# kill the python process via some other means
-
-import atspi
-import dogtail.tree
-
-def logEvent(event):
-    source = event.source
-    if isinstance(source, atspi.Accessible):
-        sourceStr = " source:%s"%(str(dogtail.tree.Node(source)))
-    else:
-        sourceStr = ""
-    print "Got event: %s%s"%(event.type, sourceStr)
-
-
-class Writer:
-    """
-    Abstract base class for writing out events
-    """
-    def recordClick(self, node):
-        raise NotImplementedError
-    
-class ScriptWriter(Writer):
-    """
-    Abstract Writer subclass which writes out Python scripts
-    """
-    pass
-
-class OOScriptWriter(ScriptWriter):
-    """
-    Concrete Writer subclass which writes out Python scripts in an object-oriented
-    style
-    """
-    def __init__(self):
-        # maintain a dict from variable names to search paths
-        self.variables = {}
-        self.debug = False
-        self.debugVariables = False
-
-    def generateVariableName(self, predicate):
-        # Ensure uniqueness
-        result = predicate.makeScriptVariableName()
-        if result in self.variables:
-            # This variable name is already in use; need to append a number:
-            index = 1
-            while result+str(index) in self.variables:
-                index+=1
-            return result+str(index)
-        else:
-            return result
-
-    def printVariables(self):
-        # debug hook
-        print "variables:"
-        for (varName, varAbsPath) in self.variables.iteritems():
-            print "varName:%s -> absPath:%s"%(varName, varAbsPath)        
-
-    def generateAbsSearchPathMethodCall(self, absSearchPath):
-        """
-        Generates a method call that identifies the absolute search path,
-        optimizing away prefixes where possible with variable names.
-        """
-        # We optimize away the longest common absolute path prefix, i.e. the
-        # shortest relative path suffix:
-        if self.debug:
-            print "*******************"
-            print "generateAbsSearchPathMethodCall for %s"%absSearchPath
-            self.printVariables()
-            
-        shortestRelativePath = None
-        for (varName, varAbsPath) in self.variables.iteritems():
-            relPath = varAbsPath.getRelativePath(absSearchPath)
-            if relPath:
-                if shortestRelativePath:
-                    if relPath.length() < shortestRelativePath[2].length():
-                        shortestRelativePath = (varName, varAbsPath, relPath)
-                else:
-                    shortestRelativePath = (varName, varAbsPath, relPath)
-
-        if self.debug:
-            if shortestRelativePath:
-                (varName, varAbsPath, relPath) = shortestRelativePath
-                print "shortestRelativePath: (%s, %s, %s)"%(varName, varAbsPath, relPath)
-            else:
-                print "shortestRelativePath: None"
-            print "*******************"
-
-        if shortestRelativePath:
-            (varName, varAbsPath, relPath) = shortestRelativePath
-            return varName+relPath.makeScriptMethodCall()
-        else:
-            # Have to specify it as an absolute path:
-            return "root"+absSearchPath.makeScriptMethodCall()
-    
-    def recordKey(self, node, key):
-        searchPath = node.getAbsoluteSearchPath()
-        result = self.generateAbsSearchPathMethodCall(searchPath)
-        result +=".rawType('%s')" % key
-
-    def recordClick(self, node):
-        searchPath = node.getAbsoluteSearchPath()
-
-        if self.debug:
-            print "----------------------------------"
-            print "click on %s"%searchPath
-            print "Full script would be: root%s"%searchPath.makeScriptMethodCall()
-            
-        # Generate variables for nodes likely to be referred to often (application, window)
-        # FIXME: make this smarter?
-        for i in [1,2,3]:
-            if i<searchPath.length():
-
-                prefixPath = searchPath.getPrefix(i)
-
-                if self.debugVariables:
-                    print "Considering: %s"%prefixPath
-
-                if not prefixPath in self.variables.values():
-                    if self.debugVariables:
-                        print "It is not yet a variable"
-                        self.printVariables()
-                        
-                    predicate = prefixPath.getPredicate(i-1)
-                    varName = predicate.makeScriptVariableName()
-                    print varName+" = "+self.generateAbsSearchPathMethodCall(prefixPath)
-                    self.variables[varName]=prefixPath
-                else:
-                    if self.debugVariables:
-                        print "It is already a variable"
-
-        result = self.generateAbsSearchPathMethodCall(searchPath)
-        result +=".click()"
-
-        if self.debug:
-            print "----------------------------------"
-
-        print result
-
-class ProceduralScriptWriter(ScriptWriter):
-    """
-    Concrete Writer subclass which writes out Python scripts in a procedural
-    style
-    """
-    def recordClick(self, node):
-        # FIXME: not yet written
-        raise NotImplementedError
-
-# Singleton EventRecorder
-global recorder
-
-# Test event recording class; under construction
-class EventRecorder:
-    def __init__(self):
-        self.writer = OOScriptWriter()
-        self.listeners = self.__registerEvents()
-        self.lastFocussedNode = None
-        self.absoluteNodePaths = True
- 
-    def __registerEvents(self):
-        # Only specific events are recorded:
-        listeners = []
-
-        # Focus events:
-        listeners.append(atspi.EventListener(marshalOnFocus, ["focus:"]))
-
-        # Mouse button-1 clicks:
-        listeners.append(atspi.EventListener(marshalOnMouseClick, ["mouse:button:1p"]))
-
-        # Window creation:
-        listeners.append(atspi.EventListener(marshalOnWindowCreate, ["window:create"]))
-
-        return listeners
-
-    def onFocus(self, event): 
-        # logEvent(event)
-        sourceNode = dogtail.tree.Node(event.source)
-        #print "Focus on %s"%str(sourceNode)
-        #path = sourceNode.getAbsoluteSourcePath()
-        #print "SourcePath: %s"%path
-        #print "    Script: %s"%path.make
-        self.lastFocussedNode = sourceNode
-
-    def onMouseClick(self, event): 
-        # logEvent(event)
-        sourceNode = dogtail.tree.Node(event.source)
-        # sourceNode seems to always be set to "main" (other events come through on all objects)
-        # so we pretend the click was on the last node to be focussed
-        # print "Click on %s"%str(self.getLogStringForNode(self.lastFocussedNode))
-        if self.lastFocussedNode!=None:
-            self.writer.recordClick(self.lastFocussedNode)
-
-    def onWindowCreate(self, event):
-        # logEvent(event)
-        sourceNode = dogtail.tree.Node(event.source)
-        # print "Window creation: %s"%str(sourceNode)
-
-    def getLogStringForNode(self, node):
-        if self.absoluteNodePaths:
-            return node.getAbsoluteSearchPath()
-        else:
-            return node
-    
-# Under construction.  These ought to be methods, but am having Python assertion
-# failures in refcounting when trying to hook them up using lambda expressions; grrr...
-def marshalOnFocus(event): 
-    recorder.onFocus(event)
-
-def marshalOnMouseClick(event):
-    recorder.onMouseClick(event)
-
-def marshalOnWindowCreate(event): 
-    recorder.onWindowCreate(event)
-
-recorder = EventRecorder()
-#recorder.writer.debug = True
-#recorder.writer.debugVariables = True
-atspi.event_main()

=== removed file 'examples/rhythmbox-test.py'
--- examples/rhythmbox-test.py	2006-02-22 12:31:33 +0000
+++ examples/rhythmbox-test.py	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-#!/usr/bin/env python
-# Dogtail demo script
-__author__ = 'David Malcolm <dmalcolm@redhat.com>'
-
-# Test playing a specific song in Rhythmbox, using the procedural API:
-# FIXME: not yet finished (barely started, in fact)
-# FIXME: doesn't work yet.  Tested with Rhythmbox 0.8.8  on FC3
-
-from dogtail.procedural import *
-from dogtail.utils import *
-
-run("rhythmbox")
-
-focus.application('rhythmbox') #FIXME: shouldn't 'run' automatically scope the app?  this call seems to be needed
-
-# name='Artist', roleName='table column header'
-
-# name='Album', roleName='table column header'
-
-
-

=== modified file 'examples/test-events.py'
--- examples/test-events.py	2006-02-22 12:31:33 +0000
+++ examples/test-events.py	2006-12-16 10:57:30 +0000
@@ -8,7 +8,7 @@
 # Test of event callbacks
 # Under construction
 
-def callback(event): 
+def callback(event):
     source = event.source
     if isinstance(source, atspi.Accessible):
         sourceStr = " source:%s"%(str(dogtail.tree.Node(source)))

=== added directory 'recorder'
=== added file 'recorder/dogtail-recorder'
--- recorder/dogtail-recorder	1970-01-01 00:00:00 +0000
+++ recorder/dogtail-recorder	2006-12-16 10:57:30 +0000
@@ -0,0 +1,850 @@
+#!/usr/bin/env python
+__author__ = 'David Malcolm <dmalcolm@redhat.com>, Zack Cerza <zcerza@redhat.com>'
+appName = 'Script Recorder'
+import os
+os.environ['GTK_MODULES']=''
+
+from dogtail.utils import checkForA11yInteractively
+checkForA11yInteractively()
+
+import atspi
+import dogtail.tree
+import gtk.gdk
+import dogtail.rawinput
+import re
+
+# Begin GUI code
+import threading
+class PlaybackThread(threading.Thread):
+    def __init__(self, script):
+        threading.Thread.__init__(self)
+        self.script = script
+
+    def run(self):
+        exec self.script
+
+import gobject
+import gnome
+import gtk.glade
+
+try:
+    import gtksourceview
+    useGtkSourceView = True
+except:
+    useGtkSourceView = False
+
+def createSourceView():
+    langManager = gtksourceview.SourceLanguagesManager()
+    lang = langManager.get_language_from_mime_type("text/x-python")
+    buffer = gtksourceview.SourceBuffer()
+    sourceView = gtksourceview.SourceView(buffer)
+    buffer.set_language(lang)
+    buffer.set_highlight(True)
+    return sourceView
+
+class RecorderGUI(gnome.Program):
+    def __init__(self):
+        gnome.Program.__init__(self)
+        appAuthors = ['Zack Cerza <zcerza@redhat.com>']
+        program = gnome.program_init(appName, '0.1')
+
+        if os.path.exists('recorder.glade'):
+            x = gtk.glade.XML('recorder.glade')
+        else:
+            import sys
+            exec_root = sys.argv[0].split("/bin/")[0]
+            if exec_root[0] is not '/':
+                exec_root = "/usr"
+            x = gtk.glade.XML(exec_root + '/share/dogtail/glade/recorder.glade')
+
+        self.window = x.get_widget('window')
+
+        try:
+            self.window.set_icon_from_file('../icons/dogtail-head.svg')
+        except:
+            self.window.set_icon_from_file('/usr/share/icons/hicolor/scalable/apps/dogtail-head.svg')
+
+        self.recordButton = x.get_widget('recordButton')
+        self.playButton = x.get_widget('playButton')
+        self.playButton.set_sensitive(False)
+        self.clearButton = x.get_widget('clearButton')
+        self.clearButton.set_sensitive(False)
+        self.saveButton = x.get_widget('saveButton')
+        self.saveButton.set_sensitive(False)
+        if useGtkSourceView:
+            oldTextView = x.get_widget('scriptTextView')
+            parent = oldTextView.get_parent()
+            parent.remove(oldTextView)
+            sourceView = createSourceView()
+            parent.add(sourceView)
+            sourceView.show()
+            self.scriptTextView = sourceView
+        else:
+            self.scriptTextView = x.get_widget('scriptTextView')
+        self.scriptTextView.set_editable(False)
+        #self.writerComboBox = x.get_widget('writerComboBox')
+        #self.writerComboBox.set_active(0)
+        #self.writerComboBox.set_sensitive(True)
+
+        # The following line added because self.writerComboBox is gone:
+        recorder.writerClass = ProceduralScriptWriter
+
+        self.connectSignals()
+
+        self.window.show_all()
+        gtk.main()
+
+    def connectSignals(self):
+        #self.writerComboBox.connect('changed', self.setWriterClass)
+        self.recordButton.connect('clicked', self.toggleRecording, self.scriptTextView)
+        self.playButton.connect('clicked', self.playScript, self.scriptTextView)
+        self.clearButton.connect('clicked', self.clearScript, self.scriptTextView)
+        self.saveButton.connect('clicked', self.saveScript)
+        self.window.connect('delete_event', self.quit)
+
+    def setWriterClass (self, comboBox):
+        selected = comboBox.get_active_text()
+        if selected == "Procedural":
+            recorder.writerClass = ProceduralScriptWriter
+        elif selected == "Object-Oriented":
+            recorder.writerClass = OOScriptWriter
+        else:
+            print selected, "isn't a ScriptWriter, but it is selected. How?"
+
+    def toggleRecording(self, recordButton = None, scriptTextView = None):
+        label = self.recordButton.get_label()
+        recordID = 'gtk-media-record'
+        stopID = 'gtk-media-stop'
+        
+        if label == recordID:
+            #self.writerComboBox.set_sensitive(False)
+            self.playButton.set_sensitive(False)
+            self.clearButton.set_sensitive(False)
+            self.saveButton.set_sensitive(False)
+            self.scriptTextView.set_editable(False)
+            self.recordButton.set_label(stopID)
+            recorder.startRecording(self.recordButton, self.scriptTextView)
+        
+        elif label == stopID:
+            #self.writerComboBox.set_sensitive(True)
+            self.playButton.set_sensitive(True)
+            self.clearButton.set_sensitive(True)
+            self.saveButton.set_sensitive(True)
+            self.scriptTextView.set_editable(True)
+            self.recordButton.set_label(recordID)
+            recorder.stopRecording(self.recordButton, self.scriptTextView)
+
+    def stopRecording(self):
+        self.recordButton.set_label('gtk-media-stop')
+        self.toggleRecording()
+
+    def playScript(self, button = None, scriptTextView = None):
+        self.recordButton.set_sensitive(False)
+        self.playButton.set_sensitive(False)
+        self.scriptTextView.set_editable(False)
+
+        buffer = self.scriptTextView.get_buffer()
+        startIter = buffer.get_start_iter()
+        endIter = buffer.get_end_iter()
+        scriptText = buffer.get_text(startIter, endIter)
+
+        self.playbackThread = PlaybackThread(scriptText)
+        self.playbackThread.start()
+        self.playbackThread.join()
+
+        self.playButton.set_sensitive(True)
+        self.recordButton.set_sensitive(True)
+        self.scriptTextView.set_editable(True)
+
+    def clearScript(self, button = None, scriptTextView = None):
+        self.scriptTextView.get_buffer().set_text('')
+        self.clearButton.set_sensitive(False)
+        self.saveButton.set_sensitive(False)
+
+    def saveScript(self, button):
+        """
+        Brings up a file chooser dialog asking where to save the script.
+        """
+        self.saveFileChooser = gtk.FileChooserDialog("Save Script...", None, \
+            gtk.FILE_CHOOSER_ACTION_SAVE, (gtk.STOCK_CANCEL, \
+            gtk.RESPONSE_CANCEL, gtk.STOCK_SAVE, gtk.RESPONSE_OK))
+        self.saveFileChooser.set_default_response(gtk.RESPONSE_OK)
+
+        # Why this isn't default, I do not understand.
+        self.saveFileChooser.set_do_overwrite_confirmation(True)
+
+        filter = gtk.FileFilter()
+        filter.set_name('Python files')
+        filter.add_pattern('*.py')
+        self.saveFileChooser.add_filter(filter)
+        filter = gtk.FileFilter()
+        filter.set_name('All Files')
+        filter.add_pattern('*')
+        self.saveFileChooser.add_filter(filter)
+
+        response = self.saveFileChooser.run()
+        if response == gtk.RESPONSE_OK:
+            fileName = self.saveFileChooser.get_filename()
+            # Append a .py to the file name if necessary
+            if fileName[-3:] != '.py':
+                fileName += '.py'
+            file = open(fileName, 'w')
+            buffer = self.scriptTextView.get_buffer()
+            startIter = buffer.get_start_iter()
+            endIter = buffer.get_end_iter()
+            scriptText = buffer.get_text(startIter, endIter)
+            file.write(scriptText)
+            file.close()
+        self.saveFileChooser.destroy()
+
+    def quit(self, *args):
+        self.stopRecording()
+        gtk.main_quit()
+
+# End GUI code
+
+def logEvent(event):
+    source = event.source
+    if isinstance(source, atspi.Accessible):
+        sourceStr = " source:%s"%(str(dogtail.tree.Node(source)))
+    else:
+        sourceStr = ""
+    print "Got event: %s%s"%(event.type, sourceStr)
+
+class ScriptWriter:
+    """
+    Abstract Writer subclass which writes out Python scripts
+    """
+    def __init__(self, scriptTextView = None):
+        self.scriptBuffer = ""
+        self.scriptTextView = scriptTextView
+        self.debug = False
+
+    def recordLine(self, string):
+        print string
+        if self.scriptTextView:
+            buffer = self.scriptTextView.get_buffer()
+            iter = buffer.get_end_iter()
+            if buffer.get_line_count() > 1:
+                string = '\n' + string
+            buffer.insert(iter, string)
+            
+            # Scroll to the end
+            iter = buffer.get_end_iter()
+            mark = buffer.create_mark('end', iter, True)
+            self.scriptTextView.scroll_mark_onscreen(mark)
+            buffer.delete_mark(mark)
+        else:
+            self.scriptBuffer += '\n' + string
+
+    def recordClick(self, node):
+        raise NotImplementedError
+
+    def recordTyping(self, string, type, node):
+        raise NotImplementedError
+
+    def recordKeyCombo(self, string, type, node):
+        raise NotImplementedError
+
+class OOScriptWriter(ScriptWriter):
+    """
+    Concrete Writer subclass which writes out Python scripts in an object-oriented
+    style
+    """
+    def __init__(self, scriptTextView = None):
+        ScriptWriter.__init__(self, scriptTextView)
+
+        self.debugVariables = False
+
+        self.recordLine("#!/usr/bin/python\nfrom dogtail.tree import *\n")
+
+        # maintain a dict from variable names to search paths
+        self.variables = {}
+
+    def generateVariableName(self, predicate):
+        # Ensure uniqueness
+        result = predicate.makeScriptVariableName()
+        if result in self.variables:
+            # This variable name is already in use; need to append a number:
+            index = 1
+            while result+str(index) in self.variables:
+                index+=1
+            return result+str(index)
+        else:
+            return result
+
+    def printVariables(self):
+        # debug hook
+        print "variables:"
+        for (varName, varAbsPath) in self.variables.iteritems():
+            print "varName:%s -> absPath:%s"%(varName, varAbsPath)
+
+    def generateAbsSearchPathMethodCall(self, absSearchPath):
+        """
+        Generates a method call that identifies the absolute search path,
+        optimizing away prefixes where possible with variable names.
+        """
+        # We optimize away the longest common absolute path prefix, i.e. the
+        # shortest relative path suffix:
+        if self.debug:
+            print "*******************"
+            print "generateAbsSearchPathMethodCall for %s"%absSearchPath
+            self.printVariables()
+
+        shortestRelativePath = None
+        for (varName, varAbsPath) in self.variables.iteritems():
+            relPath = varAbsPath.getRelativePath(absSearchPath)
+            if relPath:
+                if shortestRelativePath:
+                    if relPath.length() < shortestRelativePath[2].length():
+                        shortestRelativePath = (varName, varAbsPath, relPath)
+                else:
+                    shortestRelativePath = (varName, varAbsPath, relPath)
+
+        if self.debug:
+            if shortestRelativePath:
+                (varName, varAbsPath, relPath) = shortestRelativePath
+                print "shortestRelativePath: (%s, %s, %s)"%(varName, varAbsPath, relPath)
+            else:
+                print "shortestRelativePath: None"
+            print "*******************"
+
+        if shortestRelativePath:
+            (varName, varAbsPath, relPath) = shortestRelativePath
+            return varName+relPath.makeScriptMethodCall()
+        else:
+            # Have to specify it as an absolute path:
+            return "root"+absSearchPath.makeScriptMethodCall()
+
+    def recordClick(self, node):
+        """
+        Record a mouse click
+        """
+        if node == None: return
+        searchPath = node.getAbsoluteSearchPath()
+
+        if self.debug:
+            print "----------------------------------"
+            print "click on %s"%searchPath
+            print "Full script would be: root%s"%searchPath.makeScriptMethodCall()
+
+        # Generate variables for nodes likely to be referred to often (application, window)
+        # FIXME: make this smarter?
+        for i in [1,2,3]:
+            if i<searchPath.length():
+
+                prefixPath = searchPath.getPrefix(i)
+
+                if self.debugVariables:
+                    print "Considering: %s"%prefixPath
+
+                if not prefixPath in self.variables.values():
+                    if self.debugVariables:
+                        print "It is not yet a variable"
+                        self.printVariables()
+
+                    predicate = prefixPath.getPredicate(i-1)
+                    varName = predicate.makeScriptVariableName()
+                    self.recordLine(varName+" = "+self.generateAbsSearchPathMethodCall(prefixPath))
+                    self.variables[varName]=prefixPath
+                else:
+                    if self.debugVariables:
+                        print "It is already a variable"
+
+        result = self.generateAbsSearchPathMethodCall(searchPath)
+        result +=".click()"
+
+        if self.debug:
+            print "----------------------------------"
+
+        self.recordLine(result)
+
+class ProceduralScriptWriter(ScriptWriter):
+    """
+    Concrete Writer subclass which writes out Python scripts in a procedural
+    style
+    """
+    
+    currentWidget = None
+    currentDialog = None
+    currentFrame = None
+    currentApplication = None
+
+    def __init__(self, scriptTextView = None):
+        ScriptWriter.__init__(self, scriptTextView)
+
+        self.recordLine("#!/usr/bin/python\nfrom dogtail.procedural import *\n")
+    
+    def setUpFocus(self, node):
+        """
+        Writes out the necessary focus.application() and focus.dialog() lines 
+        to the script.
+        """
+        application = FakeNode.findAncestor(node, roleName = 'application')
+        if application:
+            needApp = True
+            if self.currentApplication:
+                if application == self.currentApplication: needApp = False
+            if needApp:
+                self.recordLine("focus.application('%s')" % application.name)
+                self.currentApplication = application
+        elif application == None:
+            print "Warning: could not determine which application you are clicking or typing on."
+            print "    It is most likely not reporting its toplevel Accessible as having a"
+            print "    role name of 'application'. Please file a bug against it!"
+
+        dialog = FakeNode.findAncestor(node, roleName = 'dialog')
+        if dialog:
+            needDialog = True
+            if dialog == self.currentDialog: needDialog = False
+            if needDialog:
+                self.recordLine("focus.dialog('%s')" % dialog.name)
+                self.currentDialog = dialog
+        else:
+            frame = FakeNode.findAncestor(node, roleName='frame')
+            if frame:
+                needFrame = True
+                if frame == self.currentFrame: needFrame = False
+                if needFrame:
+                    self.recordLine("focus.frame('%s')" % frame.name)
+                    self.currentFrame = frame
+
+        
+    def recordClick(self, node, button):
+        if node == None: return False
+
+        self.setUpFocus(node)
+        
+        widget = node
+        #possibleActions = ['click', 'activate', 'open', 'menu']
+        possibleActions = ['click', 'activate', 'menu']
+        foundAnAction = False
+        for action in possibleActions:
+            if action in widget.actions.keys():
+                if button == 1 and action == 'menu': break
+                foundAnAction = True
+                self.recordLine("%s('%s', roleName='%s')" % \
+                        (action, widget.name.replace('\n','\\n'), widget.roleName))
+                break
+        if not foundAnAction: 
+            if hasattr(widget, 'select') and button != 1:
+                self.recordLine("select('%s', roleName='%s')" % \
+                        (widget.name.replace('\n','\\n'), widget.roleName))
+            else:
+                if button != 1: btn = ', button = ' + str(button)
+                else: btn = ''
+                s = "click('%s', roleName='%s', raw=True%s)" % \
+                        (widget.name.replace('\n','\\n'), widget.roleName, btn)
+                self.recordLine(s)
+        self.currentWidget = widget
+        
+    def recordTyping(self, string, type, node):
+        if not string: return
+        self.setUpFocus(node)
+        self.recordLine("type(\"" + string.replace('"','\\"') + "\")")
+
+    def recordKeyCombo(self, string, type, node):
+        if not string: return
+        self.setUpFocus(node)
+        self.recordLine("keyCombo(\"" + string + "\")")
+
+class FakeNode(dogtail.tree.Node):
+    """A "cached pseudo-copy" of a Node
+
+    This class exists for cases where we know we're going to need information
+    about a Node instance at a point in time where it's no longer safe to
+    assume that the Accessible it wraps is still valid. It is designed to
+    cache enough information to allow all of the necessary Node methods to
+    execute properly and return something meaningful.
+
+    As it is often necessary to know the Node instance's parent, it creates
+    FakeNode instances of each and every one of its ancestors.
+    """
+    def __init__(self, node):
+        if node == None: raise TypeError, node
+
+        self.__node = node
+        self.name = self.__node.name
+        self.roleName = self.__node.roleName
+        self.description = self.__node.description
+        self.actions = self.__node.actions
+        self.debugName = self.__node.debugName
+
+        self.text = self.__node.text
+
+        self.position = self.__node.position
+
+        self.size = self.__node.size
+
+        if node.parent: self.parent = FakeNode(self.__node.parent)
+        else: self.parent = None
+
+        if node.labellee: self.labellee = FakeNode(self.__node.labellee)
+        else: self.labellee = None
+
+    def __getattr__(self, name):
+        raise AttributeError, name
+
+    def __setattr__(self, name, value):
+        self.__dict__[name] = value
+
+    def __cmp__(self, otherNode):
+        if not otherNode: return True
+
+        nameMatch = False
+        roleNameMatch = False
+        descMatch = False
+        nameMatch = otherNode.name == self.name
+        roleNameMatch = otherNode.roleName == self.roleName
+        descMatch = otherNode.description == self.description
+        match = nameMatch and roleNameMatch and descMatch
+        return not match
+
+    def findAncestor(node, name = None, roleName = None, description = None):
+        while node.parent:
+            nameMatch = False
+            roleNameMatch = False
+            descMatch = False
+            if name != None: nameMatch = node.parent.name == name
+            else: nameMatch = True
+            if roleName != None: roleNameMatch = node.parent.roleName == roleName
+            else: roleNameMatch = True
+            if description != None: 
+                descMatch = node.parent.description == description
+            else: descMatch = True
+            match = nameMatch and roleNameMatch and descMatch
+            if match: return node.parent
+            node = node.parent
+        return None
+    findAncestor = staticmethod(findAncestor)
+
+
+
+# Singleton EventRecorder
+global recorder
+
+class EventRecorder:
+    """
+    Event Recorder
+    """
+    modifiers = {
+            atspi.Accessibility_MODIFIER_NUMLOCK: 'NumLock',
+            atspi.Accessibility_MODIFIER_META3: 'Meta3',
+            atspi.Accessibility_MODIFIER_META2: 'Meta2',
+            atspi.Accessibility_MODIFIER_META: 'Meta',
+            atspi.Accessibility_MODIFIER_ALT: 'Alt',
+            atspi.Accessibility_MODIFIER_CONTROL: 'Control',
+            atspi.Accessibility_MODIFIER_SHIFTLOCK: 'ShiftLock',
+            atspi.Accessibility_MODIFIER_SHIFT: 'Shift' }
+
+    def __init__(self, writerClass = ProceduralScriptWriter):
+        self.writer = None
+        self.writerClass = writerClass
+        self.lastFocusedNode = None
+        self.lastSelectedNode = None
+        self.lastPressedNode = None
+        self.lastReleasedNode = None
+        self.typedTextBuffer = ""
+        self.lastTypedNode = None
+        self.absoluteNodePaths = True
+        self.listeners = []
+
+        import gtk.keysyms
+
+    def __registerEvents(self):
+        # Only specific events are recorded:
+        listeners = []
+
+        # Focus events:
+        listeners.append(atspi.EventListener(marshalOnFocus, ["focus:"]))
+
+        # State Changed events:
+        listeners.append(atspi.EventListener(marshalOnSelect, ["object:state-changed:selected"]))
+
+        # Mouse button events:
+        listeners.append(atspi.EventListener(marshalOnMouseButton, ["mouse:button"]))
+
+        # Keystroke events:
+        listeners.append(atspi.DeviceListener(marshalOnKeyPress))
+
+        # Window creation:
+        #listeners.append(atspi.EventListener(marshalOnWindowCreate, ["window:create"]))
+
+        return listeners
+
+    def startRecording(self, unused = None, scriptTextView = None):
+        self.writer = self.writerClass(scriptTextView)
+        self.listeners = self.__registerEvents()
+        # set lastKeyPressTimeStamp to 1, which is an invalid value.
+        self.lastKeyPressTimeStamp = 1
+        atspi.event_main()
+
+    def stopRecording(self, unused = None, scriptTextView = None):
+        for listener in self.listeners:
+            listener.deregister()
+        atspi.event_quit()
+        self.writer = None
+
+    def onFocus(self, event):
+        sourceNode = dogtail.tree.Node(event.source)
+        sourceNode = FakeNode(sourceNode)
+        #if sourceNode == self.lastPressedNode or \
+        #        sourceNode == self.lastReleasedNode:
+        #    sourceNode._FakeNode__node.blink()
+        self.lastFocusedNode = sourceNode
+
+    def onSelect(self, event):
+        sourceNode = dogtail.tree.Node(event.source)
+        sourceNode = FakeNode(sourceNode)
+        self.lastSelectedNode = sourceNode
+
+    def onMouseButton(self, event):
+        #logEvent(event)
+        self.writer.recordTyping(self.typedTextBuffer, "pressed", self.lastFocusedNode)
+        self.typedTextBuffer = ""
+
+        isPress = isRelease = False
+        g=re.match('mouse:button:(\d)(p|r)', event.type).groups()
+        button = int(g[0])
+        if g[1] == 'p': isPress = True
+        elif g[1] == 'r': isRelease = True
+
+        # The source node is always "main" - which sucks. We have to detect
+        # the real source ourselves.
+
+        def detectByCoordinates(nodes, x, y):
+            # From a list of nodes, find the smallest one that (x, y) is in
+            def isCandidate(node, x, y):
+                # If (x, y) is inside the node, return True
+                if node and node.position:
+                    #print "x,y: %s, %s" % (x, y)
+                    #print "position: %s, size: %s" % (node.position, node.size)
+                    if node.position[0] <= x <= (node.position[0] + node.size[0]) and \
+                            node.position[1] <= y <= (node.position[1] + node.size[1]):
+                        return True
+            def getAllDescendants(node):
+                result = []
+                for child in node.children:
+                    result.append(child)
+                    result.extend(getAllDescendants(child))
+                    #for grandChild in child.children:
+                    #    result.append(grandChild)
+                return result
+            def smallestNode(nodes):
+                # Return the node with the smallest area
+                areas = {}
+                for node in nodes:
+                    area = node.size[0] * node.size[1]
+                    if areas.get(area, None):
+                        print "Two nodes are the same size?!"
+                        print str(areas[area]) + "|" + str(node)
+                    areas[area] = node
+                if areas:
+                    return areas[min(areas.keys())]
+
+            detectedNode = None
+            for node in nodes:
+                if isCandidate(node, x, y):
+                    detectedNode = node
+                    # table children don't send focus signals, so we have to
+                    # find the child itself.
+                    if node.roleName == 'table':
+                        detectedNode = None
+                        if not hasattr(node, 'children'):
+                            node = node._FakeNode__node
+                        # getAllDescendants() is very expensive :(
+                        possibleNodes = getAllDescendants(node)
+                        probableNodes = [n for n in possibleNodes if \
+                                isCandidate(n, x, y)]
+                        detectedNode = smallestNode(probableNodes)
+            return detectedNode
+
+        x = event.detail1
+        y = event.detail2
+        if self.lastSelectedNode != self.lastFocusedNode:
+            possibleNodes = (self.lastSelectedNode, self.lastFocusedNode)
+        else:
+            # If self.lastSelectedNode isn't meaningful, don't waste time on 
+            # it with detectByCoordinates().
+            possibleNodes = [self.lastFocusedNode]
+        detectedNode = detectByCoordinates(possibleNodes, x, y)
+        if detectedNode and ((detectedNode.name == appName and \
+                detectedNode.roleName == 'frame') or \
+                FakeNode.findAncestor(detectedNode, \
+                roleName = 'frame', name = appName)):
+            self.lastPressedNode = None
+            self.lastReleasedNode = None
+            return
+        if detectedNode and not isinstance(detectedNode, FakeNode):
+            detectedNode = FakeNode(detectedNode)
+        if isPress: 
+            self.lastPressedNode = detectedNode
+        elif isRelease:
+            self.lastReleasedNode = detectedNode
+        
+        if isRelease and detectedNode:
+            self.writer.recordClick(detectedNode, button)
+
+    def __checkModMask(fullMask, partMask, toCheck):
+        result = False
+        if fullMask == 0 or partMask == 0:
+            return (partMask, result)
+        if partMask - toCheck >= 0:
+            partMask = partMask - toCheck
+            result = True
+        return (partMask, result)
+    __checkModMask = staticmethod(__checkModMask)
+
+    def __getModifiers(self, modMask, keyChar):
+        partMask = modMask
+        modsDict = {}
+        keys = self.modifiers.keys()
+        keys.sort()
+        for i in keys[::-1]:
+            (partMask, pressed) = self.__checkModMask(modMask, partMask, i)
+            if pressed: modsDict[self.modifiers[i]] = i
+        # Screw capslock.
+        if modsDict.has_key('ShiftLock'):
+            del modsDict['ShiftLock']
+        # Shift+foo is not considered a key combo if foo is printable
+        if modsDict.has_key('Shift') and not keyChar == '':
+            del modsDict['Shift']
+        return modsDict
+
+    def onKeyPress(self, event):
+        # The Fn key on my Thinkpad has a keyID of 0. Ignore it.
+        if not event.keyID: return
+        if event.type == atspi.SPI_KEY_PRESSED:
+            type = "pressed"
+        elif event.type == atspi.SPI_KEY_RELEASED:
+            type = "released"
+            return
+
+        self.lastKeyPressTimeStamp = event.timeStamp
+        if self.lastKeyPressTimeStamp < 0:
+            elapsedTime = event.timeStamp - self.lastKeyPressTimeStamp
+        else:
+            elapsedTime = 0
+
+        if self.lastFocusedNode:
+            self.lastFocusedNode.text = self.lastFocusedNode._FakeNode__node.text
+
+        keyString = dogtail.rawinput.keyStrings[event.keyID]
+        keyChar = dogtail.rawinput.keySymToUniChar(event.keyID)
+
+        # If the only key being pressed is a modifier, don't do anything.
+        if keyString.startswith("Alt_") or keyString.startswith("Control_") \
+                or keyString.startswith("Meta_") or \
+                keyString.startswith("Shift") or keyString == 'Caps_Lock':
+            isJustAMod = True
+            return
+        else:
+            isJustAMod = False
+
+        modsDict = self.__getModifiers(event.modifiers, keyChar)
+
+        def buildModifierString(modsDict):
+            s = ''
+            if modsDict:
+                for mod in modsDict.keys():
+                    s = s + '<' + mod + '>'
+            return s
+
+        modString = buildModifierString(modsDict)
+
+        # If modifiers are present, we're dealing with a key combo
+        if modString: combo = True
+        # Otherwise, we assume for a second that we're not.
+        else: combo = False
+        
+        # If the key represents a printable character, use that.
+        if keyChar != '': key = keyChar
+        else:
+            # Otherwise, use the keyString, e.g. 'Return'.
+            key = keyString
+            # We treat nonprintable characters like key combos.
+            combo = True
+
+        if not combo and self.lastTypedNode is not None and \
+                (self.lastTypedNode != self.lastFocusedNode):
+            #print "changed node, flushing"
+            flush = True
+        else: flush = False
+
+        #print "%s ! %s ! %s" % (str(self.lastTypedNode), str(self.lastFocusedNode), self.typedTextBuffer)
+
+        if combo:
+            self.writer.recordTyping(self.typedTextBuffer, "pressed", self.lastFocusedNode)
+            self.typedTextBuffer = ""
+            self.writer.recordKeyCombo(modString + key, type, self.lastFocusedNode)
+            self.lastTypedNode = self.lastFocusedNode
+        elif flush:
+            self.writer.recordTyping(self.typedTextBuffer, "pressed", self.lastTypedNode)
+            self.typedTextBuffer = key
+            self.lastTypedNode = self.lastFocusedNode
+        else:
+            if self.typedTextBuffer == "":
+                self.lastTypedNode = self.lastFocusedNode
+            self.typedTextBuffer = self.typedTextBuffer + key
+        return
+
+        # If we're using the keyString or have modifiers, flush 
+        # self.typedTextBuffer by recording a line and also record the key 
+        # combo.
+        if modString or flush:
+            if self.typedTextBuffer:
+                self.writer.recordTyping(self.typedTextBuffer, "pressed", self.lastFocusedNode)
+                if not combo:
+                    self.typedTextBuffer = key
+                else:
+                    self.typedTextBuffer = ""
+                self.lastTypedNode = self.lastFocusedNode
+            if modString or combo:
+                self.writer.recordKeyCombo(modString + key, type, self.lastFocusedNode)
+        # Otherwise add to the buffer, and wait to flush it.
+        else:
+            if self.typedTextBuffer == "":
+                self.lastTypedNode = self.lastFocusedNode
+            self.typedTextBuffer = self.typedTextBuffer + key
+
+    def onWindowCreate(self, event):
+        # logEvent(event)
+        sourceNode = dogtail.tree.Node(event.source)
+        # print "Window creation: %s"%str(sourceNode)
+
+    def getLogStringForNode(self, node):
+        if self.absoluteNodePaths:
+            return node.getAbsoluteSearchPath()
+        else:
+            return node
+
+# Under construction.  These ought to be methods, but am having Python assertion
+# failures in refcounting when trying to hook them up using lambda expressions; grrr...
+import traceback
+def marshalOnFocus(event):
+    try: recorder.onFocus(event)
+    except: traceback.print_exc()
+
+def marshalOnSelect(event):
+    try: recorder.onSelect(event)
+    except: traceback.print_exc()
+
+def marshalOnMouseButton(event):
+    try: recorder.onMouseButton(event)
+    except: traceback.print_exc()
+
+def marshalOnKeyPress(event):
+    try: recorder.onKeyPress(event)
+    except: traceback.print_exc()
+
+def marshalOnWindowCreate(event):
+    try: recorder.onWindowCreate(event)
+    except: traceback.print_exc()
+
+recorder = EventRecorder()
+recorderGUI = RecorderGUI()
+#recorder.writer.debug = True
+#recorder.writer.debugVariables = True
+
+
+# vim: sw=4 ts=4 sts=4 et ai

=== added file 'recorder/dogtail-recorder.desktop'
--- recorder/dogtail-recorder.desktop	1970-01-01 00:00:00 +0000
+++ recorder/dogtail-recorder.desktop	2006-12-16 10:57:30 +0000
@@ -0,0 +1,14 @@
+[Desktop Entry]
+Encoding=UTF-8
+Name=Dogtail Script Recorder
+Name[en_CA]=Dogtail Script Recorder
+Name[en_GB]=Dogtail Script Recorder
+Comment=Automate your desktop using Dogtail
+Comment[en_CA]=Automate your desktop using Dogtail
+Comment[en_GB]=Automate your desktop using Dogtail
+Exec=dogtail-recorder
+Terminal=false
+Type=Application
+Icon=dogtail-head.svg
+StartupNotify=true
+Categories=Application;Development;

=== added file 'recorder/recorder.glade'
--- recorder/recorder.glade	1970-01-01 00:00:00 +0000
+++ recorder/recorder.glade	2006-12-16 10:57:30 +0000
@@ -0,0 +1,98 @@
+<?xml version="1.0" standalone="no"?> <!--*- mode: xml -*-->
+<!DOCTYPE glade-interface SYSTEM "http://gazpacho.sicem.biz/gazpacho-0.1.dtd">
+<glade-interface>
+    <widget class="GtkWindow" id="window">
+        <property name="default_height">200</property>
+        <property name="title" context="yes" translatable="yes">Script Recorder</property>
+        <property name="visible">True</property>
+        <child>
+            <widget class="GtkVBox" id="vbox1">
+                <property name="visible">True</property>
+                <child>
+                    <widget class="GtkHButtonBox" id="hbuttonbox1">
+                        <property name="layout_style">start</property>
+                        <property name="visible">True</property>
+                        <child>
+                            <widget class="GtkButton" id="recordButton">
+                                <property name="is_focus">True</property>
+                                <property name="label">gtk-media-record</property>
+                                <property name="use_stock">True</property>
+                                <property name="visible">True</property>
+                            </widget>
+                        </child>
+                        <child>
+                            <widget class="GtkButton" id="playButton">
+                                <property name="label">gtk-media-play</property>
+                                <property name="use_stock">True</property>
+                                <property name="visible">True</property>
+                            </widget>
+                            <packing>
+                                <property name="position">1</property>
+                            </packing>
+                        </child>
+                        <child>
+                            <widget class="GtkButton" id="clearButton">
+                                <property name="label">gtk-clear</property>
+                                <property name="use_stock">True</property>
+                                <property name="visible">True</property>
+                            </widget>
+                            <packing>
+                                <property name="position">2</property>
+                            </packing>
+                        </child>
+                        <child>
+                            <widget class="GtkButton" id="saveButton">
+                                <property name="is_focus">True</property>
+                                <property name="label">gtk-save</property>
+                                <property name="use_stock">True</property>
+                                <property name="visible">True</property>
+                            </widget>
+                            <packing>
+                                <property name="position">3</property>
+                            </packing>
+                        </child>
+                    </widget>
+                    <packing>
+                        <property name="expand">False</property>
+                    </packing>
+                </child>
+                <child>
+                    <widget class="GtkVBox" id="vbox2">
+                        <property name="spacing">1</property>
+                        <property name="visible">True</property>
+                        <child>
+                            <widget class="GtkLabel" id="scriptViewLabel">
+                                <property name="label" context="yes" translatable="yes"> Script:</property>
+                                <property name="visible">True</property>
+                                <property name="xalign">0.0</property>
+                            </widget>
+                            <packing>
+                                <property name="expand">False</property>
+                            </packing>
+                        </child>
+                        <child>
+                            <widget class="GtkScrolledWindow" id="scrolledwindow1">
+                                <property name="hscrollbar_policy">automatic</property>
+                                <property name="visible">True</property>
+                                <property name="vscrollbar_policy">automatic</property>
+                                <child>
+                                    <widget class="GtkTextView" id="scriptTextView">
+                                        <property name="editable">False</property>
+                                        <property name="is_focus">True</property>
+                                        <property name="visible">True</property>
+                                    </widget>
+                                </child>
+                            </widget>
+                            <packing>
+                                <property name="position">1</property>
+                            </packing>
+                        </child>
+                    </widget>
+                    <packing>
+                        <property name="position">1</property>
+                    </packing>
+                </child>
+            </widget>
+        </child>
+    </widget>
+</glade-interface>

=== modified file 'scripts/dogtail-detect-session'
--- scripts/dogtail-detect-session	2006-02-22 12:31:33 +0000
+++ scripts/dogtail-detect-session	2006-12-16 10:57:30 +0000
@@ -50,7 +50,14 @@
 	running = False
 	return running
 
-if GNOME() or KDE():
+def JustSomeApps():
+    """
+    "Is at least one accessibility-enabled application running?"
+    """
+    assert focus.desktop
+    assert focus.desktop.children
+
+if GNOME() or KDE() or JustSomeApps():
 	sys.exit()
 else: 
 	sys.exit(1)

=== modified file 'scripts/dogtail-run-headless'
--- scripts/dogtail-run-headless	2006-02-22 12:31:33 +0000
+++ scripts/dogtail-run-headless	2006-12-16 10:57:30 +0000
@@ -1,60 +1,200 @@
-#!/bin/sh
-# dogtail-run-headless
-#
-# Usage: dogtail-run-headless ./some-dogtail-script.py
-#
-# This script launches an X server using the virtual framebuffer, allowing 
-# dogtail scripts to be run on headless servers. The server starts a minimal
-# GNOME session, based on Nat Friedman's notes here: 
-#  http://nat.org/2005/october/#Keep-It-Simple-Stupid
-# Dogtail scripts are run in the current directory. After the script 
-# terminates, so does the X server.
-#
-# The X server can be connected to using VNC via the following steps:
-#
-#  port=`"x11vnc -display :1 -viewonly -bg" | grep PORT)`
-#  port=`echo "$port" | sed -e's/PORT=//'`
-#  port=`expr $port - 5900`
-#
-#  vncviewer localhost:$port
-#
-# Author: Zack Cerza <zcerza@redhat.com>
-#
-
-A11Y_ENABLED=`gconftool-2 --get /desktop/gnome/interface/accessibility`
-
-if test x$A11Y_ENABLED = xfalse; then 
-	echo "Enabling accessibility support for GNOME"
-	gconftool-2 --set --type bool /desktop/gnome/interface/accessibility true
-fi
-
-EXIT_CODE_FILE=/tmp/dogtail-run-headless.exitcode
-
-mv -f ~/.xinitrc ~/.xinitrc-user 2>/dev/null && \
- echo "Moving ~/.xinitrc to ~/.xinitrc-user temporarily"
-
-# xinit doesn't allow specifying an alternate xinitrc
-cat << EOF > ~/.xinitrc
-#!/bin/sh
-gnome-settings-daemon &
-gnome-panel &
-nautilus -n &
-metacity &
-gconftool-2 --set --type bool /desktop/gnome/interface/accessibility true
-sleep 10
-cd $PWD && dogtail-detect-session && sh -c "$@"; echo -n \$? > $EXIT_CODE_FILE
-EOF
-
-echo "Starting GNOME Session..."
-xinit -- /usr/X11R6/bin/Xvfb :1 -screen 0 1024x768x24 -fbdir /tmp :1
-
-if test x$A11Y_ENABLED = xfalse; then
-	echo "Re-disabling accessibility support for GNOME"
-	gconftool-2 --set --type bool /desktop/gnome/interface/accessibility false
-fi
-
-rm -f ~/.xinitrc
-mv -f ~/.xinitrc-user ~/.xinitrc 2>/dev/null && \
- echo "Restored ~/.xinitrc"
-
-exit `cat $EXIT_CODE_FILE`
+#!/usr/bin/python
+"""
+dogtail-run-headless
+
+Runs a dogtail script 
+This script launches an X server using the virtual framebuffer, allowing
+dogtail scripts to be run on headless servers. 
+The server can currently use a minimal GNOME session, or just metacity.
+
+Dogtail scripts are run in the current directory. After the script
+terminates, so does the X server.
+"""
+__author__ = "Zack Cerza <zcerza@redhat.com>"
+
+_usage = """
+Usage: dogtail-run-headless <options> <script>
+
+Options:
+
+    -h, --help      Display this message.
+    
+    -g, --gnome     Use a GNOME session.
+    
+    -n, --none      Use a minimal session, consisting of just metacity.
+    
+    -k, --kde       Use a KDE session (not implemented).
+"""
+
+def usage():
+    print _usage
+
+import os
+import sys
+import gconf
+gconfClient = gconf.client_get_default()
+
+TRUE='true'
+FALSE='false'
+
+a11yGConfKey = '/desktop/gnome/interface/accessibility'
+
+global a11yIsEnabled
+global a11yWasEnabled
+a11yWasEnabled = True
+
+def makeSureGNOMEIsAccessible():
+    global a11yIsEnabled, a11yWasEnabled
+    a11yIsEnabled = gconfClient.get_bool(a11yGConfKey)
+    a11yWasEnabled = a11yIsEnabled
+
+    if not a11yIsEnabled:
+        print "Temporarily enabling accessibility support for GNOME"
+        gconfClient.set_bool(a11yGConfKey, True)
+        a11yIsEnabled = gconfClient.get_bool(a11yGConfKey)
+
+    return a11yIsEnabled
+
+global xinitrc
+xinitrc = None
+
+def startXServer():
+    def findFreeDisplay():
+        import re
+        tmp = os.listdir('/tmp')
+        pattern = re.compile('\.X([0-9]+)-lock')
+        numbers = []
+        for file in tmp:
+            match = re.match(pattern, file)
+            if match: numbers.append(int(match.groups()[0]))
+        if not numbers: return ':0'
+        numbers.sort()
+        return ':' + str(numbers[-1] + 1)
+    
+    server = os.popen('/usr/bin/which Xvfb 2>/dev/null')
+    if not server:
+        print "Cannot find Xvfb"
+        sys.exit(EXIT_DEPS)
+    server = server.readlines()[0].strip()
+
+    client = xinitrc.name
+    resolution = '1024x768x16'
+    cmd = 'xinit %s -- %s %s -screen 0 %s -ac -noreset -shmem' % \
+            (client, server, findFreeDisplay(), resolution)
+    print cmd
+    return os.system(cmd)
+    
+global exitCodeFile
+exitCodeFile = None
+
+def main(argv):
+    import getopt
+    EXIT_SYNTAX = 1
+    EXIT_NOT_IMPL = 2
+    EXIT_DEPS = 3
+
+    shortOpts = "hgkn"
+    longOpts = ['help', 'gnome', 'kde', 'none']
+    try:
+        opts, args = getopt.getopt(argv[1:], shortOpts, longOpts)
+    except getopt.GetoptError:
+        usage()
+        return EXIT_SYNTAX
+    if len(opts) == 0:
+        usage()
+        return EXIT_SYNTAX
+        
+    def stripOpt(opt):
+        # take the '-' out of e.g. '-h'
+        if len(opt) == 2: opt = opt[1]
+        # take the '--' out of e.g. '--help'
+        if len(opt) > 2: opt = opt[2:]
+        return opt
+    
+    for opt, arg in opts:
+        opt = stripOpt(opt)
+        if opt in (shortOpts[0], longOpts[0]):
+            usage()
+            cleanup()
+            return 0
+        elif len(args) == 0:
+            print "You must specify a script to execute in the headless session."
+            print
+            return EXIT_SYNTAX
+        elif len(args) > 1:
+            print "You may only specify one script to execute in the headless session."
+            print
+            print "Note: If you're trying to have dogtail-run-headless run a script using certain"
+            print "environment values, use the following format (note the quotation marks):"
+            print
+            print '   dogtail-run-headless "VAR=value /path/to/script.py"'
+            print
+            return EXIT_SYNTAX
+        else:
+            script = args[0]
+    
+        pid = str(os.getpid())
+        global exitCodeFile
+        exitCodeFile = "/tmp/dogtail-headless-exitcode." + pid
+
+        global xinitrc
+        xinitrc = file("/tmp/dogtail-headless-xinitrc." + pid, 'w')
+        xinitrc.write('#!/bin/sh\n')
+        
+        if opt in (shortOpts[1], longOpts[1]):
+            # (Fake) GNOME session
+
+            # Damn binaries, always ambling about the filesystem
+            if os.path.exists('/usr/libexec/gnome-settings-daemon'):
+                xinitrc.write('/usr/libexec/')
+            xinitrc.write('gnome-settings-daemon &\n')
+            xinitrc.write('gnome-panel &\n')
+            xinitrc.write('nautilus -n &\n')
+            xinitrc.write('metacity &\n')
+            xinitrc.write('sleep 10\n')
+            xinitrc.write('cd %s && dogtail-detect-session && sh -c "%s"; echo -n $? > %s\n' % (os.getcwdu(), script, exitCodeFile))
+            xinitrc.close()
+
+            makeSureGNOMEIsAccessible()
+            startXServer()
+            exitCode = int(file(exitCodeFile, 'r').read())
+            return exitCode
+            
+        elif opt in (shortOpts[2], longOpts[2]):
+            # KDE session
+            print "Sorry, this is just a placeholder. KDE4 should support dogtail, and vice versa."
+            cleanup()
+            return EXIT_NOT_IMPL
+
+        elif opt in (shortOpts[3], longOpts[3]):
+            # No session
+            xinitrc.write('metacity &\n')
+            xinitrc.write('sleep 3\n')
+            xinitrc.write('cd %s && sh -c "%s"; echo -n $? > %s\n' % (os.getcwdu(), script, exitCodeFile))
+            xinitrc.close()
+            
+            makeSureGNOMEIsAccessible()
+            startXServer()
+            exitCode = int(file(exitCodeFile, 'r').read())
+            return exitCode
+
+def cleanup():
+    if not a11yWasEnabled: gconfClient.set_bool(a11yGConfKey, False)
+    if exitCodeFile:
+        os.remove(exitCodeFile)
+    if xinitrc:
+        name = xinitrc.name
+        xinitrc.close()
+        os.remove(name)
+
+if __name__ == "__main__":
+    import traceback
+    try: exitCode = main(sys.argv)
+    except:
+        exitCode = 254
+        traceback.print_exc()
+    try: 
+        cleanup()
+    except: traceback.print_exc()
+    sys.exit(exitCode)
+

=== modified file 'setup.py'
--- setup.py	2006-08-01 22:59:27 +0000
+++ setup.py	2006-12-21 13:33:47 +0000
@@ -5,76 +5,77 @@
 from distutils.command.bdist_rpm import bdist_rpm
 
 def examples():
-	import os
-	exList = os.listdir(os.curdir + '/examples/')
-	result = []
-	for ex in exList:
-		if ex.split('.')[-1] == 'py' and ex != 'crack.py':
-			result = result + ['examples/' + ex]
-	return result
+    import os
+    exList = os.listdir(os.curdir + '/examples/')
+    result = []
+    for ex in exList:
+        if ex.split('.')[-1] == 'py':
+            result = result + ['examples/' + ex]
+    return result
 
 def examples_data():
-	import os
-	dataList = os.listdir(os.curdir + '/examples/data/')
-	result = []
-	for data in dataList:
-		if data != 'CVS':
-			result = result + ['examples/data/' + data]
-	return result
+    import os
+    dataList = os.listdir(os.curdir + '/examples/data/')
+    result = []
+    for data in dataList:
+        if data != 'CVS':
+            result = result + ['examples/data/' + data]
+    return result
 
 def sniff_icons():
-	import os
-	list = os.listdir(os.curdir + '/sniff/icons/')
-	result = []
-	for file in list:
-		if file.split('.')[-1] in ('xpm'):
-			result = result + ['sniff/icons/' + file]
-	return result
+    import os
+    list = os.listdir(os.curdir + '/sniff/icons/')
+    result = []
+    for file in list:
+        if file.split('.')[-1] in ('xpm'):
+            result = result + ['sniff/icons/' + file]
+    return result
 
 def icons(ext_tuple):
-	import os
-	list = os.listdir(os.curdir + '/icons/')
-	result = []
-	for file in list:
-		if file.split('.')[-1] in ext_tuple:
-			result = result + ['icons/' + file]
-	return result
+    import os
+    list = os.listdir(os.curdir + '/icons/')
+    result = []
+    for file in list:
+        if file.split('.')[-1] in ext_tuple:
+            result = result + ['icons/' + file]
+    return result
 
 def scripts():
-	import os
-	list = os.listdir(os.curdir + '/scripts/')
-	result = ['sniff/sniff']
-	for file in list:
-		if file != 'CVS':
-			result = result + ['scripts/' + file]
-	return result
+    import os
+    list = os.listdir(os.curdir + '/scripts/')
+    result = ['sniff/sniff', 'recorder/dogtail-recorder']
+    for file in list:
+        if file != 'CVS':
+            result = result + ['scripts/' + file]
+    return result
 
 setup (
-	name = 'dogtail',
-	version = '0.5.1',
-	description = """GUI test tool and automation framework that uses Accessibility (a11y) technologies to communicate with desktop applications.""",
-	author = """Zack Cerza <zcerza@redhat.com>,
-Ed Rousseau <rousseau@redhat.com>, 
+        name = 'dogtail',
+        version = '0.6.1',
+        description = """GUI test tool and automation framework that uses Accessibility (a11y) technologies to communicate with desktop applications.""",
+        author = """Zack Cerza <zcerza@redhat.com>,
+Ed Rousseau <rousseau@redhat.com>,
 David Malcolm <dmalcolm@redhat.com>""",
-	author_email = 'dogtail-list@gnome.org',
-	url = 'http://people.redhat.com/zcerza/dogtail/',
-	packages = ['dogtail', 'dogtail.apps', 'dogtail.apps.wrappers'],
-	scripts = scripts(),
-	data_files = [
-				('share/doc/dogtail/examples',
-					examples() ),
-				('share/doc/dogtail/examples/data', 
-					examples_data() ),
-				('share/dogtail/glade', ['sniff/sniff.glade']),
-				('share/dogtail/icons', sniff_icons() ),
-				('share/applications', ['sniff/sniff.desktop']),
-				('share/icons/hicolor/48x48/apps', icons('png')),
-				('share/icons/hicolor/scalable/apps', icons('svg'))
-				],
-	cmdclass = {
-		'bdist_rpm': bdist_rpm
-		}
+        author_email = 'dogtail-list@gnome.org',
+        url = 'http://people.redhat.com/zcerza/dogtail/',
+        packages = ['dogtail'],
+        scripts = scripts(),
+        data_files = [
+                                ('share/doc/dogtail/examples',
+                                        examples() ),
+                                ('share/doc/dogtail/examples/data',
+                                        examples_data() ),
+                                ('share/dogtail/glade', ['sniff/sniff.glade',
+                                        'recorder/recorder.glade']),
+                                ('share/dogtail/icons', sniff_icons() ),
+                                ('share/applications', ['sniff/sniff.desktop',
+                                        'recorder/dogtail-recorder.desktop']),
+                                ('share/icons/hicolor/48x48/apps', icons('png')),
+                                ('share/icons/hicolor/scalable/apps', icons('svg'))
+                                ],
+        cmdclass = {
+                'bdist_rpm': bdist_rpm
+                }
 )
 
 # vim: sw=4 ts=4 sts=4 noet ai
-

=== modified file 'sniff/sniff'
--- sniff/sniff	2006-02-22 12:31:33 +0000
+++ sniff/sniff	2006-12-16 10:57:30 +0000
@@ -4,6 +4,9 @@
 appName = 'Sniff'
 appAuthors = ['Zack Cerza <zcerza@redhat.com>', 'David Malcolm <dmalcolm@redhat.com']
 
+from dogtail.utils import checkForA11yInteractively
+checkForA11yInteractively()
+
 from dogtail import tree
 from dogtail import utils
 import gobject
@@ -12,17 +15,22 @@
 program = gnome.program_init(appName, '0.1')
 import gtk.glade
 
-try:
-	x = gtk.glade.XML('sniff.glade')
-except RuntimeError:
-	x = gtk.glade.XML('/usr/share/dogtail/glade/sniff.glade')
+import os
+if os.path.exists('sniff.glade'):
+    x = gtk.glade.XML('sniff.glade')
+else:
+    import sys
+    exec_root = sys.argv[0].split("/bin/")[0]
+    if exec_root[0] is not '/':
+        exec_root = "/usr"
+    x = gtk.glade.XML(exec_root + '/share/dogtail/glade/sniff.glade')
 
 sniff = x.get_widget(appName)
 
 try:
-	sniff.set_icon_from_file('../icons/dogtail-head.svg')
+    sniff.set_icon_from_file('../icons/dogtail-head.svg')
 except:
-	sniff.set_icon_from_file('/usr/share/icons/hicolor/scalable/apps/dogtail-head.svg')
+    sniff.set_icon_from_file('/usr/share/icons/hicolor/scalable/apps/dogtail-head.svg')
 
 view = x.get_widget('treeTreeView')
 
@@ -41,189 +49,180 @@
 MODEL_FIELD_PIXBUF = 4
 
 def quit(*args):
-	gtk.main_quit()
+    gtk.main_quit()
 
 def expandAll(widget, *args):
-	global view
-	if args[0] == True: view.expand_all()
-	elif args[0] == False: view.collapse_all()
+    global view
+    if args[0] == True: view.expand_all()
+    elif args[0] == False: view.collapse_all()
 
 def showAbout(*args):
-	about = gtk.AboutDialog()
-	about.set_name(appName)
-	about.set_authors(appAuthors)
-	about.set_comments('Explore your desktop with Dogtail')
-	about.set_website('http://people.redhat.com/zcerza/dogtail/')
-	about.show_all()
+    about = gtk.AboutDialog()
+    about.set_name(appName)
+    about.set_authors(appAuthors)
+    about.set_comments('Explore your desktop with Dogtail')
+    about.set_website('http://people.redhat.com/zcerza/dogtail/')
+    about.show_all()
 
 def connectSignals():
-	sniff.connect('delete_event', quit)
-
-	quit1 = x.get_widget('quit1')
-	quit1.connect('activate', quit)
-
-	expand_all1 = x.get_widget('expand_all1')
-	expand_all1.connect('activate', expandAll, True)
-	collapse_all1 = x.get_widget('collapse_all1')
-	collapse_all1.connect('activate', expandAll, False)
-	
-	about1 = x.get_widget('about1')
-	about1.connect('activate', showAbout)
-
-	refreshMenuItem = x.get_widget('refresh1')
-	refreshMenuItem.connect('activate', refreshAll)
-
-	view.connect('button-press-event', buttonPress)
-	view.connect('row-expanded', rowExpanded)
-	view.connect('row-collapsed', rowCollapsed)
-	treeSelection = view.get_selection()
-	treeSelection.connect('changed', selectionChanged)
+    sniff.connect('delete_event', quit)
+
+    quit1 = x.get_widget('quit1')
+    quit1.connect('activate', quit)
+
+    expand_all1 = x.get_widget('expand_all1')
+    expand_all1.connect('activate', expandAll, True)
+    collapse_all1 = x.get_widget('collapse_all1')
+    collapse_all1.connect('activate', expandAll, False)
+
+    about1 = x.get_widget('about1')
+    about1.connect('activate', showAbout)
+
+    refreshMenuItem = x.get_widget('refresh1')
+    refreshMenuItem.connect('activate', refreshAll)
+
+    view.connect('button-press-event', buttonPress)
+    view.connect('row-expanded', rowExpanded)
+    view.connect('row-collapsed', rowCollapsed)
+    treeSelection = view.get_selection()
+    treeSelection.connect('changed', selectionChanged)
 
 def buttonPress(widget, event, *userParams):
-	global model
-	try: path, treeViewCol, relX, relY = \
-			view.get_path_at_pos(int(event.x), int(event.y))
-	except TypeError: return
-	node = model[path][0]
-	setUpTable(node)
+    global model
+    try: path, treeViewCol, relX, relY = \
+                    view.get_path_at_pos(int(event.x), int(event.y))
+    except TypeError: return
+    node = model[path][0]
+    setUpTable(node)
 
-	if event.button == 3:
-		menu = gtk.Menu()
-		menuItem = None
-		try:
-			for action in node.actions.values():
-				menuItem = gtk.MenuItem(action.name.capitalize())
-				menuItem.connect('activate', menuItemActivate, action.do)
-				menuItem.show()
-				menu.append(menuItem)
-		except AttributeError: pass
-		if not menuItem: return
-		menu.show()
-		menu.popup(None, None, None, event.button, event.time)
+    if event.button == 3:
+        menu = gtk.Menu()
+        menuItem = None
+        if node.actions:
+            for action in node.actions.values():
+                menuItem = gtk.MenuItem(action.name.capitalize())
+                menuItem.connect('activate', menuItemActivate, action.do)
+                menuItem.show()
+                menu.append(menuItem)
+        if not menuItem: return
+        menu.show()
+        menu.popup(None, None, None, event.button, event.time)
 
 # I hate globals too. I think we need one here, though.
 # Make it a non-integer, so we can know if it has been set yet (later).
 textTextViewBufferChangedLastHandlerID = 3.141592654
 
 def setUpTable(node):
-	"""Generic code for setting up the table under the TreeView"""
-	nameTextLabel.set_text(node.name)
-	roleNameTextLabel.set_text(node.roleName)
-	descTextLabel.set_text(node.description)
-	try:
-		str = ''
-		for action in node.actions.values(): str = ' '.join([str, action.name]).strip()
-		actionsTextLabel.set_text(str)
-	except AttributeError: actionsTextLabel.set_text('')
-	
-	global textTextViewBufferChangedLastHandlerID
-	# Have we connected this signal yet? If so, disconnect it before proceeding.
-	if int(textTextViewBufferChangedLastHandlerID) == \
-		textTextViewBufferChangedLastHandlerID: 
-		textTextView.get_buffer().disconnect(textTextViewBufferChangedLastHandlerID)
-	
-	try:
-		textTextView.set_sensitive(True)
-		buffer = textTextView.get_buffer()
-		buffer.set_text(node.text)
-		try:
-			# Eeew! I'm touching tree's privates.
-			# This 'assert' will never cause an AssertionError - it
-			# will be an AttributeError.
-			assert node._Node__editableText
-			# Remember the handler ID of this connection.
-			textTextViewBufferChangedLastHandlerID = \
-				buffer.connect('changed', changeText, node)
-		except AttributeError:
-			textTextView.set_sensitive(False)
-	except AttributeError:
-		textTextView.get_buffer().set_text('')
-		textTextView.set_sensitive(False)
+    """Generic code for setting up the table under the TreeView"""
+    nameTextLabel.set_text(node.name)
+    roleNameTextLabel.set_text(node.roleName)
+    descTextLabel.set_text(node.description)
+    if node.actions:
+        str = ''
+        for action in node.actions.values(): str = ' '.join([str, action.name]).strip()
+        actionsTextLabel.set_text(str)
+
+    global textTextViewBufferChangedLastHandlerID
+    # Have we connected this signal yet? If so, disconnect it before proceeding.
+    if int(textTextViewBufferChangedLastHandlerID) == \
+            textTextViewBufferChangedLastHandlerID:
+        textTextView.get_buffer().disconnect(textTextViewBufferChangedLastHandlerID)
+
+    if node.text is not None:
+        buffer = textTextView.get_buffer()
+        buffer.set_text(node.text)
+        # Eeew! I'm touching tree's privates.
+        if node._Node__editableText:
+            # Remember the handler ID of this connection.
+            textTextView.set_sensitive(True)
+            textTextViewBufferChangedLastHandlerID = \
+                    buffer.connect('changed', changeText, node)
+        else:
+            textTextView.set_sensitive(False)
+    else:
+        textTextView.get_buffer().set_text('')
+        textTextView.set_sensitive(False)
 
 def changeText(textBuffer, node):
-	node.text = textBuffer.get_text(textBuffer.get_start_iter(), \
-			textBuffer.get_end_iter())
+    node.text = textBuffer.get_text(textBuffer.get_start_iter(), \
+                    textBuffer.get_end_iter())
 
 def rowExpanded(treeview, iter, path, *userParams):
-	global model
-	row = model[path]
-	childRows = row.iterchildren()
-	node = row[0]
-	try: 
-		childNodes = node.children
-		for childNode in childNodes:
-			childRow = childRows.next()
-			addChildren(childNode, childRow.iter)
-	except AttributeError: pass
+    global model
+    row = model[path]
+    childRows = row.iterchildren()
+    node = row[0]
+    childNodes = node.children
+    for childNode in childNodes:
+        childRow = childRows.next()
+        addChildren(childNode, childRow.iter)
 
 def rowCollapsed(treeview, iter, path, *userParams):
-	global model
-	row = model[path]
-	childRows = row.iterchildren()
-	try:
-		while True:
-			childRow = childRows.next()
-			grandChildRows = childRow.iterchildren()
-			try:
-				while True:
-					grandChildRow = grandChildRows.next()
-					model.remove(grandChildRow.iter)
-			except StopIteration: pass
-	except StopIteration: pass
+    global model
+    row = model[path]
+    childRows = row.iterchildren()
+    try:
+        while True:
+            childRow = childRows.next()
+            grandChildRows = childRow.iterchildren()
+            try:
+                while True:
+                    grandChildRow = grandChildRows.next()
+                    model.remove(grandChildRow.iter)
+            except StopIteration: pass
+    except StopIteration: pass
 
 def selectionChanged(treeSelection):
-	# print "selection changed"
-	node = getSelectedNode()
-	if node: node.blink()
+    # print "selection changed"
+    node = getSelectedNode()
+    if node: node.blink()
 
 def getSelectedNode():
-	global model
-	global view
-	(store, iter) = view.get_selection().get_selected()
-	if not iter: node = None
-	else: node = model[iter][0]
-	return node	
+    global model
+    global view
+    (store, iter) = view.get_selection().get_selected()
+    if not iter: node = None
+    else: node = model[iter][0]
+    return node
 
 def menuItemActivate(menuItem, *userParams):
-	method = userParams[0]
-	if method: method()
+    method = userParams[0]
+    if method: method()
 
 def refreshAll(menuItem, *userParams):
-	global model
-	resetModel()
+    global model
+    resetModel()
 
 def addNodeToModel(node, parentInTreeView = None):
-	global model
-	iter = model.insert_before(parentInTreeView, None)
-	model.set_value(iter, MODEL_FIELD_NODE, node)
-	return iter
+    global model
+    iter = model.insert_before(parentInTreeView, None)
+    model.set_value(iter, MODEL_FIELD_NODE, node)
+    return iter
 
 def addChildren(node, parentInTreeView = None):
-	global model
-	try:
-		for child in node.children:
-			iter = addNodeToModel(child, parentInTreeView)
-	except AttributeError: pass
+    global model
+    for child in node.children:
+        iter = addNodeToModel(child, parentInTreeView)
 
 def showNode(node, parentInTreeView = None):
-	global model
-	iter = addNodeToModel(node, parentInTreeView)
-	addChildren(node, iter)
+    global model
+    iter = addNodeToModel(node, parentInTreeView)
+    addChildren(node, iter)
 
 def resetModel():
-	global model
-	model.clear()
-	showNode(tree.root)	
-	rootPath = model.get_path(model.get_iter_root())
-	view.expand_row(rootPath, False)
+    global model
+    model.clear()
+    showNode(tree.root)
+    rootPath = model.get_path(model.get_iter_root())
+    view.expand_row(rootPath, False)
 
 def loadIcon(iconName):
-	try:
-		pixbuf = gtk.gdk.pixbuf_new_from_file('icons/' + iconName)
-	except gobject.GError:
-		iconName = '/usr/share/dogtail/icons/' + iconName
-		pixbuf = gtk.gdk.pixbuf_new_from_file(iconName)
-	return pixbuf
+    try:
+        pixbuf = gtk.gdk.pixbuf_new_from_file('icons/' + iconName)
+    except gobject.GError:
+        iconName = '/usr/share/dogtail/icons/' + iconName
+        pixbuf = gtk.gdk.pixbuf_new_from_file(iconName)
+    return pixbuf
 
 button_xpm = loadIcon("button.xpm")
 checkbutton_xpm = loadIcon("checkbutton.xpm")
@@ -251,151 +250,157 @@
 window_xpm = loadIcon("window.xpm")
 
 iconForRole = { \
-	atspi.SPI_ROLE_INVALID : None, \
-	atspi.SPI_ROLE_ACCEL_LABEL : label_xpm, \
-	atspi.SPI_ROLE_ALERT : None, \
-	atspi.SPI_ROLE_ANIMATION : None, \
-	atspi.SPI_ROLE_ARROW : None, \
-	atspi.SPI_ROLE_CALENDAR : None, \
-	atspi.SPI_ROLE_CANVAS : None, \
-	atspi.SPI_ROLE_CHECK_BOX : checkbutton_xpm, \
-	atspi.SPI_ROLE_CHECK_MENU_ITEM : checkmenuitem_xpm, \
-	atspi.SPI_ROLE_COLOR_CHOOSER : colorselection_xpm, \
-	atspi.SPI_ROLE_COLUMN_HEADER : None, \
-	atspi.SPI_ROLE_COMBO_BOX : combo_xpm, \
-	atspi.SPI_ROLE_DATE_EDITOR : None, \
-	atspi.SPI_ROLE_DESKTOP_ICON : None, \
-	atspi.SPI_ROLE_DESKTOP_FRAME : None, \
-	atspi.SPI_ROLE_DIAL : None, \
-	atspi.SPI_ROLE_DIALOG : dialog_xpm, \
-	atspi.SPI_ROLE_DIRECTORY_PANE : None, \
-	atspi.SPI_ROLE_DRAWING_AREA : None, \
-	atspi.SPI_ROLE_FILE_CHOOSER : None, \
-	atspi.SPI_ROLE_FILLER : None, \
-	atspi.SPI_ROLE_FONT_CHOOSER : None, \
-	atspi.SPI_ROLE_FRAME : window_xpm, \
-	atspi.SPI_ROLE_GLASS_PANE : None, \
-	atspi.SPI_ROLE_HTML_CONTAINER : None, \
-	atspi.SPI_ROLE_ICON : image_xpm, \
-	atspi.SPI_ROLE_IMAGE : image_xpm, \
-	atspi.SPI_ROLE_INTERNAL_FRAME : None, \
-	atspi.SPI_ROLE_LABEL : label_xpm, \
-	atspi.SPI_ROLE_LAYERED_PANE : viewport_xpm, \
-	atspi.SPI_ROLE_LIST : None, \
-	atspi.SPI_ROLE_LIST_ITEM : None, \
-	atspi.SPI_ROLE_MENU : menuitem_xpm, \
-	atspi.SPI_ROLE_MENU_BAR : menubar_xpm, \
-	atspi.SPI_ROLE_MENU_ITEM : menuitem_xpm, \
-	atspi.SPI_ROLE_OPTION_PANE : None, \
-	atspi.SPI_ROLE_PAGE_TAB : notebook_xpm, \
-	atspi.SPI_ROLE_PAGE_TAB_LIST : notebook_xpm, \
-	atspi.SPI_ROLE_PANEL : viewport_xpm, \
-	atspi.SPI_ROLE_PASSWORD_TEXT : None, \
-	atspi.SPI_ROLE_POPUP_MENU : None, \
-	atspi.SPI_ROLE_PROGRESS_BAR : None, \
-	atspi.SPI_ROLE_PUSH_BUTTON : button_xpm, \
-	atspi.SPI_ROLE_RADIO_BUTTON : None, \
-	atspi.SPI_ROLE_RADIO_MENU_ITEM : None, \
-	atspi.SPI_ROLE_ROOT_PANE : viewport_xpm, \
-	atspi.SPI_ROLE_ROW_HEADER : None, \
-	atspi.SPI_ROLE_SCROLL_BAR : vscrollbar_xpm, \
-	atspi.SPI_ROLE_SCROLL_PANE : scrolledwindow_xpm, \
-	atspi.SPI_ROLE_SEPARATOR : vseparator_xpm, \
-	atspi.SPI_ROLE_SLIDER : None, \
-	atspi.SPI_ROLE_SPIN_BUTTON : spinbutton_xpm, \
-	atspi.SPI_ROLE_SPLIT_PANE : None, \
-	atspi.SPI_ROLE_STATUS_BAR : statusbar_xpm, \
-	atspi.SPI_ROLE_TABLE : table_xpm, \
-	atspi.SPI_ROLE_TABLE_CELL : treeitem_xpm, \
-	atspi.SPI_ROLE_TABLE_COLUMN_HEADER : None, \
-	atspi.SPI_ROLE_TABLE_ROW_HEADER : None, \
-	atspi.SPI_ROLE_TEAROFF_MENU_ITEM : None, \
-	atspi.SPI_ROLE_TERMINAL : None, \
-	atspi.SPI_ROLE_TEXT : text_xpm, \
-	atspi.SPI_ROLE_TOGGLE_BUTTON : None, \
-	atspi.SPI_ROLE_TOOL_BAR : toolbar_xpm, \
-	atspi.SPI_ROLE_TOOL_TIP : None, \
-	atspi.SPI_ROLE_TREE : tree_xpm, \
-	atspi.SPI_ROLE_TREE_TABLE : tree_xpm, \
-	atspi.SPI_ROLE_UNKNOWN : unknown_xpm, \
-	atspi.SPI_ROLE_VIEWPORT : viewport_xpm, \
-	atspi.SPI_ROLE_WINDOW : window_xpm, \
-	atspi.SPI_ROLE_EXTENDED : None, \
-	atspi.SPI_ROLE_HEADER : None, \
-	atspi.SPI_ROLE_FOOTER : None, \
-	atspi.SPI_ROLE_PARAGRAPH : None, \
-	atspi.SPI_ROLE_RULER : None, \
-	atspi.SPI_ROLE_APPLICATION : None, \
-	atspi.SPI_ROLE_AUTOCOMPLETE : None, \
-	atspi.SPI_ROLE_EDITBAR : None, \
-	atspi.SPI_ROLE_EMBEDDED : None, \
-	atspi.SPI_ROLE_LAST_DEFINED: None }
+        atspi.SPI_ROLE_INVALID : None, \
+        atspi.SPI_ROLE_ACCEL_LABEL : label_xpm, \
+        atspi.SPI_ROLE_ALERT : None, \
+        atspi.SPI_ROLE_ANIMATION : None, \
+        atspi.SPI_ROLE_ARROW : None, \
+        atspi.SPI_ROLE_CALENDAR : None, \
+        atspi.SPI_ROLE_CANVAS : None, \
+        atspi.SPI_ROLE_CHECK_BOX : checkbutton_xpm, \
+        atspi.SPI_ROLE_CHECK_MENU_ITEM : checkmenuitem_xpm, \
+        atspi.SPI_ROLE_COLOR_CHOOSER : colorselection_xpm, \
+        atspi.SPI_ROLE_COLUMN_HEADER : None, \
+        atspi.SPI_ROLE_COMBO_BOX : combo_xpm, \
+        atspi.SPI_ROLE_DATE_EDITOR : None, \
+        atspi.SPI_ROLE_DESKTOP_ICON : None, \
+        atspi.SPI_ROLE_DESKTOP_FRAME : None, \
+        atspi.SPI_ROLE_DIAL : None, \
+        atspi.SPI_ROLE_DIALOG : dialog_xpm, \
+        atspi.SPI_ROLE_DIRECTORY_PANE : None, \
+        atspi.SPI_ROLE_DRAWING_AREA : None, \
+        atspi.SPI_ROLE_FILE_CHOOSER : None, \
+        atspi.SPI_ROLE_FILLER : None, \
+        atspi.SPI_ROLE_FONT_CHOOSER : None, \
+        atspi.SPI_ROLE_FRAME : window_xpm, \
+        atspi.SPI_ROLE_GLASS_PANE : None, \
+        atspi.SPI_ROLE_HTML_CONTAINER : None, \
+        atspi.SPI_ROLE_ICON : image_xpm, \
+        atspi.SPI_ROLE_IMAGE : image_xpm, \
+        atspi.SPI_ROLE_INTERNAL_FRAME : None, \
+        atspi.SPI_ROLE_LABEL : label_xpm, \
+        atspi.SPI_ROLE_LAYERED_PANE : viewport_xpm, \
+        atspi.SPI_ROLE_LIST : None, \
+        atspi.SPI_ROLE_LIST_ITEM : None, \
+        atspi.SPI_ROLE_MENU : menuitem_xpm, \
+        atspi.SPI_ROLE_MENU_BAR : menubar_xpm, \
+        atspi.SPI_ROLE_MENU_ITEM : menuitem_xpm, \
+        atspi.SPI_ROLE_OPTION_PANE : None, \
+        atspi.SPI_ROLE_PAGE_TAB : notebook_xpm, \
+        atspi.SPI_ROLE_PAGE_TAB_LIST : notebook_xpm, \
+        atspi.SPI_ROLE_PANEL : viewport_xpm, \
+        atspi.SPI_ROLE_PASSWORD_TEXT : None, \
+        atspi.SPI_ROLE_POPUP_MENU : None, \
+        atspi.SPI_ROLE_PROGRESS_BAR : None, \
+        atspi.SPI_ROLE_PUSH_BUTTON : button_xpm, \
+        atspi.SPI_ROLE_RADIO_BUTTON : None, \
+        atspi.SPI_ROLE_RADIO_MENU_ITEM : None, \
+        atspi.SPI_ROLE_ROOT_PANE : viewport_xpm, \
+        atspi.SPI_ROLE_ROW_HEADER : None, \
+        atspi.SPI_ROLE_SCROLL_BAR : vscrollbar_xpm, \
+        atspi.SPI_ROLE_SCROLL_PANE : scrolledwindow_xpm, \
+        atspi.SPI_ROLE_SEPARATOR : vseparator_xpm, \
+        atspi.SPI_ROLE_SLIDER : None, \
+        atspi.SPI_ROLE_SPIN_BUTTON : spinbutton_xpm, \
+        atspi.SPI_ROLE_SPLIT_PANE : None, \
+        atspi.SPI_ROLE_STATUS_BAR : statusbar_xpm, \
+        atspi.SPI_ROLE_TABLE : table_xpm, \
+        atspi.SPI_ROLE_TABLE_CELL : treeitem_xpm, \
+        atspi.SPI_ROLE_TABLE_COLUMN_HEADER : None, \
+        atspi.SPI_ROLE_TABLE_ROW_HEADER : None, \
+        atspi.SPI_ROLE_TEAROFF_MENU_ITEM : None, \
+        atspi.SPI_ROLE_TERMINAL : None, \
+        atspi.SPI_ROLE_TEXT : text_xpm, \
+        atspi.SPI_ROLE_TOGGLE_BUTTON : None, \
+        atspi.SPI_ROLE_TOOL_BAR : toolbar_xpm, \
+        atspi.SPI_ROLE_TOOL_TIP : None, \
+        atspi.SPI_ROLE_TREE : tree_xpm, \
+        atspi.SPI_ROLE_TREE_TABLE : tree_xpm, \
+        atspi.SPI_ROLE_UNKNOWN : unknown_xpm, \
+        atspi.SPI_ROLE_VIEWPORT : viewport_xpm, \
+        atspi.SPI_ROLE_WINDOW : window_xpm, \
+        atspi.SPI_ROLE_EXTENDED : None, \
+        atspi.SPI_ROLE_HEADER : None, \
+        atspi.SPI_ROLE_FOOTER : None, \
+        atspi.SPI_ROLE_PARAGRAPH : None, \
+        atspi.SPI_ROLE_RULER : None, \
+        atspi.SPI_ROLE_APPLICATION : None, \
+        atspi.SPI_ROLE_AUTOCOMPLETE : None, \
+        atspi.SPI_ROLE_EDITBAR : None, \
+        atspi.SPI_ROLE_EMBEDDED : None, \
+        atspi.SPI_ROLE_LAST_DEFINED: None }
 
 def getPixbufForNode(node):
-	theme = gtk.icon_theme_get_default()
-	if node.role==atspi.SPI_ROLE_APPLICATION:
-		# FIXME: Use the pixbuf from libwcnk (if available):
-		# wnckApp = Application(node).getWnckApplication()
-		# if wnckApp
-		try: return theme.load_icon(node.name, 24, gtk.ICON_LOOKUP_USE_BUILTIN)
-		except gobject.GError: 
-			try: return theme.load_icon(node.name.lower(), 24, gtk.ICON_LOOKUP_USE_BUILTIN)
-			except gobject.GError: return None
-	elif node.parent:
-		return iconForRole[node.role]
-	else:
-		return theme.load_icon("gnome-fs-desktop", 24, gtk.ICON_LOOKUP_USE_BUILTIN)
+    theme = gtk.icon_theme_get_default()
+    try:
+        if node.role==atspi.SPI_ROLE_APPLICATION:
+            # FIXME: Use the pixbuf from libwcnk (if available):
+            # wnckApp = Application(node).getWnckApplication()
+            # if wnckApp
+            try: return theme.load_icon(node.name, 24, gtk.ICON_LOOKUP_USE_BUILTIN)
+            except gobject.GError:
+                try: return theme.load_icon(node.name.lower(), 24, gtk.ICON_LOOKUP_USE_BUILTIN)
+                except gobject.GError: return None
+        elif node.parent:
+            return iconForRole[node.role]
+        else:
+            return theme.load_icon("gnome-fs-desktop", 24, gtk.ICON_LOOKUP_USE_BUILTIN)
+    except atspi.SpiException:
+        return theme.load_icon("gtk-dialog-error", 24, gtk.ICON_LOOKUP_USE_BUILTIN)
 
 def getNodeAttr(column, cell, model, iter, attr):
-	node = model.get_value(iter, MODEL_FIELD_NODE)
-	cell.set_property('text', getattr(node, attr))
+    node = model.get_value(iter, MODEL_FIELD_NODE)
+    try:
+        text = getattr(node, attr)
+    except atspi.SpiException:
+        text = "(broken node)"
+    cell.set_property('text', text)
 
 def getCellPixbufForNode(column, cell, model, iter):
-	node = model.get_value(iter, MODEL_FIELD_NODE)	
-	pixbuf = getPixbufForNode(node)
-	cell.set_property('pixbuf', pixbuf)
+    node = model.get_value(iter, MODEL_FIELD_NODE)
+    pixbuf = getPixbufForNode(node)
+    cell.set_property('pixbuf', pixbuf)
 
 def main():
-	connectSignals()
-
-	nameTextLabel.set_text('')
-	roleNameTextLabel.set_text('')
-	descTextLabel.set_text('')
-	actionsTextLabel.set_text('')
-	textTextView.set_sensitive(False)
-	textTextView.get_buffer().set_text('')
-
-	global sniff, view, model
-
-	col = gtk.TreeViewColumn()
-	cellRenderer = gtk.CellRendererPixbuf()
-	col.pack_start(cellRenderer, expand = False)
-	col.set_cell_data_func(cellRenderer, getCellPixbufForNode)
-
-	cellRenderer = gtk.CellRendererText()
-	col.pack_end(cellRenderer, expand = False)
-	col.set_cell_data_func(cellRenderer, getNodeAttr, 'name')
-
-	col.set_title('Name')
-
-	view.insert_column(col, -1)
-	#view.insert_column_with_data_func(-1, "Role Name", \
-	#		gtk.CellRendererText(), getNodeAttr, 'roleName')
-	#view.insert_column_with_data_func(-1, "Description", \
-	#		gtk.CellRendererText(), getNodeAttr, 'description')
-	for column in view.get_columns():
-		column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
-		column.set_resizable(True)
-	view.show()
-	sniff.show_all ()
-	
-	model = gtk.TreeStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING, \
-			gobject.TYPE_STRING, gobject.TYPE_STRING)
-	view.set_model(model)
-
-	resetModel()
-	
-	gtk.main()
+    connectSignals()
+
+    nameTextLabel.set_text('')
+    roleNameTextLabel.set_text('')
+    descTextLabel.set_text('')
+    actionsTextLabel.set_text('')
+    textTextView.set_sensitive(False)
+    textTextView.get_buffer().set_text('')
+
+    global sniff, view, model
+
+    col = gtk.TreeViewColumn()
+    cellRenderer = gtk.CellRendererPixbuf()
+    col.pack_start(cellRenderer, expand = False)
+    col.set_cell_data_func(cellRenderer, getCellPixbufForNode)
+
+    cellRenderer = gtk.CellRendererText()
+    col.pack_end(cellRenderer, expand = False)
+    col.set_cell_data_func(cellRenderer, getNodeAttr, 'name')
+
+    col.set_title('Name')
+
+    view.insert_column(col, -1)
+    #view.insert_column_with_data_func(-1, "Role Name", \
+    #               gtk.CellRendererText(), getNodeAttr, 'roleName')
+    #view.insert_column_with_data_func(-1, "Description", \
+    #               gtk.CellRendererText(), getNodeAttr, 'description')
+    for column in view.get_columns():
+        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
+        column.set_resizable(True)
+    view.show()
+    sniff.show_all ()
+
+    model = gtk.TreeStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING, \
+                    gobject.TYPE_STRING, gobject.TYPE_STRING)
+    view.set_model(model)
+
+    resetModel()
+
+    gtk.main()
 
 if __name__ == '__main__': main()
-

=== modified file 'sniff/sniff.desktop'
--- sniff/sniff.desktop	2006-02-22 12:31:33 +0000
+++ sniff/sniff.desktop	2006-12-16 10:57:30 +0000
@@ -11,4 +11,4 @@
 Type=Application
 Icon=dogtail-head.svg
 StartupNotify=true
-Categories=GNOME;Application;System;
+Categories=Application;Development;

=== modified file 'sniff/sniff.glade'
--- sniff/sniff.glade	2006-02-22 12:31:33 +0000
+++ sniff/sniff.glade	2006-12-16 10:57:30 +0000
@@ -3,13 +3,12 @@
 
 <glade-interface>
 <requires lib="gnome"/>
-<requires lib="bonobo"/>
 
-<widget class="GnomeApp" id="Sniff">
-  <property name="width_request">600</property>
-  <property name="height_request">600</property>
+<widget class="GtkWindow" id="Sniff">
+  <property name="width_request">325</property>
+  <property name="height_request">475</property>
   <property name="visible">True</property>
-  <property name="title" translatable="yes">Sniff</property>
+  <property name="title" translatable="yes">AT-SPI Browser</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">False</property>
@@ -22,118 +21,111 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
-  <property name="enable_layout_config">True</property>
 
-  <child internal-child="dock">
-    <widget class="BonoboDock" id="bonobodock1">
+  <child>
+    <widget class="GtkVBox" id="vbox1">
       <property name="visible">True</property>
-      <property name="allow_floating">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">0</property>
 
       <child>
-	<widget class="BonoboDockItem" id="bonobodockitem1">
+	<widget class="GtkMenuBar" id="menubar1">
 	  <property name="visible">True</property>
-	  <property name="shadow_type">GTK_SHADOW_NONE</property>
-
-	  <child>
-	    <widget class="GtkMenuBar" id="menubar1">
-	      <property name="visible">True</property>
-	      <property name="pack_direction">GTK_PACK_DIRECTION_LTR</property>
-	      <property name="child_pack_direction">GTK_PACK_DIRECTION_LTR</property>
-
-	      <child>
-		<widget class="GtkMenuItem" id="sniff1">
-		  <property name="visible">True</property>
-		  <property name="label" translatable="yes">_Sniff</property>
-		  <property name="use_underline">True</property>
-
-		  <child>
-		    <widget class="GtkMenu" id="sniff1_menu">
-
-		      <child>
-			<widget class="GtkImageMenuItem" id="quit1">
-			  <property name="visible">True</property>
-			  <property name="stock_item">GNOMEUIINFO_MENU_EXIT_ITEM</property>
-			  <signal name="activate" handler="on_quit1_activate" last_modification_time="Tue, 26 Jul 2005 14:21:44 GMT"/>
-			</widget>
-		      </child>
-		    </widget>
-		  </child>
-		</widget>
-	      </child>
-
-	      <child>
-		<widget class="GtkMenuItem" id="view1">
-		  <property name="visible">True</property>
-		  <property name="stock_item">GNOMEUIINFO_MENU_VIEW_TREE</property>
-
-		  <child>
-		    <widget class="GtkMenu" id="view1_menu">
-
-		      <child>
-			<widget class="GtkImageMenuItem" id="refresh1">
-			  <property name="visible">True</property>
-			  <property name="label" translatable="yes">_Refresh</property>
-			  <property name="use_underline">True</property>
-			  <signal name="activate" handler="on_refresh1_activate" last_modification_time="Wed, 27 Jul 2005 16:21:27 GMT"/>
-			  <accelerator key="R" modifiers="GDK_CONTROL_MASK" signal="activate"/>
-
-			  <child internal-child="image">
-			    <widget class="GtkImage" id="image1">
-			      <property name="visible">True</property>
-			      <property name="stock">gtk-refresh</property>
-			      <property name="icon_size">1</property>
-			      <property name="xalign">0.5</property>
-			      <property name="yalign">0.5</property>
-			      <property name="xpad">0</property>
-			      <property name="ypad">0</property>
-			    </widget>
-			  </child>
-			</widget>
-		      </child>
-
-		      <child>
-			<widget class="GtkSeparatorMenuItem" id="separator3">
-			  <property name="visible">True</property>
-			</widget>
-		      </child>
-
-		      <child>
-			<widget class="GtkMenuItem" id="expand_all1">
-			  <property name="visible">True</property>
-			  <property name="label" translatable="yes">_Expand All</property>
-			  <property name="use_underline">True</property>
-			  <signal name="activate" handler="on_expand_all1_activate" last_modification_time="Wed, 27 Jul 2005 18:41:34 GMT"/>
-			</widget>
-		      </child>
-
-		      <child>
-			<widget class="GtkMenuItem" id="collapse_all1">
-			  <property name="visible">True</property>
-			  <property name="label" translatable="yes">_Collapse All</property>
-			  <property name="use_underline">True</property>
-			  <signal name="activate" handler="on_collapse_all1_activate" last_modification_time="Wed, 27 Jul 2005 18:40:57 GMT"/>
-			</widget>
-		      </child>
-		    </widget>
-		  </child>
-		</widget>
-	      </child>
-
-	      <child>
-		<widget class="GtkMenuItem" id="help1">
-		  <property name="visible">True</property>
-		  <property name="stock_item">GNOMEUIINFO_MENU_HELP_TREE</property>
-
-		  <child>
-		    <widget class="GtkMenu" id="help1_menu">
-
-		      <child>
-			<widget class="GtkImageMenuItem" id="about1">
-			  <property name="visible">True</property>
-			  <property name="stock_item">GNOMEUIINFO_MENU_ABOUT_ITEM</property>
-			  <signal name="activate" handler="on_about1_activate" last_modification_time="Tue, 26 Jul 2005 14:21:44 GMT"/>
-			</widget>
-		      </child>
+	  <property name="pack_direction">GTK_PACK_DIRECTION_LTR</property>
+	  <property name="child_pack_direction">GTK_PACK_DIRECTION_LTR</property>
+
+	  <child>
+	    <widget class="GtkMenuItem" id="sniff1">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">_Sniff</property>
+	      <property name="use_underline">True</property>
+
+	      <child>
+		<widget class="GtkMenu" id="sniff1_menu">
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="quit1">
+		      <property name="visible">True</property>
+		      <property name="stock_item">GNOMEUIINFO_MENU_EXIT_ITEM</property>
+		      <signal name="activate" handler="on_quit1_activate" last_modification_time="Tue, 26 Jul 2005 14:21:44 GMT"/>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkMenuItem" id="view1">
+	      <property name="visible">True</property>
+	      <property name="stock_item">GNOMEUIINFO_MENU_VIEW_TREE</property>
+
+	      <child>
+		<widget class="GtkMenu" id="view1_menu">
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="refresh1">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Refresh</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_refresh1_activate" last_modification_time="Wed, 27 Jul 2005 16:21:27 GMT"/>
+		      <accelerator key="R" modifiers="GDK_CONTROL_MASK" signal="activate"/>
+
+		      <child internal-child="image">
+			<widget class="GtkImage" id="image1">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-refresh</property>
+			  <property name="icon_size">1</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+		      </child>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator3">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkMenuItem" id="expand_all1">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Expand All</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_expand_all1_activate" last_modification_time="Wed, 27 Jul 2005 18:41:34 GMT"/>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkMenuItem" id="collapse_all1">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Collapse All</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_collapse_all1_activate" last_modification_time="Wed, 27 Jul 2005 18:40:57 GMT"/>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkMenuItem" id="help1">
+	      <property name="visible">True</property>
+	      <property name="stock_item">GNOMEUIINFO_MENU_HELP_TREE</property>
+
+	      <child>
+		<widget class="GtkMenu" id="help1_menu">
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="about1">
+		      <property name="visible">True</property>
+		      <property name="stock_item">GNOMEUIINFO_MENU_ABOUT_ITEM</property>
+		      <signal name="activate" handler="on_about1_activate" last_modification_time="Tue, 26 Jul 2005 14:21:44 GMT"/>
 		    </widget>
 		  </child>
 		</widget>
@@ -142,11 +134,9 @@
 	  </child>
 	</widget>
 	<packing>
-	  <property name="placement">BONOBO_DOCK_TOP</property>
-	  <property name="band">0</property>
-	  <property name="position">0</property>
-	  <property name="offset">0</property>
-	  <property name="behavior">BONOBO_DOCK_ITEM_BEH_EXCLUSIVE|BONOBO_DOCK_ITEM_BEH_NEVER_VERTICAL|BONOBO_DOCK_ITEM_BEH_LOCKED</property>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
 	</packing>
       </child>
 
@@ -495,26 +485,13 @@
 	    </packing>
 	  </child>
 	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">True</property>
+	  <property name="fill">True</property>
+	</packing>
       </child>
     </widget>
-    <packing>
-      <property name="padding">0</property>
-      <property name="expand">True</property>
-      <property name="fill">True</property>
-    </packing>
-  </child>
-
-  <child internal-child="appbar">
-    <widget class="GnomeAppBar" id="appbar1">
-      <property name="visible">True</property>
-      <property name="has_progress">True</property>
-      <property name="has_status">True</property>
-    </widget>
-    <packing>
-      <property name="padding">0</property>
-      <property name="expand">True</property>
-      <property name="fill">True</property>
-    </packing>
   </child>
 </widget>
 

